/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/addrregistry.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/addrregistry.pmc"
/*
Copyright: 2005 The Perl Foundation.  All Rights Reserved.
$Id: addrregistry.pmc 12058 2006-03-28 12:32:56Z leo $

=head1 NAME

src/pmc/addrregistry.pmc - A DOD Registry PMC

=head1 DESCRIPTION

The AddrRegistry class provides the equivalence of reference counts
mainly for extenders and embeders of Parrot. The hash keys are the
addressed of the key PMC, values are reference counts, i.e. the
difference of (set_pmc_keyed - delete_pmc_keyed). If the reference
goes to zero, the entry is deleted physically.

Please not that you have to anchor an instance of AddrRegistry yourself
e.g. with C<Parrot_register_pmc> if it isn't visible to Parrot.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>
#include "pmc_hash.h"

static size_t
key_hash_int(Interp *interp, void *value, size_t seed)
{
    UNUSED(interp);
    return (size_t)value ^ seed;
}

static int
int_compare(Interp *interp, void *a, void *b)
{
    UNUSED(interp);
    return a != b;
}

static void
pobject_lives_fn(Interp *interp, PObj *o)
{
    pobject_lives(interp, o);
}

#line 64 "src/pmc/addrregistry.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_addrregistry.h"
#include "pmc_default.h"
#include "addrregistry.str"

void
Parrot_AddrRegistry_init(Interp* interpreter, PMC* pmc)
#line 67 "src/pmc/addrregistry.pmc"
{
    PMC_struct_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    new_pmc_hash_x(interpreter, pmc, enum_type_int, Hash_key_type_PMC,
            int_compare, key_hash_int);

}
#line 82 "src/pmc/addrregistry.c"


void
Parrot_AddrRegistry_mark(Interp* interpreter, PMC* pmc)
#line 91 "src/pmc/addrregistry.pmc"
{
    if (PMC_struct_val(pmc))
        mark_hash(interpreter, PMC_struct_val(pmc));

}
#line 93 "src/pmc/addrregistry.c"


void
Parrot_AddrRegistry_destroy(Interp* interpreter, PMC* pmc)
#line 74 "src/pmc/addrregistry.pmc"
{
    if (PMC_struct_val(pmc)) {
        hash_destroy(interpreter, (Hash*) PMC_struct_val(pmc));
        PMC_struct_val(pmc) = NULL;
    }

}
#line 106 "src/pmc/addrregistry.c"


INTVAL
Parrot_AddrRegistry_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 115 "src/pmc/addrregistry.pmc"
{
    Hash *hash = PMC_struct_val(pmc);
    HashBucket *b;

    b = hash_get_bucket(interpreter, hash, key);
    if (b == NULL)
        return 0;
    return (INTVAL) b->value;

}
#line 122 "src/pmc/addrregistry.c"


INTVAL
Parrot_AddrRegistry_get_bool(Interp* interpreter, PMC* pmc)
#line 129 "src/pmc/addrregistry.pmc"
{
    return hash_size(interpreter, PMC_struct_val(pmc)) != 0;

}
#line 132 "src/pmc/addrregistry.c"


PMC*
Parrot_AddrRegistry_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 198 "src/pmc/addrregistry.pmc"
{
    Hash *hash = PMC_struct_val(pmc);

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) ==
            KEY_hash_iterator_FLAGS) {
        return hash_get_idx(interpreter, hash, key);
    }
    return PMCNULL;

}
#line 148 "src/pmc/addrregistry.c"


void
Parrot_AddrRegistry_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
#line 163 "src/pmc/addrregistry.pmc"
{
    Hash * hash = (Hash *)PMC_struct_val(pmc);
    hash_put(interpreter, hash, key, (void *) value);

}
#line 159 "src/pmc/addrregistry.c"


void
Parrot_AddrRegistry_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* value)
#line 153 "src/pmc/addrregistry.pmc"
{
    Hash * hash = (Hash *)PMC_struct_val(pmc);
    HashBucket *b;
    b = hash_get_bucket(interpreter, hash, key);
    if (b)
        LVALUE_CAST(char *, b->value) ++;
    else
        hash_put(interpreter, hash, key, (void *) 1);

}
#line 175 "src/pmc/addrregistry.c"


INTVAL
Parrot_AddrRegistry_elements(Interp* interpreter, PMC* pmc)
#line 125 "src/pmc/addrregistry.pmc"
{
    return hash_size(interpreter, PMC_struct_val(pmc));

}
#line 185 "src/pmc/addrregistry.c"


void
Parrot_AddrRegistry_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 168 "src/pmc/addrregistry.pmc"
{
    Hash * hash = (Hash *)PMC_struct_val(pmc);
    HashBucket *b;
    b = hash_get_bucket(interpreter, hash, key);
    if (b) {
        if ((long) b->value == 1L)
            hash_delete(interpreter, hash, key);
        else
            LVALUE_CAST(long, b->value) --;
    }

}
#line 203 "src/pmc/addrregistry.c"


PMC*
Parrot_AddrRegistry_get_iter(Interp* interpreter, PMC* pmc)
#line 194 "src/pmc/addrregistry.pmc"
{
    return Parrot_Hash_get_iter(interpreter, pmc);

}
#line 213 "src/pmc/addrregistry.c"


void
Parrot_AddrRegistry_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_AddrRegistry,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_AddrRegistry_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_AddrRegistry_mark,
        Parrot_AddrRegistry_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_default_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_AddrRegistry_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_AddrRegistry_get_bool,
        Parrot_default_get_pmc,
        Parrot_AddrRegistry_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_AddrRegistry_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_AddrRegistry_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_AddrRegistry_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_AddrRegistry_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_AddrRegistry_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "AddrRegistry");
        vt_clone->isa_str = CONST_STRING(interp, "AddrRegistry");
        vt_clone->does_str = CONST_STRING(interp, "hash");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_AddrRegistry_class_init */


/*

=back

=head1 SEE ALSO

F<src/pmc.c:dod_register_pmc()>

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
