/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/array.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/array.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: array.pmc 12114 2006-04-04 22:50:48Z bernhard $

=head1 NAME

src/pmc/array.pmc - Array PMC

=head1 DESCRIPTION

These are the vtable functions for the Array base class.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static PMC* undef(Interp* interpreter)>

Returns a C<Undef> PMC.

=cut

*/

static PMC* undef(Interp* interpreter)
{
    return pmc_new(interpreter, enum_class_Undef);
}

/*

=item C<static PMC* retval(Interp *interp, void *ret)>

Processes C<*ret>, returning the appropriate PMC, or raising an
exception if necessary.

=cut

*/

static PMC* retval(Interp *interp, void *ret)
{
    PMC *value;
    if (ret == 0)
    real_exception(interp, NULL, E_IndexError,
        "Array index out of bounds!");
    /* XXX getting non existent value, exception or undef?
     * current is for perlarray */
    if (ret == (void*) -1)
        value = undef(interp);
    else {
        value = *(PMC**) ret;
        if (value == NULL)  /* XXX same here */
            value = undef(interp);
    }
    return value;
}

/*

=item C<static PMC*
Parrot_Array_get_pmc_ptr(Interp *interp, List *list, INTVAL key)>

Returns the PMC at index C<key> in C<*list>.

=cut

*/

static PMC*
Parrot_Array_get_pmc_ptr(Interp *interp, List *list, INTVAL key)
{
    return retval(interp, list_get(interp, list, key, enum_type_PMC));
}

/*

=item C<static PMC*
Parrot_Array_pop_pmc_ptr(Interp *interp, List *list)>

Returns the last PMC in C<*list>.

=cut

*/

static PMC*
Parrot_Array_pop_pmc_ptr(Interp *interp, List *list)
{
    return retval(interp, list_pop(interp, list, enum_type_PMC));
}

/*

=item C<static PMC*
Parrot_Array_shift_pmc_ptr(Interp *interp, List *list)>

Returns the first PMC in C<*list>.

=cut

*/

static PMC*
Parrot_Array_shift_pmc_ptr(Interp *interp, List *list)
{
    return retval(interp, list_shift(interp, list, enum_type_PMC));
}

/*

=item C<static PMC*
Parrot_Array_set_pmc_ptr(Interp *interp, List *list, INTVAL key)>

Returns a pointer to the element at index C<key> of C<*list>. If
this element was previously empty, then this function also creates
and assigns an "undef" PMC to that element.

=cut

*/

static PMC*
Parrot_Array_set_pmc_ptr(Interp *interp, List *list, INTVAL key)
{
    void * ret = list_get(interp, list, key, enum_type_PMC);
    PMC *value;

    if (ret == 0)
        real_exception(interp, NULL, E_IndexError,
            "Array index out of bounds!");
    /* assign into a sparse or not yet set value */
    if (ret == (void*) -1 || *(PMC**)ret == 0) {
        value = undef(interp);
        list_assign(interp, list, key, value, enum_type_PMC);
    }
    else
        value = *(PMC**) ret;
    return value;
}


#line 163 "src/pmc/array.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_array.h"
#include "pmc_default.h"
#include "array.str"

void
Parrot_Array_init(Interp* interpreter, PMC* pmc)
#line 185 "src/pmc/array.pmc"
{
    list_pmc_new(interpreter, pmc);
    PObj_custom_mark_SET(pmc);

}
#line 179 "src/pmc/array.c"


void
Parrot_Array_init_pmc(Interp* interpreter, PMC* pmc, PMC *init)
#line 203 "src/pmc/array.pmc"
{
    list_pmc_new_init(interpreter, pmc, init);
    PObj_custom_mark_SET(pmc);

}
#line 190 "src/pmc/array.c"


void
Parrot_Array_mark(Interp* interpreter, PMC* pmc)
#line 255 "src/pmc/array.pmc"
{
    list_mark(interpreter, (List *) PMC_data(pmc));

}
#line 200 "src/pmc/array.c"


INTVAL
Parrot_Array_type_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 374 "src/pmc/array.pmc"
{
    PMC* value;

    value = Parrot_Array_get_pmc_ptr(interpreter, (List*)PMC_data(pmc), key);
    return VTABLE_type(interpreter, value);

}
#line 213 "src/pmc/array.c"


PMC*
Parrot_Array_clone(Interp* interpreter, PMC* pmc)
#line 269 "src/pmc/array.pmc"
{
    List *l;
    PMC* dest = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    PObj_custom_mark_SET(dest);
    PMC_data(dest) = l = list_clone(interpreter, (List *) PMC_data(pmc));
    l->container = dest;
    return dest;

}
#line 228 "src/pmc/array.c"


INTVAL
Parrot_Array_get_integer(Interp* interpreter, PMC* pmc)
#line 288 "src/pmc/array.pmc"
{
    return  VTABLE_elements(interpreter, pmc);

}
#line 238 "src/pmc/array.c"


INTVAL
Parrot_Array_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 391 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return 0;
    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) return Parrot_Array_get_integer_keyed_int(interpreter, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) box = undef(interpreter);
    return VTABLE_get_integer_keyed(interpreter, box, nextkey);

}
#line 259 "src/pmc/array.c"


INTVAL
Parrot_Array_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 359 "src/pmc/array.pmc"
{
    PMC* value;

    value = Parrot_Array_get_pmc_ptr(interpreter, (List*)PMC_data(pmc), key);
    return VTABLE_get_integer(interpreter, value);

}
#line 272 "src/pmc/array.c"


FLOATVAL
Parrot_Array_get_number(Interp* interpreter, PMC* pmc)
#line 331 "src/pmc/array.pmc"
{
    return (FLOATVAL)( VTABLE_elements(interpreter, pmc));

}
#line 282 "src/pmc/array.c"


FLOATVAL
Parrot_Array_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 434 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return 0;
    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) return Parrot_Array_get_number_keyed_int(interpreter, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) box = undef(interpreter);
    return VTABLE_get_number_keyed(interpreter, box, nextkey);

}
#line 303 "src/pmc/array.c"


FLOATVAL
Parrot_Array_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 416 "src/pmc/array.pmc"
{
    PMC* value;

    value = Parrot_Array_get_pmc_ptr(interpreter, (List *) PMC_data(pmc), key);
    return VTABLE_get_number(interpreter, value);


}
#line 317 "src/pmc/array.c"


STRING*
Parrot_Array_get_string(Interp* interpreter, PMC* pmc)
#line 345 "src/pmc/array.pmc"
{
    return Parrot_sprintf_c(interpreter, "array[%p]", pmc);

}
#line 327 "src/pmc/array.c"


STRING*
Parrot_Array_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 476 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return 0;
    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) return Parrot_Array_get_string_keyed_int(interpreter, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) box = undef(interpreter);
    return VTABLE_get_string_keyed(interpreter, box, nextkey);

}
#line 348 "src/pmc/array.c"


STRING*
Parrot_Array_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 459 "src/pmc/array.pmc"
{
    PMC* value;

    value = Parrot_Array_get_pmc_ptr(interpreter, (List *) PMC_data(pmc), key);
    return VTABLE_get_string(interpreter, value);

}
#line 361 "src/pmc/array.c"


INTVAL
Parrot_Array_get_bool(Interp* interpreter, PMC* pmc)
#line 302 "src/pmc/array.pmc"
{
    INTVAL size =  VTABLE_elements(interpreter, pmc);
    return (INTVAL)(size != 0);

}
#line 372 "src/pmc/array.c"


PMC*
Parrot_Array_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 516 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return 0;
    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) return Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) box = undef(interpreter);
    return VTABLE_get_pmc_keyed(interpreter, box, nextkey);

}
#line 393 "src/pmc/array.c"


PMC*
Parrot_Array_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 501 "src/pmc/array.pmc"
{

    return Parrot_Array_get_pmc_ptr(interpreter, (List *)PMC_data(pmc), key);

}
#line 404 "src/pmc/array.c"


PMC*
Parrot_Array_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL f)
#line 1192 "src/pmc/array.pmc"
{
    switch (f) {
        case 0:
            {
                PMC *iter = pmc_new_init(interpreter,
                        enum_class_Iterator, pmc);
                PMC_struct_val(iter) = key;
                return iter;
            }
    }
    real_exception(interpreter, NULL, E_TypeError,
        "Array: Unknown slice type");
    return NULL;

}
#line 425 "src/pmc/array.c"


void
Parrot_Array_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 541 "src/pmc/array.pmc"
{
    list_set_length(interpreter, (List *) PMC_data(pmc) ,size);

}
#line 435 "src/pmc/array.c"


void
Parrot_Array_set_integer_same(Interp* interpreter, PMC* pmc, PMC* value)
#line 555 "src/pmc/array.pmc"
{
    INTVAL size = VTABLE_elements(interpreter, value);
    list_set_length(interpreter, (List *) PMC_data(pmc) ,size);

}
#line 446 "src/pmc/array.c"


void
Parrot_Array_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
#line 587 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return;

    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
         VTABLE_set_integer_keyed_int(interpreter, pmc, ix, value);
        return;
    }
    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) {
        /* autovivify an Array */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_integer_keyed(interpreter, box, nextkey, value);

}
#line 473 "src/pmc/array.c"


void
Parrot_Array_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 570 "src/pmc/array.pmc"
{
    PMC * ptr;

    ptr = Parrot_Array_set_pmc_ptr(interpreter, (List *) PMC_data(pmc), key);
    VTABLE_set_integer_native(interpreter, ptr, value);

}
#line 486 "src/pmc/array.c"


void
Parrot_Array_set_number_keyed(Interp* interpreter, PMC* pmc, PMC* key, FLOATVAL value)
#line 635 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return;
        ix = key_integer(interpreter, key);
        nextkey = key_next(interpreter, key);
        if (nextkey == NULL) {
        Parrot_Array_set_number_keyed_int(interpreter, pmc, ix, value);
        return;
    }
    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) {
        /* autovivify an Array */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_number_keyed(interpreter, box, nextkey, value);

}
#line 512 "src/pmc/array.c"


void
Parrot_Array_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 618 "src/pmc/array.pmc"
{
    PMC* ptr;

    ptr = Parrot_Array_set_pmc_ptr(interpreter, (List *) PMC_data(pmc), key);
    VTABLE_set_number_native(interpreter, ptr, value);

}
#line 525 "src/pmc/array.c"


void
Parrot_Array_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
#line 682 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    if (!key) return;
    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
        VTABLE_set_string_keyed_int(interpreter, pmc, ix, value);
        return;
    }
    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) {
        /* autovivify an Array */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_string_keyed(interpreter, box, nextkey, value);

}
#line 551 "src/pmc/array.c"


void
Parrot_Array_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 665 "src/pmc/array.pmc"
{
    PMC* ptr;

    ptr = Parrot_Array_set_pmc_ptr(interpreter, (List *) PMC_data(pmc), key);
    VTABLE_set_string_native(interpreter, ptr, value);

}
#line 564 "src/pmc/array.c"


void
Parrot_Array_set_pmc(Interp* interpreter, PMC* pmc, PMC *other)
#line 241 "src/pmc/array.pmc"
{
     VTABLE_assign_pmc(interpreter, pmc, other);

}
#line 574 "src/pmc/array.c"


void
Parrot_Array_assign_pmc(Interp* interpreter, PMC* pmc, PMC *other)
#line 218 "src/pmc/array.pmc"
{
    INTVAL size;
    INTVAL i;

    size = VTABLE_elements(interpreter,other);
     VTABLE_set_integer_native(interpreter, pmc, size);
    for(i = 0; i < size; i++) {
        PMC* elem = VTABLE_get_pmc_keyed_int(interpreter, other, i);
         VTABLE_set_pmc_keyed_int(interpreter, pmc, i, elem);
    }

}
#line 592 "src/pmc/array.c"


void
Parrot_Array_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* value)
#line 734 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
        VTABLE_set_pmc_keyed_int(interpreter, pmc, ix, value);
        return;
    }
    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL) {
        /* autovivify an Array */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_pmc_keyed(interpreter, box, nextkey, value);

}
#line 617 "src/pmc/array.c"


void
Parrot_Array_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx, PMC* src)
#line 712 "src/pmc/array.pmc"
{
    INTVAL length;
    length = ((List *) PMC_data(pmc))->length;
    if (idx >= length || -idx > length) {
        real_exception(interpreter, NULL, E_IndexError,
            "Array index out of bounds!");
    }

    list_assign(interpreter, (List *) PMC_data(pmc), idx,
        (void*)src, enum_type_PMC);

}
#line 635 "src/pmc/array.c"


INTVAL
Parrot_Array_elements(Interp* interpreter, PMC* pmc)
#line 317 "src/pmc/array.pmc"
{
    return ((List *) PMC_data(pmc))->length;

}
#line 645 "src/pmc/array.c"


INTVAL
Parrot_Array_pop_integer(Interp* interpreter, PMC* pmc)
#line 893 "src/pmc/array.pmc"
{
    PMC *ptr = Parrot_Array_pop_pmc_ptr(interpreter, (List*) PMC_data(pmc));
    return VTABLE_get_integer(interpreter, ptr);

}
#line 656 "src/pmc/array.c"


FLOATVAL
Parrot_Array_pop_float(Interp* interpreter, PMC* pmc)
#line 908 "src/pmc/array.pmc"
{
    PMC *ptr = Parrot_Array_pop_pmc_ptr(interpreter, (List*) PMC_data(pmc));
    return VTABLE_get_number(interpreter, ptr);

}
#line 667 "src/pmc/array.c"


STRING*
Parrot_Array_pop_string(Interp* interpreter, PMC* pmc)
#line 923 "src/pmc/array.pmc"
{
    PMC *ptr = Parrot_Array_pop_pmc_ptr(interpreter, (List*) PMC_data(pmc));
    return VTABLE_get_string(interpreter, ptr);

}
#line 678 "src/pmc/array.c"


PMC*
Parrot_Array_pop_pmc(Interp* interpreter, PMC* pmc)
#line 938 "src/pmc/array.pmc"
{
    return Parrot_Array_pop_pmc_ptr(interpreter, (List*) PMC_data(pmc));

}
#line 688 "src/pmc/array.c"


void
Parrot_Array_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 764 "src/pmc/array.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_integer_keyed_int(interpreter, pmc, nextix, value);

}
#line 699 "src/pmc/array.c"


void
Parrot_Array_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 780 "src/pmc/array.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_number_keyed_int(interpreter, pmc, nextix, value);

}
#line 710 "src/pmc/array.c"


void
Parrot_Array_push_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 796 "src/pmc/array.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_string_keyed_int(interpreter, pmc, nextix, value);

}
#line 721 "src/pmc/array.c"


void
Parrot_Array_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 812 "src/pmc/array.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, nextix, value);

}
#line 732 "src/pmc/array.c"


INTVAL
Parrot_Array_shift_integer(Interp* interpreter, PMC* pmc)
#line 952 "src/pmc/array.pmc"
{
    PMC *ptr = Parrot_Array_shift_pmc_ptr(interpreter, (List*) PMC_data(pmc));
    return VTABLE_get_integer(interpreter, ptr);

}
#line 743 "src/pmc/array.c"


FLOATVAL
Parrot_Array_shift_float(Interp* interpreter, PMC* pmc)
#line 967 "src/pmc/array.pmc"
{
    PMC *ptr = Parrot_Array_shift_pmc_ptr(interpreter, (List*) PMC_data(pmc));
    return VTABLE_get_number(interpreter, ptr);

}
#line 754 "src/pmc/array.c"


STRING*
Parrot_Array_shift_string(Interp* interpreter, PMC* pmc)
#line 982 "src/pmc/array.pmc"
{
    PMC *ptr = Parrot_Array_shift_pmc_ptr(interpreter, (List*) PMC_data(pmc));
    return VTABLE_get_string(interpreter, ptr);

}
#line 765 "src/pmc/array.c"


PMC*
Parrot_Array_shift_pmc(Interp* interpreter, PMC* pmc)
#line 997 "src/pmc/array.pmc"
{
    return Parrot_Array_shift_pmc_ptr(interpreter, (List*) PMC_data(pmc));

}
#line 775 "src/pmc/array.c"


void
Parrot_Array_unshift_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 828 "src/pmc/array.pmc"
{
    PMC * val = undef(interpreter);
    list_unshift(interpreter, (List*)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_integer_native(interpreter, val, value);

}
#line 787 "src/pmc/array.c"


void
Parrot_Array_unshift_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 845 "src/pmc/array.pmc"
{
    PMC * val = undef(interpreter);
    list_unshift(interpreter, (List*)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_number_native(interpreter, val, value);

}
#line 799 "src/pmc/array.c"


void
Parrot_Array_unshift_string(Interp* interpreter, PMC* pmc, STRING *value)
#line 862 "src/pmc/array.pmc"
{
    PMC * val = undef(interpreter);
    list_unshift(interpreter, (List*)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_string_native(interpreter, val, value);

}
#line 811 "src/pmc/array.c"


void
Parrot_Array_unshift_pmc(Interp* interpreter, PMC* pmc, PMC *value)
#line 879 "src/pmc/array.pmc"
{
    list_unshift(interpreter, (List*)PMC_data(pmc), value, enum_type_PMC);

}
#line 821 "src/pmc/array.c"


void
Parrot_Array_splice(Interp* interpreter, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
#line 1015 "src/pmc/array.pmc"
{
    if (pmc->vtable->base_type != value->vtable->base_type)
        real_exception(interpreter, NULL, E_TypeError,
            "Type mismatch in splice");
    list_splice(interpreter, (List*) PMC_data(pmc),
        (List *) PMC_data(value), offset, count);

}
#line 835 "src/pmc/array.c"


INTVAL
Parrot_Array_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 1156 "src/pmc/array.pmc"
{
    INTVAL j, n;

    if (value->vtable->base_type != enum_class_Array)
        return 0;
    n = Parrot_Array_elements(interpreter, pmc);
    if (VTABLE_elements(interpreter, value) != n)
        return 0;
    for (j = 0; j < n; ++j) {
        PMC *item1, *item2;
        item1 = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, j);
        item2 = VTABLE_get_pmc_keyed_int(interpreter, value, j);
        if (item1 == item2)
            continue;
        if (!mmd_dispatch_i_pp(interpreter, item1, item2, MMD_EQ))
            return 0;
    }
    return 1;

}
#line 861 "src/pmc/array.c"


INTVAL
Parrot_Array_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 1101 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL)
    return Parrot_Array_exists_keyed_int(interpreter, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL)
    return 0;
    return VTABLE_exists_keyed(interpreter, box, nextkey);

}
#line 883 "src/pmc/array.c"


INTVAL
Parrot_Array_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 1082 "src/pmc/array.pmc"
{
    void * ret;

    ret = list_get(interpreter, (List *) PMC_data(pmc), key, enum_type_PMC);
    if (ret == 0 || ret == (void *) -1)
        return 0;
    return *(PMC**) ret != NULL;

}
#line 898 "src/pmc/array.c"


INTVAL
Parrot_Array_defined_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 1056 "src/pmc/array.pmc"
{
    INTVAL ix;
    PMC* nextkey;
    PMC* box;

    ix = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL)
    return Parrot_Array_defined_keyed_int(interpreter, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interpreter, pmc, ix);
    if (box == NULL)
    return 0;
    return VTABLE_defined_keyed(interpreter, box, nextkey);

}
#line 920 "src/pmc/array.c"


INTVAL
Parrot_Array_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 1033 "src/pmc/array.pmc"
{
    PMC* value;
    void *ret;

    ret = list_get(interpreter, (List *) PMC_data(pmc), key, enum_type_PMC);
    if (ret == 0 || ret == (void *) -1)
        return 0;
    value = *(PMC**) ret;
    if (!value)
        return 0;
    return VTABLE_defined(interpreter, value);

}
#line 939 "src/pmc/array.c"


void
Parrot_Array_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 1141 "src/pmc/array.pmc"
{
    INTVAL ix = key_integer(interpreter, key);
    list_splice(interpreter, (List *) PMC_data(pmc), NULL, ix, 1);

}
#line 950 "src/pmc/array.c"


void
Parrot_Array_delete_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 1127 "src/pmc/array.pmc"
{
    list_splice(interpreter, (List *) PMC_data(pmc), NULL, key, 1);

}
#line 960 "src/pmc/array.c"


PMC*
Parrot_Array_get_iter(Interp* interpreter, PMC* pmc)
#line 1207 "src/pmc/array.pmc"
{
    PMC *iter = pmc_new_init(interpreter, enum_class_Iterator, pmc);
    PMC *key =  pmc_new(interpreter, enum_class_Key);
    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;
    PMC_int_val(key) = 0;
    if (!((List *) PMC_data(pmc))->length)
        PMC_int_val(key) = -1;
    return iter;

}
#line 977 "src/pmc/array.c"


void
Parrot_Array_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1245 "src/pmc/array.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_freeze(interpreter, pmc, info);
     VTABLE_push_integer(interpreter, io, VTABLE_elements(interpreter, pmc));

}
#line 989 "src/pmc/array.c"


void
Parrot_Array_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1261 "src/pmc/array.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
         VTABLE_set_integer_native(interpreter, pmc,  VTABLE_shift_integer(interpreter, io));
    
}
#line 1002 "src/pmc/array.c"


void
Parrot_Array_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1230 "src/pmc/array.pmc"
{
    list_visit(interpreter, (List *) PMC_data(pmc), info);
    Parrot_default_visit(interpreter, pmc, info);

}
#line 1013 "src/pmc/array.c"


void
Parrot_Array_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Array,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Array_init,
        Parrot_Array_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Array_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Array_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Array_get_integer,
        Parrot_Array_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_number,
        Parrot_Array_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_string,
        Parrot_default_get_repr,
        Parrot_Array_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Array_get_bool,
        Parrot_default_get_pmc,
        Parrot_Array_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Array_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Array_set_integer_native,
        Parrot_Array_set_integer_same,
        Parrot_Array_set_integer_keyed,
        Parrot_Array_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Array_set_number_keyed,
        Parrot_Array_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_Array_set_string_keyed,
        Parrot_Array_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_Array_set_pmc,
        Parrot_Array_assign_pmc,
        Parrot_Array_set_pmc_keyed,
        Parrot_Array_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Array_elements,
        Parrot_Array_pop_integer,
        Parrot_Array_pop_float,
        Parrot_Array_pop_string,
        Parrot_Array_pop_pmc,
        Parrot_Array_push_integer,
        Parrot_Array_push_float,
        Parrot_Array_push_string,
        Parrot_Array_push_pmc,
        Parrot_Array_shift_integer,
        Parrot_Array_shift_float,
        Parrot_Array_shift_string,
        Parrot_Array_shift_pmc,
        Parrot_Array_unshift_integer,
        Parrot_Array_unshift_float,
        Parrot_Array_unshift_string,
        Parrot_Array_unshift_pmc,
        Parrot_Array_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_delete_keyed,
        Parrot_Array_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Array_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Array_freeze,
        Parrot_Array_thaw,
        Parrot_default_thawfinish,
        Parrot_Array_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Array_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Array");
        vt_clone->isa_str = CONST_STRING(interp, "Array");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    {
        /* class_init_code */
        make_bufferlike_pool(interp, sizeof(List_chunk));
        make_bufferlike_pool(interp, sizeof(List));
    }
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_Array_class_init */


/*

=back

=head1 SEE ALSO

F<src/list.c>, F<include/parrot/list.h>

=head1 TODO

Create global immutable undef object.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
