/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/bigint.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/bigint.pmc"
/*
Copyright: 2004 The Perl Foundation.  All Rights Reserved.
$Id: bigint.pmc 12434 2006-04-26 13:27:42Z particle $

=head1 NAME

src/pmc/bigint.pmc - BigInt PMC class

=head1 DESCRIPTION

C<BigInt> provides arbitrary precision integer mathematic functions.

=head2 Functions

=over 4

=item C<static void bigint_set_long(Interp*, PMC*, long value)>

=item C<static void bigint_set_double(Interp*, PMC*, double value)>

=cut

*/

#include "parrot/parrot.h"

/*
 * TODO split that out into a separate file
 */

#ifdef PARROT_HAS_GMP
#include <gmp.h>
typedef struct {
    mpz_t b;
} BIGINT;

#define BN(x) ((BIGINT*)PMC_struct_val(x))->b

static void
bigint_init(Interp *interpreter, PMC *self) {
    PMC_struct_val(self) = malloc(sizeof(BIGINT));
    mpz_init(BN(self));
}
static void
bigint_clear(Interp *interpreter, PMC *self) {
    mpz_clear(BN(self));
}

static void
bigint_set(Interp *interpreter, PMC *dest, PMC *src) {
    mpz_set(BN(dest), BN(src));
}

static void
bigint_set_long(Interp *interpreter, PMC *self, long value) {
    mpz_set_si(BN(self), value);
}

static void
bigint_set_double(Interp *interpreter, PMC *self, double value) {
    mpz_set_d(BN(self), value);
}

static void
bigint_set_str(Interp *interpreter, PMC *self, char* value, int base) {
    mpz_set_str(BN(self), value, base);
}

static BIGNUM*
bigint_get_self(Interp *interpreter, PMC *self) {
    return PMC_struct_val(self);
}

static void
bigint_set_self(Interp *interpreter, PMC *self, BIGNUM *value) {
    mpz_set(BN(self), value);
}

static long
bigint_get_long(Interp *interpreter, PMC *self) {
    if (mpz_fits_slong_p(BN(self)))
        return mpz_get_si(BN(self));
    real_exception(interpreter, NULL, 1, "bigint_get_long: number too big");
    return 0;
}

static int
bigint_get_bool(Interp *interpreter, PMC *self) {
    if (mpz_sgn(BN(self)) != 0) {
        return 1;
    }
    else {
        return 0;
    }
}
static char *
bigint_get_string(Interp *interpreter, PMC *self, int base) {
    size_t n = mpz_sizeinbase(BN(self), base) + 2;
    char *s = mem_sys_allocate(n);
    return mpz_get_str(s, base, BN(self));
}

static double
bigint_get_double(Interp *interpreter, PMC *self) {
    return mpz_get_d( BN(self));
}

static void
bigint_add_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    mpz_add(BN(dest), BN(self), BN(value));
}

static void
bigint_add_bigint_int(Interp *interpreter, PMC* self, INTVAL value,
        PMC *dest)
{
    int n = value < 0;
    if (n) {
        mpz_sub_ui(BN(dest), BN(self), -value);
    }
    else
        mpz_add_ui(BN(dest), BN(self), value);
}
static void
bigint_sub_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    mpz_sub(BN(dest), BN(self), BN(value));
}

static void
bigint_sub_bigint_int(Interp *interpreter, PMC* self, INTVAL value,
        PMC *dest)
{
    int n = value < 0;
    if (n) 
        mpz_add_ui(BN(dest), BN(self), -value);
    else
        mpz_sub_ui(BN(dest), BN(self), value);
}
static void
bigint_mul_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    mpz_mul(BN(dest), BN(self), BN(value));
}

static void
bigint_mul_bigint_int(Interp *interpreter, PMC* self, INTVAL value,
        PMC *dest)
{
    mpz_mul_si(BN(dest), BN(self), value);
}

static void
int_check_divide_zero(Interp *interpreter, INTVAL value)
{
    if (value == 0) {
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                       "Divide by zero");
    }
}

static void
bigint_check_divide_zero(Interp *interpreter, PMC *value)
{
    /* Throw an exception if we are dividing by zero. */
    if (mpz_cmp_si(BN(value), 0) == 0) {
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                       "Divide by zero");
    }
}

static void
bigint_div_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    bigint_check_divide_zero(interpreter, value);
    /* this is mpz_fdiv_q */
    mpz_div(BN(dest), BN(self), BN(value));
}
static void
bigint_div_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    int n;
    int_check_divide_zero(interpreter, value);
    /* this is mpz_fdiv_q */
    n = value < 0;
    if (n) {
        mpz_div_ui(BN(dest), BN(self), -value);
        mpz_neg(BN(dest), BN(dest));
    }
    else
        mpz_div_ui(BN(dest), BN(self), value);
}
static void
bigint_fdiv_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    bigint_check_divide_zero(interpreter, value);
    mpz_fdiv_q(BN(dest), BN(self), BN(value));
}
static void
bigint_fdiv_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    int n;
    int_check_divide_zero(interpreter, value);
    n = value < 0;
    if (n) {
        mpz_fdiv_q_ui(BN(dest), BN(self), -value);
        mpz_neg(BN(dest), BN(dest));
    }
    else
        mpz_fdiv_q_ui(BN(dest), BN(self), value);
}

static void
bigint_mod_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    bigint_check_divide_zero(interpreter, value);
    mpz_mod(BN(dest), BN(self), BN(value));
}

static void
bigint_mod_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    int n;
    int_check_divide_zero(interpreter, value);
    n = value < 0;
    if (n) {
        mpz_mod_ui(BN(dest), BN(self), -value);
    }
    else
        mpz_mod_ui(BN(dest), BN(self), value);
}
static INTVAL
bigint_cmp(Interp *interpreter, PMC* self, PMC *value)
{
    return mpz_cmp(BN(self), BN(value));
}

static INTVAL
bigint_cmp_int(Interp *interpreter, PMC* self, INTVAL value)
{
    return mpz_cmp_si(BN(self), value);
}

static void
bigint_abs(Interp *interpreter, PMC* self, PMC *dest)
{
    VTABLE_morph(interpreter, dest, enum_class_BigInt);
    mpz_abs(BN(dest), BN(self));
}

static void
bigint_neg(Interp *interpreter, PMC* self, PMC *dest)
{
    VTABLE_morph(interpreter, dest, enum_class_BigInt);
    mpz_neg(BN(dest), BN(self));
}

static void
bigint_bitwise_shl_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    mpz_mul_2exp(BN(dest), BN(self), value);
}
static void
bigint_bitwise_shr_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    mpz_tdiv_q_2exp(BN(dest), BN(self), value);
}

#else /* ifdef PARROT_HAS_GMP */

static void
bigint_init(Interp *interpreter, PMC *self) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_clear(Interp *interpreter, PMC *self) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_long(Interp *interpreter, PMC *self, long value) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set(Interp *interpreter, PMC *dest, PMC *src) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_double(Interp *interpreter, PMC *self, double value) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_str(Interp *interpreter, PMC *self, char* value, int base) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_self(Interp *interpreter, PMC *self, BIGNUM *value) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static BIGNUM*
bigint_get_self(Interp *interpreter, PMC *self) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return NULL;
}

static char *
bigint_get_string(Interp *interpreter, PMC *self, int base) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return NULL;
}

static long
bigint_get_long(Interp *interpreter, PMC *self) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0L;
}
static long
bigint_get_bool(Interp *interpreter, PMC *self) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0L;
}
static double
bigint_get_double(Interp *interpreter, PMC *self) {
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0.0;
}
static void
bigint_add_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_add_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_sub_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_sub_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mul_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mul_bigint_int(Interp *interpreter, PMC* self, INTVAL value,
        PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_div_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_div_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_fdiv_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_fdiv_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mod_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mod_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static INTVAL
bigint_cmp(Interp *interpreter, PMC* self, PMC *value)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0;
}
static INTVAL
bigint_cmp_int(Interp *interpreter, PMC* self, INTVAL value)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0;
}
static void
bigint_abs(Interp *interpreter, PMC* self, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_neg(Interp *interpreter, PMC* self, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_bitwise_shl_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_bitwise_shl_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint(Interp *interpreter, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_bitwise_shr_bigint_int(Interp *interpreter, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interpreter, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
#endif /* ifdef PARROT_HAS_GMP */

#line 477 "src/pmc/bigint.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_bigint.h"
#include "pmc_default.h"
#include "bigint.str"

void
Parrot_BigInt_init(Interp* interpreter, PMC* pmc)
#line 507 "src/pmc/bigint.pmc"
{
    bigint_init(interpreter, pmc);
    PObj_active_destroy_SET(pmc);

}
#line 493 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_instantiate(Interp* interpreter, PMC* pmc, PMC* sig)
#line 483 "src/pmc/bigint.pmc"
{
    int argcP = REG_INT(3);
    int base;
    PMC *res;
    STRING *num;

    return PMCNULL;  /* TODO */

    res = pmc_new(interpreter, enum_class_BigInt);
    if (!argcP) {
        return res;
    }
    base = 10;
    if (argcP == 2)
        base = VTABLE_get_integer(interpreter, REG_PMC(6));
    num = VTABLE_get_string(interpreter, REG_PMC(5));
    VTABLE_set_string_keyed_int(interpreter, res, base, num);
    return res;

}
#line 519 "src/pmc/bigint.c"


void
Parrot_BigInt_morph(Interp* interpreter, PMC* pmc, INTVAL new_type)
#line 503 "src/pmc/bigint.pmc"
{
    pmc_reuse(interpreter, pmc, new_type, 0);

}
#line 529 "src/pmc/bigint.c"


void
Parrot_BigInt_destroy(Interp* interpreter, PMC* pmc)
#line 519 "src/pmc/bigint.pmc"
{
    bigint_clear(interpreter, pmc);
    mem_sys_free(PMC_struct_val(pmc));

}
#line 540 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_clone(Interp* interpreter, PMC* pmc)
#line 512 "src/pmc/bigint.pmc"
{
    PMC *res;
    res = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_set(interpreter, res, pmc);
    return res;

}
#line 553 "src/pmc/bigint.c"


INTVAL
Parrot_BigInt_get_integer(Interp* interpreter, PMC* pmc)
#line 614 "src/pmc/bigint.pmc"
{
    return bigint_get_long(interpreter, pmc);

}
#line 563 "src/pmc/bigint.c"


FLOATVAL
Parrot_BigInt_get_number(Interp* interpreter, PMC* pmc)
#line 600 "src/pmc/bigint.pmc"
{
    return bigint_get_double(interpreter, pmc);

}
#line 573 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_get_bignum(Interp* interpreter, PMC* pmc)
#line 628 "src/pmc/bigint.pmc"
{
    return pmc;

}
#line 583 "src/pmc/bigint.c"


STRING*
Parrot_BigInt_get_string(Interp* interpreter, PMC* pmc)
#line 665 "src/pmc/bigint.pmc"
{
    char *s = bigint_get_string(interpreter, pmc, 10);
    STRING *ps = string_from_cstring(interpreter, s, 0);
    mem_sys_free(s);
    return ps;

}
#line 596 "src/pmc/bigint.c"


STRING*
Parrot_BigInt_get_repr(Interp* interpreter, PMC* pmc)
#line 678 "src/pmc/bigint.pmc"
{
    STRING *s = Parrot_BigInt_get_string(interpreter, pmc);
    return string_append(interpreter, s, const_string(interpreter, "L"), 0);

}
#line 607 "src/pmc/bigint.c"


STRING*
Parrot_BigInt_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL base)
#line 672 "src/pmc/bigint.pmc"
{
    char *s = bigint_get_string(interpreter, pmc, base);
    STRING *ps = string_from_cstring(interpreter, s, 0);
    mem_sys_free(s);
    return ps;

}
#line 620 "src/pmc/bigint.c"


INTVAL
Parrot_BigInt_get_bool(Interp* interpreter, PMC* pmc)
#line 642 "src/pmc/bigint.pmc"
{
    return bigint_get_bool(interpreter, pmc);

}
#line 630 "src/pmc/bigint.c"


void
Parrot_BigInt_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
#line 532 "src/pmc/bigint.pmc"
{
    bigint_set_long(interpreter, pmc, (long)value);

}
#line 640 "src/pmc/bigint.c"


void
Parrot_BigInt_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 546 "src/pmc/bigint.pmc"
{
    bigint_set_double(interpreter, pmc, (double)value);

}
#line 650 "src/pmc/bigint.c"


void
Parrot_BigInt_set_string_native(Interp* interpreter, PMC* pmc, STRING* value)
#line 565 "src/pmc/bigint.pmc"
{
    char *s = string_to_cstring(interpreter, value);
    bigint_set_str(interpreter, pmc, s, 10);
    string_cstring_free(s);

}
#line 662 "src/pmc/bigint.c"


void
Parrot_BigInt_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL base, STRING* value)
#line 571 "src/pmc/bigint.pmc"
{
    char *s = string_to_cstring(interpreter, value);
    bigint_set_str(interpreter, pmc, s, base);
    string_cstring_free(s);

}
#line 674 "src/pmc/bigint.c"


void
Parrot_BigInt_set_pmc(Interp* interpreter, PMC* pmc, PMC *value)
#line 586 "src/pmc/bigint.pmc"
{
    bigint_set_self(interpreter, pmc, bigint_get_self(interpreter, value));

}
#line 684 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_add(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 710 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp add");
            return dest;
         
}
#line 695 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_add_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            bigint_add_bigint(interpreter, pmc, value, dest);
            return dest;
        
}PMC*
Parrot_BigInt_add_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            bigint_add_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
            return dest;
        
}

PMC*
Parrot_BigInt_add_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 733 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_add_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 730 "src/pmc/bigint.c"


void
Parrot_BigInt_i_add(Interp* interpreter, PMC* pmc, PMC* value)
#line 742 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp add");
         
}
#line 740 "src/pmc/bigint.c"
void
Parrot_BigInt_i_add_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_add_bigint(interpreter, pmc, value, pmc);
        
}void
Parrot_BigInt_i_add_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_add_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

void
Parrot_BigInt_i_add_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 754 "src/pmc/bigint.pmc"
{
    bigint_add_bigint_int(interpreter, pmc, value, pmc);

}
#line 760 "src/pmc/bigint.c"


void
Parrot_BigInt_i_add_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 758 "src/pmc/bigint.pmc"
{
    real_exception(interpreter, NULL, E_NotImplementedError, "unimp add");

}
#line 770 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_subtract(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 763 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp sub");
            return dest;
         
}
#line 781 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_subtract_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            bigint_sub_bigint(interpreter, pmc, value, dest);
            return dest;
        
}PMC*
Parrot_BigInt_subtract_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            bigint_sub_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
            return dest;
        
}

PMC*
Parrot_BigInt_subtract_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 786 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_sub_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 816 "src/pmc/bigint.c"


void
Parrot_BigInt_i_subtract(Interp* interpreter, PMC* pmc, PMC* value)
#line 795 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp sub");
         
}
#line 826 "src/pmc/bigint.c"
void
Parrot_BigInt_i_subtract_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_sub_bigint(interpreter, pmc, value, pmc);
        
}void
Parrot_BigInt_i_subtract_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_sub_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

void
Parrot_BigInt_i_subtract_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 807 "src/pmc/bigint.pmc"
{
    bigint_sub_bigint_int(interpreter, pmc, value, pmc);

}
#line 846 "src/pmc/bigint.c"


void
Parrot_BigInt_i_subtract_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 811 "src/pmc/bigint.pmc"
{
    real_exception(interpreter, NULL, E_NotImplementedError, "unimp sub");

}
#line 856 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_multiply(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 816 "src/pmc/bigint.pmc"
{
         real_exception(interpreter, NULL, E_NotImplementedError, "unimp mul");
        return dest;
     
}
#line 867 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_multiply_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_mul_bigint(interpreter, pmc, value, dest);
        return dest;
    
}PMC*
Parrot_BigInt_multiply_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_mul_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
        return dest;
     
}

PMC*
Parrot_BigInt_multiply_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 839 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_mul_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 902 "src/pmc/bigint.c"


void
Parrot_BigInt_i_multiply(Interp* interpreter, PMC* pmc, PMC* value)
#line 848 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp mul");
         
}
#line 912 "src/pmc/bigint.c"
void
Parrot_BigInt_i_multiply_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_mul_bigint(interpreter, pmc, value, pmc);
        
}void
Parrot_BigInt_i_multiply_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_mul_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

void
Parrot_BigInt_i_multiply_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 860 "src/pmc/bigint.pmc"
{
    bigint_mul_bigint_int(interpreter, pmc, value, pmc);

}
#line 932 "src/pmc/bigint.c"


void
Parrot_BigInt_i_multiply_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 864 "src/pmc/bigint.pmc"
{
    real_exception(interpreter, NULL, E_NotImplementedError, "unimp mul");

}
#line 942 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_divide(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 868 "src/pmc/bigint.pmc"
{
        real_exception(interpreter, NULL, E_NotImplementedError, "unimp div");
        return dest;
     
}
#line 953 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_div_bigint(interpreter, pmc, value, dest);
#if 0
        /* to downgrade or not that's the question */
        if (mpz_fits_slong_p(BN(dest))) {
            long iresult = mpz_get_si(BN(dest));
            VTABLE_morph(interpreter, dest, enum_class_Integer);
            VTABLE_set_integer_native(interpreter, dest, iresult);
        }
#endif
        return dest;
    
}PMC*
Parrot_BigInt_divide_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_div_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
        return dest;
    
}

PMC*
Parrot_BigInt_divide_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 899 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_div_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 996 "src/pmc/bigint.c"


void
Parrot_BigInt_i_divide(Interp* interpreter, PMC* pmc, PMC* value)
#line 908 "src/pmc/bigint.pmc"
{
         real_exception(interpreter, NULL, E_NotImplementedError, "unimp fdiv");
    
}
#line 1006 "src/pmc/bigint.c"
void
Parrot_BigInt_i_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
        bigint_div_bigint(interpreter, pmc, value, pmc);
    
}void
Parrot_BigInt_i_divide_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
        bigint_div_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
    
}

void
Parrot_BigInt_i_divide_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 920 "src/pmc/bigint.pmc"
{
    bigint_div_bigint_int(interpreter, pmc, value, pmc);

}
#line 1026 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_floor_divide(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 924 "src/pmc/bigint.pmc"
{
        real_exception(interpreter, NULL, E_NotImplementedError, "unimp fdiv");
        return dest;
    
}
#line 1037 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_floor_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_fdiv_bigint(interpreter, pmc, value, dest);
        return dest;
    
}PMC*
Parrot_BigInt_floor_divide_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_fdiv_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
        return dest;
    
}

PMC*
Parrot_BigInt_floor_divide_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 947 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_fdiv_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 1072 "src/pmc/bigint.c"


void
Parrot_BigInt_i_floor_divide(Interp* interpreter, PMC* pmc, PMC* value)
#line 956 "src/pmc/bigint.pmc"
{
        real_exception(interpreter, NULL, E_NotImplementedError, "unimp fdiv");
    
}
#line 1082 "src/pmc/bigint.c"
void
Parrot_BigInt_i_floor_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
        bigint_fdiv_bigint(interpreter, pmc, value, pmc);
    
}void
Parrot_BigInt_i_floor_divide_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
        bigint_fdiv_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
    
}

void
Parrot_BigInt_i_floor_divide_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 968 "src/pmc/bigint.pmc"
{
    bigint_fdiv_bigint_int(interpreter, pmc, value, pmc);

}
#line 1102 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_modulus(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 972 "src/pmc/bigint.pmc"
{
        real_exception(interpreter, NULL, E_NotImplementedError, "unimp mod");
        return dest;
    
}
#line 1113 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_modulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_mod_bigint(interpreter, pmc, value, dest);
        return dest;
    
}PMC*
Parrot_BigInt_modulus_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_mod_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
        return dest;
     
}

void
Parrot_BigInt_i_modulus(Interp* interpreter, PMC* pmc, PMC* value)
#line 1007 "src/pmc/bigint.pmc"
{
             real_exception(interpreter, NULL, E_NotImplementedError, "unimp mod");
         
}
#line 1143 "src/pmc/bigint.c"
void
Parrot_BigInt_i_modulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_mod_bigint(interpreter, pmc, value, pmc);
        
}void
Parrot_BigInt_i_modulus_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_mod_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

PMC*
Parrot_BigInt_cmodulus(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 995 "src/pmc/bigint.pmc"
{
            return Parrot_BigInt_modulus(interpreter, pmc, value, dest);
         
}
#line 1163 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_cmodulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            return Parrot_BigInt_modulus_BigInt(interpreter, pmc, value, dest);
        
}PMC*
Parrot_BigInt_cmodulus_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            return Parrot_BigInt_modulus_Integer(interpreter, pmc, value, dest);
         
}

void
Parrot_BigInt_i_cmodulus(Interp* interpreter, PMC* pmc, PMC* value)
#line 1019 "src/pmc/bigint.pmc"
{
             real_exception(interpreter, NULL, E_NotImplementedError, "unimp cmod");
         
}
#line 1183 "src/pmc/bigint.c"
void
Parrot_BigInt_i_cmodulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_mod_bigint(interpreter, pmc, value, pmc);
        
}void
Parrot_BigInt_i_cmodulus_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_mod_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

void
Parrot_BigInt_increment(Interp* interpreter, PMC* pmc)
#line 692 "src/pmc/bigint.pmc"
{
    bigint_add_bigint_int(interpreter, pmc, 1, pmc);

}
#line 1203 "src/pmc/bigint.c"


void
Parrot_BigInt_decrement(Interp* interpreter, PMC* pmc)
#line 706 "src/pmc/bigint.pmc"
{
    bigint_sub_bigint_int(interpreter, pmc, 1, pmc);

}
#line 1213 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_absolute(Interp* interpreter, PMC* pmc, PMC *dest)
#line 1070 "src/pmc/bigint.pmc"
{
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_abs(interpreter, pmc, dest);
    return dest;

}
#line 1226 "src/pmc/bigint.c"


void
Parrot_BigInt_i_absolute(Interp* interpreter, PMC* pmc)
#line 1077 "src/pmc/bigint.pmc"
{
    bigint_abs(interpreter, pmc, pmc);

}
#line 1236 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_neg(Interp* interpreter, PMC* pmc, PMC* dest)
#line 1094 "src/pmc/bigint.pmc"
{
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_neg(interpreter, pmc, dest);
    return dest;

}
#line 1249 "src/pmc/bigint.c"


void
Parrot_BigInt_i_neg(Interp* interpreter, PMC* pmc)
#line 1101 "src/pmc/bigint.pmc"
{
    bigint_neg(interpreter, pmc, pmc);

}
#line 1259 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_bitwise_shl(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 1123 "src/pmc/bigint.pmc"
{
        real_exception(interpreter, NULL, E_NotImplementedError, "unimp shl");
        return dest;
     
}
#line 1270 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_bitwise_shl_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_bitwise_shl_bigint_int(interpreter, pmc, VTABLE_get_integer(interpreter, value), dest);
        return dest;
    
}PMC*
Parrot_BigInt_bitwise_shl_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_bitwise_shl_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
        return dest;
     
}

PMC*
Parrot_BigInt_bitwise_shl_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 1146 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_bitwise_shl_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 1305 "src/pmc/bigint.c"


void
Parrot_BigInt_i_bitwise_shl(Interp* interpreter, PMC* pmc, PMC* value)
#line 1156 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp shl");
         
}
#line 1315 "src/pmc/bigint.c"
void
Parrot_BigInt_i_bitwise_shl_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_bitwise_shl_bigint_int(interpreter, pmc, VTABLE_get_integer(interpreter, value), pmc);
        
}void
Parrot_BigInt_i_bitwise_shl_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_bitwise_shl_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

void
Parrot_BigInt_i_bitwise_shl_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 1168 "src/pmc/bigint.pmc"
{
    bigint_bitwise_shl_bigint_int(interpreter, pmc, value, pmc);

}
#line 1335 "src/pmc/bigint.c"


PMC*
Parrot_BigInt_bitwise_shr(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 1190 "src/pmc/bigint.pmc"
{
        real_exception(interpreter, NULL, E_NotImplementedError, "unimp shr");
        return dest;
     
}
#line 1346 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_bitwise_shr_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_bitwise_shr_bigint_int(interpreter, pmc, VTABLE_get_integer(interpreter, value), dest);
        return dest;
    
}PMC*
Parrot_BigInt_bitwise_shr_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        bigint_bitwise_shr_bigint_int(interpreter, pmc, PMC_int_val(value), dest);
        return dest;
     
}

PMC*
Parrot_BigInt_bitwise_shr_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 1213 "src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interpreter, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    bigint_bitwise_shr_bigint_int(interpreter, pmc, value, dest);
    return dest;

}
#line 1381 "src/pmc/bigint.c"


void
Parrot_BigInt_i_bitwise_shr(Interp* interpreter, PMC* pmc, PMC* value)
#line 1223 "src/pmc/bigint.pmc"
{
            real_exception(interpreter, NULL, E_NotImplementedError, "unimp shr");
         
}
#line 1391 "src/pmc/bigint.c"
void
Parrot_BigInt_i_bitwise_shr_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_bitwise_shr_bigint_int(interpreter, pmc, VTABLE_get_integer(interpreter, value), pmc);
        
}void
Parrot_BigInt_i_bitwise_shr_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
            bigint_bitwise_shr_bigint_int(interpreter, pmc, PMC_int_val(value), pmc);
         
}

void
Parrot_BigInt_i_bitwise_shr_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 1235 "src/pmc/bigint.pmc"
{
    bigint_bitwise_shr_bigint_int(interpreter, pmc, value, pmc);

}
#line 1411 "src/pmc/bigint.c"


INTVAL
Parrot_BigInt_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 1045 "src/pmc/bigint.pmc"
{
             real_exception(interpreter, NULL, E_NotImplementedError, "unimp eq");
             return 0;
         
}
#line 1422 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_is_equal_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
    return bigint_cmp(interpreter, pmc, value) == 0;
        
}INTVAL
Parrot_BigInt_is_equal_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
    return bigint_cmp_int(interpreter, pmc, PMC_int_val(value)) == 0;
        
}

INTVAL
Parrot_BigInt_cmp(Interp* interpreter, PMC* pmc, PMC* value)
#line 1032 "src/pmc/bigint.pmc"
{
             real_exception(interpreter, NULL, E_NotImplementedError, "unimp cmp");
             return 0;
         
}
#line 1443 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_cmp_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
    return bigint_cmp(interpreter, pmc, value);
        
}INTVAL
Parrot_BigInt_cmp_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
    return bigint_cmp_int(interpreter, pmc, PMC_int_val(value));
        
}

void
Parrot_BigInt_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_BigInt,	/* base_type */
        NULL,	/* whoami */
        0, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_BigInt_instantiate,
        Parrot_default_new_from_string,
        Parrot_BigInt_morph,
        Parrot_default_mark,
        Parrot_BigInt_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_BigInt_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_string,
        Parrot_BigInt_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_BigInt_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_BigInt_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_BigInt_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_BigInt_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_BigInt_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_BigInt_increment,
        Parrot_BigInt_decrement,
        Parrot_BigInt_absolute,
        Parrot_BigInt_i_absolute,
        Parrot_BigInt_neg,
        Parrot_BigInt_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_add },
        { MMD_ADD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_add_BigInt },
        { MMD_ADD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_add_Integer },
        { MMD_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_add_int },
        { MMD_I_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_add },
        { MMD_I_ADD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_add_BigInt },
        { MMD_I_ADD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_add_Integer },
        { MMD_I_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_BigInt_i_add_float },
        { MMD_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_subtract },
        { MMD_SUBTRACT, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_subtract_BigInt },
        { MMD_SUBTRACT, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_subtract_Integer },
        { MMD_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_subtract_BigInt },
        { MMD_I_SUBTRACT, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_subtract_Integer },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_BigInt_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_multiply },
        { MMD_MULTIPLY, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_multiply_BigInt },
        { MMD_MULTIPLY, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_multiply_Integer },
        { MMD_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_multiply_BigInt },
        { MMD_I_MULTIPLY, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_multiply_Integer },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_BigInt_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_divide },
        { MMD_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_divide_BigInt },
        { MMD_DIVIDE, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_divide_Integer },
        { MMD_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_divide },
        { MMD_I_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_divide_BigInt },
        { MMD_I_DIVIDE, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_divide_Integer },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_floor_divide_BigInt },
        { MMD_FLOOR_DIVIDE, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_floor_divide_Integer },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_floor_divide_BigInt },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_floor_divide_Integer },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_floor_divide_int },
        { MMD_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_modulus },
        { MMD_MOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_modulus_BigInt },
        { MMD_MOD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_modulus_Integer },
        { MMD_I_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_modulus },
        { MMD_I_MOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_modulus_BigInt },
        { MMD_I_MOD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_modulus_Integer },
        { MMD_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_cmodulus },
        { MMD_CMOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_cmodulus_BigInt },
        { MMD_CMOD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_cmodulus_Integer },
        { MMD_I_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_cmodulus },
        { MMD_I_CMOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_cmodulus_BigInt },
        { MMD_I_CMOD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_cmodulus_Integer },
        { MMD_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_bitwise_shl },
        { MMD_BSL, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_bitwise_shl_BigInt },
        { MMD_BSL, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_bitwise_shl_Integer },
        { MMD_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shl_BigInt },
        { MMD_I_BSL, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shl_Integer },
        { MMD_I_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_bitwise_shr },
        { MMD_BSR, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_bitwise_shr_BigInt },
        { MMD_BSR, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_bitwise_shr_Integer },
        { MMD_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shr_BigInt },
        { MMD_I_BSR, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shr_Integer },
        { MMD_I_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_BigInt_i_bitwise_shr_int },
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_is_equal },
        { MMD_EQ, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_is_equal_BigInt },
        { MMD_EQ, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_is_equal_Integer },
        { MMD_CMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_BigInt_cmp },
        { MMD_CMP, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_BigInt_cmp_BigInt },
        { MMD_CMP, 0, enum_class_Integer,
                    (funcptr_t) Parrot_BigInt_cmp_Integer }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "BigInt");
        vt_clone->isa_str = CONST_STRING(interp, "BigInt");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_BigInt_class_init */


/*

=back
  
=cut

*/
   
/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
 */
