/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/closure.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/closure.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: closure.pmc 11975 2006-03-21 22:23:53Z bernhard $

=head1 NAME

src/pmc/closure.pmc - Closure PMC

=head1 DESCRIPTION

This class implements a closure, i.e. a subroutine which take a context
structure.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 36 "src/pmc/closure.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_closure.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "closure.str"

void
Parrot_Closure_init(Interp* interpreter, PMC* pmc)
#line 36 "src/pmc/closure.pmc"
{
    PMC_struct_val(pmc) = new_closure(interpreter);
    PMC_pmc_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
#if 0
    if (Interp_flags_TEST(interpreter, PARROT_DEBUG_FLAG))
        printf("Address of base segment is %p\n",
                (PMC_sub(pmc))->seg->base.pf->base.data);
#endif

}
#line 59 "src/pmc/closure.c"


void
Parrot_Closure_mark(Interp* interpreter, PMC* pmc)
#line 57 "src/pmc/closure.pmc"
{
    struct Parrot_sub * sub = PMC_sub(pmc);
    Parrot_Sub_mark(interpreter, pmc);
    if (sub->outer_sub)
        pobject_lives(interpreter, (PObj*)sub->outer_sub);
    if (sub->outer_ctx)
        mark_context(interpreter, sub->outer_ctx);

}
#line 74 "src/pmc/closure.c"


void
Parrot_Closure_destroy(Interp* interpreter, PMC* pmc)
#line 198 "src/pmc/closure.pmc"
{
    struct Parrot_sub * sub = PMC_sub(pmc);
#if CTX_LEAK_DEBUG
    if (Interp_debug_TEST(interpreter, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
        fprintf(stderr, "[destroy closure %p, context %p, refs=%d]\n",
    	    pmc, sub->outer_ctx,
    	    (sub->outer_ctx ? sub->outer_ctx->ref_count : 0));
    }
#endif
    if (sub->outer_ctx) {
        Parrot_free_context(interpreter, sub->outer_ctx, 0);
        sub->outer_ctx = NULL;
    }
    Parrot_Sub_destroy(interpreter, pmc);

}
#line 96 "src/pmc/closure.c"


void
Parrot_Closure_set_pointer(Interp* interpreter, PMC* pmc, void* value)
#line 81 "src/pmc/closure.pmc"
{
    struct Parrot_sub * sub = PMC_sub(pmc);
    opcode_t *addr = value;
    sub->start_offs = addr -  sub->seg->base.data;

}
#line 108 "src/pmc/closure.c"


void*
Parrot_Closure_invoke(Interp* interpreter, PMC* pmc, void* next)
#line 87 "src/pmc/closure.pmc"
{
    struct Parrot_sub * sub = PMC_sub(pmc);
    PMC *cont, *outer_sub;

    next = Parrot_Sub_invoke(interpreter, pmc, next);
    outer_sub = sub->outer_sub;
    if (sub->outer_ctx) {
        /* during newclosure, outer's ctx was stored in
         * sub->outer_ctx
         */
        sub->ctx->outer_ctx = sub->outer_ctx;
    }
    else if ((PObj_get_FLAGS(outer_sub) & SUB_FLAG_IS_OUTER) &&
        PMC_sub(outer_sub)->ctx) {
        /* the sub was invoked earlier - it still has the context
         * due to the SUB_FLAG_IS_OUTER flag
         */
        sub->outer_ctx = sub->ctx->outer_ctx = PMC_sub(outer_sub)->ctx;
    }
    else {
        /* closure is just invoked - located :outer's ctx */
        parrot_context_t *caller = sub->ctx->caller_ctx;
        while (caller) {
            if (caller->current_sub == outer_sub) {
                cont = caller->current_cont;
                cont->vtable = interpreter->vtables[enum_class_Continuation];
                sub->outer_ctx = sub->ctx->outer_ctx = caller;
                caller->ref_count++;
                return next;
            }
            caller = caller->caller_ctx;
        }
        if (!caller) {
            /* outer has never been invoked, we fake a subroutine call
             * which builds the LexPad and return immediately
             * this will usually just lead to a Null PMC access
             * exception
             */
            interpreter->current_cont = NEED_CONTINUATION;
            (void)VTABLE_invoke(interpreter, sub->outer_sub, next);
            caller = CONTEXT(interpreter->ctx);
            cont = caller->current_cont;
            cont->vtable = interpreter->vtables[enum_class_Continuation];
            sub->outer_ctx = sub->ctx->outer_ctx = caller;
            caller->ref_count++;
            (void)VTABLE_invoke(interpreter, cont, next);
        }
    }
    return next;

}
#line 165 "src/pmc/closure.c"


void
Parrot_Closure_thawfinish(Interp* interpreter, PMC* pmc, visit_info *info)
#line 138 "src/pmc/closure.pmc"
{
    struct Parrot_sub * sub = PMC_sub(pmc);
    PMC *outer;
    opcode_t i, ci;
    struct PackFile_FixupTable *ft;
    struct PackFile_ConstTable *ct;

    /*
     * XXX TODO
     *
     * A Sub PMC is frozen/thawed per item, OTOH it can refer to other
     * subs via the outer_sub (:outer) syntax. This outer though, is created
     * independently when running from .pbc, which breaks referential
     * integrity.
     *
     * The only fix (except this ugly and slow code) is to freeze/thaw
     * a code segment as one structure, which will take care of all
     * refs and self-refs. 
     *
     * TODO - intermediate step:
     *
     * Investigate if we can:
     * - freeze array of subs (instead of the useless fixup seg)
     * - do we need the Sub constant in the const seg as PMC constant?  
     */

    if (PMC_IS_NULL(sub->outer_sub))
        return;
    ft = sub->seg->fixups;
    ct = sub->seg->const_table;
    for (i = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                ci = ft->fixups[i]->offset;
                if (ci < 0 || ci >= ct->const_count - 1)
                    return; /* not yet thawed */
                if (ct->constants[ci]->type != PFC_PMC)
                    return; /* same */
                outer = ct->constants[ci]->u.key;
                if (PMC_IS_NULL(outer))
                    continue;
                if (0 == string_equal(interpreter, PMC_sub(outer)->name,
                            PMC_sub(sub->outer_sub)->name)) {
                    sub->outer_sub = outer;
                    break;
                }
        } 
    }

}
#line 221 "src/pmc/closure.c"


void
Parrot_Closure_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Closure,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Closure_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Closure_mark,
        Parrot_Closure_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Sub_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Sub_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Sub_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Closure_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_Closure_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Sub_freeze,
        Parrot_Sub_thaw,
        Parrot_Closure_thawfinish,
        Parrot_Sub_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Closure");
        vt_clone->isa_str = CONST_STRING(interp, "Closure Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_Closure_class_init */


/*

=back

=head1 HISTORY

Initial version by Leo.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
