/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/continuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/continuation.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: continuation.pmc 11612 2006-02-17 02:29:10Z rgrjr $

=head1 NAME

src/pmc/continuation.pmc - Continuation PMC

=head1 DESCRIPTION

A C<Continuation> has a copy of the interpreter's context at the location,
where the Continuation was constructed.
See the L<Glossary|docs/glossary.pod> for more information.

=head2 Functions

=over 4

=cut

*/


#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"
#include <assert.h>


/*

=back

=head2 Methods

=over 4

=cut

*/


/*
 * A Continuation (and RetContinuation, Exception_Handler) has in its
 * context a pointer to the register frame, which contains active objects.
 * Additionally ct->current_cont has he continuation of the caller.
 * To avoid deep recursion during marking of nested subroutines, we
 * need the next_for_GC pointer in the pmc_ext area.
 */

#line 62 "src/pmc/continuation.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "continuation.str"

void
Parrot_Continuation_init(Interp* interpreter, PMC* pmc)
#line 62 "src/pmc/continuation.pmc"
{
    PMC_struct_val(pmc) = new_continuation(interpreter, NULL);
    PMC_pmc_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain maybe reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interpreter, pmc);

}
#line 87 "src/pmc/continuation.c"


void
Parrot_Continuation_mark(Interp* interpreter, PMC* pmc)
#line 86 "src/pmc/continuation.pmc"
{
    struct Parrot_cont * cc = PMC_cont(pmc);
    if (cc->to_ctx)
        mark_context(interpreter, cc->to_ctx);

}
#line 99 "src/pmc/continuation.c"


void
Parrot_Continuation_destroy(Interp* interpreter, PMC* pmc)
#line 102 "src/pmc/continuation.pmc"
{
    struct Parrot_cont * cc = PMC_cont(pmc);
    if (cc) {
#if CTX_LEAK_DEBUG
        if (Interp_debug_TEST(interpreter, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
            fprintf(stderr,
                    "[destroy cont    %p, to_ctx %p, from_ctx %p]\n",
                    pmc, cc->to_ctx, cc->from_ctx);
        }
#endif
        if (cc->from_ctx)
            Parrot_free_context(interpreter, cc->from_ctx, 0);
        mem_sys_free(cc);
        PMC_struct_val(pmc) = NULL;
    }

}
#line 122 "src/pmc/continuation.c"


PMC*
Parrot_Continuation_clone(Interp* interpreter, PMC* pmc)
#line 128 "src/pmc/continuation.pmc"
{
    struct Parrot_cont * cc;
    struct Parrot_cont *cc_self = PMC_cont(pmc);
    PMC* ret = pmc_new_noinit(interpreter, enum_class_Continuation);

    PObj_custom_mark_destroy_SETALL(ret);
    cc = new_continuation(interpreter, cc_self);
    PMC_struct_val(ret) = cc;
    PMC_pmc_val(ret) = PMC_pmc_val(pmc);
    return ret;

}
#line 140 "src/pmc/continuation.c"


STRING*
Parrot_Continuation_get_string(Interp* interpreter, PMC* pmc)
#line 292 "src/pmc/continuation.pmc"
{
    return Parrot_Context_infostr(interpreter, PMC_cont(pmc)->to_ctx);

}
#line 150 "src/pmc/continuation.c"


INTVAL
Parrot_Continuation_get_bool(Interp* interpreter, PMC* pmc)
#line 208 "src/pmc/continuation.pmc"
{
    return PMC_cont(pmc)->address != NULL;

}
#line 160 "src/pmc/continuation.c"


void*
Parrot_Continuation_get_pointer(Interp* interpreter, PMC* pmc)
#line 189 "src/pmc/continuation.pmc"
{
    return PMC_cont(pmc)->address;

}
#line 170 "src/pmc/continuation.c"


void
Parrot_Continuation_set_pmc(Interp* interpreter, PMC* pmc, PMC* src)
#line 149 "src/pmc/continuation.pmc"
{
    struct Parrot_cont *cc_self = PMC_cont(pmc);
    struct Parrot_cont *cc_src  = PMC_cont(src);

    memcpy(cc_self, cc_src, sizeof(struct Parrot_cont));
    PMC_pmc_val(pmc) = PMC_pmc_val(src);

}
#line 184 "src/pmc/continuation.c"


void
Parrot_Continuation_set_pointer(Interp* interpreter, PMC* pmc, void* value)
#line 166 "src/pmc/continuation.pmc"
{
    opcode_t *pos = value;
    struct Parrot_cont * cc = PMC_cont(pmc);

    PObj_get_FLAGS(pmc) |= PObj_private1_FLAG;
    cc->address = value;
    if (pos && *pos == PARROT_OP_get_results_pc) {
        cc->current_results = pos;
    }
    else
        cc->current_results = NULL;

}
#line 203 "src/pmc/continuation.c"


INTVAL
Parrot_Continuation_defined(Interp* interpreter, PMC* pmc)
#line 204 "src/pmc/continuation.pmc"
{
    return PMC_cont(pmc)->address != NULL;

}
#line 213 "src/pmc/continuation.c"


void*
Parrot_Continuation_invoke(Interp* interpreter, PMC* pmc, void* next)
#line 223 "src/pmc/continuation.pmc"
{
    struct Parrot_cont * cc = PMC_cont(pmc);
    parrot_context_t *caller_ctx;
    parrot_context_t *ctx;
    opcode_t *pc;

#if CTX_LEAK_DEBUG
    if (Interp_debug_TEST(interpreter, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
        fprintf(stderr,
                "[invoke cont    %p, to_ctx %p, from_ctx %p (refs %d)]\n",
                pmc, cc->to_ctx, cc->from_ctx,
                (int) cc->from_ctx->ref_count);
    }
#endif
    if (! cc->to_ctx) {
        real_exception(interpreter, NULL, INVALID_OPERATION,
                       "Continuation invoked after deactivation.");
    }
    /* debug print before context is switched */
    if (Interp_trace_TEST(interpreter, PARROT_TRACE_SUB_CALL_FLAG)) {
        PMC *sub = cc->to_ctx->current_sub;

        PIO_eprintf(interpreter, "# Back in sub '%Ss'\n",
                Parrot_full_sub_name(interpreter, sub));
    }
    caller_ctx = CONTEXT(interpreter->ctx);
    /*
     * set context
     */
    CONTEXT(interpreter->ctx) = ctx = cc->to_ctx;
    interpreter->ctx.bp = ctx->bp;
    interpreter->ctx.bp_ps = ctx->bp_ps;
    if (cc->current_results) {
        /* where caller wants result */
        ctx->current_results = cc->current_results;
    }
    pc = cc->address;
    if (ctx->current_results && interpreter->current_args) {
        /*
         * the register pointer is already switched back
         * to the caller, therefore the registers of the
         * sub we are returning from aren't marked, if
         * inside argument passing a DOD run is triggered
         * therefore we have to block DOD
         */
        Parrot_block_DOD(interpreter);
        parrot_pass_args(interpreter,
                caller_ctx,
                ctx,
                PARROT_OP_set_args_pc);
        Parrot_unblock_DOD(interpreter);
    }
    interpreter->current_args = NULL;
    if (interpreter->code != cc->seg) {
        Parrot_switch_to_cs(interpreter, cc->seg, 1);
    }
    return pc;

}
#line 278 "src/pmc/continuation.c"


PMC*
Parrot_Continuation_caller(Interp* interpreter, PMC* pmc)
#line 306 "src/pmc/continuation.pmc"
{
    struct Parrot_cont * cc = PMC_cont(pmc);
    PMC *caller = cc->to_ctx->current_sub;
    if (!caller || !PMC_sub(caller)->seg) {
        caller = pmc_new(interpreter, enum_class_Undef);
    }
    return caller;


}
#line 294 "src/pmc/continuation.c"


PMC*
Parrot_Continuation_continuation(Interp* interpreter, PMC* pmc)
#line 325 "src/pmc/continuation.pmc"
{
    struct Parrot_cont * cc = PMC_cont(pmc);
    PMC *cont = cc->to_ctx->current_cont;
    if (cont)
        return cont;
    return pmc_new(interpreter, enum_class_Undef);

}
#line 308 "src/pmc/continuation.c"


void
Parrot_Continuation_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Continuation,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Continuation_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Continuation_mark,
        Parrot_Continuation_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Continuation_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Continuation_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Continuation_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_Continuation_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_Continuation_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Continuation_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Continuation_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_Continuation_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Continuation");
        vt_clone->isa_str = CONST_STRING(interp, "Continuation");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Continuation_caller),
                "caller", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Continuation_continuation),
                "continuation", "PJO");
        /* class_init */
    
    } /* pass */
} /* Parrot_Continuation_class_init */


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
