/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/coroutine.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/coroutine.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: coroutine.pmc 12311 2006-04-17 23:21:13Z leo $

=head1 NAME

src/pmc/coroutine.pmc - Co-Routine PMC

=head1 DESCRIPTION

C<Coroutine> extends C<Continuation> to provide a subroutine that can
stop in the middle, and start back up later at the point at which it
stopped. See the L<Glossary|docs/glossary.pod> for more information.

=head2 Flags

=over 4

=item private0 call flip flop

=item private3 restore current sub after "flop".  Used by generators.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"
#include <assert.h>

/*
 * XXX put these into exceptions.h
 */


#define TRY \
    do { \
        new_internal_exception(INTERP); \
        if (!setjmp(INTERP->exceptions->destination))

#define CATCH \
    else

#define ENDTRY \
    } while(0); \
    do { \
        Parrot_exception *e = INTERP->exceptions; \
        INTERP->exceptions = e->prev; \
        INTERP->exc_free_list = e; \
    } while(0)


#define THROW(e)  \
    do { \
        exceptions->err = e; \
        longjmp(exceptions->dest, 1); \
    } while(0)

static void
print_sub_name(Interp* interpreter, PMC* sub)
{
    struct Parrot_coro * co = PMC_coro(sub);
    Interp *tracer;

    tracer = interpreter->debugger ? 
        interpreter->debugger : interpreter;
    PIO_eprintf(tracer, "# %s coro '%Ss'",
        !(PObj_get_FLAGS(sub) & SUB_FLAG_CORO_FF) ? 
        "Calling" : "yielding from",
        Parrot_full_sub_name(interpreter, sub));
    if (co->ctx &&
        (PObj_get_FLAGS(sub) & SUB_FLAG_CORO_FF)) {
        PIO_eprintf(tracer, " to '%Ss'",
                Parrot_full_sub_name(interpreter, 
                    co->ctx->caller_ctx->current_sub));
    }
    PIO_eprintf(tracer, "\n# ");
    print_pbc_location(interpreter);
}

#line 99 "src/pmc/coroutine.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_coroutine.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "coroutine.str"

void
Parrot_Coroutine_init(Interp* interpreter, PMC* pmc)
#line 103 "src/pmc/coroutine.pmc"
{
    PMC_struct_val(pmc) = new_coroutine(interpreter);
    PMC_pmc_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 117 "src/pmc/coroutine.c"


void
Parrot_Coroutine_mark(Interp* interpreter, PMC* pmc)
#line 228 "src/pmc/coroutine.pmc"
{
    struct Parrot_coro *c = PMC_coro(pmc);
    if (c && c->ctx)
        mark_context(interpreter, c->ctx);
    Parrot_Sub_mark(interpreter, pmc);

}
#line 130 "src/pmc/coroutine.c"


PMC*
Parrot_Coroutine_clone(Interp* interpreter, PMC* pmc)
#line 109 "src/pmc/coroutine.pmc"
{
    struct Parrot_coro * sub;
    PMC* ret = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    PObj_custom_mark_destroy_SETALL(ret);
    sub = mem_sys_allocate(sizeof(struct Parrot_coro));
    PMC_struct_val(ret) = sub;
    PMC_pmc_val(ret) = NULL;
    memcpy(sub, PMC_sub(pmc), sizeof(struct Parrot_coro));
    sub->name = string_copy(interpreter, sub->name);
    return ret;

}
#line 148 "src/pmc/coroutine.c"


void*
Parrot_Coroutine_invoke(Interp* interpreter, PMC* pmc, void* next)
#line 131 "src/pmc/coroutine.pmc"
{
    struct Parrot_coro * co = PMC_coro(pmc);
    parrot_context_t *caller_ctx;
    struct PackFile_ByteCode *wanted_seg;
    opcode_t * dest = co->address;
    parrot_context_t *ctx;
    PMC *ccont;

    if (Interp_trace_TEST(interpreter, PARROT_TRACE_SUB_CALL_FLAG)) {
        print_sub_name(interpreter, pmc);
    }
    if (!co->ctx) {
        /* TODO factor out common code with Sub.invoke
         *      and inherit it
         */
        ccont = interpreter->current_cont;
        if (ccont == NEED_CONTINUATION) {
            ccont = new_ret_continuation_pmc(interpreter, next);
        }
        if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
            real_exception(interpreter, NULL, E_Exception,
                    "tail call to coro not allowed");
        }
        caller_ctx = CONTEXT(interpreter->ctx);
        /*
         * first time set current sub, cont, object
         */
        Parrot_alloc_context(interpreter, co->n_regs_used);
        co->ctx = ctx = CONTEXT(interpreter->ctx);
        ctx->caller_ctx = caller_ctx;
        PMC_cont(ccont)->from_ctx = ctx;
        ctx->current_sub = pmc;
        ctx->current_HLL = co->HLL_id;
        ctx->current_namespace = co->namespace_stash;
        ctx->current_cont = ccont;
        ctx->current_object = NULL;
        interpreter->current_object = NULL;
        interpreter->current_cont = NULL;

        /* create pad if needed */
        if (!PMC_IS_NULL(co->lex_info)) {
            ctx->lex_pad = pmc_new_init(interpreter,
                    Parrot_get_ctx_HLL_type(interpreter,
                        enum_class_LexPad),
                    co->lex_info);
            VTABLE_set_pointer(interpreter, ctx->lex_pad, ctx);
        }

        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg = co->seg;
        co->caller_seg = interpreter->code;
        co->address = co->seg->base.data + co->start_offs;
    }
    /* if calling the Coro we need the segment of the Coro */
    else if (!(PObj_get_FLAGS(pmc) & SUB_FLAG_CORO_FF)) {
        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg = co->seg;
        /* remember segment of caller */
        co->caller_seg = interpreter->code;
        ctx = co->ctx;
        /* and the recent call context */
        ccont = ctx->current_cont;
        ctx->caller_ctx = PMC_cont(ccont)->to_ctx = CONTEXT(interpreter->ctx);
        /* set context to coro context */
        CONTEXT(interpreter->ctx) = ctx;
        interpreter->ctx.bp = ctx->bp;
        interpreter->ctx.bp_ps = ctx->bp_ps;
    }
    else {
        PObj_get_FLAGS(pmc) &= ~SUB_FLAG_CORO_FF;
        /* switch back to last remembered code seg and context */
        wanted_seg = co->caller_seg;
        ccont = co->ctx->current_cont;
        CONTEXT(interpreter->ctx) = ctx = PMC_cont(ccont)->to_ctx;
        interpreter->ctx.bp = ctx->bp;
        interpreter->ctx.bp_ps = ctx->bp_ps;
    }

    /* toggle address */
    dest = co->address;
    co->address = next;
    if (interpreter->code != wanted_seg) {
        Parrot_switch_to_cs(interpreter, wanted_seg, 1);
    }
    return dest;

}
#line 241 "src/pmc/coroutine.c"


void
Parrot_Coroutine_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Coroutine,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Coroutine_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Coroutine_mark,
        Parrot_Sub_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Coroutine_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Sub_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Sub_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_Coroutine_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Sub_freeze,
        Parrot_Sub_thaw,
        Parrot_default_thawfinish,
        Parrot_Sub_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Coroutine");
        vt_clone->isa_str = CONST_STRING(interp, "Coroutine Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_Coroutine_class_init */


/*

=back

=head1 HISTORY

Initial version by Melvin on 2002/06/6.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
