/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/default.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/default.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: default.pmc 12359 2006-04-18 22:44:21Z particle $

=head1 NAME

src/pmc/default.pmc - Abstract root class

=head1 DESCRIPTION

These are the vtable functions for the default PMC class.

All methods which are not defined here get a default implementation
generated from F<vtable.tbl> by F<tools/build/pmc2c.pl>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define INT2KEY(i,k) key_new_integer((i), (k))

/* undef 'interface', because msvc is craptastic */
#undef interface

/*

=item C<static const char *caller(Interp* interpreter, PMC *pmc)>

Returns a C string for the name of C<*pmc>.

=cut

*/

static const char *
caller(Interp* interpreter, PMC * pmc)
{
    return pmc && pmc->vtable && pmc->vtable->whoami ?
    VTABLE_name(interpreter, pmc)->strstart : "(null)";
}

/*

=item C<static void cant_do_method(Interp* interpreter, PMC * pmc, const char *methname)>

Throws an exception "$methname() not implemented in class '$class'", used by
all unimplemented messages.

=cut

*/

static void
cant_do_method(Interp* interpreter, PMC * pmc, const char *methname)
{
    real_exception(interpreter, NULL, ILL_INHERIT,
                       "%s() not implemented in class '%s'", methname,
                       caller(interpreter, pmc));
}

/*

=item C<static void
check_set_std_props(Interp* interpreter, PMC *pmc, STRING *key, PMC *value)>

Called from C<setprop()>.

=cut

*/

static void
check_set_std_props(Interp* interpreter, PMC *pmc, STRING *key, PMC *value)
{
#if  1
    /* XXX
     * a quick hack, to prevent freeing that string during DOD
     * triggered in t/pmc/pmc_62.t when configured with --gc=libc
     */
    static STRING *ro;
    if (!ro)
        ro = string_make(interpreter, "_ro", 3, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
    if (!string_compare(interpreter, key, ro)) {
#else

    /*
     * s2 in string_compare is freed here
     */
    if (!string_compare(interpreter, key,
        string_from_cstring(interpreter, "_ro", 0))) {
#endif
        /* pmc should set/clear readonly */
        INTVAL on = VTABLE_get_bool(interpreter, value);
        /* morph to Const/normal class */
        if (on && (pmc->vtable->flags & VTABLE_HAS_CONST_TOO))
            pmc->vtable = interpreter->vtables[pmc->vtable->base_type + 1];
        else if (!on && (pmc->vtable->flags & VTABLE_IS_CONST_FLAG))
            VTABLE_morph(interpreter, pmc, pmc->vtable->base_type - 1);
    }
}

/*

=item C<static INTVAL
does_isa(Interp* interpreter, STRING *method, STRING *what)>

Compares C<*method> and C<*what>.

=cut

*/

static INTVAL
does_isa (Interp* interpreter, STRING *method, STRING *what)
{
    INTVAL len, pos = 0;

    do {
        pos = string_str_index(interpreter, what, method, pos);
        if (pos < 0)
            return 0;
        if (pos >= (INTVAL)string_length(interpreter, what))
            return 0;
        len = string_length(interpreter, method);
        if (pos && string_index(interpreter, what, pos - 1) != 32) {
            pos += len;
            continue;
        }

        if (pos+len < (INTVAL)string_length(interpreter, what) &&
            string_index(interpreter, what, pos + len) != 32) {
            pos += len;
            continue;
        }
        return 1;
    } while(1);
    return 0;
}

#line 159 "src/pmc/default.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_default.h"
#include "default.str"

void
Parrot_default_init(Interp* interpreter, PMC* pmc)
#line 165 "src/pmc/default.pmc"
{

}
#line 172 "src/pmc/default.c"


void
Parrot_default_init_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 178 "src/pmc/default.pmc"
{
     VTABLE_init(interpreter, pmc);

}
#line 182 "src/pmc/default.c"


void
Parrot_default_init_pmc_props(Interp* interpreter, PMC* pmc, PMC* initializer, PMC* properties)
#line 193 "src/pmc/default.pmc"
{
    if (!pmc->pmc_ext)
        add_pmc_ext(interpreter, pmc);
    DOD_WRITE_BARRIER(interpreter, pmc, NULL, properties);
    PMC_metadata(pmc) = properties;
    if (initializer)
         VTABLE_init_pmc(interpreter, pmc, initializer);
    else
         VTABLE_init(interpreter, pmc);

}
#line 199 "src/pmc/default.c"


PMC*
Parrot_default_instantiate(Interp* interpreter, PMC* pmc, PMC* sig)
#line 215 "src/pmc/default.pmc"
{
    INTVAL type = pmc->vtable->base_type;
    PMC* ret = pmc_new_noinit(interpreter, type);
    VTABLE_init(interpreter, ret);
    return ret;

}
#line 212 "src/pmc/default.c"


#line 213 "default.c"

PMC*
Parrot_default_new_from_string(Interp* interpreter, PMC* pmc, STRING* rep, INTVAL flags)
{
    cant_do_method(interpreter, pmc, "new_from_string");
    return (PMC*)0;
}

#line 222 "default.c"

void
Parrot_default_morph(Interp* interpreter, PMC* pmc, INTVAL type)
{
    cant_do_method(interpreter, pmc, "morph");
    
}

void
Parrot_default_mark(Interp* interpreter, PMC* pmc)
#line 232 "src/pmc/default.pmc"
{
    PANIC("custom_mark flag set but no custom mark routine defined");

}
#line 240 "src/pmc/default.c"


#line 241 "default.c"

void
Parrot_default_destroy(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "destroy");
    
}

PMC*
Parrot_default_namespace(Interp* interpreter, PMC* pmc)
#line 389 "src/pmc/default.pmc"
{
    return pmc->vtable->_namespace;

}
#line 259 "src/pmc/default.c"


PMC*
Parrot_default_getprop(Interp* interpreter, PMC* pmc, STRING* key)
#line 247 "src/pmc/default.pmc"
{
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
      return VTABLE_get_pmc_keyed_str(interpreter, PMC_metadata(pmc), key);
    }
    else {
      return PMCNULL;
    }

}
#line 274 "src/pmc/default.c"


void
Parrot_default_setprop(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
#line 266 "src/pmc/default.pmc"
{
    check_set_std_props(interpreter, pmc, key, value);
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_set_pmc_keyed_str(interpreter,
            PMC_metadata(pmc), key, value);
    } else {
        PMC *prop;
        if (!pmc->pmc_ext)
            add_pmc_ext(interpreter, pmc);
        /* first make new hash */
        PMC_metadata(pmc) = prop =
            pmc_new_noinit(interpreter, enum_class_Hash);
        DOD_WRITE_BARRIER(interpreter, pmc, NULL, prop);
        VTABLE_init(interpreter, prop);
        /* then the key, else it vanishes with --gc-debug */
        VTABLE_set_pmc_keyed_str(interpreter, prop, key, value);
#if 0
PObj_report_SET(PMC_metadata(pmc));
#endif
    }
    return;

}
#line 303 "src/pmc/default.c"


void
Parrot_default_delprop(Interp* interpreter, PMC* pmc, STRING* key)
#line 299 "src/pmc/default.pmc"
{
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_delete_keyed_str(interpreter, PMC_metadata(pmc), key);
    }
    return;

}
#line 316 "src/pmc/default.c"


PMC*
Parrot_default_getprops(Interp* interpreter, PMC* pmc)
#line 316 "src/pmc/default.pmc"
{
    if (!pmc->pmc_ext)
        add_pmc_ext(interpreter, pmc);
    if (!PMC_metadata(pmc)) {
        return PMCNULL;
    }
    return PMC_metadata(pmc);

}
#line 331 "src/pmc/default.c"


INTVAL
Parrot_default_type(Interp* interpreter, PMC* pmc)
#line 335 "src/pmc/default.pmc"
{
    return pmc->vtable->base_type;

}
#line 341 "src/pmc/default.c"


#line 342 "default.c"

INTVAL
Parrot_default_type_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "type_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_type_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 350 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_type_keyed(interpreter, pmc, r_key);

}
#line 361 "src/pmc/default.c"


#line 362 "default.c"

INTVAL
Parrot_default_type_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "type_keyed_str");
    return (INTVAL)0;
}

#line 371 "default.c"

UINTVAL
Parrot_default_subtype(Interp* interpreter, PMC* pmc, INTVAL type)
{
    cant_do_method(interpreter, pmc, "subtype");
    return (UINTVAL)0;
}

STRING*
Parrot_default_name(Interp* interpreter, PMC* pmc)
#line 365 "src/pmc/default.pmc"
{
    return pmc->vtable->whoami;

}
#line 389 "src/pmc/default.c"


#line 390 "default.c"

PMC*
Parrot_default_clone(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "clone");
    return (PMC*)0;
}

PMC*
Parrot_default_find_method(Interp* interpreter, PMC* pmc, STRING* method_name)
#line 394 "src/pmc/default.pmc"
{
    PMC *method = Parrot_find_method_with_cache(interpreter, pmc, method_name);
    if (method && method->vtable->base_type == enum_class_MultiSub &&
            interpreter->current_args) {
        return Parrot_MMD_dispatch_func(interpreter,
                method, method_name);
    }
    return method;

}
#line 414 "src/pmc/default.c"


#line 415 "default.c"

INTVAL
Parrot_default_hash(Interp* interpreter, PMC* pmc, size_t seed)
{
    cant_do_method(interpreter, pmc, "hash");
    return (INTVAL)0;
}

#line 424 "default.c"

INTVAL
Parrot_default_get_integer(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_integer");
    return (INTVAL)0;
}

#line 433 "default.c"

INTVAL
Parrot_default_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "get_integer_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 419 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_get_integer_keyed(interpreter, pmc, r_key);

}
#line 452 "src/pmc/default.c"


#line 453 "default.c"

INTVAL
Parrot_default_get_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "get_integer_keyed_str");
    return (INTVAL)0;
}

#line 462 "default.c"

FLOATVAL
Parrot_default_get_number(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_number");
    return (FLOATVAL)0;
}

#line 471 "default.c"

FLOATVAL
Parrot_default_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "get_number_keyed");
    return (FLOATVAL)0;
}

FLOATVAL
Parrot_default_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 435 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_get_number_keyed(interpreter, pmc, r_key);

}
#line 490 "src/pmc/default.c"


#line 491 "default.c"

FLOATVAL
Parrot_default_get_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "get_number_keyed_str");
    return (FLOATVAL)0;
}

#line 500 "default.c"

PMC*
Parrot_default_get_bignum(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_bignum");
    return (PMC*)0;
}

#line 509 "default.c"

STRING*
Parrot_default_get_string(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_string");
    return (STRING*)0;
}

#line 518 "default.c"

STRING*
Parrot_default_get_repr(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_repr");
    return (STRING*)0;
}

#line 527 "default.c"

STRING*
Parrot_default_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "get_string_keyed");
    return (STRING*)0;
}

STRING*
Parrot_default_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 452 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_get_string_keyed(interpreter, pmc, r_key);

}
#line 546 "src/pmc/default.c"


#line 547 "default.c"

STRING*
Parrot_default_get_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "get_string_keyed_str");
    return (STRING*)0;
}

#line 556 "default.c"

INTVAL
Parrot_default_get_bool(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_bool");
    return (INTVAL)0;
}

#line 565 "default.c"

PMC*
Parrot_default_get_pmc(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_pmc");
    return (PMC*)0;
}

#line 574 "default.c"

PMC*
Parrot_default_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "get_pmc_keyed");
    return (PMC*)0;
}

PMC*
Parrot_default_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 501 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_get_pmc_keyed(interpreter, pmc, r_key);

}
#line 593 "src/pmc/default.c"


#line 594 "default.c"

PMC*
Parrot_default_get_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "get_pmc_keyed_str");
    return (PMC*)0;
}

#line 603 "default.c"

PMC*
Parrot_default_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL flag)
{
    cant_do_method(interpreter, pmc, "slice");
    return (PMC*)0;
}

#line 612 "default.c"

void*
Parrot_default_get_pointer(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_pointer");
    return (void*)0;
}

#line 621 "default.c"

void*
Parrot_default_get_pointer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "get_pointer_keyed");
    return (void*)0;
}

#line 630 "default.c"

void*
Parrot_default_get_pointer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
{
    cant_do_method(interpreter, pmc, "get_pointer_keyed_int");
    return (void*)0;
}

#line 639 "default.c"

void*
Parrot_default_get_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "get_pointer_keyed_str");
    return (void*)0;
}

#line 648 "default.c"

void
Parrot_default_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "set_integer_native");
    
}

#line 657 "default.c"

void
Parrot_default_set_integer_same(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_integer_same");
    
}

#line 666 "default.c"

void
Parrot_default_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
{
    cant_do_method(interpreter, pmc, "set_integer_keyed");
    
}

void
Parrot_default_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 550 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
     VTABLE_set_integer_keyed(interpreter, pmc, r_key, value);

}
#line 685 "src/pmc/default.c"


#line 686 "default.c"

void
Parrot_default_set_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL value)
{
    cant_do_method(interpreter, pmc, "set_integer_keyed_str");
    
}

#line 695 "default.c"

void
Parrot_default_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "set_number_native");
    
}

#line 704 "default.c"

void
Parrot_default_set_number_same(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_number_same");
    
}

#line 713 "default.c"

void
Parrot_default_set_number_keyed(Interp* interpreter, PMC* pmc, PMC* key, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "set_number_keyed");
    
}

void
Parrot_default_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 566 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
     VTABLE_set_number_keyed(interpreter, pmc, r_key, value);

}
#line 732 "src/pmc/default.c"


#line 733 "default.c"

void
Parrot_default_set_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "set_number_keyed_str");
    
}

#line 742 "default.c"

void
Parrot_default_set_bignum_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "set_bignum_int");
    
}

#line 751 "default.c"

void
Parrot_default_set_bignum_num(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "set_bignum_num");
    
}

#line 760 "default.c"

void
Parrot_default_set_bignum_str(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "set_bignum_str");
    
}

#line 769 "default.c"

void
Parrot_default_set_string_native(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "set_string_native");
    
}

void
Parrot_default_assign_string_native(Interp* interpreter, PMC* pmc, STRING* value)
#line 536 "src/pmc/default.pmc"
{
     VTABLE_set_string_native(interpreter, pmc, value);

}
#line 787 "src/pmc/default.c"


#line 788 "default.c"

void
Parrot_default_set_string_same(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_string_same");
    
}

#line 797 "default.c"

void
Parrot_default_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
{
    cant_do_method(interpreter, pmc, "set_string_keyed");
    
}

void
Parrot_default_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* string)
#line 583 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
     VTABLE_set_string_keyed(interpreter, pmc, r_key, string);

}
#line 816 "src/pmc/default.c"


#line 817 "default.c"

void
Parrot_default_set_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, STRING* value)
{
    cant_do_method(interpreter, pmc, "set_string_keyed_str");
    
}

#line 826 "default.c"

void
Parrot_default_set_bool(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "set_bool");
    
}

#line 835 "default.c"

void
Parrot_default_set_pmc(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_pmc");
    
}

void
Parrot_default_assign_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 532 "src/pmc/default.pmc"
{
     VTABLE_set_pmc(interpreter, pmc, value);

}
#line 853 "src/pmc/default.c"


#line 854 "default.c"

void
Parrot_default_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_pmc_keyed");
    
}

void
Parrot_default_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* value)
#line 615 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
     VTABLE_set_pmc_keyed(interpreter, pmc, r_key, value);

}
#line 873 "src/pmc/default.c"


#line 874 "default.c"

void
Parrot_default_set_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_pmc_keyed_str");
    
}

#line 883 "default.c"

void
Parrot_default_set_pointer(Interp* interpreter, PMC* pmc, void* value)
{
    cant_do_method(interpreter, pmc, "set_pointer");
    
}

#line 892 "default.c"

void
Parrot_default_set_pointer_keyed(Interp* interpreter, PMC* pmc, PMC* key, void* value)
{
    cant_do_method(interpreter, pmc, "set_pointer_keyed");
    
}

#line 901 "default.c"

void
Parrot_default_set_pointer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, void* value)
{
    cant_do_method(interpreter, pmc, "set_pointer_keyed_int");
    
}

#line 910 "default.c"

void
Parrot_default_set_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, void* value)
{
    cant_do_method(interpreter, pmc, "set_pointer_keyed_str");
    
}

#line 919 "default.c"

INTVAL
Parrot_default_elements(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "elements");
    return (INTVAL)0;
}

#line 928 "default.c"

INTVAL
Parrot_default_pop_integer(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "pop_integer");
    return (INTVAL)0;
}

#line 937 "default.c"

FLOATVAL
Parrot_default_pop_float(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "pop_float");
    return (FLOATVAL)0;
}

#line 946 "default.c"

STRING*
Parrot_default_pop_string(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "pop_string");
    return (STRING*)0;
}

#line 955 "default.c"

PMC*
Parrot_default_pop_pmc(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "pop_pmc");
    return (PMC*)0;
}

#line 964 "default.c"

void
Parrot_default_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "push_integer");
    
}

#line 973 "default.c"

void
Parrot_default_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "push_float");
    
}

#line 982 "default.c"

void
Parrot_default_push_string(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "push_string");
    
}

#line 991 "default.c"

void
Parrot_default_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "push_pmc");
    
}

#line 1000 "default.c"

INTVAL
Parrot_default_shift_integer(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "shift_integer");
    return (INTVAL)0;
}

#line 1009 "default.c"

FLOATVAL
Parrot_default_shift_float(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "shift_float");
    return (FLOATVAL)0;
}

#line 1018 "default.c"

STRING*
Parrot_default_shift_string(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "shift_string");
    return (STRING*)0;
}

#line 1027 "default.c"

PMC*
Parrot_default_shift_pmc(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "shift_pmc");
    return (PMC*)0;
}

#line 1036 "default.c"

void
Parrot_default_unshift_integer(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "unshift_integer");
    
}

#line 1045 "default.c"

void
Parrot_default_unshift_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "unshift_float");
    
}

#line 1054 "default.c"

void
Parrot_default_unshift_string(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "unshift_string");
    
}

#line 1063 "default.c"

void
Parrot_default_unshift_pmc(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "unshift_pmc");
    
}

#line 1072 "default.c"

void
Parrot_default_splice(Interp* interpreter, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
{
    cant_do_method(interpreter, pmc, "splice");
    
}

#line 1081 "default.c"

PMC*
Parrot_default_add(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "add");
    return (PMC*)0;
}

#line 1090 "default.c"

PMC*
Parrot_default_add_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "add_int");
    return (PMC*)0;
}

#line 1099 "default.c"

PMC*
Parrot_default_add_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "add_float");
    return (PMC*)0;
}

#line 1108 "default.c"

void
Parrot_default_i_add(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_add");
    
}

#line 1117 "default.c"

void
Parrot_default_i_add_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_add_int");
    
}

#line 1126 "default.c"

void
Parrot_default_i_add_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_add_float");
    
}

#line 1135 "default.c"

PMC*
Parrot_default_subtract(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "subtract");
    return (PMC*)0;
}

#line 1144 "default.c"

PMC*
Parrot_default_subtract_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "subtract_int");
    return (PMC*)0;
}

#line 1153 "default.c"

PMC*
Parrot_default_subtract_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "subtract_float");
    return (PMC*)0;
}

#line 1162 "default.c"

void
Parrot_default_i_subtract(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_subtract");
    
}

#line 1171 "default.c"

void
Parrot_default_i_subtract_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_subtract_int");
    
}

#line 1180 "default.c"

void
Parrot_default_i_subtract_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_subtract_float");
    
}

#line 1189 "default.c"

PMC*
Parrot_default_multiply(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "multiply");
    return (PMC*)0;
}

#line 1198 "default.c"

PMC*
Parrot_default_multiply_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "multiply_int");
    return (PMC*)0;
}

#line 1207 "default.c"

PMC*
Parrot_default_multiply_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "multiply_float");
    return (PMC*)0;
}

#line 1216 "default.c"

void
Parrot_default_i_multiply(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_multiply");
    
}

#line 1225 "default.c"

void
Parrot_default_i_multiply_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_multiply_int");
    
}

#line 1234 "default.c"

void
Parrot_default_i_multiply_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_multiply_float");
    
}

#line 1243 "default.c"

PMC*
Parrot_default_divide(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "divide");
    return (PMC*)0;
}

#line 1252 "default.c"

PMC*
Parrot_default_divide_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "divide_int");
    return (PMC*)0;
}

#line 1261 "default.c"

PMC*
Parrot_default_divide_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "divide_float");
    return (PMC*)0;
}

#line 1270 "default.c"

void
Parrot_default_i_divide(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_divide");
    
}

#line 1279 "default.c"

void
Parrot_default_i_divide_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_divide_int");
    
}

#line 1288 "default.c"

void
Parrot_default_i_divide_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_divide_float");
    
}

#line 1297 "default.c"

PMC*
Parrot_default_floor_divide(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "floor_divide");
    return (PMC*)0;
}

#line 1306 "default.c"

PMC*
Parrot_default_floor_divide_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "floor_divide_int");
    return (PMC*)0;
}

#line 1315 "default.c"

PMC*
Parrot_default_floor_divide_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "floor_divide_float");
    return (PMC*)0;
}

#line 1324 "default.c"

void
Parrot_default_i_floor_divide(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_floor_divide");
    
}

#line 1333 "default.c"

void
Parrot_default_i_floor_divide_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_floor_divide_int");
    
}

#line 1342 "default.c"

void
Parrot_default_i_floor_divide_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_floor_divide_float");
    
}

#line 1351 "default.c"

PMC*
Parrot_default_modulus(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "modulus");
    return (PMC*)0;
}

#line 1360 "default.c"

PMC*
Parrot_default_modulus_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "modulus_int");
    return (PMC*)0;
}

#line 1369 "default.c"

PMC*
Parrot_default_modulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "modulus_float");
    return (PMC*)0;
}

#line 1378 "default.c"

void
Parrot_default_i_modulus(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_modulus");
    
}

#line 1387 "default.c"

void
Parrot_default_i_modulus_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_modulus_int");
    
}

#line 1396 "default.c"

void
Parrot_default_i_modulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_modulus_float");
    
}

#line 1405 "default.c"

PMC*
Parrot_default_cmodulus(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "cmodulus");
    return (PMC*)0;
}

#line 1414 "default.c"

PMC*
Parrot_default_cmodulus_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "cmodulus_int");
    return (PMC*)0;
}

#line 1423 "default.c"

PMC*
Parrot_default_cmodulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "cmodulus_float");
    return (PMC*)0;
}

#line 1432 "default.c"

void
Parrot_default_i_cmodulus(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_cmodulus");
    
}

#line 1441 "default.c"

void
Parrot_default_i_cmodulus_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_cmodulus_int");
    
}

#line 1450 "default.c"

void
Parrot_default_i_cmodulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_cmodulus_float");
    
}

#line 1459 "default.c"

PMC*
Parrot_default_pow(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "pow");
    return (PMC*)0;
}

#line 1468 "default.c"

PMC*
Parrot_default_pow_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "pow_int");
    return (PMC*)0;
}

#line 1477 "default.c"

PMC*
Parrot_default_pow_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "pow_float");
    return (PMC*)0;
}

#line 1486 "default.c"

void
Parrot_default_i_pow(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_pow");
    
}

#line 1495 "default.c"

void
Parrot_default_i_pow_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_pow_int");
    
}

#line 1504 "default.c"

void
Parrot_default_i_pow_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interpreter, pmc, "i_pow_float");
    
}

#line 1513 "default.c"

void
Parrot_default_increment(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "increment");
    
}

#line 1522 "default.c"

void
Parrot_default_decrement(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "decrement");
    
}

#line 1531 "default.c"

PMC*
Parrot_default_absolute(Interp* interpreter, PMC* pmc, PMC* dest)
{
    cant_do_method(interpreter, pmc, "absolute");
    return (PMC*)0;
}

#line 1540 "default.c"

void
Parrot_default_i_absolute(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "i_absolute");
    
}

#line 1549 "default.c"

PMC*
Parrot_default_neg(Interp* interpreter, PMC* pmc, PMC* dest)
{
    cant_do_method(interpreter, pmc, "neg");
    return (PMC*)0;
}

#line 1558 "default.c"

void
Parrot_default_i_neg(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "i_neg");
    
}

#line 1567 "default.c"

PMC*
Parrot_default_bitwise_or(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_or");
    return (PMC*)0;
}

#line 1576 "default.c"

PMC*
Parrot_default_bitwise_or_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_or_int");
    return (PMC*)0;
}

#line 1585 "default.c"

void
Parrot_default_i_bitwise_or(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_or");
    
}

#line 1594 "default.c"

void
Parrot_default_i_bitwise_or_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_or_int");
    
}

#line 1603 "default.c"

PMC*
Parrot_default_bitwise_and(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_and");
    return (PMC*)0;
}

#line 1612 "default.c"

PMC*
Parrot_default_bitwise_and_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_and_int");
    return (PMC*)0;
}

#line 1621 "default.c"

void
Parrot_default_i_bitwise_and(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_and");
    
}

#line 1630 "default.c"

void
Parrot_default_i_bitwise_and_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_and_int");
    
}

#line 1639 "default.c"

PMC*
Parrot_default_bitwise_xor(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_xor");
    return (PMC*)0;
}

#line 1648 "default.c"

PMC*
Parrot_default_bitwise_xor_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_xor_int");
    return (PMC*)0;
}

#line 1657 "default.c"

void
Parrot_default_i_bitwise_xor(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_xor");
    
}

#line 1666 "default.c"

void
Parrot_default_i_bitwise_xor_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_xor_int");
    
}

#line 1675 "default.c"

PMC*
Parrot_default_bitwise_ors(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_ors");
    return (PMC*)0;
}

#line 1684 "default.c"

PMC*
Parrot_default_bitwise_ors_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_ors_str");
    return (PMC*)0;
}

#line 1693 "default.c"

void
Parrot_default_i_bitwise_ors(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_ors");
    
}

#line 1702 "default.c"

void
Parrot_default_i_bitwise_ors_str(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_ors_str");
    
}

#line 1711 "default.c"

PMC*
Parrot_default_bitwise_ands(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_ands");
    return (PMC*)0;
}

#line 1720 "default.c"

PMC*
Parrot_default_bitwise_ands_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_ands_str");
    return (PMC*)0;
}

#line 1729 "default.c"

void
Parrot_default_i_bitwise_ands(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_ands");
    
}

#line 1738 "default.c"

void
Parrot_default_i_bitwise_ands_str(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_ands_str");
    
}

#line 1747 "default.c"

PMC*
Parrot_default_bitwise_xors(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_xors");
    return (PMC*)0;
}

#line 1756 "default.c"

PMC*
Parrot_default_bitwise_xors_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_xors_str");
    return (PMC*)0;
}

#line 1765 "default.c"

void
Parrot_default_i_bitwise_xors(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_xors");
    
}

#line 1774 "default.c"

void
Parrot_default_i_bitwise_xors_str(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_xors_str");
    
}

#line 1783 "default.c"

PMC*
Parrot_default_bitwise_not(Interp* interpreter, PMC* pmc, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_not");
    return (PMC*)0;
}

#line 1792 "default.c"

void
Parrot_default_i_bitwise_not(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "i_bitwise_not");
    
}

#line 1801 "default.c"

PMC*
Parrot_default_bitwise_nots(Interp* interpreter, PMC* pmc, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_nots");
    return (PMC*)0;
}

#line 1810 "default.c"

void
Parrot_default_i_bitwise_nots(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "i_bitwise_nots");
    
}

#line 1819 "default.c"

PMC*
Parrot_default_bitwise_shl(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_shl");
    return (PMC*)0;
}

#line 1828 "default.c"

PMC*
Parrot_default_bitwise_shl_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_shl_int");
    return (PMC*)0;
}

#line 1837 "default.c"

void
Parrot_default_i_bitwise_shl(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_shl");
    
}

#line 1846 "default.c"

void
Parrot_default_i_bitwise_shl_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_shl_int");
    
}

#line 1855 "default.c"

PMC*
Parrot_default_bitwise_shr(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_shr");
    return (PMC*)0;
}

#line 1864 "default.c"

PMC*
Parrot_default_bitwise_shr_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_shr_int");
    return (PMC*)0;
}

#line 1873 "default.c"

void
Parrot_default_i_bitwise_shr(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_shr");
    
}

#line 1882 "default.c"

void
Parrot_default_i_bitwise_shr_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_shr_int");
    
}

#line 1891 "default.c"

PMC*
Parrot_default_bitwise_lsr(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_lsr");
    return (PMC*)0;
}

#line 1900 "default.c"

PMC*
Parrot_default_bitwise_lsr_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "bitwise_lsr_int");
    return (PMC*)0;
}

#line 1909 "default.c"

void
Parrot_default_i_bitwise_lsr(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_lsr");
    
}

#line 1918 "default.c"

void
Parrot_default_i_bitwise_lsr_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_bitwise_lsr_int");
    
}

INTVAL
Parrot_default_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 630 "src/pmc/default.pmc"
{
    return (pmc->vtable == value->vtable
        && PMC_struct_val(pmc) == PMC_struct_val(value)
        && PMC_data(pmc) == PMC_data(value));

}
#line 1938 "src/pmc/default.c"


INTVAL
Parrot_default_is_equal_num(Interp* interpreter, PMC* pmc, PMC* value)
#line 646 "src/pmc/default.pmc"
{
    return (VTABLE_get_number(interpreter, pmc) == VTABLE_get_number(interpreter, value));

}
#line 1948 "src/pmc/default.c"


#line 1949 "default.c"

INTVAL
Parrot_default_is_equal_string(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "is_equal_string");
    return (INTVAL)0;
}

INTVAL
Parrot_default_is_same(Interp* interpreter, PMC* pmc, PMC* value)
#line 516 "src/pmc/default.pmc"
{
    return pmc == value;

}
#line 1967 "src/pmc/default.c"


#line 1968 "default.c"

INTVAL
Parrot_default_cmp(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "cmp");
    return (INTVAL)0;
}

#line 1977 "default.c"

INTVAL
Parrot_default_cmp_num(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "cmp_num");
    return (INTVAL)0;
}

#line 1986 "default.c"

INTVAL
Parrot_default_cmp_string(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "cmp_string");
    return (INTVAL)0;
}

#line 1995 "default.c"

PMC*
Parrot_default_logical_or(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "logical_or");
    return (PMC*)0;
}

#line 2004 "default.c"

PMC*
Parrot_default_logical_and(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "logical_and");
    return (PMC*)0;
}

#line 2013 "default.c"

PMC*
Parrot_default_logical_xor(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "logical_xor");
    return (PMC*)0;
}

#line 2022 "default.c"

PMC*
Parrot_default_logical_not(Interp* interpreter, PMC* pmc, PMC* dest)
{
    cant_do_method(interpreter, pmc, "logical_not");
    return (PMC*)0;
}

#line 2031 "default.c"

void
Parrot_default_i_logical_not(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "i_logical_not");
    
}

#line 2040 "default.c"

PMC*
Parrot_default_concatenate(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "concatenate");
    return (PMC*)0;
}

#line 2049 "default.c"

PMC*
Parrot_default_concatenate_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "concatenate_str");
    return (PMC*)0;
}

#line 2058 "default.c"

void
Parrot_default_i_concatenate(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_concatenate");
    
}

#line 2067 "default.c"

void
Parrot_default_i_concatenate_str(Interp* interpreter, PMC* pmc, STRING* value)
{
    cant_do_method(interpreter, pmc, "i_concatenate_str");
    
}

#line 2076 "default.c"

PMC*
Parrot_default_repeat(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "repeat");
    return (PMC*)0;
}

#line 2085 "default.c"

PMC*
Parrot_default_repeat_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interpreter, pmc, "repeat_int");
    return (PMC*)0;
}

#line 2094 "default.c"

void
Parrot_default_i_repeat(Interp* interpreter, PMC* pmc, PMC* value)
{
    cant_do_method(interpreter, pmc, "i_repeat");
    
}

#line 2103 "default.c"

void
Parrot_default_i_repeat_int(Interp* interpreter, PMC* pmc, INTVAL value)
{
    cant_do_method(interpreter, pmc, "i_repeat_int");
    
}

#line 2112 "default.c"

void
Parrot_default_substr(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
{
    cant_do_method(interpreter, pmc, "substr");
    
}

#line 2121 "default.c"

STRING*
Parrot_default_substr_str(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length)
{
    cant_do_method(interpreter, pmc, "substr_str");
    return (STRING*)0;
}

#line 2130 "default.c"

INTVAL
Parrot_default_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "exists_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 678 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_exists_keyed(interpreter, pmc, r_key);

}
#line 2149 "src/pmc/default.c"


#line 2150 "default.c"

INTVAL
Parrot_default_exists_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "exists_keyed_str");
    return (INTVAL)0;
}

INTVAL
Parrot_default_defined(Interp* interpreter, PMC* pmc)
#line 693 "src/pmc/default.pmc"
{
    return 1;

}
#line 2168 "src/pmc/default.c"


#line 2169 "default.c"

INTVAL
Parrot_default_defined_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "defined_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 709 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_defined_keyed(interpreter, pmc, r_key);

}
#line 2188 "src/pmc/default.c"


#line 2189 "default.c"

INTVAL
Parrot_default_defined_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "defined_keyed_str");
    return (INTVAL)0;
}

#line 2198 "default.c"

void
Parrot_default_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
{
    cant_do_method(interpreter, pmc, "delete_keyed");
    
}

void
Parrot_default_delete_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 724 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
     VTABLE_delete_keyed(interpreter, pmc, r_key);

}
#line 2217 "src/pmc/default.c"


#line 2218 "default.c"

void
Parrot_default_delete_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
{
    cant_do_method(interpreter, pmc, "delete_keyed_str");
    
}

#line 2227 "default.c"

PMC*
Parrot_default_nextkey_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL what)
{
    cant_do_method(interpreter, pmc, "nextkey_keyed");
    return (PMC*)0;
}

PMC*
Parrot_default_nextkey_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL w)
#line 740 "src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interpreter, key);
    return  VTABLE_nextkey_keyed(interpreter, pmc, r_key, w);

}
#line 2246 "src/pmc/default.c"


#line 2247 "default.c"

PMC*
Parrot_default_nextkey_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL what)
{
    cant_do_method(interpreter, pmc, "nextkey_keyed_str");
    return (PMC*)0;
}

#line 2256 "default.c"

PMC*
Parrot_default_get_iter(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_iter");
    return (PMC*)0;
}

#line 2265 "default.c"

void*
Parrot_default_invoke(Interp* interpreter, PMC* pmc, void* next)
{
    cant_do_method(interpreter, pmc, "invoke");
    return (void*)0;
}

INTVAL
Parrot_default_can(Interp* interpreter, PMC* pmc, STRING* method)
#line 755 "src/pmc/default.pmc"
{
    return VTABLE_find_method(interpreter, pmc, method) != NULL;

}
#line 2283 "src/pmc/default.c"


INTVAL
Parrot_default_does(Interp* interpreter, PMC* pmc, STRING* interface)
#line 769 "src/pmc/default.pmc"
{
    return does_isa(interpreter, interface, pmc->vtable->does_str);

}
#line 2293 "src/pmc/default.c"


INTVAL
Parrot_default_isa(Interp* interpreter, PMC* pmc, STRING* class)
#line 783 "src/pmc/default.pmc"
{
    /* TODO FIXME - walk mro */
    return does_isa(interpreter, class, pmc->vtable->isa_str);

}
#line 2304 "src/pmc/default.c"


PMC*
Parrot_default_subclass(Interp* interpreter, PMC* pmc, PMC *name)
#line 798 "src/pmc/default.pmc"
{
    return Parrot_single_subclass(interpreter, pmc, name);

}
#line 2314 "src/pmc/default.c"


#line 2315 "default.c"

PMC*
Parrot_default_get_attr(Interp* interpreter, PMC* pmc, INTVAL idx)
{
    cant_do_method(interpreter, pmc, "get_attr");
    return (PMC*)0;
}

PMC*
Parrot_default_get_attr_str(Interp* interpreter, PMC* pmc, STRING* name)
#line 819 "src/pmc/default.pmc"
{
    PMC *p = NULL;
    HashBucket* b;
    /* lets look for props first
     * XXX do we need that in the default object system?
     */
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
         b = hash_get_bucket(interpreter, (Hash*) PMC_metadata(pmc), name);
         if (b)
             p = b->value;
    }
    if (PMC_IS_NULL(p)) {
        /* may be NCI? */
        p = VTABLE_find_method(interpreter, pmc, name);
    }
    if (PMC_IS_NULL(p)) {
        /* TODO AttributeError */
    }
    else if (VTABLE_isa(interpreter, p, CONST_STRING(interpreter, "NCI"))) {
        PMC *bound_meth = VTABLE_clone(interpreter, p);
        bound_meth->vtable = interpreter->vtables[enum_class_Bound_NCI];
        VTABLE_set_pmc(interpreter, bound_meth, pmc);
        return bound_meth;
    }
    else if (p->vtable->base_type == enum_class_MultiSub) {
        PMC *bound_meth = pmc_new(interpreter, enum_class_Bound_NCI);
        VTABLE_set_pmc(interpreter, bound_meth, pmc);
        PMC_struct_val(bound_meth) = p;
        PObj_get_FLAGS(bound_meth) |= PObj_private0_FLAG;
        return bound_meth;
    }
    /* TODO bound user functions */
    return p;

}
#line 2364 "src/pmc/default.c"


#line 2365 "default.c"

void
Parrot_default_set_attr(Interp* interpreter, PMC* pmc, INTVAL idx, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_attr");
    
}

#line 2374 "default.c"

void
Parrot_default_set_attr_str(Interp* interpreter, PMC* pmc, STRING* idx, PMC* value)
{
    cant_do_method(interpreter, pmc, "set_attr_str");
    
}

PMC*
Parrot_default_get_class(Interp* interpreter, PMC* pmc)
#line 815 "src/pmc/default.pmc"
{
    return pmc;

}
#line 2392 "src/pmc/default.c"


void
Parrot_default_add_parent(Interp* interpreter, PMC* pmc, PMC *parent)
#line 864 "src/pmc/default.pmc"
{
    Parrot_add_parent(interpreter, pmc, parent);

}
#line 2402 "src/pmc/default.c"


#line 2403 "default.c"

void
Parrot_default_become_parent(Interp* interpreter, PMC* pmc, PMC* class)
{
    cant_do_method(interpreter, pmc, "become_parent");
    
}

#line 2412 "default.c"

INTVAL
Parrot_default_class_type(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "class_type");
    return (INTVAL)0;
}

void
Parrot_default_add_method(Interp* interpreter, PMC* pmc, STRING *method_name, PMC *sub_pmc)
#line 404 "src/pmc/default.pmc"
{
    STRING *names =  VTABLE_name(interpreter, pmc);
    Parrot_store_global(interpreter, names, method_name, sub_pmc);

}
#line 2431 "src/pmc/default.c"


#line 2432 "default.c"

void
Parrot_default_remove_method(Interp* interpreter, PMC* pmc, STRING* method)
{
    cant_do_method(interpreter, pmc, "remove_method");
    
}

#line 2441 "default.c"

PMC*
Parrot_default_new_singleton(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "new_singleton");
    return (PMC*)0;
}

#line 2450 "default.c"

PMC*
Parrot_default_get_anonymous_subclass(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "get_anonymous_subclass");
    return (PMC*)0;
}

void
Parrot_default_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 901 "src/pmc/default.pmc"
{
    /* default - no action */

}
#line 2468 "src/pmc/default.c"


void
Parrot_default_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 915 "src/pmc/default.pmc"
{
    /* default - initialize the PMC */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        if (!pmc->pmc_ext)
            add_pmc_ext(interpreter, pmc);
        info->thaw_ptr = &PMC_metadata(pmc);
        info->container = pmc;
        (info->visit_pmc_now)(interpreter, PMC_metadata(pmc), info);
    }
    else
         VTABLE_init(interpreter, pmc);

}
#line 2487 "src/pmc/default.c"


void
Parrot_default_thawfinish(Interp* interpreter, PMC* pmc, visit_info *info)
#line 938 "src/pmc/default.pmc"
{
    /* default - no action */

}
#line 2497 "src/pmc/default.c"


void
Parrot_default_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 878 "src/pmc/default.pmc"
{
    /* default - mark prop hash */
    if (pmc->pmc_ext && PMC_metadata(pmc) &&
        info->extra_flags != EXTRA_IS_PROP_HASH) {
        info->extra_flags = EXTRA_IS_PROP_HASH;
        info->extra = PMC_metadata(pmc);
        /* place escape mark */
        (info->visit_pmc_now)(interpreter, pmc, info);
        /* place and the prop hash */
        (info->visit_pmc_now)(interpreter, PMC_metadata(pmc), info);
    }

}
#line 2516 "src/pmc/default.c"


#line 2517 "default.c"

void
Parrot_default_share(Interp* interpreter, PMC* pmc)
{
    cant_do_method(interpreter, pmc, "share");
    
}



/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
