/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/delegate.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/delegate.pmc"
/*
Copyright: 2003 The Perl Foundation.  All Rights Reserved.
$Id: delegate.pmc 12005 2006-03-24 15:19:48Z leo $

=head1 NAME

src/pmc/delegate.pmc - Delegate PMC

=head1 DESCRIPTION

Delegate each and every function to parrot bytecode.

Almost all methods are auto-generated in lib/Parrot/Pmc2c.pm

=head2 Functions

=over 4

=cut

*/


#include "parrot/parrot.h"
#include "delegate.str"
#include <assert.h>


/*

=item C<static PMC *
find_meth(Interp* interpreter, PMC *pmc, STRING *name)>

Finds and returns the delegated method with string C<name>.

=cut

*/


static PMC *
find_meth(Interp* interpreter, PMC *pmc, STRING *meth) {
    PMC *class = pmc;

    if (PObj_is_object_TEST(pmc)) {
        class = GET_CLASS((Buffer *)PMC_data(pmc), pmc);
    }
    return Parrot_find_method_with_cache(interpreter, class, meth);
}

/*

=item C<static PMC *
find_or_die(Interp* interpreter, PMC *pmc, STRING *name)>

Returns the result of calling C<find_meth()> with the arguments, raising
an exception if no method is found.

=cut

*/

static PMC *
find_or_die(Interp* interpreter, PMC *pmc, STRING *meth) {
    PMC *returnPMC = find_meth(interpreter, pmc, meth);
    if (PMC_IS_NULL(returnPMC)) {
        PMC *class = pmc;
        if (PObj_is_object_TEST(pmc)) {
            class = GET_CLASS((Buffer *)PMC_data(pmc), pmc);
            real_exception(interpreter, NULL, E_LookupError,
                "Can't find method '%s' for object '%s'",
                string_to_cstring(interpreter, meth),
                string_to_cstring(interpreter, PMC_str_val(
                        get_attrib_num((SLOTTYPE *)PMC_data(class),
                            PCD_CLASS_NAME)))
                );
        } else {
            real_exception(interpreter, NULL, E_LookupError,
                "Can't find method '%s' - erroneous PMC",
                string_to_cstring(interpreter, meth)
                );
        }
    }
    return returnPMC;
}

/*

=back

All these functions to run code can leak a full parrot register file, as
well as potentially permanently unroot some PMCs or strings, if the
vtable method throws an exception. It really ought be caught rather than
let flow through.

=over 4

=item C<PARROT_INLINE static void
noarg_noreturn(Interp* interpreter, PMC *obj, const char *meth, int die)>

Calls the delegated method with no arguments or return value. If C<die>
is true then an exception will be raised if the method is not found.

=cut

*/

static void
noarg_noreturn(Interp* interpreter, PMC *obj, PMC* class,
        const char *name, int die)
{
    STRING *meth = const_string(interpreter, name);
    PMC *method = die ? find_or_die(interpreter, class, meth) :
        find_meth(interpreter, class, meth);
    if (PMC_IS_NULL(method)) {
        if (Interp_trace_TEST(interpreter, PARROT_TRACE_FIND_METH_FLAG)) {
            PIO_eprintf(interpreter, "# not found\n");
        }
        return;
    }
    Parrot_run_meth_fromc(interpreter, method, obj, meth);
}

#line 136 "src/pmc/delegate.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_delegate.h"
#include "pmc_default.h"
#include "delegate.str"

void
Parrot_delegate_init(Interp* interpreter, PMC* pmc)
#line 150 "src/pmc/delegate.pmc"
{
    noarg_noreturn(interpreter, pmc, pmc, PARROT_VTABLE_INIT_METHNAME, 0);

}
#line 151 "src/pmc/delegate.c"


void
Parrot_delegate_init_pmc(Interp* interpreter, PMC* pmc, PMC* class)
#line 154 "src/pmc/delegate.pmc"
{
    noarg_noreturn(interpreter, pmc, class, PARROT_VTABLE_INIT_METHNAME, 0);

}
#line 161 "src/pmc/delegate.c"


#line 162 "delegate.c"

void
Parrot_delegate_init_pmc_props(Interp* interpreter, PMC* pmc, PMC* initializer, PMC* properties)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__init_pmc_props");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vPP", initializer, properties);
    
}

PMC*
Parrot_delegate_instantiate(Interp* interpreter, PMC* pmc, PMC* sig)
#line 166 "src/pmc/delegate.pmc"
{
    STRING *meth = const_string(interpreter,
            PARROT_VTABLE_INSTANTIATE_METHNAME);
    PMC *sub = find_meth(interpreter, pmc, meth);

    if (PMC_IS_NULL(sub)) {
        /* run default fallback that constructs an empty object */
        return Parrot_default_instantiate(interpreter, pmc, sig);
    }
    return (PMC*) Parrot_run_meth_fromc(interpreter, sub, pmc, meth);

}
#line 192 "src/pmc/delegate.c"


#line 193 "delegate.c"

PMC*
Parrot_delegate_new_from_string(Interp* interpreter, PMC* pmc, STRING* rep, INTVAL flags)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__new_from_string");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PSI", rep, flags);
    return ret_val;
}

#line 206 "delegate.c"

void
Parrot_delegate_morph(Interp* interpreter, PMC* pmc, INTVAL type)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__morph");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", type);
    
}

void
Parrot_delegate_mark(Interp* interpreter, PMC* pmc)
#line 162 "src/pmc/delegate.pmc"
{
    /* don't delegate mark */

}
#line 228 "src/pmc/delegate.c"


void
Parrot_delegate_destroy(Interp* interpreter, PMC* pmc)
#line 158 "src/pmc/delegate.pmc"
{
    /* don't delegate destroy */

}
#line 238 "src/pmc/delegate.c"


PMC*
Parrot_delegate_namespace(Interp* interpreter, PMC* pmc)
#line 186 "src/pmc/delegate.pmc"
{
    return pmc->vtable->_namespace;

}
#line 248 "src/pmc/delegate.c"


#line 249 "delegate.c"

PMC*
Parrot_delegate_getprop(Interp* interpreter, PMC* pmc, STRING* key)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__getprop");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PS", key);
    return ret_val;
}

#line 262 "delegate.c"

void
Parrot_delegate_setprop(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__setprop");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vSP", key, value);
    
}

#line 275 "delegate.c"

void
Parrot_delegate_delprop(Interp* interpreter, PMC* pmc, STRING* key)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__delprop");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", key);
    
}

#line 288 "delegate.c"

PMC*
Parrot_delegate_getprops(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__getprops");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 301 "delegate.c"

INTVAL
Parrot_delegate_type(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__type");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 314 "delegate.c"

INTVAL
Parrot_delegate_type_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__type_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IP", key);
    return ret_val;
}

#line 327 "delegate.c"

INTVAL
Parrot_delegate_type_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__type_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "II", key);
    return ret_val;
}

#line 340 "delegate.c"

INTVAL
Parrot_delegate_type_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__type_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", key);
    return ret_val;
}

#line 353 "delegate.c"

UINTVAL
Parrot_delegate_subtype(Interp* interpreter, PMC* pmc, INTVAL type)
 {
    UINTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__subtype");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (UINTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "?I", type);
    return ret_val;
}

STRING*
Parrot_delegate_name(Interp* interpreter, PMC* pmc)
#line 182 "src/pmc/delegate.pmc"
{
    return pmc->vtable->whoami;

}
#line 375 "src/pmc/delegate.c"


#line 376 "delegate.c"

PMC*
Parrot_delegate_clone(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__clone");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 389 "delegate.c"

PMC*
Parrot_delegate_find_method(Interp* interpreter, PMC* pmc, STRING* method_name)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__find_method");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PS", method_name);
    return ret_val;
}

#line 402 "delegate.c"

INTVAL
Parrot_delegate_hash(Interp* interpreter, PMC* pmc, size_t seed)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__hash");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I?", seed);
    return ret_val;
}

#line 415 "delegate.c"

INTVAL
Parrot_delegate_get_integer(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_integer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 428 "delegate.c"

INTVAL
Parrot_delegate_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_integer_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IP", key);
    return ret_val;
}

#line 441 "delegate.c"

INTVAL
Parrot_delegate_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_integer_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "II", key);
    return ret_val;
}

#line 454 "delegate.c"

INTVAL
Parrot_delegate_get_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_integer_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", key);
    return ret_val;
}

#line 467 "delegate.c"

FLOATVAL
Parrot_delegate_get_number(Interp* interpreter, PMC* pmc)
 {
    FLOATVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_number");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (FLOATVAL) Parrot_run_meth_fromc_args_retf(interpreter, sub,
        pmc, meth, "N");
    return ret_val;
}

#line 480 "delegate.c"

FLOATVAL
Parrot_delegate_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    FLOATVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_number_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (FLOATVAL) Parrot_run_meth_fromc_args_retf(interpreter, sub,
        pmc, meth, "NP", key);
    return ret_val;
}

#line 493 "delegate.c"

FLOATVAL
Parrot_delegate_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    FLOATVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_number_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (FLOATVAL) Parrot_run_meth_fromc_args_retf(interpreter, sub,
        pmc, meth, "NI", key);
    return ret_val;
}

#line 506 "delegate.c"

FLOATVAL
Parrot_delegate_get_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    FLOATVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_number_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (FLOATVAL) Parrot_run_meth_fromc_args_retf(interpreter, sub,
        pmc, meth, "NS", key);
    return ret_val;
}

#line 519 "delegate.c"

PMC*
Parrot_delegate_get_bignum(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_bignum");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 532 "delegate.c"

STRING*
Parrot_delegate_get_string(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_string");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "S");
    return ret_val;
}

#line 545 "delegate.c"

STRING*
Parrot_delegate_get_repr(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_repr");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "S");
    return ret_val;
}

#line 558 "delegate.c"

STRING*
Parrot_delegate_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_string_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "SP", key);
    return ret_val;
}

#line 571 "delegate.c"

STRING*
Parrot_delegate_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_string_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "SI", key);
    return ret_val;
}

#line 584 "delegate.c"

STRING*
Parrot_delegate_get_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_string_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "SS", key);
    return ret_val;
}

#line 597 "delegate.c"

INTVAL
Parrot_delegate_get_bool(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_bool");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 610 "delegate.c"

PMC*
Parrot_delegate_get_pmc(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 623 "delegate.c"

PMC*
Parrot_delegate_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pmc_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", key);
    return ret_val;
}

#line 636 "delegate.c"

PMC*
Parrot_delegate_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pmc_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PI", key);
    return ret_val;
}

#line 649 "delegate.c"

PMC*
Parrot_delegate_get_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pmc_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PS", key);
    return ret_val;
}

#line 662 "delegate.c"

PMC*
Parrot_delegate_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL flag)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__slice");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PPI", key, flag);
    return ret_val;
}

#line 675 "delegate.c"

void*
Parrot_delegate_get_pointer(Interp* interpreter, PMC* pmc)
 {
    void* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pointer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (void*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "?");
    return ret_val;
}

#line 688 "delegate.c"

void*
Parrot_delegate_get_pointer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    void* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pointer_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (void*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "?P", key);
    return ret_val;
}

#line 701 "delegate.c"

void*
Parrot_delegate_get_pointer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    void* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pointer_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (void*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "?I", key);
    return ret_val;
}

#line 714 "delegate.c"

void*
Parrot_delegate_get_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    void* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_pointer_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (void*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "?S", key);
    return ret_val;
}

#line 727 "delegate.c"

void
Parrot_delegate_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_integer_native");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", value);
    
}

#line 740 "delegate.c"

void
Parrot_delegate_set_integer_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_integer_same");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 753 "delegate.c"

void
Parrot_delegate_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_integer_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vPI", key, value);
    
}

#line 766 "delegate.c"

void
Parrot_delegate_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_integer_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vII", key, value);
    
}

#line 779 "delegate.c"

void
Parrot_delegate_set_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_integer_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vSI", key, value);
    
}

#line 792 "delegate.c"

void
Parrot_delegate_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_number_native");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vN", value);
    
}

#line 805 "delegate.c"

void
Parrot_delegate_set_number_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_number_same");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 818 "delegate.c"

void
Parrot_delegate_set_number_keyed(Interp* interpreter, PMC* pmc, PMC* key, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_number_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vPN", key, value);
    
}

#line 831 "delegate.c"

void
Parrot_delegate_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_number_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vIN", key, value);
    
}

#line 844 "delegate.c"

void
Parrot_delegate_set_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_number_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vSN", key, value);
    
}

#line 857 "delegate.c"

void
Parrot_delegate_set_bignum_int(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_bignum_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", value);
    
}

#line 870 "delegate.c"

void
Parrot_delegate_set_bignum_num(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_bignum_num");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vN", value);
    
}

#line 883 "delegate.c"

void
Parrot_delegate_set_bignum_str(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_bignum_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", value);
    
}

#line 896 "delegate.c"

void
Parrot_delegate_set_string_native(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_string_native");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", value);
    
}

#line 909 "delegate.c"

void
Parrot_delegate_assign_string_native(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__assign_string_native");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", value);
    
}

#line 922 "delegate.c"

void
Parrot_delegate_set_string_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_string_same");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 935 "delegate.c"

void
Parrot_delegate_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_string_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vPS", key, value);
    
}

#line 948 "delegate.c"

void
Parrot_delegate_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_string_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vIS", key, value);
    
}

#line 961 "delegate.c"

void
Parrot_delegate_set_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_string_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vSS", key, value);
    
}

#line 974 "delegate.c"

void
Parrot_delegate_set_bool(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_bool");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", value);
    
}

#line 987 "delegate.c"

void
Parrot_delegate_set_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 1000 "delegate.c"

void
Parrot_delegate_assign_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__assign_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 1013 "delegate.c"

void
Parrot_delegate_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pmc_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vPP", key, value);
    
}

#line 1026 "delegate.c"

void
Parrot_delegate_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pmc_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vIP", key, value);
    
}

#line 1039 "delegate.c"

void
Parrot_delegate_set_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pmc_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vSP", key, value);
    
}

#line 1052 "delegate.c"

void
Parrot_delegate_set_pointer(Interp* interpreter, PMC* pmc, void* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pointer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v?", value);
    
}

#line 1065 "delegate.c"

void
Parrot_delegate_set_pointer_keyed(Interp* interpreter, PMC* pmc, PMC* key, void* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pointer_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP?", key, value);
    
}

#line 1078 "delegate.c"

void
Parrot_delegate_set_pointer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, void* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pointer_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI?", key, value);
    
}

#line 1091 "delegate.c"

void
Parrot_delegate_set_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, void* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_pointer_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS?", key, value);
    
}

#line 1104 "delegate.c"

INTVAL
Parrot_delegate_elements(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__elements");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 1117 "delegate.c"

INTVAL
Parrot_delegate_pop_integer(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__pop_integer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 1130 "delegate.c"

FLOATVAL
Parrot_delegate_pop_float(Interp* interpreter, PMC* pmc)
 {
    FLOATVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__pop_float");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (FLOATVAL) Parrot_run_meth_fromc_args_retf(interpreter, sub,
        pmc, meth, "N");
    return ret_val;
}

#line 1143 "delegate.c"

STRING*
Parrot_delegate_pop_string(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__pop_string");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "S");
    return ret_val;
}

#line 1156 "delegate.c"

PMC*
Parrot_delegate_pop_pmc(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__pop_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 1169 "delegate.c"

void
Parrot_delegate_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__push_integer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", value);
    
}

#line 1182 "delegate.c"

void
Parrot_delegate_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__push_float");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vN", value);
    
}

#line 1195 "delegate.c"

void
Parrot_delegate_push_string(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__push_string");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", value);
    
}

#line 1208 "delegate.c"

void
Parrot_delegate_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__push_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 1221 "delegate.c"

INTVAL
Parrot_delegate_shift_integer(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__shift_integer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 1234 "delegate.c"

FLOATVAL
Parrot_delegate_shift_float(Interp* interpreter, PMC* pmc)
 {
    FLOATVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__shift_float");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (FLOATVAL) Parrot_run_meth_fromc_args_retf(interpreter, sub,
        pmc, meth, "N");
    return ret_val;
}

#line 1247 "delegate.c"

STRING*
Parrot_delegate_shift_string(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__shift_string");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "S");
    return ret_val;
}

#line 1260 "delegate.c"

PMC*
Parrot_delegate_shift_pmc(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__shift_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 1273 "delegate.c"

void
Parrot_delegate_unshift_integer(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__unshift_integer");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", value);
    
}

#line 1286 "delegate.c"

void
Parrot_delegate_unshift_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__unshift_float");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vN", value);
    
}

#line 1299 "delegate.c"

void
Parrot_delegate_unshift_string(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__unshift_string");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", value);
    
}

#line 1312 "delegate.c"

void
Parrot_delegate_unshift_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__unshift_pmc");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", value);
    
}

#line 1325 "delegate.c"

void
Parrot_delegate_splice(Interp* interpreter, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__splice");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vPII", value, offset, count);
    
}

#line 1338 "delegate.c"

void
Parrot_delegate_increment(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__increment");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1351 "delegate.c"

void
Parrot_delegate_decrement(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__decrement");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1364 "delegate.c"

PMC*
Parrot_delegate_absolute(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__absolute");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", dest);
    return ret_val;
}

#line 1377 "delegate.c"

void
Parrot_delegate_i_absolute(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__i_absolute");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1390 "delegate.c"

PMC*
Parrot_delegate_neg(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__neg");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", dest);
    return ret_val;
}

#line 1403 "delegate.c"

void
Parrot_delegate_i_neg(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__i_neg");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1416 "delegate.c"

PMC*
Parrot_delegate_bitwise_not(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__bitwise_not");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", dest);
    return ret_val;
}

#line 1429 "delegate.c"

void
Parrot_delegate_i_bitwise_not(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__i_bitwise_not");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1442 "delegate.c"

PMC*
Parrot_delegate_bitwise_nots(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__bitwise_nots");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", dest);
    return ret_val;
}

#line 1455 "delegate.c"

void
Parrot_delegate_i_bitwise_nots(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__i_bitwise_nots");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1468 "delegate.c"

INTVAL
Parrot_delegate_is_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__is_same");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IP", value);
    return ret_val;
}

#line 1481 "delegate.c"

PMC*
Parrot_delegate_logical_not(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__logical_not");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", dest);
    return ret_val;
}

#line 1494 "delegate.c"

void
Parrot_delegate_i_logical_not(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__i_logical_not");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

#line 1507 "delegate.c"

void
Parrot_delegate_substr(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__substr");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vIIP", offset, length, dest);
    
}

#line 1520 "delegate.c"

STRING*
Parrot_delegate_substr_str(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length)
 {
    STRING* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__substr_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (STRING*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "SII", offset, length);
    return ret_val;
}

#line 1533 "delegate.c"

INTVAL
Parrot_delegate_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__exists_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IP", key);
    return ret_val;
}

#line 1546 "delegate.c"

INTVAL
Parrot_delegate_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__exists_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "II", key);
    return ret_val;
}

#line 1559 "delegate.c"

INTVAL
Parrot_delegate_exists_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__exists_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", key);
    return ret_val;
}

#line 1572 "delegate.c"

INTVAL
Parrot_delegate_defined(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__defined");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

#line 1585 "delegate.c"

INTVAL
Parrot_delegate_defined_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__defined_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IP", key);
    return ret_val;
}

#line 1598 "delegate.c"

INTVAL
Parrot_delegate_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__defined_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "II", key);
    return ret_val;
}

#line 1611 "delegate.c"

INTVAL
Parrot_delegate_defined_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__defined_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", key);
    return ret_val;
}

#line 1624 "delegate.c"

void
Parrot_delegate_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__delete_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", key);
    
}

#line 1637 "delegate.c"

void
Parrot_delegate_delete_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__delete_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vI", key);
    
}

#line 1650 "delegate.c"

void
Parrot_delegate_delete_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__delete_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", key);
    
}

#line 1663 "delegate.c"

PMC*
Parrot_delegate_nextkey_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL what)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__nextkey_keyed");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PPI", key, what);
    return ret_val;
}

#line 1676 "delegate.c"

PMC*
Parrot_delegate_nextkey_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL what)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__nextkey_keyed_int");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PII", key, what);
    return ret_val;
}

#line 1689 "delegate.c"

PMC*
Parrot_delegate_nextkey_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL what)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__nextkey_keyed_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PSI", key, what);
    return ret_val;
}

#line 1702 "delegate.c"

PMC*
Parrot_delegate_get_iter(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_iter");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 1715 "delegate.c"

void*
Parrot_delegate_invoke(Interp* interpreter, PMC* pmc, void* next)
 {
    void* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__invoke");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (void*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "??", next);
    return ret_val;
}

#line 1728 "delegate.c"

INTVAL
Parrot_delegate_can(Interp* interpreter, PMC* pmc, STRING* method)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__can");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", method);
    return ret_val;
}

#line 1741 "delegate.c"

INTVAL
Parrot_delegate_does(Interp* interpreter, PMC* pmc, STRING* method)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__does");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", method);
    return ret_val;
}

#line 1754 "delegate.c"

INTVAL
Parrot_delegate_isa(Interp* interpreter, PMC* pmc, STRING* _class)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__isa");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "IS", _class);
    return ret_val;
}

#line 1767 "delegate.c"

PMC*
Parrot_delegate_subclass(Interp* interpreter, PMC* pmc, PMC* name)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__subclass");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PP", name);
    return ret_val;
}

#line 1780 "delegate.c"

PMC*
Parrot_delegate_get_attr(Interp* interpreter, PMC* pmc, INTVAL idx)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_attr");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PI", idx);
    return ret_val;
}

#line 1793 "delegate.c"

PMC*
Parrot_delegate_get_attr_str(Interp* interpreter, PMC* pmc, STRING* idx)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_attr_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "PS", idx);
    return ret_val;
}

#line 1806 "delegate.c"

void
Parrot_delegate_set_attr(Interp* interpreter, PMC* pmc, INTVAL idx, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_attr");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vIP", idx, value);
    
}

#line 1819 "delegate.c"

void
Parrot_delegate_set_attr_str(Interp* interpreter, PMC* pmc, STRING* idx, PMC* value)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__set_attr_str");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vSP", idx, value);
    
}

#line 1832 "delegate.c"

PMC*
Parrot_delegate_get_class(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_class");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 1845 "delegate.c"

void
Parrot_delegate_add_parent(Interp* interpreter, PMC* pmc, PMC* parent)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__add_parent");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", parent);
    
}

#line 1858 "delegate.c"

void
Parrot_delegate_become_parent(Interp* interpreter, PMC* pmc, PMC* class)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__become_parent");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vP", class);
    
}

#line 1871 "delegate.c"

INTVAL
Parrot_delegate_class_type(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    STRING *meth = CONST_STRING(interpreter, "__class_type");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (INTVAL) Parrot_run_meth_fromc_args_reti(interpreter, sub,
        pmc, meth, "I");
    return ret_val;
}

void
Parrot_delegate_add_method(Interp* interpreter, PMC* pmc, STRING *method_name, PMC *sub_pmc)
#line 178 "src/pmc/delegate.pmc"
{
    Parrot_default_add_method(interpreter, pmc, method_name, sub_pmc);

}
#line 1893 "src/pmc/delegate.c"


#line 1894 "delegate.c"

void
Parrot_delegate_remove_method(Interp* interpreter, PMC* pmc, STRING* method)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__remove_method");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "vS", method);
    
}

#line 1907 "delegate.c"

PMC*
Parrot_delegate_new_singleton(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__new_singleton");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 1920 "delegate.c"

PMC*
Parrot_delegate_get_anonymous_subclass(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    STRING *meth = CONST_STRING(interpreter, "__get_anonymous_subclass");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    ret_val = (PMC*) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "P");
    return ret_val;
}

#line 1933 "delegate.c"

void
Parrot_delegate_freeze(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__freeze");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v?", info);
    
}

#line 1946 "delegate.c"

void
Parrot_delegate_thaw(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__thaw");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v?", info);
    
}

#line 1959 "delegate.c"

void
Parrot_delegate_thawfinish(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__thawfinish");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v?", info);
    
}

#line 1972 "delegate.c"

void
Parrot_delegate_visit(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__visit");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v?", info);
    
}

#line 1985 "delegate.c"

void
Parrot_delegate_share(Interp* interpreter, PMC* pmc)
 {
    
    STRING *meth = CONST_STRING(interpreter, "__share");
    PMC *sub = find_or_die(interpreter, pmc, meth);
    (void) Parrot_run_meth_fromc_args(interpreter, sub,
        pmc, meth, "v");
    
}

void
Parrot_delegate_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_delegate,	/* base_type */
        NULL,	/* whoami */
        0, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_delegate_init,
        Parrot_delegate_init_pmc,
        Parrot_delegate_init_pmc_props,
        Parrot_delegate_instantiate,
        Parrot_delegate_new_from_string,
        Parrot_delegate_morph,
        Parrot_delegate_mark,
        Parrot_delegate_destroy,
        Parrot_delegate_namespace,
        Parrot_delegate_getprop,
        Parrot_delegate_setprop,
        Parrot_delegate_delprop,
        Parrot_delegate_getprops,
        Parrot_delegate_type,
        Parrot_delegate_type_keyed,
        Parrot_delegate_type_keyed_int,
        Parrot_delegate_type_keyed_str,
        Parrot_delegate_subtype,
        Parrot_delegate_name,
        Parrot_delegate_clone,
        Parrot_delegate_find_method,
        Parrot_delegate_hash,
        Parrot_delegate_get_integer,
        Parrot_delegate_get_integer_keyed,
        Parrot_delegate_get_integer_keyed_int,
        Parrot_delegate_get_integer_keyed_str,
        Parrot_delegate_get_number,
        Parrot_delegate_get_number_keyed,
        Parrot_delegate_get_number_keyed_int,
        Parrot_delegate_get_number_keyed_str,
        Parrot_delegate_get_bignum,
        Parrot_delegate_get_string,
        Parrot_delegate_get_repr,
        Parrot_delegate_get_string_keyed,
        Parrot_delegate_get_string_keyed_int,
        Parrot_delegate_get_string_keyed_str,
        Parrot_delegate_get_bool,
        Parrot_delegate_get_pmc,
        Parrot_delegate_get_pmc_keyed,
        Parrot_delegate_get_pmc_keyed_int,
        Parrot_delegate_get_pmc_keyed_str,
        Parrot_delegate_slice,
        Parrot_delegate_get_pointer,
        Parrot_delegate_get_pointer_keyed,
        Parrot_delegate_get_pointer_keyed_int,
        Parrot_delegate_get_pointer_keyed_str,
        Parrot_delegate_set_integer_native,
        Parrot_delegate_set_integer_same,
        Parrot_delegate_set_integer_keyed,
        Parrot_delegate_set_integer_keyed_int,
        Parrot_delegate_set_integer_keyed_str,
        Parrot_delegate_set_number_native,
        Parrot_delegate_set_number_same,
        Parrot_delegate_set_number_keyed,
        Parrot_delegate_set_number_keyed_int,
        Parrot_delegate_set_number_keyed_str,
        Parrot_delegate_set_bignum_int,
        Parrot_delegate_set_bignum_num,
        Parrot_delegate_set_bignum_str,
        Parrot_delegate_set_string_native,
        Parrot_delegate_assign_string_native,
        Parrot_delegate_set_string_same,
        Parrot_delegate_set_string_keyed,
        Parrot_delegate_set_string_keyed_int,
        Parrot_delegate_set_string_keyed_str,
        Parrot_delegate_set_bool,
        Parrot_delegate_set_pmc,
        Parrot_delegate_assign_pmc,
        Parrot_delegate_set_pmc_keyed,
        Parrot_delegate_set_pmc_keyed_int,
        Parrot_delegate_set_pmc_keyed_str,
        Parrot_delegate_set_pointer,
        Parrot_delegate_set_pointer_keyed,
        Parrot_delegate_set_pointer_keyed_int,
        Parrot_delegate_set_pointer_keyed_str,
        Parrot_delegate_elements,
        Parrot_delegate_pop_integer,
        Parrot_delegate_pop_float,
        Parrot_delegate_pop_string,
        Parrot_delegate_pop_pmc,
        Parrot_delegate_push_integer,
        Parrot_delegate_push_float,
        Parrot_delegate_push_string,
        Parrot_delegate_push_pmc,
        Parrot_delegate_shift_integer,
        Parrot_delegate_shift_float,
        Parrot_delegate_shift_string,
        Parrot_delegate_shift_pmc,
        Parrot_delegate_unshift_integer,
        Parrot_delegate_unshift_float,
        Parrot_delegate_unshift_string,
        Parrot_delegate_unshift_pmc,
        Parrot_delegate_splice,
        Parrot_delegate_increment,
        Parrot_delegate_decrement,
        Parrot_delegate_absolute,
        Parrot_delegate_i_absolute,
        Parrot_delegate_neg,
        Parrot_delegate_i_neg,
        Parrot_delegate_bitwise_not,
        Parrot_delegate_i_bitwise_not,
        Parrot_delegate_bitwise_nots,
        Parrot_delegate_i_bitwise_nots,
        Parrot_delegate_is_same,
        Parrot_delegate_logical_not,
        Parrot_delegate_i_logical_not,
        Parrot_delegate_substr,
        Parrot_delegate_substr_str,
        Parrot_delegate_exists_keyed,
        Parrot_delegate_exists_keyed_int,
        Parrot_delegate_exists_keyed_str,
        Parrot_delegate_defined,
        Parrot_delegate_defined_keyed,
        Parrot_delegate_defined_keyed_int,
        Parrot_delegate_defined_keyed_str,
        Parrot_delegate_delete_keyed,
        Parrot_delegate_delete_keyed_int,
        Parrot_delegate_delete_keyed_str,
        Parrot_delegate_nextkey_keyed,
        Parrot_delegate_nextkey_keyed_int,
        Parrot_delegate_nextkey_keyed_str,
        Parrot_delegate_get_iter,
        Parrot_delegate_invoke,
        Parrot_delegate_can,
        Parrot_delegate_does,
        Parrot_delegate_isa,
        Parrot_delegate_subclass,
        Parrot_delegate_get_attr,
        Parrot_delegate_get_attr_str,
        Parrot_delegate_set_attr,
        Parrot_delegate_set_attr_str,
        Parrot_delegate_get_class,
        Parrot_delegate_add_parent,
        Parrot_delegate_become_parent,
        Parrot_delegate_class_type,
        Parrot_delegate_add_method,
        Parrot_delegate_remove_method,
        Parrot_delegate_new_singleton,
        Parrot_delegate_get_anonymous_subclass,
        Parrot_delegate_freeze,
        Parrot_delegate_thaw,
        Parrot_delegate_thawfinish,
        Parrot_delegate_visit,
        Parrot_delegate_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "delegate");
        vt_clone->isa_str = CONST_STRING(interp, "delegate");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_delegate_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
