/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/eval.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/eval.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: eval.pmc 12007 2006-03-24 15:56:23Z leo $

=head1 NAME

src/pmc/eval.pmc - Dynamic code evaluation

=head1 DESCRIPTION

C<Eval> extends C<Closure> to provide C<eval>-like dynamic code
evaluation and execution.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

static void
clear_fixups(Interp* interpreter, parrot_sub_t sub_data)
{
    opcode_t i, ci;
    struct PackFile_ByteCode *seg;
    struct PackFile_FixupTable *ft;
    struct PackFile_ConstTable *ct;
    PMC *sub;

    seg = sub_data->seg;
    if (!seg)
        return;
    ft = seg->fixups;
    if (!ft)
        return;
    ct = seg->const_table;
    if (!ct)
        return;
    for (i = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                ci = ft->fixups[i]->offset;
                sub = ct->constants[ci]->u.key;
                if (PMC_sub(sub)) {
                    PMC_sub(sub)->seg = NULL;
                    PMC_sub(sub)->eval_pmc = NULL;
                }
                ct->constants[ci]->u.key = NULL;
                ft->fixups[i]->type = 0;
        }
    }
}

static PMC*
get_sub(Interp* interpreter, PMC* self, int idx)
{
    opcode_t i, n, ci;
    struct PackFile_ByteCode *seg;
    struct PackFile_FixupTable *ft;
    struct PackFile_ConstTable *ct;
    PMC *sub;

    seg = PMC_sub(self)->seg;
    if (!seg)
        return PMCNULL;
    ft = seg->fixups;
    if (!ft)
        return PMCNULL;
    ct = seg->const_table;
    if (!ct)
        return PMCNULL;
    for (i = n = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                if (n++ != idx)
                    continue;
                ci = ft->fixups[i]->offset;
                sub = ct->constants[ci]->u.key;
                return sub;
        }
    }
    return PMCNULL;
}

static void
mark_subs(Interp* interpreter, PMC* self)
{
    opcode_t i, ci;
    struct PackFile_ByteCode *seg;
    struct PackFile_FixupTable *ft;
    struct PackFile_ConstTable *ct;
    PMC *sub;

    seg = PMC_sub(self)->seg;
    if (!seg)
        return;
    ft = seg->fixups;
    if (!ft)
        return;
    ct = seg->const_table;
    if (!ct)
        return;
    for (i = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                ci = ft->fixups[i]->offset;
                sub = ct->constants[ci]->u.key;
                pobject_lives(interpreter, (PObj*)sub);
        }
    }
}

#line 128 "src/pmc/eval.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_eval.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "eval.str"

void
Parrot_Eval_init(Interp* interpreter, PMC* pmc)
#line 118 "src/pmc/eval.pmc"
{
    parrot_sub_t sub_data;
    Parrot_Sub_init(interpreter, pmc);
    sub_data = PMC_sub(pmc);
    PObj_custom_mark_destroy_SETALL(pmc);
    sub_data->seg = NULL;

}
#line 148 "src/pmc/eval.c"


void
Parrot_Eval_mark(Interp* interpreter, PMC* pmc)
#line 194 "src/pmc/eval.pmc"
{
    mark_subs(interpreter, pmc);

}
#line 158 "src/pmc/eval.c"


void
Parrot_Eval_destroy(Interp* interpreter, PMC* pmc)
#line 140 "src/pmc/eval.pmc"
{
    /*
     * If the compiled code contained any .sub (or .pcc.sub)
     * subroutines, these subs got installed in the globals
     * during compiling this bytecode segment.
     *
     * These globals still exist, calling them will segfault
     * as the segment is destroyed now.
     *
     * TODO walk the fixups for this segment, locate globals
     *      and nullify the Sub PMC.
     * This probably needs a pointer into the globals.
     *
     * OTOH - if the global exists - this eval pmc ought
     *        to be alive and destroy isn't called.
     */
    parrot_sub_t sub_data;
    struct PackFile_Segment *seg;
    struct PackFile_ByteCode *cur_cs;

    sub_data = PMC_sub(pmc);

    if (!sub_data)
        return;
    clear_fixups(interpreter, sub_data);
    cur_cs = sub_data->seg;
    if (!cur_cs)
        return;

    /* TODO create PF API, move it there */
    seg = (struct PackFile_Segment *)cur_cs->const_table;
    if (seg) {
        PackFile_Segment_destroy(interpreter, seg);
    }
    seg = (struct PackFile_Segment *)cur_cs->debugs;
    if (seg) {
        PackFile_Segment_destroy(interpreter, seg);
    }
    seg = (struct PackFile_Segment *)cur_cs->fixups;
    if (seg) {
        PackFile_Segment_destroy(interpreter, seg);
        cur_cs->fixups = NULL;
    }
    seg = cur_cs->pic_index;
    if (seg) {
        PackFile_Segment_destroy(interpreter, seg);
    }
    seg = (struct PackFile_Segment *)cur_cs;
    PackFile_Segment_destroy(interpreter, seg);
    sub_data->seg = NULL;
    PMC_struct_val(pmc) = NULL;
    mem_sys_free(sub_data);

}
#line 218 "src/pmc/eval.c"


STRING*
Parrot_Eval_get_string(Interp* interpreter, PMC* pmc)
#line 209 "src/pmc/eval.pmc"
{
    STRING *res;
    struct PackFile *pf;
    size_t size, aligned_size;
    struct PackFile_ByteCode *seg;

    pf = PackFile_new(interpreter, 0);
    seg = PMC_sub(pmc)->seg;
    PackFile_add_segment(interpreter, &pf->directory,
            (struct PackFile_Segment *)seg);
    if (seg->const_table)
        PackFile_add_segment(interpreter, &pf->directory,
                (struct PackFile_Segment *)seg->const_table);
    if (seg->debugs)
        PackFile_add_segment(interpreter, &pf->directory,
                (struct PackFile_Segment *)seg->debugs);
    if (seg->fixups)
        PackFile_add_segment(interpreter, &pf->directory,
                (struct PackFile_Segment *)seg->fixups);
    if (seg->pic_index)
        PackFile_add_segment(interpreter, &pf->directory,
                (struct PackFile_Segment *)seg->pic_index);
    size = PackFile_pack_size(interpreter, pf) * sizeof(opcode_t);
    /*
     * work around packfile bug:
     * as far as I have checked it the story is:
     * - PackFile_pack_size() assumes 16 byte alignment but doesn't
     *   have the actual start of the code (packed)
     * - PackFile_pack() uses 16 bye alignment relative to the start
     *   of the code, which isn't really the same
     * Therefore align code at 16, which should give the desired
     * effect
     */
    aligned_size = size + 15;
    res = string_make_empty(interpreter, enum_stringrep_one, aligned_size);
    res->strlen = res->bufused = size;
    if ((size_t)(res->strstart) & 0xf) {
        char *adr = res->strstart;
        adr += 16 - ((size_t)adr & 0xf);
        res->strstart = adr;
    }
    PackFile_pack(interpreter, pf, res->strstart);
    /* now remove all segments from directory again and destroy
     * the packfile
     */
    pf->directory.num_segments = 0;
    PackFile_destroy(interpreter, pf);
    return res;

}
#line 274 "src/pmc/eval.c"


PMC*
Parrot_Eval_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 269 "src/pmc/eval.pmc"
{
    return get_sub(interpreter, pmc, key);

}
#line 284 "src/pmc/eval.c"


void*
Parrot_Eval_invoke(Interp* interpreter, PMC* pmc, void *next)
#line 135 "src/pmc/eval.pmc"
{
    PMC *sub = Parrot_Eval_get_pmc_keyed_int(interpreter, pmc, 0);
    return VTABLE_invoke(interpreter, sub, next);

}
#line 295 "src/pmc/eval.c"


void
Parrot_Eval_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 287 "src/pmc/eval.pmc"
{
    IMAGE_IO *io = info->image_io;
    STRING *packed = Parrot_Eval_get_string(interpreter, pmc);
     VTABLE_push_string(interpreter, io, packed);
    Parrot_Sub_freeze(interpreter, pmc, info);

}
#line 308 "src/pmc/eval.c"


void
Parrot_Eval_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 294 "src/pmc/eval.pmc"
{
    IMAGE_IO *io = info->image_io;
    struct PackFile *pf;
    STRING *packed;
    size_t i;
    struct PackFile_Segment *seg;
    struct Parrot_sub * sub;

    packed =  VTABLE_shift_string(interpreter, io);
    Parrot_Sub_thaw(interpreter, pmc, info);
    sub = PMC_sub(pmc);
    pf = PackFile_new(interpreter, 0);
    if (!PackFile_unpack(interpreter, pf, packed->strstart, packed->strlen))
        real_exception(interpreter, NULL, E_IOError,
                "couldn't unpack packfile");
    do_sub_pragmas(interpreter, pf->cur_cs, PBC_PBC, pmc);
    for (i = 0; i < pf->directory.num_segments; ++i) {
        seg = pf->directory.segments[i];
        if (seg->type == PF_BYTEC_SEG) {
            PMC_sub(pmc)->seg = (struct PackFile_ByteCode *)seg;
            break;
        }
    }
    pf->directory.num_segments = 0;
    /*
     * XXX this isn't ok - it seems that the packfile
     *     gets attached to interpreter->code and is
     *     destroyed again during interpreter destruction
     */
    /* PackFile_destroy(interpreter, pf); */

}
#line 346 "src/pmc/eval.c"


void
Parrot_Eval_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Eval,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Eval_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Eval_mark,
        Parrot_Eval_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Sub_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Eval_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Sub_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_Eval_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Sub_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_Eval_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Eval_freeze,
        Parrot_Eval_thaw,
        Parrot_default_thawfinish,
        Parrot_Sub_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Eval");
        vt_clone->isa_str = CONST_STRING(interp, "Eval Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_Eval_class_init */


/*

=back

=head1 HISTORY

Initial version by leo 2003/01/16.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
