/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/exception.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/exception.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: exception.pmc 12507 2006-05-04 22:10:56Z bernhard $

=head1 NAME

src/pmc/exception.pmc - Exception PMC

=head1 DESCRIPTION

This is the exception base class.

As we are still lacking objects, this class is based on a C<SArray>.
This will probably change.

An exception object has these attributes:

=over 4

=item 0 C<_message>

Textual representation of the exception.

=item 1 C<_type>

The exception type, (see F<include/parrot/exceptions.h>, F<except_type.pasm>).

=item 2 C<_severity>

The severity of the exception, (see F<src/exceptions.h>,
F<except_severity.pasm>).

=item 3 C<unused>

=item 4 C<unused>

=back

Optional:

=over 4

=item 5 C<_C_file>

The C code file in which the exception was raised.

=item 6 C<_C_line>

The line of C code on which the exception was raised.

=item 7 C<_P_file>

The PASM/PIR/Perl file in which the exception was raised.

=item 8 C<_P_line>

The line of PASM/PIR/Perl code on which the exception was raised.

=item 9, 10 C<unused>

Any information attached by the HL. This shouldn't start with an
underscore (that is reserved for Parrot's internal usage. These are
stored as properties.

Note: currently, HLL information must be indexed by number. Slots 9 and 10
are available for the HLL - This is subject to change.

=back

When an exception handler is called, the exception object is passed as
as the first argument, the message as the second argument of the call.
These arguments can be retrieved with the C<get_results> opcode.

This is experimental code. The C<enum_class> of the C<Exception> isn't
fixed. The interface isn't fixed.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 99 "src/pmc/exception.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_exception.h"
#include "pmc_sarray.h"
#include "pmc_default.h"
#include "exception.str"

void
Parrot_Exception_init(Interp* interpreter, PMC* pmc)
#line 99 "src/pmc/exception.pmc"
{
    Parrot_SArray_init(interpreter, pmc);
     VTABLE_set_integer_native(interpreter, pmc, 11);
     VTABLE_set_string_keyed_int(interpreter, pmc, 0, NULL);
     VTABLE_set_integer_keyed_int(interpreter, pmc, 1, 0);
     VTABLE_set_integer_keyed_int(interpreter, pmc, 2, 0);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 3, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 4, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 5, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 6, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 7, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 8, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 9, PMCNULL);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, 10, PMCNULL);

}
#line 127 "src/pmc/exception.c"


INTVAL
Parrot_Exception_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 152 "src/pmc/exception.pmc"
{
    STRING* s = key_string(interpreter, key);
    if (!string_compare(interpreter, s,
        string_from_cstring(interpreter, "_type", 0)))
        return  VTABLE_get_integer_keyed_int(interpreter, pmc, 1);
    if (!string_compare(interpreter, s,
        string_from_cstring(interpreter, "_severity", 0)))
        return  VTABLE_get_integer_keyed_int(interpreter, pmc, 2);
    return 0;

}
#line 144 "src/pmc/exception.c"


STRING*
Parrot_Exception_get_string(Interp* interpreter, PMC* pmc)
#line 138 "src/pmc/exception.pmc"
{
    return  VTABLE_get_string_keyed_int(interpreter, pmc, 0);

}
#line 154 "src/pmc/exception.c"


STRING*
Parrot_Exception_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 130 "src/pmc/exception.pmc"
{
    STRING* s = key_string(interpreter, key);
    if (!string_compare(interpreter, s,
        string_from_cstring(interpreter, "_message", 0)))
        return  VTABLE_get_string_keyed_int(interpreter, pmc, 0);
    return 0;

}
#line 168 "src/pmc/exception.c"


PMC*
Parrot_Exception_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 173 "src/pmc/exception.pmc"
{
    STRING* s = key_string(interpreter, key);
    return  VTABLE_getprop(interpreter, pmc, s);

}
#line 179 "src/pmc/exception.c"


void
Parrot_Exception_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
#line 205 "src/pmc/exception.pmc"
{
    STRING* s = key_string(interpreter, key);
    if (!string_compare(interpreter, s,
        string_from_cstring(interpreter, "_type", 0)))
         VTABLE_set_integer_keyed_int(interpreter, pmc, 1, value);
    if (!string_compare(interpreter, s,
        string_from_cstring(interpreter, "_severity", 0)))
         VTABLE_set_integer_keyed_int(interpreter, pmc, 2, value);

}
#line 195 "src/pmc/exception.c"


void
Parrot_Exception_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
#line 188 "src/pmc/exception.pmc"
{
    STRING* s = key_string(interpreter, key);
    if (!string_compare(interpreter, s,
        string_from_cstring(interpreter, "_message", 0)))
         VTABLE_set_string_keyed_int(interpreter, pmc, 0, value);

}
#line 208 "src/pmc/exception.c"


void
Parrot_Exception_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key, PMC *value)
#line 225 "src/pmc/exception.pmc"
{
    STRING* s = key_string(interpreter, key);
     VTABLE_setprop(interpreter, pmc, s, value);

}
#line 219 "src/pmc/exception.c"


INTVAL
Parrot_Exception_is_equal(Interp* interpreter, PMC* pmc, PMC *value)
#line 238 "src/pmc/exception.pmc"
{
    if (value->vtable->base_type == enum_class_Exception ||
            VTABLE_isa(interpreter, value,
                const_string(interpreter, "Exception"))) {
        /* TODO check parents */
        return 1;
    }
    return 0;

}
#line 235 "src/pmc/exception.c"


void
Parrot_Exception_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Exception,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Exception_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_SArray_morph,
        Parrot_SArray_mark,
        Parrot_SArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_SArray_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_SArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_SArray_get_integer,
        Parrot_Exception_get_integer_keyed,
        Parrot_SArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_SArray_get_number_keyed,
        Parrot_SArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Exception_get_string,
        Parrot_default_get_repr,
        Parrot_Exception_get_string_keyed,
        Parrot_SArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_SArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_Exception_get_pmc_keyed,
        Parrot_SArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_SArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Exception_set_integer_keyed,
        Parrot_SArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_SArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_Exception_set_string_keyed,
        Parrot_SArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_Exception_set_pmc_keyed,
        Parrot_SArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_SArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_SArray_push_integer,
        Parrot_SArray_push_float,
        Parrot_SArray_push_string,
        Parrot_SArray_push_pmc,
        Parrot_SArray_shift_integer,
        Parrot_SArray_shift_float,
        Parrot_SArray_shift_string,
        Parrot_SArray_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Exception_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Exception");
        vt_clone->isa_str = CONST_STRING(interp, "Exception SArray");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_Exception_class_init */


/*

=back

=head1 HISTORY

Initial revision by leo 2003.07.10.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
