/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/file.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/file.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: file.pmc 11512 2006-02-12 20:53:04Z ambs $

=head1 NAME

src/pmc/file.pmc - File PMC

=head1 DESCRIPTION

C<File> is a singleton class which provides access to File functions.

=head2 Methods

=over 4

=cut

*/

#ifdef WIN32
#include <direct.h>
#endif

#include "parrot/parrot.h"

/* XXX Check if we need to deallocate strerror strings */
/* XXX apparently, strerror_r is thread-safe and should be used instead.*/

static PMC * File_PMC;
#line 43 "src/pmc/file.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_file.h"
#include "pmc_default.h"
#include "file.str"

void*
Parrot_File_get_pointer(Interp* interpreter, PMC* pmc)
#line 46 "src/pmc/file.pmc"
{
    return File_PMC;

}
#line 58 "src/pmc/file.c"


void
Parrot_File_set_pointer(Interp* interpreter, PMC* pmc, void* ptr)
#line 50 "src/pmc/file.pmc"
{
    File_PMC = (PMC*) ptr;

}
#line 68 "src/pmc/file.c"


INTVAL
Parrot_File_is_dir(Interp* interpreter, PMC* pmc, STRING *path)
#line 64 "src/pmc/file.pmc"
{
    struct stat info;
    char *cpath = string_to_cstring(interpreter, path);
#ifdef WIN32
    int error = stat(cpath, &info);
#else
    int error = lstat(cpath, &info);
#endif
    string_cstring_free(cpath);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interpreter, NULL, E_SystemError, errmsg);
    }

    if (S_ISDIR(info.st_mode)) {
        return 1;
    } else {
        return 0;
    }

}
#line 95 "src/pmc/file.c"


INTVAL
Parrot_File_is_file(Interp* interpreter, PMC* pmc, STRING *path)
#line 95 "src/pmc/file.pmc"
{
    struct stat info;
    char *cpath = string_to_cstring(interpreter, path);
#ifdef WIN32
    int error = stat(cpath, &info);
#else
    int error = lstat(cpath, &info);
#endif
    string_cstring_free(cpath);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interpreter, NULL, E_SystemError, errmsg);
    }

    if (S_ISREG(info.st_mode)) {
        return 1;
    } else {
        return 0;
    }

}
#line 122 "src/pmc/file.c"


INTVAL
Parrot_File_is_link(Interp* interpreter, PMC* pmc, STRING *path)
#line 126 "src/pmc/file.pmc"
{
#ifdef WIN32
    /* I love win32 implementations */
    return 0;
#else
    struct stat info;
    char *cpath = string_to_cstring(interpreter, path);
    int error = lstat(cpath, &info);
    string_cstring_free(cpath);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interpreter, NULL, E_SystemError, errmsg);
    }

    if (S_ISLNK(info.st_mode)) {
        return 1;
    } else {
        return 0;
    }
#endif

}
#line 150 "src/pmc/file.c"


void
Parrot_File_copy(Interp* interpreter, PMC* pmc, STRING *from, STRING *to)
#line 164 "src/pmc/file.pmc"
{
#define CHUNK_SIZE 1024
    FILE *source = NULL;
    FILE *target = NULL;

    char *cfrom = string_to_cstring(interpreter, from);
    char *cto = string_to_cstring(interpreter, to);
    source = fopen(cfrom, "rb");
    if (source) {
        target = fopen(cto, "w+b");
        if (target) {
            char buf[CHUNK_SIZE];
            int bytes_read, bytes_written;
            while(!feof(source)) {
                bytes_read = fread(buf, 1, CHUNK_SIZE, source);
                if (bytes_read) {
                    bytes_written = fwrite(buf, 1, bytes_read, target);
                    if (bytes_read != bytes_written) {
                        real_exception(interpreter, NULL, E_SystemError, 
                                       "Error writting file");
                        break;
                    }
                }
            }
            fclose(target);
        } else {
            char *errmsg = strerror(errno);
            real_exception(interpreter, NULL, E_SystemError, errmsg);
        }
        fclose(source);
    } else {
        char *errmsg = strerror(errno);
        real_exception(interpreter, NULL, E_SystemError, errmsg);
    }
    string_cstring_free(cfrom);
    string_cstring_free(cto);
#undef CHUNK_SIZE

}
#line 195 "src/pmc/file.c"


void
Parrot_File_rename(Interp* interpreter, PMC* pmc, STRING *from, STRING *to)
#line 213 "src/pmc/file.pmc"
{
    char *cfrom = string_to_cstring(interpreter, from);
    char *cto = string_to_cstring(interpreter, to);
    int error = rename(cfrom, cto);
    string_cstring_free(cfrom);
    string_cstring_free(cto);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interpreter, NULL, E_SystemError, errmsg);
    }

}
#line 213 "src/pmc/file.c"


void
Parrot_File_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_File,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_IS_SINGLETON, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_default_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_default_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_File_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_File_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "File");
        vt_clone->isa_str = CONST_STRING(interp, "File");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_File_is_dir),
                "is_dir", "IJOS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_File_is_file),
                "is_file", "IJOS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_File_is_link),
                "is_link", "IJOS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_File_copy),
                "copy", "vJOSS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_File_rename),
                "rename", "vJOSS");
        /* class_init */
    
    } /* pass */
} /* Parrot_File_class_init */


/*

=back

=head1 SEE ALS0

   stat(2), rename(2)

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
