/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/fixedbooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/fixedbooleanarray.pmc"
/*
Copyright: 2001-2005 The Perl Foundation.  All Rights Reserved.
$Id: fixedbooleanarray.pmc 11610 2006-02-17 01:54:32Z particle $

=head1 NAME

src/pmc/fixedbooleanarray.pmc - fixed size array for booleans only

=head1 DESCRIPTION

The C<FixedBooleanArray PMC> implements an array of fixed size, which stores booleans.
It uses the C<Boolean PMC> for all conversions.
The C<FixedBooleanArray PMC> is extended by the C<ResizableBooleanArray PMC>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


/*
 * TODO merge this with functions from BigInt PMC
 */

#define BITS_PER_CHAR 8

static void
booleanarray_init(Interp *interpreter, PMC *self) {
    PMC_int_val2(self) = 0;
    PMC_data(self) = NULL;
}

static void
booleanarray_clone(Interp *interpreter, PMC *self, PMC *dest) {
    if (PMC_data(self)) {
        Parrot_UInt1 *sd = PMC_data(self);
        PMC_int_val2(dest) = PMC_int_val2(self);
        PMC_data(dest) = malloc(PMC_int_val2(self) / BITS_PER_CHAR);
        mem_sys_memcopy(PMC_data(dest), PMC_data(self), PMC_int_val2(self) / BITS_PER_CHAR);
    }
}

static void
booleanarray_clear(Interp *interpreter, PMC *self) {
    PMC_int_val2(self) = 0;
}

#line 65 "src/pmc/fixedbooleanarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "fixedbooleanarray.str"

void
Parrot_FixedBooleanArray_init(Interp* interpreter, PMC* pmc)
#line 71 "src/pmc/fixedbooleanarray.pmc"
{
    PMC_int_val(pmc) = 0;       /* size of array */
    booleanarray_init(interpreter, pmc);
    PObj_active_destroy_SET(pmc);

}
#line 82 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_morph(Interp* interpreter, PMC* pmc, INTVAL type)
#line 88 "src/pmc/fixedbooleanarray.pmc"
{
    Parrot_default_morph(interpreter, pmc, type);

}
#line 92 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_destroy(Interp* interpreter, PMC* pmc)
#line 103 "src/pmc/fixedbooleanarray.pmc"
{
    booleanarray_clear(interpreter, pmc);
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
    PMC_int_val(pmc) = 0;

}
#line 106 "src/pmc/fixedbooleanarray.c"


PMC*
Parrot_FixedBooleanArray_clone(Interp* interpreter, PMC* pmc)
#line 121 "src/pmc/fixedbooleanarray.pmc"
{
    PMC * dest = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_int_val(dest) = PMC_int_val(pmc);

    booleanarray_clone(interpreter, pmc, dest);
    PObj_active_destroy_SET(dest);
    return dest;

}
#line 121 "src/pmc/fixedbooleanarray.c"


INTVAL
Parrot_FixedBooleanArray_get_integer(Interp* interpreter, PMC* pmc)
#line 166 "src/pmc/fixedbooleanarray.pmc"
{
    return Parrot_FixedBooleanArray_elements(interpreter, pmc);

}
#line 131 "src/pmc/fixedbooleanarray.c"


INTVAL
Parrot_FixedBooleanArray_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 201 "src/pmc/fixedbooleanarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interpreter, key);
    return Parrot_FixedBooleanArray_get_integer_keyed_int(interpreter, pmc, k);

}
#line 143 "src/pmc/fixedbooleanarray.c"


INTVAL
Parrot_FixedBooleanArray_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 181 "src/pmc/fixedbooleanarray.pmc"
{
    Parrot_UInt1 *sd = PMC_data(pmc);

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedBooleanArray: index out of bounds!");

    return ( sd[key/BITS_PER_CHAR] & ( 1 << ( key % BITS_PER_CHAR ) )) ? 1 : 0;

}
#line 159 "src/pmc/fixedbooleanarray.c"


FLOATVAL
Parrot_FixedBooleanArray_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 232 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_number_keyed_int(interpreter, pmc, k);

}
#line 170 "src/pmc/fixedbooleanarray.c"


FLOATVAL
Parrot_FixedBooleanArray_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 218 "src/pmc/fixedbooleanarray.pmc"
{
    return (FLOATVAL) VTABLE_get_integer_keyed_int(interpreter, pmc, key);

}
#line 180 "src/pmc/fixedbooleanarray.c"


STRING*
Parrot_FixedBooleanArray_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 262 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_string_keyed_int(interpreter, pmc, k);

}
#line 191 "src/pmc/fixedbooleanarray.c"


STRING*
Parrot_FixedBooleanArray_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 247 "src/pmc/fixedbooleanarray.pmc"
{
    PMC *val =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_string(interpreter, val);

}
#line 202 "src/pmc/fixedbooleanarray.c"


INTVAL
Parrot_FixedBooleanArray_get_bool(Interp* interpreter, PMC* pmc)
#line 140 "src/pmc/fixedbooleanarray.pmc"
{
    return Parrot_FixedBooleanArray_elements(interpreter, pmc) ? 1 : 0;

}
#line 212 "src/pmc/fixedbooleanarray.c"


PMC*
Parrot_FixedBooleanArray_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 295 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_pmc_keyed_int(interpreter, pmc, k);

}
#line 223 "src/pmc/fixedbooleanarray.c"


PMC*
Parrot_FixedBooleanArray_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 278 "src/pmc/fixedbooleanarray.pmc"
{
    PMC *ret = pmc_new(interpreter, enum_class_Boolean);
    INTVAL val =  VTABLE_get_integer_keyed_int(interpreter, pmc, key);
    VTABLE_set_integer_native(interpreter, ret, val);
    return ret;

}
#line 236 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 310 "src/pmc/fixedbooleanarray.pmc"
{
    if (PMC_int_val(pmc) || size < 1)
        real_exception(interpreter, NULL, E_IndexError,
                "FixedBooleanArray: Can't resize!");

    PMC_int_val(pmc) = size;
    PMC_int_val2(pmc) = (size / BITS_PER_CHAR + 1) * BITS_PER_CHAR;
    PMC_data(pmc) = mem_sys_allocate_zeroed(PMC_int_val2(pmc) / BITS_PER_CHAR);

}
#line 252 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC *key, INTVAL value)
#line 354 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
     VTABLE_set_integer_keyed_int(interpreter, pmc, k, value);

}
#line 263 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 330 "src/pmc/fixedbooleanarray.pmc"
{
    Parrot_UInt1 *sd = PMC_data(pmc);

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedBooleanArray: index out of bounds!");

    if ( value ) {
        sd[key/BITS_PER_CHAR] |= ( 1 << ( key % BITS_PER_CHAR ) );
    } else {
        sd[key/BITS_PER_CHAR] &= ( ~ ( 1 << ( key % BITS_PER_CHAR ) ) );
    }

}
#line 283 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_number_keyed(Interp* interpreter, PMC* pmc, PMC *key, FLOATVAL value)
#line 385 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
     VTABLE_set_number_keyed_int(interpreter, pmc, k, value);

}
#line 294 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 370 "src/pmc/fixedbooleanarray.pmc"
{
     VTABLE_set_integer_keyed_int(interpreter, pmc, key, ( value ? 1 : 0 ));

}
#line 304 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_string_keyed(Interp* interpreter, PMC* pmc, PMC *key, STRING* value)
#line 421 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
     VTABLE_set_string_keyed_int(interpreter, pmc, k, value);

}
#line 315 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 400 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL tempInt;
    PMC *tempPMC;

    tempPMC = pmc_new(interpreter, enum_class_Boolean);
    VTABLE_set_string_native(interpreter, tempPMC, value);
    tempInt = VTABLE_get_integer(interpreter, tempPMC);
     VTABLE_set_integer_keyed_int(interpreter, pmc, key, tempInt);

}
#line 331 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key, PMC* value)
#line 454 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, k, value);

}
#line 343 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* src)
#line 436 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL tempInt;

    tempInt = VTABLE_get_integer(interpreter, src);
     VTABLE_set_integer_keyed_int(interpreter, pmc, key, tempInt);

}
#line 356 "src/pmc/fixedbooleanarray.c"


INTVAL
Parrot_FixedBooleanArray_elements(Interp* interpreter, PMC* pmc)
#line 152 "src/pmc/fixedbooleanarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 366 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 471 "src/pmc/fixedbooleanarray.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_integer_keyed_int(interpreter, pmc, nextix, value);

}
#line 377 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 491 "src/pmc/fixedbooleanarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    STRING *s;
     VTABLE_push_integer(interpreter, io, PMC_int_val(pmc));
    s = string_from_cstring(interpreter, PMC_data(pmc), PMC_int_val2(pmc)/BITS_PER_CHAR);
     VTABLE_push_string(interpreter, io, s);

}
#line 391 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 508 "src/pmc/fixedbooleanarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        INTVAL size =  VTABLE_shift_integer(interpreter, io);
        STRING * s  =  VTABLE_shift_string(interpreter, io);
        PMC_int_val(pmc) = size;
        PMC_int_val2(pmc) = s->bufused * BITS_PER_CHAR;
        PMC_data(pmc) = mem_sys_allocate_zeroed(s->bufused);
        mem_sys_memcopy(PMC_data(pmc), s->strstart, s->bufused);
    }

}
#line 410 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_fill(Interp* interpreter, PMC* pmc, INTVAL fill)
#line 532 "src/pmc/fixedbooleanarray.pmc"
{
    Parrot_UInt1 *sd = PMC_data(pmc);
    INTVAL j;
    j = PMC_int_val(pmc) / BITS_PER_CHAR + 1;
    if (fill)
        memset(sd, 0xff, j);
    else
        memset(sd, 0, j);

}
#line 426 "src/pmc/fixedbooleanarray.c"


void
Parrot_FixedBooleanArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_FixedBooleanArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedBooleanArray_morph,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_FixedBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_FixedBooleanArray_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_FixedBooleanArray_freeze,
        Parrot_FixedBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "FixedBooleanArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedBooleanArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_FixedBooleanArray_fill),
                "fill", "vJOI");
        /* class_init */
    
    } /* pass */
} /* Parrot_FixedBooleanArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
