/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/fixedintegerarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/fixedintegerarray.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: fixedintegerarray.pmc 11610 2006-02-17 01:54:32Z particle $

=head1 NAME

src/pmc/fixedintegerarray.pmc - fixed size array for integers only

=head1 DESCRIPTION

This class, FixedIntegerArray, implements an array of fixed size, which stored INTVALs,
it uses Integer PMCs for all of the conversions

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 36 "src/pmc/fixedintegerarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_default.h"
#include "fixedintegerarray.str"

void
Parrot_FixedIntegerArray_init(Interp* interpreter, PMC* pmc)
#line 42 "src/pmc/fixedintegerarray.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = NULL;

}
#line 52 "src/pmc/fixedintegerarray.c"


PMC*
Parrot_FixedIntegerArray_new_from_string(Interp* interpreter, PMC* pmc, STRING *rep, INTVAL flags)
#line 57 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL type, n, elem;
    char *p, *start;
    UINTVAL i, l;
    int base;

    type = pmc->vtable->base_type;
    if (flags & PObj_constant_FLAG)
        pmc = constant_pmc_new(interpreter, type);
    else
        pmc = pmc_new(interpreter, type);
    l = string_length(interpreter, rep);
    if (!l)
        return pmc;
    if (rep->encoding != Parrot_fixed_8_encoding_ptr)
        real_exception(interpreter, NULL, E_ValueError,
                "unhandled string encoding in constructor");
    if (l <= 2 && ((char*)rep->strstart)[0] == '(')   /* "()" - no args */
        return pmc;
    /* count commas */
    p = rep->strstart;
    for (i = l, n = 0; i; --i, ++p) {
        if (*p == ',')
            ++n;
    }
    /* presize the array */
    Parrot_FixedIntegerArray_set_integer_native(interpreter, pmc, n + 1);
    /* parse string */
    p = rep->strstart;
    for (i = l, n = 0; i; --i, ++p) {
        switch (*p) {
            case ' ': continue;
            case '\t': continue;
            case '(': continue;
            case ')': break;
            case ',':
                      n++;
                      break;
            default:
                      base = 10;
                      if (*p == '0') {
                          ++p;
                          --i;
                          if (*p == 'b' || *p == 'B') {
                              base = 2;
                              ++p;
                              --i;
                          }
                          else if (*p == 'x' || *p == 'X') {
                              base = 16;
                              ++p;
                              --i;
                          }
                      }
                      start = p;
                      elem = strtoul(p, &p, base);
                      --p;
                      i -= (p - start);
                      Parrot_FixedIntegerArray_set_integer_keyed_int(interpreter, pmc, n, elem);
                      break;
        }
    }
    return pmc;

}
#line 123 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_morph(Interp* interpreter, PMC* pmc, INTVAL type)
#line 132 "src/pmc/fixedintegerarray.pmc"
{
    Parrot_default_morph(interpreter, pmc, type);

}
#line 133 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_destroy(Interp* interpreter, PMC* pmc)
#line 147 "src/pmc/fixedintegerarray.pmc"
{
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
    PMC_int_val(pmc) = 0;

}
#line 146 "src/pmc/fixedintegerarray.c"


PMC*
Parrot_FixedIntegerArray_clone(Interp* interpreter, PMC* pmc)
#line 164 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL size;
    PMC * dest;
    /* a quick hack to create a clone in the constant PMC arena
     * this is needed for the call signatures
     *
     * a better way would be probably to supply a flag to the clone
     * vtable
     */

    if (PObj_constant_TEST(pmc))
        dest = constant_pmc_new(interpreter, pmc->vtable->base_type);
    else
        dest = pmc_new(interpreter, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;
    size = PMC_int_val(pmc);
    PMC_int_val(dest) = size;

    PMC_data(dest) = mem_sys_allocate(size * sizeof(INTVAL));
    mem_sys_memcopy(PMC_data(dest), PMC_data(pmc), size*sizeof(INTVAL));
    PObj_active_destroy_SET(dest);
    return dest;

}
#line 178 "src/pmc/fixedintegerarray.c"


INTVAL
Parrot_FixedIntegerArray_get_integer(Interp* interpreter, PMC* pmc)
#line 227 "src/pmc/fixedintegerarray.pmc"
{
    return Parrot_FixedIntegerArray_elements(interpreter, pmc);

}
#line 188 "src/pmc/fixedintegerarray.c"


INTVAL
Parrot_FixedIntegerArray_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 262 "src/pmc/fixedintegerarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_integer_keyed_int(interpreter, pmc, k);

}
#line 200 "src/pmc/fixedintegerarray.c"


INTVAL
Parrot_FixedIntegerArray_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 242 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL *data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedIntegerArray: index out of bounds!");

    data = (INTVAL *)PMC_data(pmc);
    return data[key];

}
#line 216 "src/pmc/fixedintegerarray.c"


FLOATVAL
Parrot_FixedIntegerArray_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 293 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_number_keyed_int(interpreter, pmc, k);

}
#line 227 "src/pmc/fixedintegerarray.c"


FLOATVAL
Parrot_FixedIntegerArray_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 279 "src/pmc/fixedintegerarray.pmc"
{
    return (FLOATVAL) VTABLE_get_integer_keyed_int(interpreter, pmc, key);

}
#line 237 "src/pmc/fixedintegerarray.c"


STRING*
Parrot_FixedIntegerArray_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 324 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_string_keyed_int(interpreter, pmc, k);

}
#line 248 "src/pmc/fixedintegerarray.c"


STRING*
Parrot_FixedIntegerArray_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 308 "src/pmc/fixedintegerarray.pmc"
{
    PMC *temp;
    temp =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_string(interpreter, temp);

}
#line 260 "src/pmc/fixedintegerarray.c"


INTVAL
Parrot_FixedIntegerArray_get_bool(Interp* interpreter, PMC* pmc)
#line 200 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL size = Parrot_FixedIntegerArray_elements(interpreter, pmc);
    return (INTVAL)(size != 0);

}
#line 271 "src/pmc/fixedintegerarray.c"


PMC*
Parrot_FixedIntegerArray_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 360 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_pmc_keyed_int(interpreter, pmc, k);

}
#line 282 "src/pmc/fixedintegerarray.c"


PMC*
Parrot_FixedIntegerArray_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 340 "src/pmc/fixedintegerarray.pmc"
{
    PMC *ret;
    INTVAL val;

    ret = pmc_new(interpreter, enum_class_Integer);
    val =  VTABLE_get_integer_keyed_int(interpreter, pmc, key);
    VTABLE_set_integer_native(interpreter, ret, val);
    return ret;

}
#line 298 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 375 "src/pmc/fixedintegerarray.pmc"
{
    if (PMC_int_val(pmc) || size < 1)
        real_exception(interpreter, NULL, E_IndexError,
            "FixedIntegerArray: Can't resize!");
    PMC_int_val(pmc) = size;
    PMC_data(pmc) = mem_sys_allocate_zeroed(size * sizeof(INTVAL));
    PObj_active_destroy_SET(pmc);

}
#line 313 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC *key, INTVAL value)
#line 414 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_integer_keyed_int(interpreter, pmc, k, value);

}
#line 325 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 394 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL *data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedIntegerArray: index out of bounds!");

    data = (INTVAL*)PMC_data(pmc);
    data[key] = value;

}
#line 341 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_number_keyed(Interp* interpreter, PMC* pmc, PMC *key, FLOATVAL value)
#line 446 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_number_keyed_int(interpreter, pmc, k, value);

}
#line 353 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 431 "src/pmc/fixedintegerarray.pmc"
{
     VTABLE_set_integer_keyed_int(interpreter, pmc, key, (INTVAL)value);

}
#line 363 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_string_keyed(Interp* interpreter, PMC* pmc, PMC *key, STRING* value)
#line 483 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_string_keyed_int(interpreter, pmc, k, value);

}
#line 375 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 462 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL tempInt;
    PMC *tempPMC;

    tempPMC = pmc_new(interpreter, enum_class_Integer);
    VTABLE_set_string_native(interpreter, tempPMC, value);
    tempInt = VTABLE_get_integer(interpreter, tempPMC);
     VTABLE_set_integer_keyed_int(interpreter, pmc, key, tempInt);

}
#line 391 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key, PMC* value)
#line 517 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, k, value);

}
#line 403 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* src)
#line 499 "src/pmc/fixedintegerarray.pmc"
{
    INTVAL tempInt;

    tempInt = VTABLE_get_integer(interpreter, src);
     VTABLE_set_integer_keyed_int(interpreter, pmc, key, tempInt);

}
#line 416 "src/pmc/fixedintegerarray.c"


INTVAL
Parrot_FixedIntegerArray_elements(Interp* interpreter, PMC* pmc)
#line 213 "src/pmc/fixedintegerarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 426 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 547 "src/pmc/fixedintegerarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    INTVAL i, n;
    INTVAL *ar;

    Parrot_default_freeze(interpreter, pmc, info);
    n = VTABLE_elements(interpreter, pmc);
     VTABLE_push_integer(interpreter, io, n);
    ar = (INTVAL *)PMC_data(pmc);
    for (i = 0; i < n; ++i) {
         VTABLE_push_integer(interpreter, io, ar[i]);
    }

}
#line 446 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 561 "src/pmc/fixedintegerarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    INTVAL i, n;
    INTVAL *ar;

    if (info->extra_flags == EXTRA_IS_NULL) {
        PMC_int_val(pmc) = 0;
        PMC_data(pmc) = NULL;
        n =  VTABLE_shift_integer(interpreter, io);
        if (!n)
            return;
         VTABLE_set_integer_native(interpreter, pmc, n);
        ar = (INTVAL *)PMC_data(pmc);
        for (i = 0; i < n; ++i) {
            ar[i] =  VTABLE_shift_integer(interpreter, io);
        }
    }
    else
        Parrot_default_thaw(interpreter, pmc, info);

}
#line 473 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 543 "src/pmc/fixedintegerarray.pmc"
{
    Parrot_default_visit(interpreter, pmc, info);

}
#line 483 "src/pmc/fixedintegerarray.c"


void
Parrot_FixedIntegerArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_FixedIntegerArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedIntegerArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_FixedIntegerArray_new_from_string,
        Parrot_FixedIntegerArray_morph,
        Parrot_default_mark,
        Parrot_FixedIntegerArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_FixedIntegerArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedIntegerArray_get_integer,
        Parrot_FixedIntegerArray_get_integer_keyed,
        Parrot_FixedIntegerArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedIntegerArray_get_number_keyed,
        Parrot_FixedIntegerArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_FixedIntegerArray_get_string_keyed,
        Parrot_FixedIntegerArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedIntegerArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedIntegerArray_get_pmc_keyed,
        Parrot_FixedIntegerArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedIntegerArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedIntegerArray_set_integer_keyed,
        Parrot_FixedIntegerArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedIntegerArray_set_number_keyed,
        Parrot_FixedIntegerArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedIntegerArray_set_string_keyed,
        Parrot_FixedIntegerArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedIntegerArray_set_pmc_keyed,
        Parrot_FixedIntegerArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedIntegerArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_FixedIntegerArray_freeze,
        Parrot_FixedIntegerArray_thaw,
        Parrot_default_thawfinish,
        Parrot_FixedIntegerArray_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "FixedIntegerArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedIntegerArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_FixedIntegerArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
