/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/fixedpmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/fixedpmcarray.pmc"
/*
Copyright: 2001-2005 The Perl Foundation.  All Rights Reserved.
$Id: fixedpmcarray.pmc 11853 2006-03-10 14:24:22Z leo $

=head1 NAME

src/pmc/fixedpmcarray.pmc - fixed size array for PMCs only

=head1 DESCRIPTION

This class, FixedPMCArray, implements an array of fixed size, which stores PMCs,
it puts things into Integer, Float, or String PMCs as appropriate

=head2 Note

The flag C<PObj_private0_FLAG> is used in the C<NameSpace> PMC and should 
never be set for user arrays.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

static void
swap(void **x, void **y)
{
    void *t = *x;
    *x = *y;
    *y = t;
}

typedef INTVAL (*sort_func_t)(Interp *, void*, void*);

static INTVAL
COMPARE(Interp *interpreter, void *a, void *b, PMC *cmp)
{
    if (!cmp)
        return mmd_dispatch_i_pp(interpreter, a, b, MMD_CMP);
    if (cmp->vtable->base_type == enum_class_NCI) {
        sort_func_t f = (sort_func_t)D2FPTR(PMC_struct_val(cmp));
        return f(interpreter, a, b);
    }
    return Parrot_runops_fromc_args_reti(interpreter, cmp, "IPP", a, b);
}

static void
quicksort(Interp *interpreter, void **data, UINTVAL n, PMC *cmp)
{
    UINTVAL i, j, ln, rn;

    while (n > 1) {
        swap(&data[0], &data[n/2]);
        for (i = 0, j = n; ; ) {
            do
                --j;
            while (COMPARE(interpreter, data[j], data[0], cmp) > 0);
            do
                ++i;
            while (i < j && COMPARE(interpreter, data[i], data[0], cmp) < 0);
            if (i >= j)
                break;
            swap(&data[i], &data[j]);
        }
        swap(&data[j], &data[0]);
        ln = j;
        rn = n - ++j;
        if (ln < rn) {
            quicksort(interpreter, data, ln, cmp);
            data += j;
            n = rn;
        }
        else {
            quicksort(interpreter, data + j, rn, cmp);
            n = ln;
        }
    }
}

#line 96 "src/pmc/fixedpmcarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "fixedpmcarray.str"

void
Parrot_FixedPMCArray_init(Interp* interpreter, PMC* pmc)
#line 124 "src/pmc/fixedpmcarray.pmc"
{
    PMC_int_val(pmc) = 0;
    PObj_active_destroy_SET(pmc);
    PObj_data_is_PMC_array_SET(pmc);

}
#line 113 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_morph(Interp* interpreter, PMC* pmc, INTVAL type)
#line 140 "src/pmc/fixedpmcarray.pmc"
{
    Parrot_default_morph(interpreter, pmc, type);

}
#line 123 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_destroy(Interp* interpreter, PMC* pmc)
#line 155 "src/pmc/fixedpmcarray.pmc"
{
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
    PMC_int_val(pmc) = 0;

}
#line 136 "src/pmc/fixedpmcarray.c"


PMC*
Parrot_FixedPMCArray_clone(Interp* interpreter, PMC* pmc)
#line 172 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL size;
    PMC * dest = pmc_new(interpreter, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;
    size = PMC_int_val(pmc);
    PMC_int_val(dest) = size;

    PMC_data(dest) = mem_sys_allocate(size * sizeof(PMC*));
    mem_sys_memcopy(PMC_data(dest), PMC_data(pmc), size*sizeof(PMC*));
    PObj_data_is_PMC_array_SET(dest);
    return dest;

}
#line 157 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_get_integer(Interp* interpreter, PMC* pmc)
#line 224 "src/pmc/fixedpmcarray.pmc"
{
    return  VTABLE_elements(interpreter, pmc);

}
#line 167 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 296 "src/pmc/fixedpmcarray.pmc"
{
    PMC *tempPMC;

    tempPMC =  VTABLE_get_pmc_keyed(interpreter, pmc, key);
    return VTABLE_get_integer(interpreter, tempPMC);

}
#line 180 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 281 "src/pmc/fixedpmcarray.pmc"
{
    PMC *tempPMC =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_integer(interpreter, tempPMC);

}
#line 191 "src/pmc/fixedpmcarray.c"


FLOATVAL
Parrot_FixedPMCArray_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 329 "src/pmc/fixedpmcarray.pmc"
{
    PMC *tempPMC;

    tempPMC =  VTABLE_get_pmc_keyed(interpreter, pmc, key);
    return VTABLE_get_number(interpreter, tempPMC);

}
#line 204 "src/pmc/fixedpmcarray.c"


FLOATVAL
Parrot_FixedPMCArray_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 314 "src/pmc/fixedpmcarray.pmc"
{
    PMC *tempPMC =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_number(interpreter, tempPMC);

}
#line 215 "src/pmc/fixedpmcarray.c"


STRING*
Parrot_FixedPMCArray_get_string(Interp* interpreter, PMC* pmc)
#line 243 "src/pmc/fixedpmcarray.pmc"
{
    return string_from_int(interpreter,  VTABLE_elements(interpreter, pmc));

}
#line 225 "src/pmc/fixedpmcarray.c"


STRING*
Parrot_FixedPMCArray_get_repr(Interp* interpreter, PMC* pmc)
#line 247 "src/pmc/fixedpmcarray.pmc"
{
    STRING *res;
    INTVAL j, n;
    PMC *val;

    res = string_from_cstring(interpreter, "(", 0);
    n = VTABLE_elements(interpreter, pmc);
    for (j = 0; j < n; ++j) {
        val = Parrot_FixedPMCArray_get_pmc_keyed_int(interpreter, pmc, j);
        res = string_append(interpreter, res,
                VTABLE_get_repr(interpreter, val), 0);
        if (n == 1)
            res = string_append(interpreter, res,
                    const_string(interpreter, ","), 0);
        else if (j < n - 1)
            res = string_append(interpreter, res,
                    const_string(interpreter, ", "), 0);
    }
    res = string_append(interpreter, res,
            const_string(interpreter, ")"), 0);
    return res;


}
#line 255 "src/pmc/fixedpmcarray.c"


STRING*
Parrot_FixedPMCArray_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 361 "src/pmc/fixedpmcarray.pmc"
{
    PMC *tempPMC;

    tempPMC =  VTABLE_get_pmc_keyed(interpreter, pmc, key);
    return VTABLE_get_string(interpreter, tempPMC);

}
#line 268 "src/pmc/fixedpmcarray.c"


STRING*
Parrot_FixedPMCArray_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 346 "src/pmc/fixedpmcarray.pmc"
{
    PMC *tempPMC =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_string(interpreter, tempPMC);

}
#line 279 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_get_bool(Interp* interpreter, PMC* pmc)
#line 197 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL size =  VTABLE_elements(interpreter, pmc);
    return (INTVAL)(size != 0);

}
#line 290 "src/pmc/fixedpmcarray.c"


PMC*
Parrot_FixedPMCArray_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 399 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    PMC *box, *nextkey;

    nextkey = key_next(interpreter, key);
    if (!nextkey)
        return  VTABLE_get_pmc_keyed_int(interpreter, pmc, k);
    box = Parrot_FixedPMCArray_get_pmc_keyed_int(interpreter, pmc, k);
    if (box == NULL)
        box = pmc_new(interpreter, enum_class_Undef);
    return VTABLE_get_pmc_keyed(interpreter, box, nextkey);

}
#line 309 "src/pmc/fixedpmcarray.c"


PMC*
Parrot_FixedPMCArray_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 379 "src/pmc/fixedpmcarray.pmc"
{
    PMC **data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedPMCArray: index out of bounds!");

    data = (PMC **)PMC_data(pmc);
    return data[key];

}
#line 325 "src/pmc/fixedpmcarray.c"


PMC*
Parrot_FixedPMCArray_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL f)
#line 687 "src/pmc/fixedpmcarray.pmc"
{
    switch (f) {
        case 0:
            {
                PMC *iter = pmc_new_init(interpreter,
                        enum_class_Iterator, pmc);
                PMC_struct_val(iter) = key;
                return iter;
            }
    }
    real_exception(interpreter, NULL, E_IndexError, "Array: Unknown slice type");
    return NULL;

}
#line 345 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 422 "src/pmc/fixedpmcarray.pmc"
{
    int i;
    PMC **data;

    if (PMC_int_val(pmc) && size)
        real_exception(interpreter, NULL, E_IndexError,
                "FixedPMCArray: Can't resize!");
    if (!size)
        return;
    PMC_int_val(pmc) = size;
    data = (PMC**)mem_sys_allocate(size * sizeof(PMC*));
    for(i = 0; i < size; i++)
        data[i] = PMCNULL;
    PMC_data(pmc) = data;

}
#line 367 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC *key, INTVAL value)
#line 485 "src/pmc/fixedpmcarray.pmc"
{
    PMC *val;

    val = pmc_new(interpreter, 
            Parrot_get_ctx_HLL_type(interpreter,
                enum_class_Integer));
    VTABLE_set_integer_native(interpreter, val, value);
    /* Let set_pmc_keyed worry about multi keys */
     VTABLE_set_pmc_keyed(interpreter, pmc, key, val);

}
#line 384 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 465 "src/pmc/fixedpmcarray.pmc"
{
    PMC *val;

    val = pmc_new(interpreter, 
            Parrot_get_ctx_HLL_type(interpreter,
                enum_class_Integer));
    VTABLE_set_integer_native(interpreter, val, value);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, key, val);

}
#line 400 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_number_keyed(Interp* interpreter, PMC* pmc, PMC *key, FLOATVAL value)
#line 528 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL k;
    PMC*   nextkey;

    k = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
         VTABLE_set_number_keyed_int(interpreter, pmc, k, value);
    } else {
        PMC* box;

        box = Parrot_FixedPMCArray_get_pmc_keyed_int(interpreter, pmc, k);
        if (box == NULL) {
            /* TODO: autovivify an Array and insert it in pmc */
            box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
        }
        VTABLE_set_number_keyed(interpreter, box, nextkey, value);
    }

}
#line 426 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 507 "src/pmc/fixedpmcarray.pmc"
{
    PMC *val;

    val = pmc_new(interpreter, 
            Parrot_get_ctx_HLL_type(interpreter,
                enum_class_Float));
    VTABLE_set_number_native(interpreter, val, value);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, key, val);

}
#line 442 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_string_keyed(Interp* interpreter, PMC* pmc, PMC *key, STRING* value)
#line 579 "src/pmc/fixedpmcarray.pmc"
{
    PMC *val;

    val = pmc_new(interpreter, 
            Parrot_get_ctx_HLL_type(interpreter,
                enum_class_String));
    VTABLE_set_string_native(interpreter, val, value);
    /* Let set_pmc_keyed worry about multi keys */
     VTABLE_set_pmc_keyed(interpreter, pmc, key, val);

}
#line 459 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 558 "src/pmc/fixedpmcarray.pmc"
{
    PMC *val;

    val = pmc_new(interpreter, 
            Parrot_get_ctx_HLL_type(interpreter,
                enum_class_String));
    VTABLE_set_string_native(interpreter, val, value);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, key, val);

}
#line 475 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_pmc(Interp* interpreter, PMC* pmc, PMC *value)
#line 438 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL size;

    if (value->vtable->base_type != enum_class_FixedPMCArray &&
            value->vtable->base_type != enum_class_ResizablePMCArray)
        real_exception(interpreter, NULL, E_TypeError,
                "Can't set self from this type");
    if (pmc != value) {
        if (PMC_data(pmc))
            mem_sys_free(PMC_data(pmc));
    }
    size = PMC_int_val(pmc) = PMC_int_val(value);
    PMC_data(pmc) = mem_sys_allocate(size * sizeof(PMC*));
    mem_sys_memcopy(PMC_data(pmc), PMC_data(value), size*sizeof(PMC*));
    PMC_int_val2(pmc) = size;
    PObj_data_is_PMC_array_SET(pmc);

}
#line 499 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key, PMC* value)
#line 621 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL k;
    PMC*   nextkey;

    k = key_integer(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (!nextkey) {
         VTABLE_set_pmc_keyed_int(interpreter, pmc, k, value);
    } else {
        PMC* box;

        box = Parrot_FixedPMCArray_get_pmc_keyed_int(interpreter, pmc, k);
        if (box == NULL) {
            /* TODO: autovivify an Array and insert it in pmc */
            box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
        }
        VTABLE_set_pmc_keyed(interpreter, box, nextkey, value);
    }

}
#line 525 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* src)
#line 600 "src/pmc/fixedpmcarray.pmc"
{
    PMC **data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedPMCArray: index out of bounds!");

    data = (PMC**)PMC_data(pmc);
    DOD_WRITE_BARRIER(interpreter, pmc, data[key], src);
    data[key] = src;

}
#line 542 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_elements(Interp* interpreter, PMC* pmc)
#line 210 "src/pmc/fixedpmcarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 552 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 651 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL j, n;

    if (value->vtable->base_type != enum_class_FixedPMCArray)
        return 0;
    n = Parrot_FixedPMCArray_elements(interpreter, pmc);
    if (VTABLE_elements(interpreter, value) != n)
        return 0;
    for (j = 0; j < n; ++j) {
        PMC *item1, *item2;
        item1 = Parrot_FixedPMCArray_get_pmc_keyed_int(interpreter, pmc, j);
        item2 = VTABLE_get_pmc_keyed_int(interpreter, value, j);
        if (item1 == item2)
            continue;
        if (!mmd_dispatch_i_pp(interpreter, item1, item2, MMD_EQ))
            return 0;
    }
    return 1;

}
#line 578 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 733 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL ix = key_integer(interpreter, key);
    return Parrot_FixedPMCArray_exists_keyed_int(interpreter, pmc, ix);

}
#line 589 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 723 "src/pmc/fixedpmcarray.pmc"
{
    PMC **data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedPMCArray: index out of bounds!");

    data = (PMC**)PMC_data(pmc);
    return !PMC_IS_NULL(data[key]);

}
#line 605 "src/pmc/fixedpmcarray.c"


INTVAL
Parrot_FixedPMCArray_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 794 "src/pmc/fixedpmcarray.pmc"
{
    PMC* val;

    val =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    if(PMC_IS_NULL(val))
        return 0;

    return VTABLE_defined(interpreter, val);

}
#line 621 "src/pmc/fixedpmcarray.c"


PMC*
Parrot_FixedPMCArray_get_iter(Interp* interpreter, PMC* pmc)
#line 701 "src/pmc/fixedpmcarray.pmc"
{
    PMC *iter = pmc_new_init(interpreter, enum_class_Iterator, pmc);
    PMC *key =  pmc_new(interpreter, enum_class_Key);
    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;
    PMC_int_val(key) = 0;
    if (PMC_int_val(pmc) == 0)
        PMC_int_val(key) = -1;
    return iter;

}
#line 638 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 771 "src/pmc/fixedpmcarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_freeze(interpreter, pmc, info);
     VTABLE_push_integer(interpreter, io, VTABLE_elements(interpreter, pmc));

}
#line 650 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 777 "src/pmc/fixedpmcarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
         VTABLE_set_integer_native(interpreter, pmc,  VTABLE_shift_integer(interpreter, io));

}
#line 663 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 758 "src/pmc/fixedpmcarray.pmc"
{
    INTVAL i, n;
    PMC **pos;

    n = VTABLE_elements(interpreter, pmc);
    pos = (PMC **)PMC_data(pmc);
    for (i = 0; i < n; ++i, ++pos) {
        info->thaw_ptr = pos;
        (info->visit_pmc_now)(interpreter, *pos, info);
    }
    Parrot_default_visit(interpreter, pmc, info);

}
#line 682 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_sort(Interp* interpreter, PMC* pmc, PMC *cmp_func)
#line 96 "src/pmc/fixedpmcarray.pmc"
{
UINTVAL n;


n = (UINTVAL) PMC_int_val(pmc);
if (n <= 1)
    return;
if (PMC_IS_NULL(cmp_func))
    cmp_func = NULL;
quicksort(interpreter, PMC_data(pmc), n, cmp_func);

}
#line 700 "src/pmc/fixedpmcarray.c"


void
Parrot_FixedPMCArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_FixedPMCArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedPMCArray_morph,
        Parrot_default_mark,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_FixedPMCArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_repr,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_FixedPMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_FixedPMCArray_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedPMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedPMCArray_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedPMCArray_set_pmc_keyed,
        Parrot_FixedPMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedPMCArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_FixedPMCArray_exists_keyed,
        Parrot_FixedPMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_FixedPMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_FixedPMCArray_freeze,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_FixedPMCArray_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_FixedPMCArray_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "FixedPMCArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedPMCArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_FixedPMCArray_sort),
                "sort", "vJOP");
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_FixedPMCArray_class_init */


/*

=back

=head1 TODO

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
