/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/fixedstringarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/fixedstringarray.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: fixedstringarray.pmc 11610 2006-02-17 01:54:32Z particle $

=head1 NAME

src/pmc/fixedstringarray.pmc - fixed size array for strings only

=head1 DESCRIPTION

This class, FixedStringArray, implements an array of fixed size, which
stores Parrot strings.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 36 "src/pmc/fixedstringarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedstringarray.h"
#include "pmc_default.h"
#include "fixedstringarray.str"

void
Parrot_FixedStringArray_init(Interp* interpreter, PMC* pmc)
#line 42 "src/pmc/fixedstringarray.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = NULL;

}
#line 52 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_morph(Interp* interpreter, PMC* pmc, INTVAL type)
#line 57 "src/pmc/fixedstringarray.pmc"
{
    Parrot_default_morph(interpreter, pmc, type);

}
#line 62 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_mark(Interp* interpreter, PMC* pmc)
#line 114 "src/pmc/fixedstringarray.pmc"
{
    int i, end;
    STRING **data;
    if (!PMC_data(pmc))
        return;
    data = (STRING **) PMC_data(pmc);
    end = PMC_int_val(pmc);
    for(i = 0; i < end; i++) {
        if(data[i]) {
            pobject_lives(interpreter, (PObj *) data[i]);
        }
    }

}
#line 82 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_destroy(Interp* interpreter, PMC* pmc)
#line 72 "src/pmc/fixedstringarray.pmc"
{
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
    PMC_int_val(pmc) = 0;

}
#line 95 "src/pmc/fixedstringarray.c"


PMC*
Parrot_FixedStringArray_clone(Interp* interpreter, PMC* pmc)
#line 89 "src/pmc/fixedstringarray.pmc"
{
    INTVAL size;
    PMC * dest = pmc_new(interpreter, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;
    size = PMC_int_val(pmc);
    PMC_int_val(dest) = size;

    PMC_data(dest) = mem_sys_allocate(size * sizeof(STRING*));
    mem_sys_memcopy(PMC_data(dest), PMC_data(pmc), size*sizeof(STRING*));
    PObj_custom_mark_destroy_SETALL(dest);
    return dest;

}
#line 116 "src/pmc/fixedstringarray.c"


INTVAL
Parrot_FixedStringArray_get_integer(Interp* interpreter, PMC* pmc)
#line 169 "src/pmc/fixedstringarray.pmc"
{
    return Parrot_FixedStringArray_elements(interpreter, pmc);

}
#line 126 "src/pmc/fixedstringarray.c"


INTVAL
Parrot_FixedStringArray_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 199 "src/pmc/fixedstringarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_integer_keyed_int(interpreter, pmc, k);

}
#line 138 "src/pmc/fixedstringarray.c"


INTVAL
Parrot_FixedStringArray_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 184 "src/pmc/fixedstringarray.pmc"
{
    PMC *tempPMC =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_integer(interpreter, tempPMC);

}
#line 149 "src/pmc/fixedstringarray.c"


FLOATVAL
Parrot_FixedStringArray_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 231 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_number_keyed_int(interpreter, pmc, k);

}
#line 160 "src/pmc/fixedstringarray.c"


FLOATVAL
Parrot_FixedStringArray_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 216 "src/pmc/fixedstringarray.pmc"
{
    PMC *tempPMC =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    return VTABLE_get_number(interpreter, tempPMC);

}
#line 171 "src/pmc/fixedstringarray.c"


STRING*
Parrot_FixedStringArray_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 266 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_string_keyed_int(interpreter, pmc, k);

}
#line 182 "src/pmc/fixedstringarray.c"


STRING*
Parrot_FixedStringArray_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 246 "src/pmc/fixedstringarray.pmc"
{
    STRING **data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedStringArray: index out of bounds!");

    data = (STRING **)PMC_data(pmc);
    return data[key];

}
#line 198 "src/pmc/fixedstringarray.c"


INTVAL
Parrot_FixedStringArray_get_bool(Interp* interpreter, PMC* pmc)
#line 140 "src/pmc/fixedstringarray.pmc"
{
    INTVAL size = Parrot_FixedStringArray_elements(interpreter, pmc);
    return (INTVAL)(size != 0);

}
#line 209 "src/pmc/fixedstringarray.c"


PMC*
Parrot_FixedStringArray_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 302 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return  VTABLE_get_pmc_keyed_int(interpreter, pmc, k);

}
#line 220 "src/pmc/fixedstringarray.c"


PMC*
Parrot_FixedStringArray_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 282 "src/pmc/fixedstringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interpreter, enum_class_String);
    val =  VTABLE_get_string_keyed_int(interpreter, pmc, key);
    VTABLE_set_string_native(interpreter, ret, val);
    return ret;

}
#line 236 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 319 "src/pmc/fixedstringarray.pmc"
{
    if (PMC_int_val(pmc) || size < 1)
        real_exception(interpreter, NULL, E_IndexError,
                "FixedStringArray: Can't resize!");
    PMC_int_val(pmc) = size;
    PMC_data(pmc) = mem_sys_allocate_zeroed(size * sizeof(STRING*));
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 251 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC *key, INTVAL value)
#line 358 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_integer_keyed_int(interpreter, pmc, k, value);

}
#line 263 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 338 "src/pmc/fixedstringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interpreter, enum_class_String);
    VTABLE_set_integer_native(interpreter, ret, value);
    val = VTABLE_get_string(interpreter, ret);
     VTABLE_set_string_keyed_int(interpreter, pmc, key, val);

}
#line 279 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_number_keyed(Interp* interpreter, PMC* pmc, PMC *key, FLOATVAL value)
#line 396 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_number_keyed_int(interpreter, pmc, k, value);

}
#line 291 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 375 "src/pmc/fixedstringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interpreter, enum_class_String);
    VTABLE_set_number_native(interpreter, ret, value);
    val = VTABLE_get_string(interpreter, ret);
     VTABLE_set_string_keyed_int(interpreter, pmc, key, val);

}
#line 307 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_string_keyed(Interp* interpreter, PMC* pmc, PMC *key, STRING* value)
#line 434 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_string_keyed_int(interpreter, pmc, k, value);

}
#line 319 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 412 "src/pmc/fixedstringarray.pmc"
{
    STRING **data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
            "FixedStringArray: index out of bounds!");

    data = (STRING**)PMC_data(pmc);
    DOD_WRITE_BARRIER(interpreter, pmc, data[key], value);
    data[key] = value;

}
#line 336 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key, PMC* value)
#line 468 "src/pmc/fixedstringarray.pmc"
{
    INTVAL k;
    k = key_integer(interpreter, key);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, k, value);

}
#line 348 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* src)
#line 450 "src/pmc/fixedstringarray.pmc"
{
    STRING *temp;

    temp = VTABLE_get_string(interpreter, src);
     VTABLE_set_string_keyed_int(interpreter, pmc, key, temp);

}
#line 361 "src/pmc/fixedstringarray.c"


INTVAL
Parrot_FixedStringArray_elements(Interp* interpreter, PMC* pmc)
#line 155 "src/pmc/fixedstringarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 371 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 489 "src/pmc/fixedstringarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    INTVAL i, n;
    STRING **data;

    data = (STRING**)PMC_data(pmc);
    n = PMC_int_val(pmc);
     VTABLE_push_integer(interpreter, io, n);
    for (i = 0; i < n; ++i) {
         VTABLE_push_string(interpreter, io, data[i]);
    }

}
#line 390 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 511 "src/pmc/fixedstringarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    INTVAL i, n;
    STRING **data;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
         VTABLE_init(interpreter, pmc);
        n =  VTABLE_shift_integer(interpreter, io);
         VTABLE_set_integer_native(interpreter, pmc, n);
        data = PMC_data(pmc);
        for (i = 0; i < n; ++i)
            data[i] =  VTABLE_shift_string(interpreter, io);
    }

}
#line 411 "src/pmc/fixedstringarray.c"


void
Parrot_FixedStringArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_FixedStringArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedStringArray_morph,
        Parrot_FixedStringArray_mark,
        Parrot_FixedStringArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_FixedStringArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_FixedStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedStringArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedStringArray_set_integer_keyed,
        Parrot_FixedStringArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedStringArray_set_number_keyed,
        Parrot_FixedStringArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedStringArray_set_string_keyed,
        Parrot_FixedStringArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedStringArray_set_pmc_keyed,
        Parrot_FixedStringArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedStringArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_FixedStringArray_freeze,
        Parrot_FixedStringArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "FixedStringArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedStringArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_FixedStringArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
