/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/float.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/float.pmc"
/*
Copyright: 2003-2006 The Perl Foundation.  All Rights Reserved.
$Id: float.pmc 12496 2006-05-04 06:20:10Z petdance $

=head1 NAME

src/pmc/float.pmc - Floating-point number

=head1 DESCRIPTION

C<Float> extends C<scalar> to provide floating-point number operations.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 35 "src/pmc/float.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_float.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "float.str"

void
Parrot_Float_init(Interp* interpreter, PMC* pmc)
#line 35 "src/pmc/float.pmc"
{
    PMC_num_val(pmc) = 0.0;

}
#line 51 "src/pmc/float.c"


PMC*
Parrot_Float_new_from_string(Interp* interpreter, PMC* pmc, STRING *rep, INTVAL flags)
#line 48 "src/pmc/float.pmc"
{
    PMC *res;
    const INTVAL type = pmc->vtable->base_type;

    if (flags & PObj_constant_FLAG)
        res = constant_pmc_new(interpreter, type);
    else
        res = pmc_new(interpreter, type);
    PMC_num_val(res) = string_to_num(interpreter, rep);
    return res;

}
#line 69 "src/pmc/float.c"


void
Parrot_Float_morph(Interp* interpreter, PMC* pmc, INTVAL type)
#line 213 "src/pmc/float.pmc"
{
    pmc_reuse(interpreter, pmc, type, 0);

}
#line 79 "src/pmc/float.c"


INTVAL
Parrot_Float_get_integer(Interp* interpreter, PMC* pmc)
#line 84 "src/pmc/float.pmc"
{
    return (INTVAL) PMC_num_val(pmc);
   
}
#line 89 "src/pmc/float.c"


FLOATVAL
Parrot_Float_get_number(Interp* interpreter, PMC* pmc)
#line 70 "src/pmc/float.pmc"
{
    return PMC_num_val(pmc);

}
#line 99 "src/pmc/float.c"


STRING*
Parrot_Float_get_string(Interp* interpreter, PMC* pmc)
#line 114 "src/pmc/float.pmc"
{
    return string_from_num(interpreter, PMC_num_val(pmc));

}
#line 109 "src/pmc/float.c"


STRING*
Parrot_Float_get_repr(Interp* interpreter, PMC* pmc)
#line 118 "src/pmc/float.pmc"
{
    double d = (double) PMC_num_val(pmc);
    const char * const sign = signbit(PMC_num_val(pmc)) ? "-" : "";
    d = fabs(d);
    return Parrot_sprintf_c(interpreter, "%s" FLOATVAL_FMT, sign, d);

}
#line 122 "src/pmc/float.c"


INTVAL
Parrot_Float_get_bool(Interp* interpreter, PMC* pmc)
#line 98 "src/pmc/float.pmc"
{
    return (INTVAL)(PMC_num_val(pmc) != 0.0);

}
#line 132 "src/pmc/float.c"


void
Parrot_Float_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
#line 135 "src/pmc/float.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_Integer);
     VTABLE_set_integer_native(interpreter, pmc, value);

}
#line 143 "src/pmc/float.c"


void
Parrot_Float_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 155 "src/pmc/float.pmc"
{
    PMC_num_val(pmc) = value;

}
#line 153 "src/pmc/float.c"


void
Parrot_Float_set_number_same(Interp* interpreter, PMC* pmc, PMC* value)
#line 169 "src/pmc/float.pmc"
{
    PMC_num_val(pmc) = PMC_num_val(value);

}
#line 163 "src/pmc/float.c"


void
Parrot_Float_set_string_native(Interp* interpreter, PMC* pmc, STRING * value)
#line 185 "src/pmc/float.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_String);
     VTABLE_set_string_native(interpreter, pmc, value);

}
#line 174 "src/pmc/float.c"


void
Parrot_Float_set_bool(Interp* interpreter, PMC* pmc, INTVAL value)
#line 140 "src/pmc/float.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_Boolean);
     VTABLE_set_bool(interpreter, pmc, value);

}
#line 185 "src/pmc/float.c"


void
Parrot_Float_set_pmc(Interp* interpreter, PMC* pmc, PMC *value)
#line 200 "src/pmc/float.pmc"
{
    PMC_num_val(pmc) = VTABLE_get_number(interpreter, value);

}
#line 195 "src/pmc/float.c"


void
Parrot_Float_increment(Interp* interpreter, PMC* pmc)
#line 324 "src/pmc/float.pmc"
{
    PMC_num_val(pmc) ++;

}
#line 205 "src/pmc/float.c"


void
Parrot_Float_decrement(Interp* interpreter, PMC* pmc)
#line 338 "src/pmc/float.pmc"
{
    PMC_num_val(pmc) --;

}
#line 215 "src/pmc/float.c"


PMC*
Parrot_Float_absolute(Interp* interpreter, PMC* pmc, PMC *dest)
#line 353 "src/pmc/float.pmc"
{
    const FLOATVAL a = fabs( VTABLE_get_number(interpreter, pmc));
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_number_native(interpreter, dest, a);
    return dest;

}
#line 229 "src/pmc/float.c"


void
Parrot_Float_i_absolute(Interp* interpreter, PMC* pmc)
#line 361 "src/pmc/float.pmc"
{
    const FLOATVAL a = fabs( VTABLE_get_number(interpreter, pmc));
    VTABLE_set_number_native(interpreter, pmc, a);

}
#line 240 "src/pmc/float.c"


PMC*
Parrot_Float_neg(Interp* interpreter, PMC* pmc, PMC * dest)
#line 231 "src/pmc/float.pmc"
{
    const FLOATVAL a = -  VTABLE_get_number(interpreter, pmc);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_number_native(interpreter, dest, a);
    return dest;

}
#line 254 "src/pmc/float.c"


void
Parrot_Float_i_neg(Interp* interpreter, PMC* pmc)
#line 239 "src/pmc/float.pmc"
{
    const FLOATVAL a = -  VTABLE_get_number(interpreter, pmc);
    VTABLE_set_number_native(interpreter, pmc, a);

}
#line 265 "src/pmc/float.c"


INTVAL
Parrot_Float_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 254 "src/pmc/float.pmc"
{
    return (INTVAL)(PMC_num_val(pmc) == VTABLE_get_number(interpreter, value));
    
}
#line 275 "src/pmc/float.c"
INTVAL
Parrot_Float_is_equal_Float(Interp* interpreter, PMC* pmc, PMC* value)
{
    return (INTVAL)(PMC_num_val(pmc) == PMC_num_val(value));
    
}

INTVAL
Parrot_Float_is_equal_num(Interp* interpreter, PMC* pmc, PMC* value)
#line 263 "src/pmc/float.pmc"
{
    return (INTVAL)(PMC_num_val(pmc) == VTABLE_get_number(interpreter, value));
    
}
#line 290 "src/pmc/float.c"
INTVAL
Parrot_Float_is_equal_num_Float(Interp* interpreter, PMC* pmc, PMC* value)
{
    return (INTVAL)(PMC_num_val(pmc) == PMC_num_val(value));
    
}

INTVAL
Parrot_Float_cmp(Interp* interpreter, PMC* pmc, PMC* value)
#line 282 "src/pmc/float.pmc"
{
        const FLOATVAL diff = PMC_num_val(pmc) - VTABLE_get_number(interpreter, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}
#line 306 "src/pmc/float.c"
INTVAL
Parrot_Float_cmp_Float(Interp* interpreter, PMC* pmc, PMC* value)
{
        const FLOATVAL diff = PMC_num_val(pmc) - PMC_num_val(value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}

INTVAL
Parrot_Float_cmp_num(Interp* interpreter, PMC* pmc, PMC* value)
#line 303 "src/pmc/float.pmc"
{
        const FLOATVAL diff = PMC_num_val(pmc) - VTABLE_get_number(interpreter, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}
#line 323 "src/pmc/float.c"
INTVAL
Parrot_Float_cmp_num_Float(Interp* interpreter, PMC* pmc, PMC* value)
{
        const FLOATVAL diff = PMC_num_val(pmc) - PMC_num_val(value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}

void
Parrot_Float_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 375 "src/pmc/float.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interpreter, pmc, info);
     VTABLE_push_float(interpreter, io, PMC_num_val(pmc));

}
#line 341 "src/pmc/float.c"


void
Parrot_Float_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 390 "src/pmc/float.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        PMC_num_val(pmc) =  VTABLE_shift_float(interpreter, io);

}
#line 354 "src/pmc/float.c"


PMC*
Parrot_Float_acos(Interp* interpreter, PMC* pmc)
#line 442 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = acos(PMC_num_val(pmc));
    return d;

}
#line 366 "src/pmc/float.c"


PMC*
Parrot_Float_cos(Interp* interpreter, PMC* pmc)
#line 447 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter,
            Parrot_get_ctx_HLL_type(interpreter, enum_class_Float));
    PMC_num_val(d) = cos(VTABLE_get_number(interpreter, pmc));
    return d;

}
#line 379 "src/pmc/float.c"


PMC*
Parrot_Float_asec(Interp* interpreter, PMC* pmc)
#line 453 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = acos(1.0 / PMC_num_val(pmc));
    return d;

}
#line 391 "src/pmc/float.c"


PMC*
Parrot_Float_asin(Interp* interpreter, PMC* pmc)
#line 458 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = asin(PMC_num_val(pmc));
    return d;

}
#line 403 "src/pmc/float.c"


PMC*
Parrot_Float_atan(Interp* interpreter, PMC* pmc)
#line 463 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = atan(PMC_num_val(pmc));
    return d;

}
#line 415 "src/pmc/float.c"


PMC*
Parrot_Float_atan2(Interp* interpreter, PMC* pmc, PMC *val)
#line 468 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = atan2(PMC_num_val(pmc), PMC_num_val(val));
    return d;

}
#line 427 "src/pmc/float.c"


PMC*
Parrot_Float_cosh(Interp* interpreter, PMC* pmc)
#line 473 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = cosh(PMC_num_val(pmc));
    return d;

}
#line 439 "src/pmc/float.c"


PMC*
Parrot_Float_exp(Interp* interpreter, PMC* pmc)
#line 478 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = exp(PMC_num_val(pmc));
    return d;

}
#line 451 "src/pmc/float.c"


PMC*
Parrot_Float_ln(Interp* interpreter, PMC* pmc)
#line 483 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = log(PMC_num_val(pmc));
    return d;

}
#line 463 "src/pmc/float.c"


PMC*
Parrot_Float_log10(Interp* interpreter, PMC* pmc)
#line 488 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = log10(PMC_num_val(pmc));
    return d;

}
#line 475 "src/pmc/float.c"


PMC*
Parrot_Float_log2(Interp* interpreter, PMC* pmc)
#line 493 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = log(PMC_num_val(pmc)) / log(2.0);
    return d;

}
#line 487 "src/pmc/float.c"


PMC*
Parrot_Float_sec(Interp* interpreter, PMC* pmc)
#line 498 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = 1.0 / cos(PMC_num_val(pmc));
    return d;

}
#line 499 "src/pmc/float.c"


PMC*
Parrot_Float_sech(Interp* interpreter, PMC* pmc)
#line 503 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = 1.0 / cosh(PMC_num_val(pmc));
    return d;

}
#line 511 "src/pmc/float.c"


PMC*
Parrot_Float_sin(Interp* interpreter, PMC* pmc)
#line 508 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = sin(PMC_num_val(pmc));
    return d;

}
#line 523 "src/pmc/float.c"


PMC*
Parrot_Float_sinh(Interp* interpreter, PMC* pmc)
#line 513 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = sinh(PMC_num_val(pmc));
    return d;

}
#line 535 "src/pmc/float.c"


PMC*
Parrot_Float_tan(Interp* interpreter, PMC* pmc)
#line 518 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = tan(PMC_num_val(pmc));
    return d;

}
#line 547 "src/pmc/float.c"


PMC*
Parrot_Float_tanh(Interp* interpreter, PMC* pmc)
#line 523 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = tanh(PMC_num_val(pmc));
    return d;

}
#line 559 "src/pmc/float.c"


PMC*
Parrot_Float_sqrt(Interp* interpreter, PMC* pmc)
#line 529 "src/pmc/float.pmc"
{
    PMC * const d = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_num_val(d) = sqrt(PMC_num_val(pmc));
    return d;

}
#line 571 "src/pmc/float.c"


void
Parrot_Float_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Float,	/* base_type */
        NULL,	/* whoami */
        0, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Float_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_Float_new_from_string,
        Parrot_Float_morph,
        Parrot_default_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_scalar_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Float_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Float_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Float_get_string,
        Parrot_Float_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Float_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Float_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Float_set_number_native,
        Parrot_Float_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Float_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Float_set_bool,
        Parrot_Float_set_pmc,
        Parrot_scalar_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_Float_increment,
        Parrot_Float_decrement,
        Parrot_Float_absolute,
        Parrot_Float_i_absolute,
        Parrot_Float_neg,
        Parrot_Float_i_neg,
        Parrot_scalar_bitwise_not,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_scalar_logical_not,
        Parrot_scalar_i_logical_not,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Float_freeze,
        Parrot_Float_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_add_Complex },
        { MMD_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_add },
        { MMD_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_add_int },
        { MMD_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_add_float },
        { MMD_I_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_add },
        { MMD_I_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_add_float },
        { MMD_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_subtract },
        { MMD_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_subtract_int },
        { MMD_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_subtract_float },
        { MMD_I_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_multiply },
        { MMD_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_multiply_int },
        { MMD_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_multiply_float },
        { MMD_I_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_divide },
        { MMD_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_divide_int },
        { MMD_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_divide_float },
        { MMD_I_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_divide },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_divide_float },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_floor_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_floor_divide_float },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_floor_divide_float },
        { MMD_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_modulus },
        { MMD_MOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_modulus_int },
        { MMD_MOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_modulus_float },
        { MMD_I_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_modulus },
        { MMD_I_MOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_modulus_int },
        { MMD_I_MOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_modulus_float },
        { MMD_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_cmodulus },
        { MMD_CMOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_cmodulus_float },
        { MMD_I_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_cmodulus },
        { MMD_I_CMOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_cmodulus_int },
        { MMD_I_CMOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_cmodulus_float },
        { MMD_POW, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_pow },
        { MMD_POW, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_pow_int },
        { MMD_POW, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_pow_float },
        { MMD_I_POW, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_pow },
        { MMD_I_POW, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_pow_int },
        { MMD_I_POW, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_pow_float },
        { MMD_BOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_or },
        { MMD_BOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_or_int },
        { MMD_I_BOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_or },
        { MMD_I_BOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_or_int },
        { MMD_BAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_and },
        { MMD_BAND, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_and_int },
        { MMD_I_BAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_and },
        { MMD_I_BAND, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_and_int },
        { MMD_BXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_xor },
        { MMD_BXOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_xor_int },
        { MMD_I_BXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_xor },
        { MMD_I_BXOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_xor_int },
        { MMD_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_shl },
        { MMD_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_shr },
        { MMD_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_shr_int },
        { MMD_LSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_lsr },
        { MMD_LSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_lsr_int },
        { MMD_I_LSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_lsr },
        { MMD_I_LSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_lsr_int },
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Float_is_equal },
        { MMD_EQ, 0, enum_class_Float,
                    (funcptr_t) Parrot_Float_is_equal_Float },
        { MMD_NUMEQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Float_is_equal_num },
        { MMD_NUMEQ, 0, enum_class_Float,
                    (funcptr_t) Parrot_Float_is_equal_num_Float },
        { MMD_CMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Float_cmp },
        { MMD_CMP, 0, enum_class_Float,
                    (funcptr_t) Parrot_Float_cmp_Float },
        { MMD_NUMCMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Float_cmp_num },
        { MMD_NUMCMP, 0, enum_class_Float,
                    (funcptr_t) Parrot_Float_cmp_num_Float },
        { MMD_STRCMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_cmp_string },
        { MMD_LOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_or },
        { MMD_LAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_and },
        { MMD_LXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_xor },
        { MMD_CONCAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_concatenate },
        { MMD_CONCAT, 0, enum_type_STRING,
                    (funcptr_t) Parrot_scalar_concatenate_str },
        { MMD_I_CONCAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_concatenate },
        { MMD_I_CONCAT, 0, enum_type_STRING,
                    (funcptr_t) Parrot_scalar_i_concatenate_str },
        { MMD_REPEAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_repeat },
        { MMD_REPEAT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_repeat_int },
        { MMD_I_REPEAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_repeat },
        { MMD_I_REPEAT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_repeat_int }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Float");
        vt_clone->isa_str = CONST_STRING(interp, "Float scalar");
        vt_clone->does_str = CONST_STRING(interp, "scalar float");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_acos),
                "acos", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_cos),
                "cos", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_asec),
                "asec", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_asin),
                "asin", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_atan),
                "atan", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_atan2),
                "atan2", "PJOP");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_cosh),
                "cosh", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_exp),
                "exp", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_ln),
                "ln", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_log10),
                "log10", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_log2),
                "log2", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_sec),
                "sec", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_sech),
                "sech", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_sin),
                "sin", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_sinh),
                "sinh", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_tan),
                "tan", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_tanh),
                "tanh", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Float_sqrt),
                "sqrt", "PJO");
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_Float_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
