/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/hash.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: hash.pmc 12496 2006-05-04 06:20:10Z petdance $

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>


/*

=item C<static PMC * get_integer_pmc(Interp* interpreter, INTVAL base_type )>

Lookup the PMC type which is used for storing native integers.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC* get_integer_pmc(Interp* interpreter, INTVAL base_type ) {

    return pmc_new(interpreter,
                   Parrot_get_ctx_HLL_type(interpreter, enum_class_Integer) );
}

/*

=item C<static PMC * get_none_pmc(Interp* interpreter, INTVAL base_type )>

As C<None> is a singleton PMCs, it is probably
cheap to call C<pmc_new>.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC * get_none_pmc(Interp* interpreter, INTVAL base_type ) {

    return pmc_new(interpreter,
                   Parrot_get_ctx_HLL_type(interpreter, enum_class_None) );
}

/*

=item C<static PMC * get_number_pmc(Interp* interpreter, INTVAL base_type )>

Lookup the PMC type which is used for floating point numbers.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC * get_number_pmc(Interp* interpreter, INTVAL base_type ) {

    return pmc_new(interpreter,
                   Parrot_get_ctx_HLL_type(interpreter, enum_class_Float) );
}

/*

=item C<static PMC * get_string_pmc(Interp* interpreter, INTVAL base_type )>

Lookup the PMC type which is used for storing strings.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC * get_string_pmc(Interp* interpreter, INTVAL base_type ) {

    return pmc_new(interpreter,
                   Parrot_get_ctx_HLL_type(interpreter, enum_class_String) );
}


/*

=item C<static STRING* make_hash_key(Interp *interpreter, PMC *key)>

Returns a Parrot string for C<*key>.

=cut

*/

static STRING* make_hash_key(Interp* interpreter, PMC * key)
{
    if (key == NULL) {
        real_exception(interpreter, NULL, E_KeyError,
                "Hash: Cannot use NULL key");
        return NULL;
    }
    return key_string(interpreter, key);
}

/* Albeit the Hash PMC doesn't use PMC_data, it needs the next_for_GC pointer
 * We would get recursive marking of a deeply nested HoHoH...
 */
#line 134 "src/pmc/hash.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"

void
Parrot_Hash_init(Interp* interpreter, PMC* pmc)
#line 138 "src/pmc/hash.pmc"
{
    PMC_struct_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    new_pmc_hash(interpreter, pmc);

}
#line 151 "src/pmc/hash.c"


void
Parrot_Hash_mark(Interp* interpreter, PMC* pmc)
#line 160 "src/pmc/hash.pmc"
{
    if (PMC_struct_val(pmc))
        mark_hash(interpreter, PMC_struct_val(pmc));

}
#line 162 "src/pmc/hash.c"


void
Parrot_Hash_destroy(Interp* interpreter, PMC* pmc)
#line 144 "src/pmc/hash.pmc"
{
    if (PMC_struct_val(pmc)) {
        hash_destroy(interpreter, (Hash*) PMC_struct_val(pmc));
        PMC_struct_val(pmc) = NULL;
    }

}
#line 175 "src/pmc/hash.c"


INTVAL
Parrot_Hash_type_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 196 "src/pmc/hash.pmc"
{
    PMC* valpmc;
    PMC* nextkey;
    STRING* const keystr = make_hash_key(interpreter, key);
    HashBucket* const b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                        keystr);
    if (b == NULL) {
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_type(interpreter, none);
    }
    nextkey = key_next(interpreter, key);
    valpmc = b->value;
    if (!nextkey)
        return VTABLE_type(interpreter, valpmc);
    return VTABLE_type_keyed(interpreter, valpmc, nextkey);

}
#line 199 "src/pmc/hash.c"


INTVAL
Parrot_Hash_type_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 175 "src/pmc/hash.pmc"
{
    HashBucket* const b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                    key);
    if (b == NULL) {
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_type(interpreter, none);
    }
    return VTABLE_type(interpreter, (PMC*) b->value);

}
#line 216 "src/pmc/hash.c"


PMC*
Parrot_Hash_clone(Interp* interpreter, PMC* pmc)
#line 224 "src/pmc/hash.pmc"
{
    PMC* const dest = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    PObj_custom_mark_destroy_SETALL(dest);
    hash_clone(interpreter, (Hash *)PMC_struct_val(pmc),
               (Hash**)&PMC_struct_val(dest));
    ((Hash*)PMC_struct_val(dest))->container = dest;
    return dest;

}
#line 231 "src/pmc/hash.c"


INTVAL
Parrot_Hash_get_integer(Interp* interpreter, PMC* pmc)
#line 243 "src/pmc/hash.pmc"
{
    return hash_size(interpreter, PMC_struct_val(pmc));

}
#line 241 "src/pmc/hash.c"


INTVAL
Parrot_Hash_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 283 "src/pmc/hash.pmc"
{
    PMC* valpmc;
    STRING* keystr;
    Hash * const hash = PMC_struct_val(pmc);
    HashBucket *b;
    PMC* nextkey;

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            /* called from iterator with an integer idx in key
             * check if we really have Hash_key_type_int
             */
            if (hash->key_type == Hash_key_type_int) {
                return (INTVAL)hash_get_idx(interpreter, hash, key);
            }
            else {
                STRING *s = hash_get_idx(interpreter, hash, key);
                return string_to_int(interpreter, s);
            }
        default:
            keystr = make_hash_key(interpreter, key);
    }
    b = hash_get_bucket(interpreter, hash, keystr);
    if (b == NULL) {
        /* XXX Warning: use of uninitialized value */
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_get_integer(interpreter, none);
    }
    nextkey = key_next(interpreter, key);
    valpmc = b->value;
    if (!nextkey)
        return VTABLE_get_integer(interpreter, valpmc);
    return VTABLE_get_integer_keyed(interpreter, valpmc, nextkey);

}
#line 283 "src/pmc/hash.c"


INTVAL
Parrot_Hash_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 269 "src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interpreter, key);
    return Parrot_Hash_get_integer_keyed_str(interpreter, pmc, s);

}
#line 294 "src/pmc/hash.c"


INTVAL
Parrot_Hash_get_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 257 "src/pmc/hash.pmc"
{
    HashBucket * const b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                    key);
    if (b == NULL) {
        /* XXX Warning: use of uninitialized value */
        PMC * const  none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_get_integer(interpreter, none);
    }
    return VTABLE_get_integer(interpreter, (PMC*) b->value);

}
#line 312 "src/pmc/hash.c"


FLOATVAL
Parrot_Hash_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 355 "src/pmc/hash.pmc"
{
    PMC* valpmc;
    STRING* const keystr = make_hash_key(interpreter, key);
    HashBucket * const b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                    keystr);
    PMC* nextkey;
    if (b == NULL) {
        /* XXX Warning: Use of uninitialized value */
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_get_number(interpreter, none);
    }
    nextkey = key_next(interpreter, key);
    valpmc = b->value;
    if (!nextkey)
        return VTABLE_get_number(interpreter, valpmc);
    return VTABLE_get_number_keyed(interpreter, valpmc, nextkey);

}
#line 337 "src/pmc/hash.c"


FLOATVAL
Parrot_Hash_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 341 "src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interpreter, key);
    return Parrot_Hash_get_number_keyed_str(interpreter, pmc, s);

}
#line 348 "src/pmc/hash.c"


FLOATVAL
Parrot_Hash_get_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 329 "src/pmc/hash.pmc"
{
    HashBucket * const b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                    key);
    if (b == NULL) {
        /* XXX Warning: Use of uninitialized value */
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_get_number(interpreter, none);
    }
    return VTABLE_get_number(interpreter, (PMC*) b->value);

}
#line 366 "src/pmc/hash.c"


STRING*
Parrot_Hash_get_string(Interp* interpreter, PMC* pmc)
#line 390 "src/pmc/hash.pmc"
{
    return Parrot_sprintf_c(interpreter, "Hash[0x%x]", pmc);

}
#line 376 "src/pmc/hash.c"


STRING*
Parrot_Hash_get_repr(Interp* interpreter, PMC* pmc)
#line 394 "src/pmc/hash.pmc"
{
    /* TODO use freeze */
    PMC * const iter = VTABLE_get_iter(interpreter, pmc);
    STRING *res = string_from_cstring(interpreter, "{", 0);
    const INTVAL n = VTABLE_elements(interpreter, pmc);
    INTVAL j;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interpreter, iter);
        int i,all_digit = 1;
        PMC *val;

        for (i = 0; i < (int)key->strlen; ++i) {
            if (!isdigit(((char *)key->strstart)[i])) {
                all_digit = 0;
                break;
            }
        }
        if (all_digit) {
            res = string_append(interpreter, res, key, 0);
        }
        else {
            res = string_append(interpreter, res,
                    const_string(interpreter, "'"), 0);
            res = string_append(interpreter, res, key, 0);
            res = string_append(interpreter, res,
                    const_string(interpreter, "'"), 0);
        }
        res = string_append(interpreter, res,
                const_string(interpreter, ": "), 0);
        val = Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, key);
        res = string_append(interpreter, res,
                VTABLE_get_string(interpreter, val), 0);
        if (j < n - 1)
            res = string_append(interpreter, res,
                    const_string(interpreter, ", "), 0);
    }
    res = string_append(interpreter, res,
            const_string(interpreter, "}"), 0);
    return res;

}
#line 424 "src/pmc/hash.c"


STRING*
Parrot_Hash_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 473 "src/pmc/hash.pmc"
{
    PMC* valpmc;
    STRING* keystr;
    HashBucket *b;
    Hash * const hash = PMC_struct_val(pmc);
    PMC* nextkey;

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            /* called from iterator with an integer idx in key */
            if (hash->key_type == Hash_key_type_int) {
                INTVAL i = (INTVAL)hash_get_idx(interpreter, hash, key);
                return string_from_int(interpreter, i);
            }
            return hash_get_idx(interpreter, hash, key);
        default:
            keystr = make_hash_key(interpreter, key);
    }
    b = hash_get_bucket(interpreter, hash, keystr);
    if (b == NULL) {
        /* XXX Warning: use of uninitialized value */
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_get_string(interpreter, none);
    }
    nextkey = key_next(interpreter, key);
    valpmc = b->value;
    if (!nextkey)
        return VTABLE_get_string(interpreter, valpmc);
    return VTABLE_get_string_keyed(interpreter, valpmc, nextkey);

}
#line 462 "src/pmc/hash.c"


STRING*
Parrot_Hash_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 458 "src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interpreter, key);
    return Parrot_Hash_get_string_keyed_str(interpreter, pmc, s);

}
#line 473 "src/pmc/hash.c"


STRING*
Parrot_Hash_get_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 446 "src/pmc/hash.pmc"
{
    HashBucket * const b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                    key);
    if (b == NULL) {
        /* XXX Warning: use of uninitialized value */
        PMC * const none = get_none_pmc(interpreter, pmc->vtable->base_type);

        return VTABLE_get_string(interpreter, none);
    }
    return VTABLE_get_string(interpreter, (PMC*) b->value);

}
#line 491 "src/pmc/hash.c"


INTVAL
Parrot_Hash_get_bool(Interp* interpreter, PMC* pmc)
#line 515 "src/pmc/hash.pmc"
{
    return hash_size(interpreter, PMC_struct_val(pmc)) != 0;

}
#line 501 "src/pmc/hash.c"


PMC*
Parrot_Hash_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 588 "src/pmc/hash.pmc"
{
    Hash * const hash = PMC_struct_val(pmc);
    STRING* keystr;
    HashBucket *b;
    PMC* nextkey;
    PMC* result;

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            /* called from iterator with an integer idx in key
             * check if we really have Hash_key_type_int
             */
            if (hash->key_type == Hash_key_type_int) {
                const INTVAL i = (INTVAL)hash_get_idx(interpreter, hash, key);
                result = pmc_new(interpreter, enum_class_Integer);
                PMC_int_val(result) = i;
            }
            else {
                STRING * const s = hash_get_idx(interpreter, hash, key);
                result = pmc_new(interpreter, enum_class_String);
                VTABLE_set_string_native(interpreter, result, s);
            }
            return result;
        default:
            keystr = make_hash_key(interpreter, key);
    }
    b = hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc),
                                    keystr);
    if (b == NULL) {
        /* XXX should store the undef for consistency */
        return get_none_pmc(interpreter, pmc->vtable->base_type);
    }
    nextkey = key_next(interpreter, key);
    if (!nextkey)
        return b->value;
    return VTABLE_get_pmc_keyed(interpreter, (PMC*)b->value, nextkey);

}
#line 545 "src/pmc/hash.c"


PMC*
Parrot_Hash_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 553 "src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interpreter, key);
    return Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, s);

}
#line 556 "src/pmc/hash.c"


PMC*
Parrot_Hash_get_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 543 "src/pmc/hash.pmc"
{
    HashBucket * const b =
        hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc), key);
    if (b == NULL) {
        /* XXX should store the undef for consistency */
        return get_none_pmc(interpreter, pmc->vtable->base_type);
    }
    return b->value;

}
#line 572 "src/pmc/hash.c"


PMC*
Parrot_Hash_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL f)
#line 985 "src/pmc/hash.pmc"
{
    switch (f) {
        case 0:
            {
                PMC * const iter = pmc_new_init(interpreter,
                        enum_class_Iterator, pmc);
                PMC_struct_val(iter) = key;
                return iter;
            }
    }
    real_exception(interpreter, NULL, E_IndexError,
            "Hash: Unknown slice type");
    return NULL;

}
#line 593 "src/pmc/hash.c"


void
Parrot_Hash_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
#line 649 "src/pmc/hash.pmc"
{
    STRING* keystr;
    PMC* nextkey;
    PMC* box;

    if (!key) return;
    keystr = make_hash_key(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
        PMC* val = get_integer_pmc(interpreter, pmc->vtable->base_type);

        VTABLE_set_integer_native(interpreter, val, value);
        hash_put(interpreter, PMC_struct_val(pmc), keystr, val);
        return;
    }
    box = Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, keystr);
    if (box == NULL) {
        /* autovivify an Hash */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_integer_keyed(interpreter, box, nextkey, value);

}
#line 622 "src/pmc/hash.c"


void
Parrot_Hash_set_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL value)
#line 680 "src/pmc/hash.pmc"
{
    PMC* const val = get_integer_pmc(interpreter, pmc->vtable->base_type);

    PMC_int_val(val) = value;
    hash_put(interpreter, PMC_struct_val(pmc), key, val);

}
#line 635 "src/pmc/hash.c"


void
Parrot_Hash_set_number_keyed(Interp* interpreter, PMC* pmc, PMC* key, FLOATVAL value)
#line 695 "src/pmc/hash.pmc"
{
    STRING* keystr;
    PMC* nextkey;
    PMC* box;

    if (!key) return;
    keystr = make_hash_key(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
        PMC* val = get_number_pmc(interpreter, pmc->vtable->base_type);
        PMC_num_val(val) = value;
        hash_put(interpreter, PMC_struct_val(pmc), keystr, val);
        return;
    }
    box = Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, keystr);
    if (box == NULL) {
        /* autovivify an Hash */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_number_keyed(interpreter, box, nextkey, value);

}
#line 663 "src/pmc/hash.c"


void
Parrot_Hash_set_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, FLOATVAL value)
#line 727 "src/pmc/hash.pmc"
{
    PMC* const val = get_number_pmc(interpreter, pmc->vtable->base_type);

    PMC_num_val(val) = value;
    hash_put(interpreter, PMC_struct_val(pmc), key, val);

}
#line 676 "src/pmc/hash.c"


void
Parrot_Hash_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
#line 742 "src/pmc/hash.pmc"
{
    STRING* keystr;
    PMC* nextkey;
    PMC* box;

    if (!key) return;
    keystr = make_hash_key(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
        PMC* const val = get_string_pmc(interpreter, pmc->vtable->base_type);
        VTABLE_set_string_native(interpreter, val, value);
        hash_put(interpreter, PMC_struct_val(pmc), keystr, val);
        return;
    }
    box = Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, keystr);
    if (box == NULL) {
        /* autovivify an Hash */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_string_keyed(interpreter, box, nextkey, value);

}
#line 704 "src/pmc/hash.c"


void
Parrot_Hash_set_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, STRING* value)
#line 772 "src/pmc/hash.pmc"
{
    PMC* const val = get_string_pmc(interpreter, pmc->vtable->base_type);

    VTABLE_set_string_native(interpreter, val, value);
    hash_put(interpreter, PMC_struct_val(pmc), key, val);

}
#line 717 "src/pmc/hash.c"


void
Parrot_Hash_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* value)
#line 787 "src/pmc/hash.pmc"
{
    STRING* keystr;
    PMC* nextkey;
    PMC* box;

    if (!key) return;
    keystr = make_hash_key(interpreter, key);
    nextkey = key_next(interpreter, key);
    if (nextkey == NULL) {
        hash_put(interpreter, PMC_struct_val(pmc), keystr, value);
        return;
    }
    box = Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, keystr);
    if (box == NULL) {
        /* autovivify an Hash */
        box = pmc_new(interpreter,  VTABLE_type(interpreter, pmc));
    }
    VTABLE_set_pmc_keyed(interpreter, box, nextkey, value);

}
#line 743 "src/pmc/hash.c"


void
Parrot_Hash_set_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
#line 817 "src/pmc/hash.pmc"
{
    hash_put(interpreter, PMC_struct_val(pmc), key, value);

}
#line 753 "src/pmc/hash.c"


INTVAL
Parrot_Hash_elements(Interp* interpreter, PMC* pmc)
#line 529 "src/pmc/hash.pmc"
{
    return hash_size(interpreter, PMC_struct_val(pmc));

}
#line 763 "src/pmc/hash.c"


INTVAL
Parrot_Hash_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 833 "src/pmc/hash.pmc"
{
    PMC * const iter = VTABLE_get_iter(interpreter, pmc);
    INTVAL j, n;

    /* TODO: comparing Hash and PerlHash should probably be possible */
    if (value->vtable->base_type != pmc->vtable->base_type)
        return 0;
    n = Parrot_Hash_elements(interpreter, pmc);
    if (VTABLE_elements(interpreter, value) != n)
        return 0;
    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interpreter, iter);
        PMC *item1, *item2;
        if (!VTABLE_exists_keyed_str(interpreter, value, key))
            return 0;
        item1 = Parrot_Hash_get_pmc_keyed_str(interpreter, pmc, key);
        item2 = VTABLE_get_pmc_keyed_str(interpreter, value, key);
        if (item1 == item2)
            continue;
        if (!mmd_dispatch_i_pp(interpreter, item1, item2, MMD_EQ))
            return 0;
    }
    return 1;

}
#line 794 "src/pmc/hash.c"


INTVAL
Parrot_Hash_is_same(Interp* interpreter, PMC* pmc, PMC* other)
#line 636 "src/pmc/hash.pmc"
{
    return (INTVAL)( other->vtable == pmc->vtable &&
        PMC_struct_val(other) == PMC_struct_val(pmc));

}
#line 805 "src/pmc/hash.c"


INTVAL
Parrot_Hash_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 882 "src/pmc/hash.pmc"
{
    Hash * const h = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interpreter, key);
    HashBucket *b;

    key = key_next(interpreter, key);
    b = hash_get_bucket(interpreter, h, sx);
    if (b == NULL)
        return 0;       /* no such key */
    if (key == NULL)
        return 1;       /* lookup stops here */
    return VTABLE_exists_keyed(interpreter, (PMC*)b->value, key);

}
#line 825 "src/pmc/hash.c"


INTVAL
Parrot_Hash_exists_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 866 "src/pmc/hash.pmc"
{
    HashBucket * const b =
        hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc), key);
    return b != NULL;

}
#line 837 "src/pmc/hash.c"


INTVAL
Parrot_Hash_defined_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 923 "src/pmc/hash.pmc"
{
    Hash * const h = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interpreter, key);
    HashBucket *b;

    key = key_next(interpreter, key);
    b = hash_get_bucket(interpreter, h, sx);
    if (b == NULL)
        return 0;       /* no such key */
    if (key == NULL)
        return VTABLE_defined(interpreter, (PMC*)b->value);
    else
        return VTABLE_defined_keyed( interpreter, (PMC*)b->value, key);

}
#line 858 "src/pmc/hash.c"


INTVAL
Parrot_Hash_defined_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 904 "src/pmc/hash.pmc"
{
    HashBucket * const b =
        hash_get_bucket(interpreter, (Hash*) PMC_struct_val(pmc), key);

    if (b == NULL)
        return 0;       /* no such key */
    return VTABLE_defined(interpreter, (PMC*)b->value);

}
#line 873 "src/pmc/hash.c"


void
Parrot_Hash_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 960 "src/pmc/hash.pmc"
{
    Hash * const h = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interpreter, key);
    HashBucket *b;

    key = key_next(interpreter, key);
    b = hash_get_bucket(interpreter, h, sx);
    if (b == NULL)
        return;  /* no such key */
    if (key == NULL)
        hash_delete(interpreter, h, sx);
    else
        VTABLE_delete_keyed(interpreter, (PMC*)b->value, key);

}
#line 894 "src/pmc/hash.c"


void
Parrot_Hash_delete_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 946 "src/pmc/hash.pmc"
{
    hash_delete(interpreter, (Hash *)PMC_struct_val(pmc), key);

}
#line 904 "src/pmc/hash.c"


PMC*
Parrot_Hash_get_iter(Interp* interpreter, PMC* pmc)
#line 572 "src/pmc/hash.pmc"
{
    PMC * const iter = pmc_new_init(interpreter, enum_class_Iterator, pmc);
    PMC * const key =  pmc_new(interpreter, enum_class_Key);

    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_hash_iterator_FLAGS;
    PMC_data(key) = (void *)INITBucketIndex;
    /* -1 for an empty hash, 0 for a non-empty hash.  */
    PMC_int_val(key) = hash_size(interpreter, PMC_struct_val(pmc)) ? 0 : -1;
    return iter;

}
#line 922 "src/pmc/hash.c"


void
Parrot_Hash_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1027 "src/pmc/hash.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Hash * const hash = (Hash *)PMC_struct_val(pmc);;

    Parrot_default_freeze(interpreter, pmc, info);
     VTABLE_push_integer(interpreter, io, VTABLE_elements(interpreter, pmc));
     VTABLE_push_integer(interpreter, io, hash->key_type);
     VTABLE_push_integer(interpreter, io, hash->entry_type);

}
#line 938 "src/pmc/hash.c"


void
Parrot_Hash_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1047 "src/pmc/hash.pmc"
{
    IMAGE_IO * const io = info->image_io;

    if (info->extra_flags == EXTRA_IS_NULL) {
        const INTVAL elems =  VTABLE_shift_integer(interpreter, io);
        const INTVAL k_type =  VTABLE_shift_integer(interpreter, io);
        const INTVAL v_type =  VTABLE_shift_integer(interpreter, io);
        Hash *hash;

        info->extra_flags = EXTRA_IS_COUNT;
        info->extra = (void *)elems;
        /* TODO make a better interface for hash creation
         * TODO create hash with needed size in the first place
         */
        if (k_type == Hash_key_type_int && v_type == enum_hash_int) {
            PMC * const dummy = Parrot_new_INTVAL_hash(interpreter, 0);
            PMC_struct_val(pmc) = PMC_struct_val(dummy);
            PMC_struct_val(dummy) = NULL;
        }
        else
            Parrot_Hash_init(interpreter, pmc);
        hash = PMC_struct_val(pmc);
        assert((INTVAL)hash->key_type == k_type);
        assert(hash->entry_type == v_type);
        hash->container = pmc;
    }
    else {
        Parrot_default_thaw(interpreter, pmc, info);
    }

}
#line 975 "src/pmc/hash.c"


void
Parrot_Hash_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1011 "src/pmc/hash.pmc"
{
    info->container = pmc;
    hash_visit(interpreter, (Hash*)PMC_struct_val(pmc), info);
    Parrot_default_visit(interpreter, pmc, info);

}
#line 987 "src/pmc/hash.c"


void
Parrot_Hash_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Hash,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Hash_mark,
        Parrot_Hash_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Hash_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_string,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_Hash_get_bool,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_Hash_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Hash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_Hash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_Hash_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_Hash_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Hash_freeze,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_Hash_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Hash_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Hash");
        vt_clone->isa_str = CONST_STRING(interp, "Hash");
        vt_clone->does_str = CONST_STRING(interp, "hash");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_Hash_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
