/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/integer.pmc"
/*
Copyright: 2003-2006 The Perl Foundation.  All Rights Reserved.
$Id: integer.pmc 12514 2006-05-05 14:28:23Z petdance $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages
that want a value-restricted integer type without going to an I
register.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

/* XXX create MMD headers to in Pmc2c.pm */
extern INTVAL Parrot_BigInt_is_equal_BigInt(Interp*, PMC*, PMC*);
extern PMC* Parrot_BigInt_multiply_int(Interp* interpreter,
        PMC* pmc, INTVAL value, PMC* dest) ;

static PMC*
overflow(Interp *interpreter, PMC *self, INTVAL b, PMC *dest, int mmd)
{
    const INTVAL a = VTABLE_get_integer(interpreter, self);

    if (PARROT_ERRORS_test(interpreter,PARROT_ERRORS_OVERFLOW_FLAG)) {
        real_exception(interpreter, NULL, ERR_OVERFLOW,
                "Integer overflow");
    }
    if (self == dest) {
        /* TODO preserve type system */
        VTABLE_morph(interpreter, self, enum_class_BigInt);
        VTABLE_set_integer_native(interpreter, self, a);
        return mmd_dispatch_p_pip(interpreter, self, b, dest, mmd);
    }
    else {
        PMC * const temp = VTABLE_get_bignum(interpreter, self);
        return mmd_dispatch_p_pip(interpreter, temp, b, dest, mmd);
    }
}

static PMC*
overflow_p(Interp *interpreter, PMC *self, PMC *val, PMC *dest, int mmd)
{
    const INTVAL a = VTABLE_get_integer(interpreter, self);

    if (PARROT_ERRORS_test(interpreter,PARROT_ERRORS_OVERFLOW_FLAG)) {
        real_exception(interpreter, NULL, ERR_OVERFLOW,
                "Integer overflow");
    }
    if (self == dest) {
        VTABLE_morph(interpreter, self, enum_class_BigInt);
        VTABLE_set_integer_native(interpreter, self, a);
        return mmd_dispatch_p_ppp(interpreter, self, val, dest, mmd);
    }
    else {
        PMC * const temp = VTABLE_get_bignum(interpreter, self);
        return mmd_dispatch_p_ppp(interpreter, temp, val, dest, mmd);
    }
}

#line 84 "src/pmc/integer.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"

void
Parrot_Integer_init(Interp* interpreter, PMC* pmc)
#line 112 "src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = 0;

}
#line 100 "src/pmc/integer.c"


PMC*
Parrot_Integer_instantiate(Interp* interpreter, PMC* pmc, PMC* sig)
#line 87 "src/pmc/integer.pmc"
{
    PMC* const ret = new_pmc_header(interpreter, 0);
    opcode_t *arg_op;
    INTVAL init = 0;

    ret->vtable = interpreter->vtables[pmc->vtable->base_type];
    arg_op = interpreter->current_args;
    if (SIG_ELEMS(sig) == 2) {
        switch (SIG_ITEM(sig, 1)) {
            case PARROT_ARG_I:
                init = REG_INT(arg_op[3]);
                break;
            case PARROT_ARG_IC:
                init = arg_op[3];
                break;
            default:
                internal_exception(1, 
                        "Integer.instantiate: unhandled initializer");
                break;
        }
    }
    PMC_int_val(ret) = init;
    return ret;

}
#line 131 "src/pmc/integer.c"


PMC*
Parrot_Integer_new_from_string(Interp* interpreter, PMC* pmc, STRING *rep, INTVAL flags)
#line 125 "src/pmc/integer.pmc"
{
    PMC *res;
    const INTVAL type = pmc->vtable->base_type;

    if (flags & PObj_constant_FLAG)
        res = constant_pmc_new(interpreter, type);
    else
        res = pmc_new(interpreter, type);
    /* TODO bigint overflow */
    PMC_int_val(res) = string_to_int(interpreter, rep);
    return res;

}
#line 150 "src/pmc/integer.c"


INTVAL
Parrot_Integer_get_integer(Interp* interpreter, PMC* pmc)
#line 183 "src/pmc/integer.pmc"
{
    return PMC_int_val(pmc);

}
#line 160 "src/pmc/integer.c"


FLOATVAL
Parrot_Integer_get_number(Interp* interpreter, PMC* pmc)
#line 209 "src/pmc/integer.pmc"
{
    return (FLOATVAL)PMC_int_val(pmc);

}
#line 170 "src/pmc/integer.c"


PMC*
Parrot_Integer_get_bignum(Interp* interpreter, PMC* pmc)
#line 222 "src/pmc/integer.pmc"
{
    const INTVAL val =  VTABLE_get_integer(interpreter, pmc);
    PMC * const ret = pmc_new(interpreter, enum_class_BigInt);
    VTABLE_set_integer_native(interpreter, ret, val);
    return ret;

}
#line 183 "src/pmc/integer.c"


STRING*
Parrot_Integer_get_string(Interp* interpreter, PMC* pmc)
#line 238 "src/pmc/integer.pmc"
{
    return string_from_int(interpreter, PMC_int_val(pmc));

}
#line 193 "src/pmc/integer.c"


INTVAL
Parrot_Integer_get_bool(Interp* interpreter, PMC* pmc)
#line 196 "src/pmc/integer.pmc"
{
    return PMC_int_val(pmc) ? 1 : 0;

}
#line 203 "src/pmc/integer.c"


void
Parrot_Integer_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
#line 257 "src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = value;

}
#line 213 "src/pmc/integer.c"


void
Parrot_Integer_set_integer_same(Interp* interpreter, PMC* pmc, PMC * value)
#line 253 "src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = PMC_int_val(value);

}
#line 223 "src/pmc/integer.c"


void
Parrot_Integer_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 284 "src/pmc/integer.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_Float);
     VTABLE_set_number_native(interpreter, pmc, value);

}
#line 234 "src/pmc/integer.c"


void
Parrot_Integer_set_bignum_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 294 "src/pmc/integer.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_BigInt);
     VTABLE_set_integer_native(interpreter, pmc, value);

}
#line 245 "src/pmc/integer.c"


void
Parrot_Integer_set_string_native(Interp* interpreter, PMC* pmc, STRING* value)
#line 299 "src/pmc/integer.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_String);
     VTABLE_set_string_native(interpreter, pmc, value);

}
#line 256 "src/pmc/integer.c"


void
Parrot_Integer_set_bool(Interp* interpreter, PMC* pmc, INTVAL value)
#line 289 "src/pmc/integer.pmc"
{
     VTABLE_morph(interpreter, pmc, enum_class_Boolean);
     VTABLE_set_bool(interpreter, pmc, value);

}
#line 267 "src/pmc/integer.c"


void
Parrot_Integer_set_pmc(Interp* interpreter, PMC* pmc, PMC *value)
#line 148 "src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = VTABLE_get_integer(interpreter, value);

}
#line 277 "src/pmc/integer.c"


PMC*
Parrot_Integer_add(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 320 "src/pmc/integer.pmc"
{
        if (!dest)
            dest = pmc_new(interpreter, value->vtable->base_type);
        VTABLE_set_number_native(interpreter, dest,
             VTABLE_get_integer(interpreter, pmc) + VTABLE_get_number(interpreter, value));
        return dest;
    
}
#line 291 "src/pmc/integer.c"
PMC*
Parrot_Integer_add_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        /*
         * pmc and value can both be PMCs that inherit
         * from Integer:
         *   cl = subclass "Integer", "MyInt"
         * so we can't used PMC_int_val(pmc) in any of these
         * Integer methods
         *
         * TODO
         *   check for exact Integer type
         *   e.g. MMD_Integer_EXACT
         */

        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        const INTVAL b = VTABLE_get_integer(interpreter, value);
        const INTVAL c = a + b;
        if ((c^a) >= 0 || (c^b) >= 0) {
            if (!dest)
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            /* need this for e.g. Undef PMC */
            VTABLE_set_integer_native(interpreter, dest, c);
            return dest;
        }
        else
            return overflow(interpreter, pmc, b, dest, MMD_ADD);
    
}PMC*
Parrot_Integer_add_Complex(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        if (dest)
            VTABLE_morph(interpreter, dest, value->vtable->base_type);
        else
            dest = pmc_new(interpreter, value->vtable->base_type);
        VTABLE_set_number_native(interpreter, dest,
                a + VTABLE_get_number_keyed_int(interpreter, value, 0));
        VTABLE_set_number_keyed_int(interpreter, dest, 1,
                VTABLE_get_number_keyed_int(interpreter, value, 1));
        return dest;
    
}PMC*
Parrot_Integer_add_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interpreter, pmc, value, dest, MMD_ADD);
    
}

PMC*
Parrot_Integer_add_int(Interp* interpreter, PMC* pmc, INTVAL b, PMC* dest)
#line 371 "src/pmc/integer.pmc"
{
    /* INTVAL a = PMC_int_val(pmc); */
    const INTVAL a = VTABLE_get_integer(interpreter, pmc);
    const INTVAL c = a + b;
    if ((c^a) >= 0 || (c^b) >= 0) {
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_integer_native(interpreter, dest, c);
        return dest;
    }
    else
        return overflow(interpreter, pmc, b, dest, MMD_ADD);

}
#line 358 "src/pmc/integer.c"


void
Parrot_Integer_i_add(Interp* interpreter, PMC* pmc, PMC* value)
#line 399 "src/pmc/integer.pmc"
{
    VTABLE_set_number_native(interpreter, pmc,
        PMC_int_val(pmc) + VTABLE_get_number(interpreter, value));
    
}
#line 369 "src/pmc/integer.c"
void
Parrot_Integer_i_add_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
        Parrot_Integer_i_add_int(interpreter, pmc, VTABLE_get_integer(interpreter, value));
    
}void
Parrot_Integer_i_add_Complex(Interp* interpreter, PMC* pmc, PMC* value)
{
        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        VTABLE_morph(interpreter, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interpreter, pmc,
                (FLOATVAL)a +
                VTABLE_get_number_keyed_int(interpreter, value, 0));
        VTABLE_set_number_keyed_int(interpreter, pmc, 1,
                VTABLE_get_number_keyed_int(interpreter, value, 1));
    
}

void
Parrot_Integer_i_add_int(Interp* interpreter, PMC* pmc, INTVAL b)
#line 418 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    const INTVAL c = a + b;
    if ((c^a) >= 0 || (c^b) >= 0) {
        VTABLE_set_integer_native(interpreter, pmc, c);
    }
    else
        overflow(interpreter, pmc, b, pmc, MMD_SUBTRACT);

}
#line 401 "src/pmc/integer.c"


void
Parrot_Integer_i_add_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 428 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    VTABLE_set_number_native(interpreter, pmc, a + value);

}
#line 412 "src/pmc/integer.c"


PMC*
Parrot_Integer_subtract(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 445 "src/pmc/integer.pmc"
{
        if (!dest)
            dest = pmc_new(interpreter, value->vtable->base_type);
        VTABLE_set_number_native(interpreter, dest,
             VTABLE_get_integer(interpreter, pmc) - VTABLE_get_number(interpreter, value));
        return dest;
    
}
#line 426 "src/pmc/integer.c"
PMC*
Parrot_Integer_subtract_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        const INTVAL b = VTABLE_get_integer(interpreter, value);
        const INTVAL c = a - b;
        if ((c^a) >= 0 || (c^~b) >= 0) {
            if (!dest)
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            VTABLE_set_integer_native(interpreter, dest, c);
            return dest;
        }
        else
            return overflow(interpreter, pmc, b, dest, MMD_SUBTRACT);
    
}PMC*
Parrot_Integer_subtract_Complex(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        if (dest)
            VTABLE_morph(interpreter, dest, value->vtable->base_type);
        else
            dest = pmc_new(interpreter, value->vtable->base_type);
        VTABLE_set_number_native(interpreter, dest,
                a - VTABLE_get_number_keyed_int(interpreter, value, 0));
        VTABLE_set_number_keyed_int(interpreter, dest, 1,
                -VTABLE_get_number_keyed_int(interpreter, value, 1));
        return dest;
    
}PMC*
Parrot_Integer_subtract_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interpreter, pmc, value, dest, MMD_SUBTRACT);
    
}

PMC*
Parrot_Integer_subtract_int(Interp* interpreter, PMC* pmc, INTVAL b, PMC* dest)
#line 492 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    const INTVAL c = a - b;
    if ((c^a) >= 0 || (c^~b) >= 0) {
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_integer_native(interpreter, dest, c);
        return dest;
    }
    else
        return overflow(interpreter, pmc, b, dest, MMD_SUBTRACT);

}
#line 479 "src/pmc/integer.c"


void
Parrot_Integer_i_subtract(Interp* interpreter, PMC* pmc, PMC* value)
#line 519 "src/pmc/integer.pmc"
{
    VTABLE_set_number_native(interpreter, pmc,
         VTABLE_get_integer(interpreter, pmc) - VTABLE_get_number(interpreter, value));
    
}
#line 490 "src/pmc/integer.c"
void
Parrot_Integer_i_subtract_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        const INTVAL b = VTABLE_get_integer(interpreter, value);
        const INTVAL c = a - b;
        if ((c^a) >= 0 || (c^~b) >= 0) {
            VTABLE_set_integer_native(interpreter, pmc, c);
        }
        else
            overflow(interpreter, pmc, b, pmc, MMD_SUBTRACT);
    
}void
Parrot_Integer_i_subtract_Complex(Interp* interpreter, PMC* pmc, PMC* value)
{
        const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
        VTABLE_morph(interpreter, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interpreter, pmc,
                (FLOATVAL)a -
                VTABLE_get_number_keyed_int(interpreter, value, 0));
        VTABLE_set_number_keyed_int(interpreter, pmc, 1,
                -VTABLE_get_number_keyed_int(interpreter, value, 1));
    
}

void
Parrot_Integer_i_subtract_int(Interp* interpreter, PMC* pmc, INTVAL b)
#line 545 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    const INTVAL c = a - b;
    if ((c^a) >= 0 || (c^~b) >= 0) {
        VTABLE_set_integer_native(interpreter, pmc, c);
    }
    else
        overflow(interpreter, pmc, b, pmc, MMD_SUBTRACT);

}
#line 529 "src/pmc/integer.c"


void
Parrot_Integer_i_subtract_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 555 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    VTABLE_set_number_native(interpreter, pmc, a - value);

}
#line 540 "src/pmc/integer.c"


PMC*
Parrot_Integer_multiply(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 571 "src/pmc/integer.pmc"
{
        const FLOATVAL valf = VTABLE_get_number(interpreter, value);
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_number_native(interpreter, dest, valf * PMC_int_val(pmc));
        return dest;
    
}
#line 554 "src/pmc/integer.c"
PMC*
Parrot_Integer_multiply_Integer(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a = VTABLE_get_integer(interpreter, pmc);
        const INTVAL b = VTABLE_get_integer(interpreter, value);
        const double cf = (double)a * (double)b;
        const INTVAL c = a * b;
        if ((double) c == cf) {
            if (!dest)
                dest = pmc_new(interpreter, pmc->vtable->base_type);
            VTABLE_set_integer_native(interpreter, dest, c);
            return dest;
        }
        else
            return overflow(interpreter, pmc, b, dest, MMD_MULTIPLY);
    
}PMC*
Parrot_Integer_multiply_Complex(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
            real_exception(interpreter, NULL, E_NotImplementedError,
                    "TODO mul<Integer, Complex>");
            return dest;
        
}PMC*
Parrot_Integer_multiply_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return Parrot_BigInt_multiply_int(interpreter, value,
                 VTABLE_get_integer(interpreter, pmc), dest);
    
}PMC*
Parrot_Integer_multiply_String(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return Parrot_Integer_multiply_Integer(interpreter, pmc, value, dest);
    
}

PMC*
Parrot_Integer_multiply_int(Interp* interpreter, PMC* pmc, INTVAL b, PMC* dest)
#line 607 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    const double cf = (double)a * (double)b;
    const INTVAL c = a * b;
    if ((double) c == cf) {
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_integer_native(interpreter, dest, c);
        return dest;
    }
    else
        return overflow(interpreter, pmc, b, dest, MMD_MULTIPLY);

}
#line 608 "src/pmc/integer.c"


void
Parrot_Integer_i_multiply(Interp* interpreter, PMC* pmc, PMC* value)
#line 635 "src/pmc/integer.pmc"
{
    VTABLE_set_number_native(interpreter, pmc,
        PMC_int_val(pmc) * VTABLE_get_number(interpreter, value));
    
}
#line 619 "src/pmc/integer.c"
void
Parrot_Integer_i_multiply_Integer(Interp* interpreter, PMC* pmc, PMC* value)
{
        Parrot_Integer_i_multiply_int(interpreter, pmc, VTABLE_get_integer(interpreter, value));
    
}void
Parrot_Integer_i_multiply_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
        Parrot_BigInt_multiply_int(interpreter, value,
                 VTABLE_get_integer(interpreter, pmc), pmc);
    
}void
Parrot_Integer_i_multiply_Complex(Interp* interpreter, PMC* pmc, PMC* value)
{
            real_exception(interpreter, NULL, E_NotImplementedError,
                    "TODO i_mul<Integer, Complex>");
    
}

void
Parrot_Integer_i_multiply_int(Interp* interpreter, PMC* pmc, INTVAL b)
#line 653 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    const double cf = (double)a * (double)b;
    const INTVAL c = a * b;
    if ((double) c == cf) {
         VTABLE_set_integer_native(interpreter, pmc, c);
    }
    else
        overflow(interpreter, pmc, b, pmc, MMD_MULTIPLY);

}
#line 653 "src/pmc/integer.c"


void
Parrot_Integer_i_multiply_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 664 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    VTABLE_set_number_native(interpreter, pmc, a * value);

}
#line 664 "src/pmc/integer.c"


PMC*
Parrot_Integer_divide(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 691 "src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "float division by zero");
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_number_native(interpreter, dest,  VTABLE_get_number(interpreter, pmc) / d);
        return dest;
    
}
#line 682 "src/pmc/integer.c"
PMC*
Parrot_Integer_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interpreter, pmc, value, dest, MMD_DIVIDE);
    
}

void
Parrot_Integer_i_divide(Interp* interpreter, PMC* pmc, PMC* value)
#line 708 "src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "float division by zero");
        VTABLE_set_number_native(interpreter, pmc,  VTABLE_get_number(interpreter, pmc) / d);
    
}
#line 702 "src/pmc/integer.c"
void
Parrot_Integer_i_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
         overflow_p(interpreter, pmc, value, pmc, MMD_DIVIDE);
    
}

PMC*
Parrot_Integer_floor_divide(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 744 "src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "float division by zero");
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_integer_native(interpreter, dest,
                (INTVAL)floor( VTABLE_get_number(interpreter, pmc) / d));
        return dest;
    
}
#line 726 "src/pmc/integer.c"
PMC*
Parrot_Integer_floor_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interpreter, pmc, value, dest, MMD_FLOOR_DIVIDE);
    
}

PMC*
Parrot_Integer_floor_divide_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 762 "src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest,
            (INTVAL)floor( VTABLE_get_number(interpreter, pmc) / value));
    return dest;

}
#line 748 "src/pmc/integer.c"


PMC*
Parrot_Integer_floor_divide_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
#line 773 "src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest,
            (INTVAL)floor( VTABLE_get_number(interpreter, pmc) / value));
    return dest;

}
#line 765 "src/pmc/integer.c"


void
Parrot_Integer_i_floor_divide(Interp* interpreter, PMC* pmc, PMC* value)
#line 784 "src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "float division by zero");
        VTABLE_set_integer_native(interpreter, pmc,
                (INTVAL)floor( VTABLE_get_number(interpreter, pmc) / d));
    
}
#line 781 "src/pmc/integer.c"
void
Parrot_Integer_i_floor_divide_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
        overflow_p(interpreter, pmc, value, pmc, MMD_FLOOR_DIVIDE);
    
}

void
Parrot_Integer_i_floor_divide_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 799 "src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_integer_native(interpreter, pmc,
            (INTVAL)floor( VTABLE_get_number(interpreter, pmc) / value));

}
#line 800 "src/pmc/integer.c"


void
Parrot_Integer_i_floor_divide_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 807 "src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_integer_native(interpreter, pmc,
            (INTVAL)floor( VTABLE_get_number(interpreter, pmc) / value));

}
#line 814 "src/pmc/integer.c"


PMC*
Parrot_Integer_modulus(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 933 "src/pmc/integer.pmc"
{
        const INTVAL d = VTABLE_get_integer(interpreter, value);

        if (d == 0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "int modulus by zero");
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_integer_native(interpreter, dest,
                intval_mod( VTABLE_get_integer(interpreter, pmc), d));
        return dest;
    
}
#line 833 "src/pmc/integer.c"
PMC*
Parrot_Integer_modulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interpreter, pmc, value, dest, MMD_MOD);
    
}

PMC*
Parrot_Integer_modulus_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 951 "src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest,
            intval_mod( VTABLE_get_integer(interpreter, pmc), value));
    return dest;

}
#line 855 "src/pmc/integer.c"


PMC*
Parrot_Integer_modulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
#line 962 "src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest,
            intval_mod( VTABLE_get_integer(interpreter, pmc), (INTVAL)value));
    return dest;

}
#line 872 "src/pmc/integer.c"


void
Parrot_Integer_i_modulus(Interp* interpreter, PMC* pmc, PMC* value)
#line 972 "src/pmc/integer.pmc"
{
        const INTVAL d = VTABLE_get_integer(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "int modulus by zero");
        VTABLE_set_integer_native(interpreter, pmc,
                intval_mod( VTABLE_get_integer(interpreter, pmc) , d));
    
}
#line 888 "src/pmc/integer.c"
void
Parrot_Integer_i_modulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
         overflow_p(interpreter, pmc, value, pmc, MMD_MOD);
    
}

void
Parrot_Integer_i_modulus_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 987 "src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    VTABLE_set_integer_native(interpreter, pmc,
            intval_mod( VTABLE_get_integer(interpreter, pmc) , value));

}
#line 907 "src/pmc/integer.c"


void
Parrot_Integer_i_modulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 995 "src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    VTABLE_set_integer_native(interpreter, pmc,
            intval_mod( VTABLE_get_integer(interpreter, pmc) , (INTVAL)value));

}
#line 921 "src/pmc/integer.c"


PMC*
Parrot_Integer_cmodulus(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 839 "src/pmc/integer.pmc"
{
        INTVAL d = VTABLE_get_integer(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "int cmodulus by zero");
        if (!dest)
            dest = pmc_new(interpreter, pmc->vtable->base_type);
        VTABLE_set_integer_native(interpreter, dest,
                 VTABLE_get_integer(interpreter, pmc) % d);
        return dest;
    
}
#line 940 "src/pmc/integer.c"
PMC*
Parrot_Integer_cmodulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interpreter, pmc, value, dest, MMD_CMOD);
    
}

PMC*
Parrot_Integer_cmodulus_int(Interp* interpreter, PMC* pmc, INTVAL value, PMC* dest)
#line 868 "src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest,
             VTABLE_get_integer(interpreter, pmc) % value);
    return dest;

}
#line 962 "src/pmc/integer.c"


PMC*
Parrot_Integer_cmodulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value, PMC* dest)
#line 857 "src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest,
            (INTVAL)fmod( VTABLE_get_integer(interpreter, pmc), value));
    return dest;

}
#line 979 "src/pmc/integer.c"


void
Parrot_Integer_i_cmodulus(Interp* interpreter, PMC* pmc, PMC* value)
#line 879 "src/pmc/integer.pmc"
{
        const INTVAL d = VTABLE_get_integer(interpreter, value);

        if (d == 0.0)
            real_exception(interpreter, NULL, E_ZeroDivisionError,
                    "int cmodulus by zero");
        VTABLE_set_integer_native(interpreter, pmc,
                 VTABLE_get_integer(interpreter, pmc) % d);
    
}
#line 995 "src/pmc/integer.c"
void
Parrot_Integer_i_cmodulus_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
         overflow_p(interpreter, pmc, value, pmc, MMD_CMOD);
    
}

void
Parrot_Integer_i_cmodulus_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 894 "src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    VTABLE_set_integer_native(interpreter, pmc,
             VTABLE_get_integer(interpreter, pmc) % value);

}
#line 1014 "src/pmc/integer.c"


void
Parrot_Integer_i_cmodulus_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 902 "src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interpreter, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    VTABLE_set_integer_native(interpreter, pmc,
            (INTVAL)fmod( VTABLE_get_integer(interpreter, pmc), value));

}
#line 1028 "src/pmc/integer.c"


PMC*
Parrot_Integer_pow(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 1022 "src/pmc/integer.pmc"
{
    const INTVAL v = VTABLE_get_integer(interpreter, value);
    return Parrot_Integer_pow_int(interpreter, pmc, v, dest);

}
#line 1039 "src/pmc/integer.c"


PMC*
Parrot_Integer_pow_int(Interp* interpreter, PMC* pmc, INTVAL b, PMC* dest)
#line 1027 "src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interpreter, pmc);
    INTVAL r;

    if (b < 0)
        return Parrot_scalar_pow_int(interpreter, pmc, b, dest);
    r = 1;
    if (a) {
        INTVAL temp = a;
        while (b > 0) {
            INTVAL prev = r;
            if (b & 1) {
                r *= temp;
                if (r / temp != prev) {
                    return overflow(interpreter, pmc, b, dest, MMD_POW);
                }
            }
            b >>= 1;
            if (!b)
                break;
            prev = temp;
            temp *= temp;
            if (prev != 0 && temp / prev != prev) {
                return overflow(interpreter, pmc, b, dest, MMD_POW);
            }
        }
    }
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest, r);
    return dest;


}
#line 1079 "src/pmc/integer.c"


void
Parrot_Integer_i_pow(Interp* interpreter, PMC* pmc, PMC* value)
#line 1061 "src/pmc/integer.pmc"
{
    Parrot_Integer_pow(interpreter, pmc, value, pmc);

}
#line 1089 "src/pmc/integer.c"


void
Parrot_Integer_i_pow_int(Interp* interpreter, PMC* pmc, INTVAL value)
#line 1065 "src/pmc/integer.pmc"
{
    Parrot_Integer_pow_int(interpreter, pmc, value, pmc);

}
#line 1099 "src/pmc/integer.c"


void
Parrot_Integer_increment(Interp* interpreter, PMC* pmc)
#line 1168 "src/pmc/integer.pmc"
{
    /* XXX overflow */
    PMC_int_val(pmc) ++;

}
#line 1110 "src/pmc/integer.c"


void
Parrot_Integer_decrement(Interp* interpreter, PMC* pmc)
#line 1182 "src/pmc/integer.pmc"
{
    /* XXX overflow */
    PMC_int_val(pmc) --;

}
#line 1121 "src/pmc/integer.c"


PMC*
Parrot_Integer_absolute(Interp* interpreter, PMC* pmc, PMC *dest)
#line 1198 "src/pmc/integer.pmc"
{
    const INTVAL a = abs( VTABLE_get_integer(interpreter, pmc));
    /* XXX overlflow for -maxint */
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_integer_native(interpreter, dest, a);
    return dest;


}
#line 1137 "src/pmc/integer.c"


void
Parrot_Integer_i_absolute(Interp* interpreter, PMC* pmc)
#line 1208 "src/pmc/integer.pmc"
{
    const INTVAL a = abs( VTABLE_get_integer(interpreter, pmc));
    VTABLE_set_integer_native(interpreter, pmc, a);

}
#line 1148 "src/pmc/integer.c"


INTVAL
Parrot_Integer_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 1079 "src/pmc/integer.pmc"
{
    return (INTVAL)(PMC_int_val(pmc) ==
        VTABLE_get_integer(interpreter, value));
    
}
#line 1159 "src/pmc/integer.c"
INTVAL
Parrot_Integer_is_equal_BigInt(Interp* interpreter, PMC* pmc, PMC* value)
{
    PMC* const temp = pmc_new(interpreter, enum_class_BigInt);
    VTABLE_set_integer_native(interpreter, temp, PMC_int_val(pmc));
    return Parrot_BigInt_is_equal_BigInt(interpreter, temp, value);

}

INTVAL
Parrot_Integer_cmp(Interp* interpreter, PMC* pmc, PMC* value)
#line 1100 "src/pmc/integer.pmc"
{
        /* int or undef */
        const INTVAL diff = PMC_int_val(pmc)
            - VTABLE_get_integer(interpreter, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}
#line 1179 "src/pmc/integer.c"
INTVAL
Parrot_Integer_cmp_String(Interp* interpreter, PMC* pmc, PMC* value)
{
        const FLOATVAL fdiff =
            PMC_int_val(pmc) - VTABLE_get_number(interpreter, value);
        if (fdiff == 0) {
            const INTVAL idiff =
                PMC_int_val(pmc) - VTABLE_get_integer(interpreter, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        } else {
            return fdiff > 0 ? 1 : -1;
        }
    
}INTVAL
Parrot_Integer_cmp_Float(Interp* interpreter, PMC* pmc, PMC* value)
{
        const FLOATVAL diff =
            (FLOATVAL)PMC_int_val(pmc) - VTABLE_get_number(interpreter, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}

INTVAL
Parrot_Integer_cmp_num(Interp* interpreter, PMC* pmc, PMC* value)
#line 1134 "src/pmc/integer.pmc"
{
        /* int or undef */
        const INTVAL diff =
            PMC_int_val(pmc) - VTABLE_get_integer(interpreter, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}
#line 1212 "src/pmc/integer.c"
INTVAL
Parrot_Integer_cmp_num_String(Interp* interpreter, PMC* pmc, PMC* value)
{
        const FLOATVAL fdiff =
            PMC_int_val(pmc) - VTABLE_get_number(interpreter, value);
        if (fdiff == 0) {
            const INTVAL idiff =
                PMC_int_val(pmc) - VTABLE_get_integer(interpreter, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        } else {
            return fdiff > 0 ? 1 : -1;
        }
    
}INTVAL
Parrot_Integer_cmp_num_Float(Interp* interpreter, PMC* pmc, PMC* value)
{
        const FLOATVAL diff =
            (FLOATVAL)PMC_int_val(pmc) - VTABLE_get_number(interpreter, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    
}

void
Parrot_Integer_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1244 "src/pmc/integer.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interpreter, pmc, info);
     VTABLE_push_integer(interpreter, io, PMC_int_val(pmc));

}
#line 1244 "src/pmc/integer.c"


void
Parrot_Integer_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 1259 "src/pmc/integer.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        PMC_int_val(pmc) =  VTABLE_shift_integer(interpreter, io);

}
#line 1257 "src/pmc/integer.c"


void
Parrot_Integer_share(Interp* interpreter, PMC* pmc)
#line 161 "src/pmc/integer.pmc"
{
    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof(INTVAL) != sizeof(long))
        Parrot_default_share(interpreter, pmc);

}
#line 1276 "src/pmc/integer.c"


STRING*
Parrot_Integer_get_as_base(Interp* interpreter, PMC* pmc, INTVAL base)
#line 1224 "src/pmc/integer.pmc"
{
    char buf[128];

    if((base < 2) || (base > 36))
        real_exception(interpreter, NULL, E_RuntimeError,
                "get_as_base: base out of bounds");

    return int_to_str(interpreter, buf,
            (HUGEINTVAL)PMC_int_val(pmc), (char)base);

}
#line 1293 "src/pmc/integer.c"


void
Parrot_Integer_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Integer,	/* base_type */
        NULL,	/* whoami */
        0, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_Integer_instantiate,
        Parrot_Integer_new_from_string,
        Parrot_scalar_morph,
        Parrot_default_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_scalar_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Integer_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_set_integer_native,
        Parrot_Integer_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Integer_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Integer_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Integer_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Integer_set_bool,
        Parrot_Integer_set_pmc,
        Parrot_scalar_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_Integer_increment,
        Parrot_Integer_decrement,
        Parrot_Integer_absolute,
        Parrot_Integer_i_absolute,
        Parrot_scalar_neg,
        Parrot_scalar_i_neg,
        Parrot_scalar_bitwise_not,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_scalar_logical_not,
        Parrot_scalar_i_logical_not,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Integer_freeze,
        Parrot_Integer_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_Integer_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_add_Complex },
        { MMD_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_add },
        { MMD_ADD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_Integer_add_Integer },
        { MMD_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_Integer_add_Complex },
        { MMD_ADD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_add_BigInt },
        { MMD_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_add_int },
        { MMD_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_add_float },
        { MMD_I_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_add },
        { MMD_I_ADD, 0, enum_class_Integer,
                    (funcptr_t) Parrot_Integer_i_add_Integer },
        { MMD_I_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_Integer_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_i_add_float },
        { MMD_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_subtract },
        { MMD_SUBTRACT, 0, enum_class_Integer,
                    (funcptr_t) Parrot_Integer_subtract_Integer },
        { MMD_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_Integer_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_subtract_BigInt },
        { MMD_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_subtract_int },
        { MMD_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_subtract_float },
        { MMD_I_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_class_Integer,
                    (funcptr_t) Parrot_Integer_i_subtract_Integer },
        { MMD_I_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_Integer_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_multiply },
        { MMD_MULTIPLY, 0, enum_class_Integer,
                    (funcptr_t) Parrot_Integer_multiply_Integer },
        { MMD_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_Integer_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_multiply_BigInt },
        { MMD_MULTIPLY, 0, enum_class_String,
                    (funcptr_t) Parrot_Integer_multiply_String },
        { MMD_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_multiply_int },
        { MMD_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_multiply_float },
        { MMD_I_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_class_Integer,
                    (funcptr_t) Parrot_Integer_i_multiply_Integer },
        { MMD_I_MULTIPLY, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_i_multiply_BigInt },
        { MMD_I_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_Integer_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_divide },
        { MMD_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_divide_BigInt },
        { MMD_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_divide_int },
        { MMD_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_divide_float },
        { MMD_I_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_divide },
        { MMD_I_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_i_divide_BigInt },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_divide_float },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_floor_divide_BigInt },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_floor_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_floor_divide_float },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_i_floor_divide_BigInt },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_i_floor_divide_float },
        { MMD_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_modulus },
        { MMD_MOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_modulus_BigInt },
        { MMD_MOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_modulus_int },
        { MMD_MOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_modulus_float },
        { MMD_I_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_modulus },
        { MMD_I_MOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_i_modulus_BigInt },
        { MMD_I_MOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_modulus_int },
        { MMD_I_MOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_i_modulus_float },
        { MMD_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_cmodulus },
        { MMD_CMOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_cmodulus_BigInt },
        { MMD_CMOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_cmodulus_int },
        { MMD_CMOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_cmodulus_float },
        { MMD_I_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_cmodulus },
        { MMD_I_CMOD, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_i_cmodulus_BigInt },
        { MMD_I_CMOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_cmodulus_int },
        { MMD_I_CMOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_Integer_i_cmodulus_float },
        { MMD_POW, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_pow },
        { MMD_POW, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_pow_int },
        { MMD_POW, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_pow_float },
        { MMD_I_POW, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_i_pow },
        { MMD_I_POW, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_Integer_i_pow_int },
        { MMD_I_POW, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_pow_float },
        { MMD_BOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_or },
        { MMD_BOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_or_int },
        { MMD_I_BOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_or },
        { MMD_I_BOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_or_int },
        { MMD_BAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_and },
        { MMD_BAND, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_and_int },
        { MMD_I_BAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_and },
        { MMD_I_BAND, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_and_int },
        { MMD_BXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_xor },
        { MMD_BXOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_xor_int },
        { MMD_I_BXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_xor },
        { MMD_I_BXOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_xor_int },
        { MMD_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_shl },
        { MMD_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_shr },
        { MMD_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_shr_int },
        { MMD_LSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_lsr },
        { MMD_LSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_lsr_int },
        { MMD_I_LSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_lsr },
        { MMD_I_LSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_lsr_int },
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_is_equal },
        { MMD_EQ, 0, enum_class_BigInt,
                    (funcptr_t) Parrot_Integer_is_equal_BigInt },
        { MMD_CMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_cmp },
        { MMD_CMP, 0, enum_class_String,
                    (funcptr_t) Parrot_Integer_cmp_String },
        { MMD_CMP, 0, enum_class_Float,
                    (funcptr_t) Parrot_Integer_cmp_Float },
        { MMD_NUMCMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Integer_cmp_num },
        { MMD_NUMCMP, 0, enum_class_String,
                    (funcptr_t) Parrot_Integer_cmp_num_String },
        { MMD_NUMCMP, 0, enum_class_Float,
                    (funcptr_t) Parrot_Integer_cmp_num_Float },
        { MMD_STRCMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_cmp_string },
        { MMD_LOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_or },
        { MMD_LAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_and },
        { MMD_LXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_xor },
        { MMD_CONCAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_concatenate },
        { MMD_CONCAT, 0, enum_type_STRING,
                    (funcptr_t) Parrot_scalar_concatenate_str },
        { MMD_I_CONCAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_concatenate },
        { MMD_I_CONCAT, 0, enum_type_STRING,
                    (funcptr_t) Parrot_scalar_i_concatenate_str },
        { MMD_REPEAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_repeat },
        { MMD_REPEAT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_repeat_int },
        { MMD_I_REPEAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_repeat },
        { MMD_I_REPEAT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_repeat_int }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Integer");
        vt_clone->isa_str = CONST_STRING(interp, "Integer scalar");
        vt_clone->does_str = CONST_STRING(interp, "scalar integer");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Integer_get_as_base),
                "get_as_base", "SJOI");
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_Integer_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
