/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/multiarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/multiarray.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: multiarray.pmc 11248 2006-01-18 20:02:15Z bernhard $

=head1 NAME

src/pmc/multiarray.pmc - Multi-dimensional Array

=head1 DESCRIPTION

C<MultiArray> extends C<Array> to provide a multi-dimensional array.

This is one way for calculating offsets in 2 dimensional space.

MULTIDIM CALC OFFSET

Algorithm:

    i + j*Ni + k*Ni*Nj + l*Ni*Nj*Nk ...

where i,j,k,l... are coordinates in a multidimensional space and
Ni,Nj,Nk... are the lengths of the dimensions.

Limitations: the array can only expand in the last dimension The first
(n-1) dimensions of a n-dimensional array are fixed and layed out at
array creation.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static INTVAL calc_offset(Interp *interpreter, List *list, PMC *key)>

Calculates the offset for C<*key>.

=cut

*/

static INTVAL calc_offset(Interp* interpreter, List*list, PMC *key)
{
    INTVAL l;
    INTVAL ninj;
    PMC * dim = VTABLE_get_pmc_keyed_int(interpreter, list->user_data, 1);

    l = key_integer(interpreter, key);
    ninj = 1;
    for(; dim ; dim = key_next(interpreter, dim)) {
        key = key_next(interpreter, key);
        if (!key)
            break;
        ninj *= key_integer(interpreter, dim);
        l += key_integer(interpreter, key) * ninj;
    }
    return l;
}

#line 78 "src/pmc/multiarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_multiarray.h"
#include "pmc_array.h"
#include "pmc_default.h"
#include "multiarray.str"

void
Parrot_MultiArray_init(Interp* interpreter, PMC* pmc)
#line 78 "src/pmc/multiarray.pmc"
{
    /* override default in Array - no init */

}
#line 94 "src/pmc/multiarray.c"


INTVAL
Parrot_MultiArray_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 92 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
    return  VTABLE_get_integer_keyed_int(interpreter, pmc, ix);

}
#line 105 "src/pmc/multiarray.c"


FLOATVAL
Parrot_MultiArray_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 107 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
    return  VTABLE_get_number_keyed_int(interpreter, pmc, ix);

}
#line 116 "src/pmc/multiarray.c"


STRING*
Parrot_MultiArray_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 122 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
    return  VTABLE_get_string_keyed_int(interpreter, pmc, ix);

}
#line 127 "src/pmc/multiarray.c"


PMC*
Parrot_MultiArray_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 137 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
    return  VTABLE_get_pmc_keyed_int(interpreter, pmc, ix);

}
#line 138 "src/pmc/multiarray.c"


void
Parrot_MultiArray_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
#line 152 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
     VTABLE_set_integer_keyed_int(interpreter, pmc, ix, value);

}
#line 149 "src/pmc/multiarray.c"


void
Parrot_MultiArray_set_number_keyed(Interp* interpreter, PMC* pmc, PMC* key, FLOATVAL value)
#line 167 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
     VTABLE_set_number_keyed_int(interpreter, pmc, ix, value);

}
#line 160 "src/pmc/multiarray.c"


void
Parrot_MultiArray_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
#line 182 "src/pmc/multiarray.pmc"
{
    INTVAL ix = calc_offset(interpreter, (List*) PMC_data(pmc), key);
     VTABLE_set_string_keyed_int(interpreter, pmc, ix, value);

}
#line 171 "src/pmc/multiarray.c"


void
Parrot_MultiArray_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* dest_key, PMC* src)
#line 197 "src/pmc/multiarray.pmc"
{
    /* XXX array ??? */

}
#line 181 "src/pmc/multiarray.c"


void
Parrot_MultiArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_MultiArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_MultiArray_init,
        Parrot_Array_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Array_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Array_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Array_get_integer,
        Parrot_MultiArray_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_number,
        Parrot_MultiArray_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_string,
        Parrot_default_get_repr,
        Parrot_MultiArray_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Array_get_bool,
        Parrot_default_get_pmc,
        Parrot_MultiArray_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Array_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Array_set_integer_native,
        Parrot_Array_set_integer_same,
        Parrot_MultiArray_set_integer_keyed,
        Parrot_Array_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_MultiArray_set_number_keyed,
        Parrot_Array_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_MultiArray_set_string_keyed,
        Parrot_Array_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_Array_set_pmc,
        Parrot_Array_assign_pmc,
        Parrot_MultiArray_set_pmc_keyed,
        Parrot_Array_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Array_elements,
        Parrot_Array_pop_integer,
        Parrot_Array_pop_float,
        Parrot_Array_pop_string,
        Parrot_Array_pop_pmc,
        Parrot_Array_push_integer,
        Parrot_Array_push_float,
        Parrot_Array_push_string,
        Parrot_Array_push_pmc,
        Parrot_Array_shift_integer,
        Parrot_Array_shift_float,
        Parrot_Array_shift_string,
        Parrot_Array_shift_pmc,
        Parrot_Array_unshift_integer,
        Parrot_Array_unshift_float,
        Parrot_Array_unshift_string,
        Parrot_Array_unshift_pmc,
        Parrot_Array_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_delete_keyed,
        Parrot_Array_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Array_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Array_freeze,
        Parrot_Array_thaw,
        Parrot_default_thawfinish,
        Parrot_Array_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "MultiArray");
        vt_clone->isa_str = CONST_STRING(interp, "MultiArray Array");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_MultiArray_class_init */


/*

=back

=head1 HISTORY

Initial revision by Josef Hook <joh@stacken.kth.se>

1.6 Based on list.c by Leopold Toetsch <lt@toetsch.at>

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
