/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/namespace.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/namespace.pmc"
/*
Copyright: 2005 The Perl Foundation.  All Rights Reserved.
$Id: namespace.pmc 12369 2006-04-19 07:43:47Z mdiep $

=head1 NAME

src/pmc/namespace.pmc - NameSpace PMC

=head1 DESCRIPTION

These are the vtable functions for the namespace PMC.

=head2 Data

  PMC_struct_val       ... the hash, bucket->value is either a
                           var/sub or a namespace, of a FixedPMCarray
                           of 2 PMCs (namespace, sub/var) slots
  PMC_pmc_val          ... parent namespace
  PMC_data             ... name STRING of this namespace part 

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

/*
 * Typically a named slot either contains another namespace or a
 * var/sub (not both). 
 * In case that the bucket->value is occupied, a FixedPMCArray is
 * created, and the items are moved over to that extra storage.
 * The array is flagged with FPA_is_ns_ext to distinguish it from a
 * plain array variable.
 *
 * This could easily expanded to a full-fledged typed namespace if needed. 
 */

enum {
    NS_slot_ns,
    NS_slot_var_sub,         /* unspecified ~half-raw slot */
    NS_max_slots
} NS_slot_enum;

#define FPA_is_ns_ext PObj_private0_FLAG

#line 63 "src/pmc/namespace.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_namespace.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "namespace.str"

void
Parrot_NameSpace_init(Interp* interpreter, PMC* pmc)
#line 64 "src/pmc/namespace.pmc"
{
    Parrot_Hash_init(interpreter, pmc);                        /* _struct_val := Hash */
    PMC_pmc_val(pmc) = NULL;       /* parent */
    PMC_data(pmc)    = NULL;       /* namespace name */

}
#line 81 "src/pmc/namespace.c"


void
Parrot_NameSpace_mark(Interp* interpreter, PMC* pmc)
#line 79 "src/pmc/namespace.pmc"
{
    Parrot_Hash_mark(interpreter, pmc);
    if (PMC_pmc_val(pmc))
        pobject_lives(interpreter, (PObj*)PMC_pmc_val(pmc));
    if (PMC_data(pmc))
        pobject_lives(interpreter, (PObj*)PMC_data(pmc));

}
#line 95 "src/pmc/namespace.c"


STRING*
Parrot_NameSpace_get_string(Interp* interpreter, PMC* pmc)
#line 328 "src/pmc/namespace.pmc"
{
    return PMC_data(pmc);

}
#line 105 "src/pmc/namespace.c"


PMC*
Parrot_NameSpace_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key)
#line 228 "src/pmc/namespace.pmc"
{
    PMC *ns = pmc;
    STRING *part;
    INTVAL i, n;
    
    if (key->vtable->base_type == enum_class_String) {
        return Parrot_NameSpace_get_pmc_keyed_str(interpreter, pmc, VTABLE_get_string(interpreter, key));
    }
    else if (key->vtable->base_type == enum_class_Key) {
        while (key) {
            part = key_string(interpreter, key);
            ns = VTABLE_get_pmc_keyed_str(interpreter, ns, part);
            if (PMC_IS_NULL(ns))
                return PMCNULL;
            key = key_next(interpreter, key);
        }
        return ns;
    }
    n = VTABLE_elements(interpreter, key);
    if (!n)
        return PMCNULL;
    for (i = 0; i < n; ++i) {
        part = VTABLE_get_string_keyed_int(interpreter, key, i);
        ns = VTABLE_get_pmc_keyed_str(interpreter, ns, part);
        if (PMC_IS_NULL(ns))
            return PMCNULL;
    }
    return ns;

}
#line 141 "src/pmc/namespace.c"


PMC*
Parrot_NameSpace_get_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 217 "src/pmc/namespace.pmc"
{
    PMC *ns = hash_get(interpreter, 
            (Hash*) PMC_struct_val(pmc), key);
    if (!ns)
        return PMCNULL;
    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interpreter, ns, NS_slot_ns);
    return ns;

}
#line 158 "src/pmc/namespace.c"


void*
Parrot_NameSpace_get_pointer_keyed(Interp* interpreter, PMC* pmc, PMC *key)
#line 282 "src/pmc/namespace.pmc"
{
    PMC *ns = pmc;
    STRING *part;
    INTVAL i, n;
    
    if (key->vtable->base_type == enum_class_String) {
        return Parrot_NameSpace_get_pointer_keyed_str(interpreter, pmc, VTABLE_get_string(interpreter, key));
    }
    else if (key->vtable->base_type == enum_class_Key) {
        while (key) {
            part = key_string(interpreter, key);
            key = key_next(interpreter, key);
            if (key)
                ns = VTABLE_get_pmc_keyed_str(interpreter, ns, part);
            else
                ns = VTABLE_get_pointer_keyed_str(interpreter, ns, part);
            if (PMC_IS_NULL(ns))
                return PMCNULL;
        }
        return ns;
    }
    n = VTABLE_elements(interpreter, key);
    if (!n)
        return PMCNULL;
    for (i = 0; i < n; ++i) {
        part = VTABLE_get_string_keyed_int(interpreter, key, i);
        if (i < n - 1)
            ns = VTABLE_get_pmc_keyed_str(interpreter, ns, part);
        else
            ns = VTABLE_get_pointer_keyed_str(interpreter, ns, part);
        if (PMC_IS_NULL(ns))
            return PMCNULL;
    }
    return ns;

}
#line 200 "src/pmc/namespace.c"


void*
Parrot_NameSpace_get_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 271 "src/pmc/namespace.pmc"
{
    PMC *ns = hash_get(interpreter, 
            (Hash*) PMC_struct_val(pmc), key);
    if (!ns)
        return PMCNULL;
    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interpreter, ns, NS_slot_var_sub);
    return ns;

}
#line 217 "src/pmc/namespace.c"


void
Parrot_NameSpace_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC *key, PMC *value)
#line 167 "src/pmc/namespace.pmc"
{
    PMC *ns = pmc, *next;
    STRING *part;
    INTVAL i, n;
    if (key->vtable->base_type == enum_class_String) {
        Parrot_NameSpace_set_pmc_keyed_str(interpreter, pmc, VTABLE_get_string(interpreter, key), value);
        return;
    }
    if (key->vtable->base_type == enum_class_Key) {
        while (1) {
            part = key_string(interpreter, key);
            key = key_next(interpreter, key);
            next = VTABLE_get_pmc_keyed_str(interpreter, ns, part);
            if (key) {
                if (PMC_IS_NULL(next) || 
                        next->vtable->base_type != enum_class_NameSpace) {
                    next = pmc_new(interpreter, enum_class_NameSpace);
                    VTABLE_set_pmc_keyed_str(interpreter, ns, part, next);
                }
            }
            else {
                VTABLE_set_pmc_keyed_str(interpreter, ns, part, value);
                break;
            }
            ns = next;
        }
        return;
    }
    n = VTABLE_elements(interpreter, key);
    if (!n)
        real_exception(interpreter, NULL, E_NameError,
                "Empty namespace array");
    for (i = 0; ; ++i) {
        part = VTABLE_get_string_keyed_int(interpreter, key, i);
        next = VTABLE_get_pmc_keyed_str(interpreter, ns, part);
        if (i < n - 1) {
            if (PMC_IS_NULL(next) || 
                    next->vtable->base_type != enum_class_NameSpace) {
                next = pmc_new(interpreter, enum_class_NameSpace);
                VTABLE_set_pmc_keyed_str(interpreter, ns, part, next);
            }
        }
        else {
            VTABLE_set_pmc_keyed_str(interpreter, ns, part, value);
            break;
        }
        ns = next;
    }

}
#line 273 "src/pmc/namespace.c"


void
Parrot_NameSpace_set_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING *key, PMC *value)
#line 115 "src/pmc/namespace.pmc"
{
    PMC *tuple = NULL;
    HashBucket *b = hash_get_bucket(interpreter, 
            (Hash*) PMC_struct_val(pmc), key);
    int val_is_NS = value->vtable->base_type == enum_class_NameSpace;
    if (!b)
        Parrot_Hash_set_pmc_keyed_str(interpreter, pmc, key, value);
    else {
        PMC *old = b->value;
        if (old->vtable->base_type == enum_class_NameSpace &&
                val_is_NS) {
            Parrot_Hash_set_pmc_keyed_str(interpreter, pmc, key, value);      /* ns changed */
        }
        else if (old->vtable->base_type != enum_class_NameSpace &&
                !val_is_NS) {
            Parrot_Hash_set_pmc_keyed_str(interpreter, pmc, key, value);      /* var/sub changed */
        }
        else if ((PObj_get_FLAGS(old) & FPA_is_ns_ext) &&
                old->vtable->base_type == enum_class_FixedPMCArray) {
            /* we have a tuple extension already */
            VTABLE_set_pmc_keyed_int(interpreter, old, 
                    val_is_NS ? NS_slot_ns : NS_slot_var_sub, value);
        }
        else {
            /* creat new tuple */
            tuple = pmc_new(interpreter, enum_class_FixedPMCArray);
            /* flag it as special */
            PObj_get_FLAGS(tuple) |= FPA_is_ns_ext;
            /* for a fully typed namespace, we'd need 3 or 4 */
            VTABLE_set_integer_native(interpreter, tuple, NS_max_slots);
        }
    }
    if (val_is_NS) {
        PMC_pmc_val(value) = pmc;  /* set parent */
        PMC_data(value)    = key;   /* and name */
        if (tuple) {
            VTABLE_set_pmc_keyed_int(interpreter, tuple, NS_slot_ns, value);
            VTABLE_set_pmc_keyed_int(interpreter, tuple, NS_slot_var_sub, 
                    b->value);
            b->value = tuple;
            /* distinction from a plain FPA, which doesn't extend the
             * namespace storage
             */
        }
    }
    else if (tuple) {
        VTABLE_set_pmc_keyed_int(interpreter, tuple, NS_slot_ns, b->value);
        VTABLE_set_pmc_keyed_int(interpreter, tuple, NS_slot_var_sub, value);
        b->value = tuple;
    }

}
#line 331 "src/pmc/namespace.c"


PMC*
Parrot_NameSpace_name(Interp* interpreter, PMC* pmc)
#line 360 "src/pmc/namespace.pmc"
{
    PMC *ar, *ns;

    ar = pmc_new(interpreter, enum_class_ResizableStringArray);
    ns = pmc;
    while (ns) {
        VTABLE_unshift_string(interpreter, ar, PMC_data(ns));
        ns = PMC_pmc_val(ns);
    }
    return ar;

}
#line 349 "src/pmc/namespace.c"


void
Parrot_NameSpace_export_to(Interp* interpreter, PMC* pmc, PMC* dest, PMC* what)
#line 383 "src/pmc/namespace.pmc"
{
    INTVAL i, n;

    n = VTABLE_elements(interpreter, what);
    if (!n)
        return;
    for (i = 0; i < n; ++i) {
        STRING *name;
        PMC *el;

        name = VTABLE_get_string_keyed_int(interpreter, what, i);
        el = VTABLE_get_pmc_keyed_str(interpreter, pmc, name);
        VTABLE_set_pmc_keyed_str(interpreter, dest, name, el);
    }

}
#line 371 "src/pmc/namespace.c"


void
Parrot_NameSpace_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_NameSpace,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_NameSpace_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_NameSpace_mark,
        Parrot_Hash_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Hash_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_NameSpace_get_string,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_Hash_get_bool,
        Parrot_default_get_pmc,
        Parrot_NameSpace_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_NameSpace_get_pmc_keyed_str,
        Parrot_Hash_slice,
        Parrot_default_get_pointer,
        Parrot_NameSpace_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_NameSpace_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Hash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_Hash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_NameSpace_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_NameSpace_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_Hash_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_Hash_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Hash_freeze,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_Hash_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "NameSpace");
        vt_clone->isa_str = CONST_STRING(interp, "NameSpace Hash");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_name),
                "name", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_export_to),
                "export_to", "vJOPP");
        /* class_init */
    
    } /* pass */
} /* Parrot_NameSpace_class_init */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd21_namespaces.pod>

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
