/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/orderedhash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/orderedhash.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: orderedhash.pmc 11615 2006-02-17 02:54:09Z particle $

=head1 NAME

src/pmc/orderedhash.pmc - Ordered Hash

=head1 DESCRIPTION

C<OrderedHash> extends C<Hash> to provide the interfaces of
C<array> and C<hash>. To achieve the functionality of an ordered
hash there are a few restrictions though: C<delete_keyed> never removes 
items, they are just nulled. 

Please note that if values are set via integer idx, these indices
have to be in strict order. Using C<push_xx> simplifies this task.
This creates a key "\1idx" for C<idx> and is therefore not fully transparent.

There are 2 iterator interfaces:

=over 4

=item * retrieve values (in creation order)

Please note that after a C<delete_keyed> operation, iterating over
values doesn't work any more, you'll get an error 'No such key'.

=item * retrieve keys (in creation order)

=back

See F<t/pmc/orderedhash.t>.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "pmc_hash.h"


#line 59 "src/pmc/orderedhash.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_orderedhash.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "orderedhash.str"

PMC*
Parrot_OrderedHash_clone(Interp* interpreter, PMC* pmc)
#line 536 "src/pmc/orderedhash.pmc"
{
    PMC *dest;
    Hash *hash = PMC_struct_val(pmc), *h_dest;

    UINTVAL i;
    HashBucket *b;
    void *key;
    void *valtmp;

    dest = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    new_pmc_hash_x(interpreter, dest, hash->entry_type,
            hash->key_type, hash->compare, hash->hash_val);
    h_dest = PMC_struct_val(dest);
    for (i = 0; i <= hash->mask; i++) {
        b = hash->bs + i;
        key = b->key;
        if (!key)
            continue;
        valtmp = VTABLE_clone(interpreter, (PMC*)b->value);
        hash_put(interpreter, h_dest, key, valtmp);
    }
    return dest;

}
#line 95 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 179 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            return Parrot_Hash_get_integer_keyed(interpreter, pmc, key);
        case KEY_integer_FLAG:
            item = Parrot_OrderedHash_get_pmc_keyed_int(interpreter, pmc, key_integer(interpreter, key));
            next = key_next(interpreter, key);
            if (!next)
                return VTABLE_get_integer(interpreter, item);
            return VTABLE_get_integer_keyed(interpreter, item, next);
        default:
            return Parrot_Hash_get_integer_keyed(interpreter, pmc, key);
    }

}
#line 117 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 159 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        real_exception(interpreter, NULL, OUT_OF_BOUNDS,
                "OrderedHash: index out of bounds!");
    }
    b = h->bs + idx;
    if (b->key)
        return VTABLE_get_integer(interpreter, (PMC*) b->value);
    real_exception(interpreter, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
    return 0;

}
#line 143 "src/pmc/orderedhash.c"


FLOATVAL
Parrot_OrderedHash_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 229 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            return Parrot_Hash_get_number_keyed(interpreter, pmc, key);
        case KEY_integer_FLAG:
            item = Parrot_OrderedHash_get_pmc_keyed_int(interpreter, pmc, key_integer(interpreter, key));
            next = key_next(interpreter, key);
            if (!next)
                return VTABLE_get_number(interpreter, item);
            return VTABLE_get_number_keyed(interpreter, item, next);
        default:
            return Parrot_Hash_get_number_keyed(interpreter, pmc, key);
    }

}
#line 165 "src/pmc/orderedhash.c"


FLOATVAL
Parrot_OrderedHash_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 209 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        real_exception(interpreter, NULL, OUT_OF_BOUNDS,
                "OrderedHash: index out of bounds!");
    }
    b = h->bs + idx;
    if (b->key)
        return VTABLE_get_number(interpreter, (PMC*) b->value);
    real_exception(interpreter, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
    return 0.0;

}
#line 191 "src/pmc/orderedhash.c"


STRING*
Parrot_OrderedHash_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 129 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            return Parrot_Hash_get_string_keyed(interpreter, pmc, key);
        case KEY_integer_FLAG:
            item = Parrot_OrderedHash_get_pmc_keyed_int(interpreter, pmc, key_integer(interpreter, key));
            next = key_next(interpreter, key);
            if (!next)
                return VTABLE_get_string(interpreter, item);
            return VTABLE_get_string_keyed(interpreter, item, next);
        default:
            return Parrot_Hash_get_string_keyed(interpreter, pmc, key);
    }

}
#line 213 "src/pmc/orderedhash.c"


STRING*
Parrot_OrderedHash_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 109 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        real_exception(interpreter, NULL, KEY_NOT_FOUND,
                "OrderedHash: index out of bounds!");
    }
    b = h->bs + idx;
    if (b->key)
        return VTABLE_get_string(interpreter, (PMC*) b->value);
    real_exception(interpreter, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
    return NULL;

}
#line 239 "src/pmc/orderedhash.c"


PMC*
Parrot_OrderedHash_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 81 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            return Parrot_Hash_get_pmc_keyed(interpreter, pmc, key);
        case KEY_integer_FLAG:
            item = Parrot_OrderedHash_get_pmc_keyed_int(interpreter, pmc, key_integer(interpreter, key));
            next = key_next(interpreter, key);
            if (!next)
                return item;
            return VTABLE_get_pmc_keyed(interpreter, item, next);
        default:
            return Parrot_Hash_get_pmc_keyed(interpreter, pmc, key);
    }

}
#line 261 "src/pmc/orderedhash.c"


PMC*
Parrot_OrderedHash_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 61 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        real_exception(interpreter, NULL, KEY_NOT_FOUND,
                "OrderedHash: index out of bounds!");
    }
    b = h->bs + idx;
    if (b->key)
        return (PMC*) b->value;
    real_exception(interpreter, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
    return PMCNULL;

}
#line 287 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx, INTVAL value)
#line 288 "src/pmc/orderedhash.pmc"
{
    PMC *v = pmc_new(interpreter, Parrot_get_ctx_HLL_type(interpreter,
                enum_class_Integer));
    VTABLE_set_integer_native(interpreter, v, value);
    Parrot_OrderedHash_set_pmc_keyed_int(interpreter, pmc, idx, v);

}
#line 300 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx, FLOATVAL value)
#line 295 "src/pmc/orderedhash.pmc"
{
    PMC *v = pmc_new(interpreter, Parrot_get_ctx_HLL_type(interpreter,
                enum_class_Float));
    VTABLE_set_number_native(interpreter, v, value);
    Parrot_OrderedHash_set_pmc_keyed_int(interpreter, pmc, idx, v);

}
#line 313 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx, STRING* value)
#line 302 "src/pmc/orderedhash.pmc"
{
    PMC *v = pmc_new(interpreter, Parrot_get_ctx_HLL_type(interpreter,
                enum_class_String));
    VTABLE_set_string_native(interpreter, v, value);
    Parrot_OrderedHash_set_pmc_keyed_int(interpreter, pmc, idx, v);

}
#line 326 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx, PMC* val)
#line 262 "src/pmc/orderedhash.pmc"
{
    STRING *key, *fmt;
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;
    fmt = CONST_STRING(interpreter, "\1%d");
    if (idx >= n) {
        /* TODO warn or fill if there are holes */
        key = Parrot_sprintf_s(interpreter, fmt, idx);
         VTABLE_set_pmc_keyed_str(interpreter, pmc, key, val);
    }
    else {
        b = h->bs + idx;
        if (!b->key) {
            b->key = Parrot_sprintf_s(interpreter, fmt, idx);
        }
        b->value = val;
    }

}
#line 358 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 332 "src/pmc/orderedhash.pmc"
{
    INTVAL n =  VTABLE_elements(interpreter, pmc);
    Parrot_OrderedHash_set_integer_keyed_int(interpreter, pmc, n, value);

}
#line 369 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 327 "src/pmc/orderedhash.pmc"
{
    INTVAL n =  VTABLE_elements(interpreter, pmc);
    Parrot_OrderedHash_set_number_keyed_int(interpreter, pmc, n, value);

}
#line 380 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_push_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 337 "src/pmc/orderedhash.pmc"
{
    INTVAL n =  VTABLE_elements(interpreter, pmc);
    Parrot_OrderedHash_set_string_keyed_int(interpreter, pmc, n, value);

}
#line 391 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 322 "src/pmc/orderedhash.pmc"
{
    INTVAL n =  VTABLE_elements(interpreter, pmc);
    Parrot_OrderedHash_set_pmc_keyed_int(interpreter, pmc, n, value);

}
#line 402 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 371 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        Hash *h = PMC_struct_val(pmc);
        INTVAL n, idx;
        HashBucket *b;

        idx = key_integer(interpreter, key);
        n = h->entries;
        if (idx < 0)
            idx += n;
        if (idx < 0 || idx >= n) {
            return 0;
        }
        b = h->bs + idx;
        if (!b->key)
            return 0;
        item = b->value;
        next = key_next(interpreter, key);
        if (!next)
            return 1;
        return VTABLE_exists_keyed(interpreter, item, next);
    }
    else {
        return Parrot_Hash_exists_keyed(interpreter, pmc, key);
    }

}
#line 436 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 354 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        return 0;
    }
    b = h->bs + idx;
    if (b->key)
        return 1;
    return 0;

}
#line 459 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_exists_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 399 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    HashBucket *b;
    b = hash_get_bucket(interpreter, h, key);
    if (b && b->key)
        return 1;
    return 0;

}
#line 474 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_defined_keyed(Interp* interpreter, PMC* pmc, PMC *key)
#line 421 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        Hash *h = PMC_struct_val(pmc);
        INTVAL n, idx;
        HashBucket *b;

        idx = key_integer(interpreter, key);
        n = h->entries;
        if (idx < 0)
            idx += n;
        if (idx < 0 || idx >= n) {
            /* XXX non-existant is undefined - is this correct */
            return 0;
        }
        b = h->bs + idx;
        if (!b->key)
            return 0;
        item = b->value;
        next = key_next(interpreter, key);
        if (!next)
            return VTABLE_defined(interpreter, item);
        return VTABLE_defined_keyed(interpreter, item, next);
    }
    return Parrot_Hash_defined_keyed(interpreter, pmc, key);

}
#line 507 "src/pmc/orderedhash.c"


INTVAL
Parrot_OrderedHash_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 448 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        return 0;
    }
    b = h->bs + idx;
    if (b->key)
        return VTABLE_defined(interpreter, (PMC*)b->value);
    return 0;

}
#line 530 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 479 "src/pmc/orderedhash.pmc"
{
    PMC *item, *next;
    next = key_next(interpreter, key);
    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        if (next) {
            item = Parrot_OrderedHash_get_pmc_keyed_int(interpreter, pmc, key_integer(interpreter, key));
            VTABLE_delete_keyed(interpreter, item, next);
            return;
        }
        Parrot_OrderedHash_delete_keyed_int(interpreter, pmc, key_integer(interpreter, key));
    }
    else {
        if (next) {
            item =  VTABLE_get_pmc_keyed_str(interpreter, pmc, key_string(interpreter, key));
            VTABLE_delete_keyed(interpreter, item, next);
            return;
        }
        Parrot_OrderedHash_delete_keyed_str(interpreter, pmc, key_string(interpreter, key));
    }

}
#line 557 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_delete_keyed_int(Interp* interpreter, PMC* pmc, INTVAL idx)
#line 500 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    INTVAL n;
    HashBucket *b;

    n = h->entries;
    if (idx < 0)
        idx += n;
    if (idx < 0 || idx >= n) {
        return;
    }
    b = h->bs + idx;
    if (b)
        b->key = NULL;

}
#line 579 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_delete_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
#line 516 "src/pmc/orderedhash.pmc"
{
    Hash *h = PMC_struct_val(pmc);
    HashBucket *b;
    b = hash_get_bucket(interpreter, h, key);
    if (b)
        b->key = NULL;

}
#line 593 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 580 "src/pmc/orderedhash.pmc"
{
    UINTVAL i;
    HashBucket *b;
    void *key;
    IMAGE_IO *io = info->image_io;
    Hash *hash = (Hash *)PMC_struct_val(pmc);

    info->container = pmc;
    switch (info->what) {
        case VISIT_THAW_NORMAL:
        case VISIT_THAW_CONSTANTS:
            Parrot_Hash_visit(interpreter, pmc, info);
            break;
        case VISIT_FREEZE_NORMAL:
        case VISIT_FREEZE_AT_DESTRUCT:
            for (i = 0; i <= hash->mask; i++) {
                b = hash->bs + i;
                key = b->key;
                if (!key)
                    continue;
                 VTABLE_push_string(interpreter, io, key);
                (info->visit_pmc_now)(interpreter, b->value, info);
            }
            break;
        default:
            real_exception(interpreter, NULL, E_Exception,
                    "unhandled visit action (%d)",
                    info->what);
    }

}
#line 630 "src/pmc/orderedhash.c"


void
Parrot_OrderedHash_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_OrderedHash,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Hash_mark,
        Parrot_Hash_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_OrderedHash_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Hash_get_integer,
        Parrot_OrderedHash_get_integer_keyed,
        Parrot_OrderedHash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_OrderedHash_get_number_keyed,
        Parrot_OrderedHash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_string,
        Parrot_Hash_get_repr,
        Parrot_OrderedHash_get_string_keyed,
        Parrot_OrderedHash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_Hash_get_bool,
        Parrot_default_get_pmc,
        Parrot_OrderedHash_get_pmc_keyed,
        Parrot_OrderedHash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_Hash_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_integer_keyed,
        Parrot_OrderedHash_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Hash_set_number_keyed,
        Parrot_OrderedHash_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_Hash_set_string_keyed,
        Parrot_OrderedHash_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_OrderedHash_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_OrderedHash_push_integer,
        Parrot_OrderedHash_push_float,
        Parrot_OrderedHash_push_string,
        Parrot_OrderedHash_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_Hash_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_OrderedHash_exists_keyed,
        Parrot_OrderedHash_exists_keyed_int,
        Parrot_OrderedHash_exists_keyed_str,
        Parrot_default_defined,
        Parrot_OrderedHash_defined_keyed,
        Parrot_OrderedHash_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_OrderedHash_delete_keyed,
        Parrot_OrderedHash_delete_keyed_int,
        Parrot_OrderedHash_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Hash_freeze,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_OrderedHash_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "OrderedHash");
        vt_clone->isa_str = CONST_STRING(interp, "OrderedHash Hash");
        vt_clone->does_str = CONST_STRING(interp, "array hash");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_OrderedHash_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=head1 HISTORY

Initial rev by leo 2003-08-21.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/

