/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/parrotclass.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/parrotclass.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: parrotclass.pmc 12340 2006-04-18 15:10:09Z leo $

=head1 NAME

src/pmc/parrotclass.pmc - Parrot Class

=head1 DESCRIPTION

The structure of a parrot class is reasonably straightforward. The PMC's
cached integer value is the number of attribute slots that an object of
this type requires. The data pointer holds a pointer to an array of
PMCs. That array has:

=over 4

=item 0, PCD_PARENTS

An array of immediate parents.

=item 1, PCD_CLASS_NAME

The class name PMC.

=item 2, PCD_ATTRIB_OFFS

A hash, keys are the class names, values are the offsets to their attributes.

=item 3, PCD_ATTRIBUTES

A hash, the keys are the classname/attrib name pair (separated by a
C<NULL>), while the value is the offset to the attribute.

=item 4, PCD_CLASS_ATTRIBUTES

Array of attribute of this class.

=item 5, PCD_OBJECT_VTABLE

Vtable PMC that holds the vtable for objects of this class.

=item ex 2, PCD_ALL_PARENTS

Is now class->vtable->mro and contains the class itself too.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 71 "src/pmc/parrotclass.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_parrotclass.h"
#include "pmc_delegate.h"
#include "pmc_default.h"
#include "parrotclass.str"

void
Parrot_ParrotClass_init(Interp* interpreter, PMC* pmc)
#line 76 "src/pmc/parrotclass.pmc"
{
    /* No attributes to start with */
    PMC_int_val(pmc) = ATTRIB_COUNT(pmc) = 0;
    /* But we are a class, really */
    PObj_is_class_SET(pmc);
    /* turn on marking of the class_data array */
    PObj_data_is_PMC_array_SET(pmc);

}
#line 92 "src/pmc/parrotclass.c"


void
Parrot_ParrotClass_init_pmc(Interp* interpreter, PMC* pmc, PMC* name)
#line 85 "src/pmc/parrotclass.pmc"
{
    STRING *class_name;

    Parrot_ParrotClass_init(interpreter, pmc);
    Parrot_new_class(interpreter, pmc, name);

}
#line 105 "src/pmc/parrotclass.c"


STRING*
Parrot_ParrotClass_name(Interp* interpreter, PMC* pmc)
#line 129 "src/pmc/parrotclass.pmc"
{
    PMC **class_data, *name;
    class_data = (PMC **)PMC_data(pmc);

    if (class_data) {
        name = class_data[PCD_CLASS_NAME];
        return readable_name(interpreter, name);
    }
    return pmc->vtable->whoami;

}
#line 122 "src/pmc/parrotclass.c"


INTVAL
Parrot_ParrotClass_isa(Interp* interpreter, PMC* pmc, STRING* classname)
#line 102 "src/pmc/parrotclass.pmc"
{
    PMC *class;
    if (Parrot_default_isa(interpreter, pmc, classname))
        return 1;
    class = Parrot_class_lookup(interpreter, classname);
    return Parrot_object_isa(interpreter, pmc, class);

}
#line 136 "src/pmc/parrotclass.c"


PMC*
Parrot_ParrotClass_get_class(Interp* interpreter, PMC* pmc)
#line 125 "src/pmc/parrotclass.pmc"
{
    return pmc;

}
#line 146 "src/pmc/parrotclass.c"


void
Parrot_ParrotClass_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 192 "src/pmc/parrotclass.pmc"
{
    IMAGE_IO *io = info->image_io;
    PMC **class_data, **pos;

    Parrot_default_freeze(interpreter, pmc, info);
    class_data = (PMC **)PMC_data(pmc);

    /* 1) freeze class name */
    pos = class_data + PCD_CLASS_NAME;
     VTABLE_push_string(interpreter, io,
            VTABLE_get_string(interpreter, *pos));


}
#line 166 "src/pmc/parrotclass.c"


void
Parrot_ParrotClass_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 206 "src/pmc/parrotclass.pmc"
{
    IMAGE_IO *io = info->image_io;

    /*
     * Thawing a class is tricky - it might or might not exist
     * in the interpreter, where it get thawed.
     * Additionally, it could happen that a class exists
     * but the thawed one differs.
     *
     * So here's the plan:
     * During thaw, we first extend the class_data by two,
     * thaw parents and attribs into that new area, and
     * then we see what to do.
     */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        Parrot_default_thaw(interpreter, pmc, info);
    }
    else if (info->extra_flags == EXTRA_IS_NULL) {
        STRING *class_name;
        INTVAL new_type;
        PMC *real_class;

        /* thaw class name */
        class_name =  VTABLE_shift_string(interpreter, io);
        /* if class exists in this interpreter, check if the
         * thawed class is the same, if not bail out, if yes
         * ignore the class, consume the byte string
         */
        new_type = pmc_type(interpreter, class_name);
        if (new_type > enum_type_undef) {
            real_class = Parrot_class_lookup(interpreter, class_name);
            info->extra = real_class;
            info->extra_flags = EXTRA_CLASS_EXISTS;
        }
        else {
            PMC *name = pmc_new(interpreter, enum_class_String);
            real_class = pmc;
            VTABLE_set_string_native(interpreter, name, class_name);
            Parrot_ParrotClass_init_pmc(interpreter, pmc, name);
        }
        /* make room for thawed arrays */
        if (PMC_int_val(real_class) == PCD_MAX) {
            PMC **class_data;
            resize_attrib_array(real_class, PCD_MAX + 2);
            class_data = (PMC **)PMC_data(real_class);
            class_data[PCD_MAX] = NULL;
            class_data[PCD_MAX + 1] = NULL;
        }

    }

}
#line 224 "src/pmc/parrotclass.c"


void
Parrot_ParrotClass_thawfinish(Interp* interpreter, PMC* pmc, visit_info *info)
#line 258 "src/pmc/parrotclass.pmc"
{
    INTVAL i, n, nold;
    PMC * class;
    PMC *parents, *attribs, *old;
    PMC **class_data;

    class = pmc;
    class_data = (PMC**)(PMC_data(class));

    old = class_data[PCD_PARENTS];
    nold = VTABLE_elements(interpreter, old);
    parents = class_data[PCD_MAX];
    if (!parents)
        n = 0;
    else
        n = VTABLE_elements(interpreter, parents);
    if (nold && n != nold)
        real_exception(interpreter, NULL, E_AssertionError,
                "thawed class differs");
    /* TODO compare elements */
    if (!nold) {
        for (i = 0; i < n; ++i) {
            Parrot_add_parent(interpreter, class,
                    VTABLE_get_pmc_keyed_int(interpreter, parents, i));
        }
    }
    /*
     * preserve the thawed attrib array
     */
    old = class_data[PCD_CLASS_ATTRIBUTES];
    nold = VTABLE_elements(interpreter, old);
    attribs = class_data[PCD_MAX + 1];
    if (!attribs)
        n = 0;
    else
        n = VTABLE_elements(interpreter, attribs);
    if (nold && n != nold)
        real_exception(interpreter, NULL, E_AssertionError,
                "thawed class differs");
    /* TODO compare attribs */

    if (!nold) {
        for (i = 0; i < n; ++i) {
            Parrot_add_attribute(interpreter, class,
                    VTABLE_get_string_keyed_int(interpreter, attribs, i));
        }
    }
    class_data[PCD_MAX] = NULL;
    class_data[PCD_MAX + 1] = NULL;

}
#line 281 "src/pmc/parrotclass.c"


void
Parrot_ParrotClass_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 166 "src/pmc/parrotclass.pmc"
{
    PMC **class_data, **pos;

    class_data = (PMC **)PMC_data(pmc);

    /* 2) direct parents array */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS)
        pos = class_data + PCD_MAX;
    else
        pos = class_data + PCD_PARENTS;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interpreter, *pos, info);

    /* 3) attributes array */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS)
        pos = class_data + PCD_MAX + 1;
    else
        pos = class_data + PCD_CLASS_ATTRIBUTES;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interpreter, *pos, info);

    Parrot_default_visit(interpreter, pmc, info);

}
#line 313 "src/pmc/parrotclass.c"


void
Parrot_ParrotClass_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ParrotClass,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_ParrotClass_init,
        Parrot_ParrotClass_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_delegate_instantiate,
        Parrot_delegate_new_from_string,
        Parrot_delegate_morph,
        Parrot_delegate_mark,
        Parrot_delegate_destroy,
        Parrot_delegate_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_delegate_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_delegate_type_keyed_str,
        Parrot_delegate_subtype,
        Parrot_ParrotClass_name,
        Parrot_delegate_clone,
        Parrot_default_find_method,
        Parrot_delegate_hash,
        Parrot_delegate_get_integer,
        Parrot_delegate_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_delegate_get_integer_keyed_str,
        Parrot_delegate_get_number,
        Parrot_delegate_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_delegate_get_number_keyed_str,
        Parrot_delegate_get_bignum,
        Parrot_delegate_get_string,
        Parrot_delegate_get_repr,
        Parrot_delegate_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_delegate_get_string_keyed_str,
        Parrot_delegate_get_bool,
        Parrot_delegate_get_pmc,
        Parrot_delegate_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_delegate_get_pmc_keyed_str,
        Parrot_delegate_slice,
        Parrot_delegate_get_pointer,
        Parrot_delegate_get_pointer_keyed,
        Parrot_delegate_get_pointer_keyed_int,
        Parrot_delegate_get_pointer_keyed_str,
        Parrot_delegate_set_integer_native,
        Parrot_delegate_set_integer_same,
        Parrot_delegate_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_delegate_set_integer_keyed_str,
        Parrot_delegate_set_number_native,
        Parrot_delegate_set_number_same,
        Parrot_delegate_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_delegate_set_number_keyed_str,
        Parrot_delegate_set_bignum_int,
        Parrot_delegate_set_bignum_num,
        Parrot_delegate_set_bignum_str,
        Parrot_delegate_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_delegate_set_string_same,
        Parrot_delegate_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_delegate_set_string_keyed_str,
        Parrot_delegate_set_bool,
        Parrot_delegate_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_delegate_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_delegate_set_pmc_keyed_str,
        Parrot_delegate_set_pointer,
        Parrot_delegate_set_pointer_keyed,
        Parrot_delegate_set_pointer_keyed_int,
        Parrot_delegate_set_pointer_keyed_str,
        Parrot_delegate_elements,
        Parrot_delegate_pop_integer,
        Parrot_delegate_pop_float,
        Parrot_delegate_pop_string,
        Parrot_delegate_pop_pmc,
        Parrot_delegate_push_integer,
        Parrot_delegate_push_float,
        Parrot_delegate_push_string,
        Parrot_delegate_push_pmc,
        Parrot_delegate_shift_integer,
        Parrot_delegate_shift_float,
        Parrot_delegate_shift_string,
        Parrot_delegate_shift_pmc,
        Parrot_delegate_unshift_integer,
        Parrot_delegate_unshift_float,
        Parrot_delegate_unshift_string,
        Parrot_delegate_unshift_pmc,
        Parrot_delegate_splice,
        Parrot_delegate_increment,
        Parrot_delegate_decrement,
        Parrot_delegate_absolute,
        Parrot_delegate_i_absolute,
        Parrot_delegate_neg,
        Parrot_delegate_i_neg,
        Parrot_delegate_bitwise_not,
        Parrot_delegate_i_bitwise_not,
        Parrot_delegate_bitwise_nots,
        Parrot_delegate_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_delegate_logical_not,
        Parrot_delegate_i_logical_not,
        Parrot_delegate_substr,
        Parrot_delegate_substr_str,
        Parrot_delegate_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_delegate_exists_keyed_str,
        Parrot_default_defined,
        Parrot_delegate_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_delegate_defined_keyed_str,
        Parrot_delegate_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_delegate_delete_keyed_str,
        Parrot_delegate_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_delegate_nextkey_keyed_str,
        Parrot_delegate_get_iter,
        Parrot_delegate_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_ParrotClass_isa,
        Parrot_default_subclass,
        Parrot_delegate_get_attr,
        Parrot_default_get_attr_str,
        Parrot_delegate_set_attr,
        Parrot_delegate_set_attr_str,
        Parrot_ParrotClass_get_class,
        Parrot_default_add_parent,
        Parrot_delegate_become_parent,
        Parrot_delegate_class_type,
        Parrot_delegate_add_method,
        Parrot_delegate_remove_method,
        Parrot_delegate_new_singleton,
        Parrot_delegate_get_anonymous_subclass,
        Parrot_ParrotClass_freeze,
        Parrot_ParrotClass_thaw,
        Parrot_ParrotClass_thawfinish,
        Parrot_ParrotClass_visit,
        Parrot_delegate_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ParrotClass");
        vt_clone->isa_str = CONST_STRING(interp, "ParrotClass delegate");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_ParrotClass_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
