/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/parrotinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/parrotinterpreter.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: parrotinterpreter.pmc 12201 2006-04-13 13:23:02Z leo $

=head1 NAME

src/pmc/parrotinterpreter.pmc - Parrot Interpreter

=head1 DESCRIPTION

These are the vtable functions for the ParrotInterpreter base class

   getinterp P0
   set P1, P0[.IGLOBALS_*]  # access interpreter globals
   set I0, P0[x]            # interpinfo I0, x
   set I0, P0[-1]           # get interpreter flags
   set P0[-1], x            # set flags on interpreter
                            # NOTE: this doesn't restart

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/embed.h"
#include <assert.h>

/*

=item C<void
clone_interpreter(PMC* dest, PMC* self)>

Clones the interpreter.

=cut

*/

void
clone_interpreter(PMC* dest, PMC* self)
{

    Parrot_Interp s = PMC_data(self);
    Parrot_Interp d;

    d = PMC_data(dest);

    /*
     * copy over packfile - done currently in the runinterp opcode
     * for multi-threading we have to generate separate
     * profile data
     */
#if 0
    pt_clone_code(d, s);
#endif
    /*
     * set flags and run core
     */
    d->run_core = s->run_core;
    d->flags = s->flags;
}


/*

=item C<static void
create_interp(PMC *self, Parrot_Interp parent)>

Creates a new child interpreter of C<parent>.

=cut

*/

static void
create_interp(PMC *self, Parrot_Interp parent)
{
    Interp_flags flag  = 0;
    Parrot_Interp new_interp;

    if (self->vtable->base_type == enum_class_ParrotThread)
        flag = PARROT_IS_THREAD;

    new_interp = make_interpreter(parent, flag);
    PMC_data(self) = new_interp;
    VTABLE_set_pmc_keyed_int(new_interp, new_interp->iglobals,
        (INTVAL) IGLOBALS_INTERPRETER, self);
}

static int
recursion_limit(Parrot_Interp interpreter, PMC *self, int l)
{
    int ret = interpreter->recursion_limit;
    interpreter->recursion_limit = l;
    return ret;
}

#line 114 "src/pmc/parrotinterpreter.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotinterpreter.str"

void
Parrot_ParrotInterpreter_init(Interp* interpreter, PMC* pmc)
#line 166 "src/pmc/parrotinterpreter.pmc"
{
    /*
     * init/init_pmc may be called internally (from thread creation in
     * ParrotThread::init_pmc() or stand-alone
     * so we check, if the interpreter is already setup
     */
    if (!PMC_data(pmc)) {
        create_interp(pmc, interpreter);
    }
    PMC_struct_val(pmc) = NULL;
    PMC_pmc_val(pmc) = NULL;

}
#line 138 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_init_pmc(Interp* interpreter, PMC* pmc, PMC *parent)
#line 189 "src/pmc/parrotinterpreter.pmc"
{
    Parrot_Interp p = PMC_data(parent);

    if (!PMC_data(pmc)) {
        create_interp(pmc, p);
    }
    PMC_struct_val(pmc) = NULL;

}
#line 153 "src/pmc/parrotinterpreter.c"


PMC*
Parrot_ParrotInterpreter_clone(Interp* interpreter, PMC* pmc)
#line 442 "src/pmc/parrotinterpreter.pmc"
{
    PMC* dest = pmc_new(interpreter, pmc->vtable->base_type);
    clone_interpreter(dest, pmc);
    return dest;

}
#line 165 "src/pmc/parrotinterpreter.c"


INTVAL
Parrot_ParrotInterpreter_get_integer(Interp* interpreter, PMC* pmc)
#line 236 "src/pmc/parrotinterpreter.pmc"
{
    Parrot_Interp i = PMC_data(pmc);
    return (INTVAL)i->thread_data->tid;

}
#line 176 "src/pmc/parrotinterpreter.c"


INTVAL
Parrot_ParrotInterpreter_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 389 "src/pmc/parrotinterpreter.pmc"
{
    Interp * new_interp =
        (Interp *)PMC_data(pmc);
    switch (key) {
        case -1:
        return (INTVAL) new_interp->flags;
        default:
        return interpinfo(new_interp, key);
    }

}
#line 193 "src/pmc/parrotinterpreter.c"


PMC*
Parrot_ParrotInterpreter_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC * key)
#line 313 "src/pmc/parrotinterpreter.pmc"
{
    int level = 0;
    PMC* nextkey;
    STRING *item, *s, *outer;
    parrot_context_t *ctx;
    PMC *cont;

    item =  key_string(interpreter, key);
    s = CONST_STRING(interpreter, "globals");
    if (string_equal(interpreter, item, s) == 0)
        return interpreter->stash_hash;
    outer = NULL;
    s = CONST_STRING(interpreter, "outer");
    if (string_equal(interpreter, item, s) == 0) {
        outer = item;
        nextkey = key_next(interpreter, key);
        if (nextkey && (PObj_get_FLAGS(nextkey) & KEY_string_FLAG)) {
            key = nextkey;
            item = key_string(interpreter, key);
        }
    }
    nextkey = key_next(interpreter, key);
    if (nextkey)
        level = key_integer(interpreter, nextkey);
    else if (outer)
        level = 1;
    if (level < 0)
        real_exception(interpreter, NULL, E_ValueError,
                "No such caller depth");
    ctx = CONTEXT(interpreter->ctx);
    if (outer) {
        for (; level; --level) {
            ctx = ctx->outer_ctx;
            if (!ctx)
                real_exception(interpreter, NULL, E_ValueError,
                        "No such outer depth");
        }
    }
    else {
        for (; level; --level) {
            cont = ctx->current_cont;
            if (PMC_IS_NULL(cont) || !PMC_cont(cont)->seg)
                real_exception(interpreter, NULL, E_ValueError,
                        "No such caller depth");
            ctx = PMC_cont(cont)->to_ctx;
            if (!ctx->current_sub)
                real_exception(interpreter, NULL, E_ValueError,
                        "No such caller depth");

        }
    }
    if (item == outer)
        return ctx->current_sub;
    s = CONST_STRING(interpreter, "sub");
    if (string_equal(interpreter, item, s) == 0)
        return ctx->current_sub;
    s = CONST_STRING(interpreter, "lexpad");
    if (string_equal(interpreter, item, s) == 0)
        return ctx->lex_pad;
    s = CONST_STRING(interpreter, "continuation");
    if (string_equal(interpreter, item, s) == 0)
        return VTABLE_clone(interpreter, ctx->current_cont);
    real_exception(interpreter, NULL, E_ValueError,
            "No such item %Ss", item);
    return PMCNULL;

}
#line 266 "src/pmc/parrotinterpreter.c"


PMC*
Parrot_ParrotInterpreter_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 281 "src/pmc/parrotinterpreter.pmc"
{
    Interp * new_interp =
        (Interp *)PMC_data(pmc);
    if (key >= 0 && key < IGLOBALS_SIZE)
        return VTABLE_get_pmc_keyed_int(new_interp,
            new_interp->iglobals, key);
    /* quick hack to get the global stash */
    if (key == -1)
        return new_interp->stash_hash;
    return NULL;

}
#line 284 "src/pmc/parrotinterpreter.c"


void*
Parrot_ParrotInterpreter_get_pointer(Interp* interpreter, PMC* pmc)
#line 222 "src/pmc/parrotinterpreter.pmc"
{
    return PMC_struct_val(pmc);

}
#line 294 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL val)
#line 410 "src/pmc/parrotinterpreter.pmc"
{
    Interp * new_interp =
        (Interp *)PMC_data(pmc);
    INTVAL allowed;

    switch (key) {
        case -1:    /* set interpreter flags */
        allowed =
            PARROT_BOUNDS_FLAG |
            PARROT_PROFILE_FLAG |
            PARROT_GC_DEBUG_FLAG;
        Parrot_clear_flag(new_interp, allowed);
        Parrot_set_flag(new_interp, val & allowed);
        break;
    }

}
#line 317 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_set_pointer(Interp* interpreter, PMC* pmc, void* value)
#line 208 "src/pmc/parrotinterpreter.pmc"
{
    PMC_struct_val(pmc) = value;

}
#line 327 "src/pmc/parrotinterpreter.c"


INTVAL
Parrot_ParrotInterpreter_is_equal(Interp* interpreter, PMC* pmc, PMC* val)
#line 461 "src/pmc/parrotinterpreter.pmc"
{
    Parrot_Interp self, other;
    self = PMC_data(pmc);
    other = PMC_data(val);
    if (!self->thread_data && !other->thread_data)
        return 1;
    if (self->thread_data && other->thread_data &&
        self->thread_data->tid == other->thread_data->tid)
        return 1;
    return 0;

}
#line 345 "src/pmc/parrotinterpreter.c"


void*
Parrot_ParrotInterpreter_invoke(Interp* interpreter, PMC* pmc, void* next)
#line 251 "src/pmc/parrotinterpreter.pmc"
{
    Interp * new_interp =
        (Interp *)PMC_data(pmc);
    /*
     * setup code
     */
    pt_thread_prepare_for_run(new_interp, interpreter);
    /*
     * TODO pass arguments fro parent (interpreter)
     *      to child (new_interp)
     *      by possibly clone of share the arguments
     *      r/o args can be passed as is
     */

    /* calculate offset and run */
    runops(new_interp, (opcode_t *)PMC_struct_val(pmc) -
        (opcode_t *)interpreter->code->base.data);
    return next;

}
#line 371 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 540 "src/pmc/parrotinterpreter.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_freeze(interpreter, pmc, info);

}
#line 382 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 545 "src/pmc/parrotinterpreter.pmc"
{
    IMAGE_IO *io = info->image_io;
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        Parrot_default_thaw(interpreter, pmc, info);
    }
    else if (info->extra_flags == EXTRA_IS_NULL) {
        PMC_data(pmc) = interpreter;
        info->what = VISIT_THAW_CONSTANTS;
    }

}
#line 399 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_thawfinish(Interp* interpreter, PMC* pmc, visit_info *info)
#line 556 "src/pmc/parrotinterpreter.pmc"
{
    INTVAL i, n, m;
    PMC *hll_info, *entry, *lib_pmc, *new_info, *ns_hash;
    STRING *lib_name, *hll_name;

    hll_info = interpreter->HLL_info;
    n = VTABLE_elements(interpreter, hll_info);
    new_info = PMC_pmc_val(pmc);
    PMC_pmc_val(pmc) = NULL;
    m = VTABLE_elements(interpreter, new_info);
    /* merge new_info */
    /* TODO compare old entries */
    for (i = n; i < m; ++i) {
        entry = VTABLE_get_pmc_keyed_int(interpreter, new_info, i);
        lib_pmc = VTABLE_get_pmc_keyed_int(interpreter, entry, 1);
        if (!PMC_IS_NULL(lib_pmc)) {
            lib_name = VTABLE_get_string(interpreter, lib_pmc);
            if (lib_name->strlen)
                Parrot_load_lib(interpreter, lib_name, NULL);
        }
        hll_name = VTABLE_get_string_keyed_int(interpreter, entry, 0);
        /* create HLL namespace */
        hll_name = string_downcase(interpreter, hll_name);

        /* HLL type mappings aren't yet created, we can't create
         * a namespace in HLL's flavor yet - mabe promote the
         * ns_hash to another type, if mappings provide one
         *
         * XXX always try to fetch namespace first?
         */

        ns_hash = Parrot_global_namespace(interpreter, interpreter->stash_hash,
                hll_name);
        /* cache HLLs toplevel namespace */
        VTABLE_set_pmc_keyed_int(interpreter, interpreter->HLL_namespace, 
                i, ns_hash);
    }
    if (m > n) {
        /* TODO destruct old HLL_info are constants */
        interpreter->HLL_info = new_info;
    }

}
#line 448 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 500 "src/pmc/parrotinterpreter.pmc"
{
    PMC **pos;
    /*
     * the information frozen here is part of all PBCs
     * we probably need to freeze all dynamic extensible
     * mappings (or at least the dynamic part)
     * e.g.
     *    charsets   idx - name
     *    encodings  idx - name
     *    pmc types  idx - name
     *    dynamic oplibs    opcode nr - opname
     *
     * The machine thawing this info still needs to load
     * these extensions, but the order of loading could be
     * relaxed.
     *
     * creating all these info as standard PMCs would vastly
     * simplify this process
     *
     * thaw would then need a merge operation:
     *  - compare existing for sanity
     *  - extend new
     */

    /*  HLL_info */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS) {
#if 0
        if (PMC_pmc_val(pmc))
            real_exception(interpreter, NULL, UNIMPLEMENTED,
                    "Can't deal with recursive load_bytecode");
#endif
        pos = &PMC_pmc_val(pmc);
    }
    else
        pos = &interpreter->HLL_info;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interpreter, *pos, info);

}
#line 494 "src/pmc/parrotinterpreter.c"


void
Parrot_ParrotInterpreter_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ParrotInterpreter,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_ParrotInterpreter_init,
        Parrot_ParrotInterpreter_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_default_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_ParrotInterpreter_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_ParrotInterpreter_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_ParrotInterpreter_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_get_bool,
        Parrot_default_get_pmc,
        Parrot_ParrotInterpreter_get_pmc_keyed,
        Parrot_ParrotInterpreter_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_ParrotInterpreter_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_ParrotInterpreter_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_ParrotInterpreter_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_ParrotInterpreter_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_ParrotInterpreter_freeze,
        Parrot_ParrotInterpreter_thaw,
        Parrot_ParrotInterpreter_thawfinish,
        Parrot_ParrotInterpreter_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_ParrotInterpreter_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ParrotInterpreter");
        vt_clone->isa_str = CONST_STRING(interp, "ParrotInterpreter");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    {
        int typ = enum_class_ParrotInterpreter;

        if (pass) {

            /*
             * thread start methods for threads type 1..3
             */
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_run_1), "thread1", "vJOP");
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_run_2), "thread2", "vJOP");
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_run_3), "thread3", "vJOP");

            /*
             * TODO unify and fix signatures
             */
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_yield), "yield", "v");
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_join), "join", "PJi");
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_detach), "detach", "vi");
            enter_nci_method(interp, typ,
                    F2DPTR(pt_thread_kill), "kill", "vi");

            /*
             * misc functions
             */
            enter_nci_method(interp, typ,
                    F2DPTR(recursion_limit), "recursion_limit", "iJOi");
        }

    }
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_ParrotInterpreter_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
