/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/parrotio.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/parrotio.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: parrotio.pmc 11975 2006-03-21 22:23:53Z bernhard $

=head1 NAME

src/pmc/parrotio.pmc - Parrot IO

=head1 DESCRIPTION

These are the vtable functions for Parrot IO.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/* This class is actually part of the io subsystem */
#include "../src/io/io_private.h"

#ifdef PARROT_HAS_READLINE
extern char* readline(const char*);
void add_history(const char*);
#endif

#line 43 "src/pmc/parrotio.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_parrotio.h"
#include "pmc_default.h"
#include "parrotio.str"

void
Parrot_ParrotIO_init(Interp* interpreter, PMC* pmc)
#line 250 "src/pmc/parrotio.pmc"
{
    PObj_active_destroy_SET(pmc);

}
#line 58 "src/pmc/parrotio.c"


void
Parrot_ParrotIO_destroy(Interp* interpreter, PMC* pmc)
#line 264 "src/pmc/parrotio.pmc"
{
    ParrotIO *io = PMC_data(pmc);
    if (io) {
        /* shared filehandles will only get flushed */
        if (io->flags & PIO_F_SHARED) {
            PIO_flush(interpreter, pmc);
        }
        else {
            PIO_close(interpreter, pmc);
        }
    }

}
#line 77 "src/pmc/parrotio.c"


PMC*
Parrot_ParrotIO_clone(Interp* interpreter, PMC* pmc)
#line 290 "src/pmc/parrotio.pmc"
{
    PMC* dest = pmc_new(interpreter, pmc->vtable->base_type);
    PMC_data(dest) = PMC_data(pmc);
    PMC_struct_val(dest) = PMC_struct_val(pmc);
    return dest;

}
#line 90 "src/pmc/parrotio.c"


STRING*
Parrot_ParrotIO_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL n)
#line 324 "src/pmc/parrotio.pmc"
{
    ParrotIO *io = PMC_data(pmc);
    ParrotIOLayer *layer;
    if (!io)
        return const_string(interpreter, "");
    layer = io->stack;
    if (n >= 0) {
        ParrotIOLayer *last;
        last = layer;
        for (; layer; layer = layer->down)
            last = layer;
        for (; n && last; --n, last = last->up)
            ;
        if (last)
            return string_from_cstring(interpreter, last->name, 0);
        return const_string(interpreter, "");
    }
    for (++n; n && layer; layer = layer->down, ++n)
        ;
    if (layer)
        return string_from_cstring(interpreter, layer->name, 0);
    return const_string(interpreter, "");

}
#line 120 "src/pmc/parrotio.c"


INTVAL
Parrot_ParrotIO_get_bool(Interp* interpreter, PMC* pmc)
#line 307 "src/pmc/parrotio.pmc"
{
    return !PIO_eof(interpreter, pmc);

}
#line 130 "src/pmc/parrotio.c"


STRING*
Parrot_ParrotIO_pop_string(Interp* interpreter, PMC* pmc)
#line 365 "src/pmc/parrotio.pmc"
{
    return PIO_pop_layer_str(interpreter, pmc);

}
#line 140 "src/pmc/parrotio.c"


void
Parrot_ParrotIO_push_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 361 "src/pmc/parrotio.pmc"
{
    PIO_push_layer_str(interpreter, pmc, value);

}
#line 150 "src/pmc/parrotio.c"


INTVAL
Parrot_ParrotIO_say(Interp* interpreter, PMC* pmc, STRING *s)
#line 44 "src/pmc/parrotio.pmc"
{
    PMC *out = pmc == interpreter->vtables[enum_class_ParrotIO]->class ?
        PIO_STDOUT(interpreter) : pmc;
    INTVAL r = PIO_putps(interpreter, out, s);
    r  += PIO_puts(interpreter, out, "\n");
    return r;

}
#line 164 "src/pmc/parrotio.c"


PMC*
Parrot_ParrotIO_open(Interp* interpreter, PMC* pmc, STRING* file, STRING *mode, STRING* layer)
#line 61 "src/pmc/parrotio.pmc"
{
    ParrotIOLayer *l;
    const char *c_file, *c_mode, *c_layer;
    PMC *pio;

    c_file = string_to_cstring(interpreter, file);
    c_mode = string_to_cstring(interpreter, mode);
    c_layer = string_to_cstring(interpreter, layer);
    l = PIO_get_layer(interpreter, c_layer);
    pio = PIO_open(interpreter, l, c_file, c_mode);
    if (!pio || !PMC_struct_val(pio))
        return pmc_new(interpreter, enum_class_Undef);
    if (l) {
        ParrotIO *io = PMC_data(pio);
        int is_mmap = strcmp(c_layer, "mmap") == 0;
        /*
         * XXX move this into the layer
         */
        if ((is_mmap && (io->b.flags & PIO_BF_MMAP)) || !is_mmap) {
            l = interpreter->piodata->default_stack;
            if (!strcmp(l->name, "buf"))
                l = l->down;
            /* XXX layer is stored twice - which is used when */
            io->stack = PMC_struct_val(pio) = l;
            /* push the layer */
            PIO_push_layer_str(interpreter, pio, layer);
        }
        else {
            l = interpreter->piodata->default_stack;
            io->stack = PMC_struct_val(pio) = l;
        }
    }
    /* XXX leaks as in ops/io.ops: open */
    return pio;

}
#line 206 "src/pmc/parrotio.c"


INTVAL
Parrot_ParrotIO_set_readline_interactive(Interp* interpreter, PMC* pmc, INTVAL on)
#line 137 "src/pmc/parrotio.pmc"
{
    ParrotIO *io = PMC_data(pmc);
    INTVAL flag;
    if (!io) 
        return -2;
    if (!(io->flags & PIO_F_READ))
        return -2;
#ifdef PARROT_HAS_READLINE
    if (on && !(io->flags & PIO_F_CONSOLE))
        return -2;
    flag = !!(io->flags & PIO_F_READLINE);
    if (on)
        io->flags |= PIO_F_READLINE;
    else
        io->flags &= ~PIO_F_READLINE;
    return flag;
#else
    return -1;
#endif

}
#line 233 "src/pmc/parrotio.c"


STRING*
Parrot_ParrotIO_readline(Interp* interpreter, PMC* pmc, STRING* prompt)
#line 158 "src/pmc/parrotio.pmc"
{
    ParrotIO *io = PMC_data(pmc);
    STRING *res = NULL;
    UINTVAL len;

    if (!io) 
        return NULL;
#ifdef PARROT_HAS_READLINE
    if (io->flags & PIO_F_READLINE) {
        char *r;

        r = readline (prompt ? prompt->strstart : NULL);
        if (r) {
            if (*r)
                add_history(r);
            res = string_from_cstring(interpreter, r, 0);
            free(r);
        }
        return res;
    }
    else
#endif
    {
        if (!(io->flags & PIO_F_LINEBUF))
            PIO_setlinebuf(interpreter, pmc);
        res = PIO_reads(interpreter, pmc, 0);
        if (!res)
            return res;
        /* readline should better return the string w/o NL */
        len = string_length(interpreter, res);
        while (len && (((char*)res->strstart)[len-1] == '\n'
                   ||  ((char*)res->strstart)[len-1] == '\r')) {
            --len;
            --res->strlen;
            --res->bufused;
        }
        return res;
    }

}
#line 279 "src/pmc/parrotio.c"


void
Parrot_ParrotIO_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ParrotIO,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_ParrotIO_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_default_mark,
        Parrot_ParrotIO_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_ParrotIO_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_ParrotIO_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_ParrotIO_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_ParrotIO_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_ParrotIO_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ParrotIO");
        vt_clone->isa_str = CONST_STRING(interp, "ParrotIO");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_say),
                "say", "IJOS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_open),
                "open", "PJOSSS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_set_readline_interactive),
                "set_readline_interactive", "IJOI");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_readline),
                "readline", "SJOS");
        /* class_init */
    {

        if (pass) {
            enter_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_flush), "flush", "vJO");
            enter_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_setbuf), "setbuf", "iJOi");
            enter_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_setlinebuf), "setlinebuf", "iJO");
            enter_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_puts), "puts", "iJOt");
            enter_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_eof), "eof", "iJO");
        }
    }
    } /* pass */
} /* Parrot_ParrotIO_class_init */


/*

=back

=head1 HISTORY

Initial version by leo 2003/06/23.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
