/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/resizablebooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/resizablebooleanarray.pmc"
/*
Copyright: 2001-2005 The Perl Foundation.  All Rights Reserved.
$Id: resizablebooleanarray.pmc 12496 2006-05-04 06:20:10Z petdance $

=head1 NAME

src/pmc/resizablebooleanarray.pmc - resizable array for booleans only

=head1 DESCRIPTION

The C<ResizableBooleanArray PMC> implements an array of resizable size,
which stores booleans.
It uses the C<Boolean PMC> for all conversions.
The C<ResizableBooleanArray PMC> extends the C<FixedBooleanArray PMC>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


#define BITS_PER_CHAR 8
#define MIN_ALLOC 8 * BITS_PER_CHAR

#line 42 "src/pmc/resizablebooleanarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablebooleanarray.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "resizablebooleanarray.str"

INTVAL
Parrot_ResizableBooleanArray_get_integer(Interp* interpreter, PMC* pmc)
#line 274 "src/pmc/resizablebooleanarray.pmc"
{
    return Parrot_ResizableBooleanArray_elements(interpreter, pmc);

}
#line 58 "src/pmc/resizablebooleanarray.c"


INTVAL
Parrot_ResizableBooleanArray_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 49 "src/pmc/resizablebooleanarray.pmc"
{
    /* Try to make negative index into a real index */
    if (key < 0) {
        key = Parrot_ResizableBooleanArray_elements(interpreter, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            real_exception(interpreter, NULL, E_IndexError,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Adjust key for the current head position */
    key += PMC_int_val2(pmc);

    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);

    return Parrot_FixedBooleanArray_get_integer_keyed_int(interpreter, pmc, key);

}
#line 84 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 109 "src/pmc/resizablebooleanarray.pmc"
{
    INTVAL newASize;
    const INTVAL currSize = PMC_int_val(pmc) - PMC_int_val2(pmc);

    /* We are already at the requested size. Yay */
    if (size == currSize)
        return;

    if (size < 0)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizableBooleanArray: Can't resize!");

    newASize = (size / MIN_ALLOC + 1) * MIN_ALLOC;

    /* Nothing allocated yet */
    if ( ! PMC_data(pmc) ) {
        PMC_data(pmc) = mem_sys_allocate_zeroed(newASize);
    }
    else {
        Parrot_UInt1 * const sd = PMC_data(pmc);
        PMC_data(pmc) = mem_sys_realloc(sd, newASize);
    }

    PMC_int_val2(pmc) = 0;
    PMC_int_val(pmc) = size;

}
#line 117 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 79 "src/pmc/resizablebooleanarray.pmc"
{
    /* Try to make negative index into a real index */
    if (key < 0) {
        key = Parrot_ResizableBooleanArray_elements(interpreter, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            real_exception(interpreter, NULL, E_IndexError,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Adjust key for the current head position */
    key += PMC_int_val2(pmc);

    if(key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);

    Parrot_FixedBooleanArray_set_integer_keyed_int(interpreter, pmc, key, value);

}
#line 143 "src/pmc/resizablebooleanarray.c"


INTVAL
Parrot_ResizableBooleanArray_elements(Interp* interpreter, PMC* pmc)
#line 260 "src/pmc/resizablebooleanarray.pmc"
{
    return PMC_int_val(pmc) - PMC_int_val2(pmc);

}
#line 153 "src/pmc/resizablebooleanarray.c"


INTVAL
Parrot_ResizableBooleanArray_pop_integer(Interp* interpreter, PMC* pmc)
#line 162 "src/pmc/resizablebooleanarray.pmc"
{
    INTVAL size, value;

    if ( VTABLE_elements(interpreter, pmc) < 1)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizableBooleanArray: Can't pop from an empty array!");

    size = PMC_int_val(pmc) - PMC_int_val2(pmc);
    value =  VTABLE_get_integer_keyed_int(interpreter, pmc, size - 1);
     VTABLE_set_integer_native(interpreter, pmc, size - 1);

    return value;

}
#line 173 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 146 "src/pmc/resizablebooleanarray.pmc"
{
    const INTVAL size = PMC_int_val(pmc) - PMC_int_val2(pmc);
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
     VTABLE_set_integer_keyed_int(interpreter, pmc, size, value);

}
#line 185 "src/pmc/resizablebooleanarray.c"


INTVAL
Parrot_ResizableBooleanArray_shift_integer(Interp* interpreter, PMC* pmc)
#line 221 "src/pmc/resizablebooleanarray.pmc"
{
    INTVAL value;

    if ( VTABLE_elements(interpreter, pmc) < 1)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizableBooleanArray: Can't shift from an empty array!");

    /* Get head value */
    value =  VTABLE_get_integer_keyed_int(interpreter, pmc, 0);

    /* Move the head position */
    PMC_int_val2(pmc)++;

    /* If int_val2 is bigger than our allocation unit size, size
        this thing down */
    if (PMC_int_val2(pmc) >= MIN_ALLOC) {
        Parrot_UInt1 * const sdOld = PMC_data(pmc);
        Parrot_UInt1 * const sdNew = mem_sys_allocate_zeroed(
            ((PMC_int_val2(pmc) / MIN_ALLOC) * MIN_ALLOC) 
            + PMC_int_val(pmc)
            + ((PMC_int_val(pmc) / MIN_ALLOC + 1) * MIN_ALLOC)
        );
        mem_sys_memmove(sdNew, sdOld + PMC_int_val2(pmc), 
            PMC_int_val(pmc));
        mem_sys_free(sdOld);
        PMC_data(pmc) = sdNew;
    }

    return value;

}
#line 222 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_unshift_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 187 "src/pmc/resizablebooleanarray.pmc"
{
    /* If int_val2 is smaller than 0, size this thing up */
    if (PMC_int_val2(pmc) <= 0) {
        Parrot_UInt1 * const sdOld = PMC_data(pmc);
        Parrot_UInt1 * const sdNew = mem_sys_allocate_zeroed(
            ((PMC_int_val2(pmc) / MIN_ALLOC) * MIN_ALLOC) 
            + PMC_int_val(pmc)
            + ((PMC_int_val(pmc) / MIN_ALLOC + 1) * MIN_ALLOC)
        );
        mem_sys_memmove(sdNew, sdOld + PMC_int_val2(pmc), 
            PMC_int_val(pmc));
        mem_sys_free(sdOld);
        PMC_data(pmc) = sdNew;
        PMC_int_val2(pmc) += MIN_ALLOC;
        PMC_int_val(pmc) += MIN_ALLOC;
    }

    /* Move the head position */
    PMC_int_val2(pmc)--;

    /* Assign the new value as the first item */
     VTABLE_set_integer_keyed_int(interpreter, pmc, 0, value);

}
#line 252 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 293 "src/pmc/resizablebooleanarray.pmc"
{
    /* XXX Dino - I'm concerned about freezing the entire
        allocated block of memory, it's dependent on the
        BITS_PER_CHAR value.
        Maybe we need to store that during the freeze as well
        and use it during thaw?
    */

    IMAGE_IO * const io = info->image_io;
    STRING *s;
    const INTVAL size = (PMC_int_val(pmc) / MIN_ALLOC + 1) * MIN_ALLOC;

     VTABLE_push_integer(interpreter, io, PMC_int_val2(pmc));
     VTABLE_push_integer(interpreter, io, PMC_int_val(pmc));
    s = string_from_cstring(interpreter, PMC_data(pmc), size);
     VTABLE_push_string(interpreter, io, s);

}
#line 276 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 320 "src/pmc/resizablebooleanarray.pmc"
{
    IMAGE_IO * const io = info->image_io;
    const INTVAL headPos =  VTABLE_shift_integer(interpreter, io);
    const INTVAL tailPos =  VTABLE_shift_integer(interpreter, io);
    STRING * const s =  VTABLE_shift_string(interpreter, io);

    PMC_data(pmc) = mem_sys_allocate_zeroed(s->bufused);
    mem_sys_memcopy(PMC_data(pmc), s->strstart, s->bufused);
    PMC_int_val2(pmc) = headPos;
    PMC_int_val(pmc) = tailPos;

}
#line 294 "src/pmc/resizablebooleanarray.c"


void
Parrot_ResizableBooleanArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ResizableBooleanArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedBooleanArray_morph,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_ResizableBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_ResizableBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizableBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_ResizableBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_ResizableBooleanArray_elements,
        Parrot_ResizableBooleanArray_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_ResizableBooleanArray_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_ResizableBooleanArray_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_ResizableBooleanArray_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_ResizableBooleanArray_freeze,
        Parrot_ResizableBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ResizableBooleanArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableBooleanArray FixedBooleanArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_ResizableBooleanArray_class_init */
  /* pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11

Changed allocator to double size - Matt Fowles 2004-06-15

Added push_integer               - Bernhard Schmalhofer 2004-10-17

Changed allocation code, added   - Dino Morelli 2005-06-10
  push_, pop_, shift_, 
  unshift_integer, freeze, thaw

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
