/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/resizablefloatarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/resizablefloatarray.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: resizablefloatarray.pmc 12301 2006-04-17 19:33:04Z particle $

=head1 NAME

src/pmc/resizablefloatarray.pmc - resizable array for floating point 
numbers only

=head1 DESCRIPTION

This class, C<ResizableFloatArray>, implements an array of resizable size, 
which stores FLOATVALs. It uses Float PMCs to do all necessary conversions.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 37 "src/pmc/resizablefloatarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablefloatarray.h"
#include "pmc_fixedfloatarray.h"
#include "pmc_default.h"
#include "resizablefloatarray.str"

PMC*
Parrot_ResizableFloatArray_clone(Interp* interpreter, PMC* pmc)
#line 139 "src/pmc/resizablefloatarray.pmc"
{
    PMC *copy = Parrot_FixedFloatArray_clone(interpreter, pmc);
    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);
    return copy;

}
#line 56 "src/pmc/resizablefloatarray.c"


FLOATVAL
Parrot_ResizableFloatArray_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 38 "src/pmc/resizablefloatarray.pmc"
{
    FLOATVAL *data;
    if (key < 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableFloatArray: index out of bounds!");
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);

    data = (FLOATVAL *)PMC_data(pmc);
    return data[key];

}
#line 74 "src/pmc/resizablefloatarray.c"


void
Parrot_ResizableFloatArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 90 "src/pmc/resizablefloatarray.pmc"
{
    if (size < 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableFloatArray: Can't resize to negative value!");

    if(!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedFloatArray_set_integer_native(interpreter, pmc, 8);
            PMC_int_val(pmc) = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedFloatArray_set_integer_native(interpreter, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL cur, needed;
        cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            needed = size - cur;
            cur += needed + 4096;
            cur &= ~0xfff;
        }
        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof(FLOATVAL));
        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc) = size;
    }

}
#line 119 "src/pmc/resizablefloatarray.c"


void
Parrot_ResizableFloatArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 61 "src/pmc/resizablefloatarray.pmc"
{
    FLOATVAL *data;
    if (key < 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableFloatArray: index out of bounds!");
    if(key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);

    data = (FLOATVAL *)PMC_data(pmc);
    data[key] = value;

}
#line 137 "src/pmc/resizablefloatarray.c"


FLOATVAL
Parrot_ResizableFloatArray_pop_float(Interp* interpreter, PMC* pmc)
#line 171 "src/pmc/resizablefloatarray.pmc"
{
    INTVAL size;
    FLOATVAL value;

    size = PMC_int_val(pmc);

    if (size == 0) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableFloatArray: Can't pop from an empty array!");
    }

    value =  VTABLE_get_number_keyed_int(interpreter, pmc, size-1);
     VTABLE_set_integer_native(interpreter, pmc, size - 1);
    return value;

}
#line 159 "src/pmc/resizablefloatarray.c"


void
Parrot_ResizableFloatArray_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 156 "src/pmc/resizablefloatarray.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_number_keyed_int(interpreter, pmc, nextix, value);

}
#line 170 "src/pmc/resizablefloatarray.c"


FLOATVAL
Parrot_ResizableFloatArray_shift_float(Interp* interpreter, PMC* pmc)
#line 196 "src/pmc/resizablefloatarray.pmc"
{
    INTVAL size;
    FLOATVAL value, *data;

    size = PMC_int_val(pmc);
    if (size == 0) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableFloatArray: Can't shift from an empty array!");
    }
    data = (FLOATVAL *)PMC_data(pmc);
    value = data[0];
    PMC_int_val(pmc) = --size;
    mem_sys_memmove(data, data + 1, size * sizeof(FLOATVAL));
    return value;

}
#line 192 "src/pmc/resizablefloatarray.c"


void
Parrot_ResizableFloatArray_unshift_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 222 "src/pmc/resizablefloatarray.pmc"
{
    INTVAL size; 
    FLOATVAL *data;

    size = PMC_int_val(pmc);
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    data = (FLOATVAL *)PMC_data(pmc);
    mem_sys_memmove(data + 1, data, size * sizeof(FLOATVAL));
    data[0] = value;

}
#line 209 "src/pmc/resizablefloatarray.c"


void
Parrot_ResizableFloatArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ResizableFloatArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedFloatArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedFloatArray_morph,
        Parrot_default_mark,
        Parrot_FixedFloatArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_ResizableFloatArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedFloatArray_get_integer,
        Parrot_FixedFloatArray_get_integer_keyed,
        Parrot_FixedFloatArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedFloatArray_get_number_keyed,
        Parrot_ResizableFloatArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_FixedFloatArray_get_string_keyed,
        Parrot_FixedFloatArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedFloatArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedFloatArray_get_pmc_keyed,
        Parrot_FixedFloatArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizableFloatArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedFloatArray_set_integer_keyed,
        Parrot_FixedFloatArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedFloatArray_set_number_keyed,
        Parrot_ResizableFloatArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedFloatArray_set_string_keyed,
        Parrot_FixedFloatArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedFloatArray_set_pmc_keyed,
        Parrot_FixedFloatArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedFloatArray_elements,
        Parrot_default_pop_integer,
        Parrot_ResizableFloatArray_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_ResizableFloatArray_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_ResizableFloatArray_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_ResizableFloatArray_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ResizableFloatArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableFloatArray FixedFloatArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_ResizableFloatArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
