/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/resizablepmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/resizablepmcarray.pmc"
/*
Copyright: 2001-2005 The Perl Foundation.  All Rights Reserved.
$Id: resizablepmcarray.pmc 11844 2006-03-10 01:47:38Z particle $

=head1 NAME

src/pmc/resizablepmcarray.pmc - resizable array for PMCs only

=head1 DESCRIPTION

This class, ResizablePMCArray, implements an resizable array,
which stores PMCs. It puts things into Integer, Float, or String PMCs
as appropriate.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


#line 38 "src/pmc/resizablepmcarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "resizablepmcarray.str"

PMC*
Parrot_ResizablePMCArray_clone(Interp* interpreter, PMC* pmc)
#line 559 "src/pmc/resizablepmcarray.pmc"
{
    PMC *copy = Parrot_FixedPMCArray_clone(interpreter, pmc);
    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);
    return copy;

}
#line 57 "src/pmc/resizablepmcarray.c"


PMC*
Parrot_ResizablePMCArray_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 197 "src/pmc/resizablepmcarray.pmc"
{
    PMC **data;

    if (key < 0)
        key += PMC_int_val(pmc);
    if (key < 0)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizablePMCArray: index out of bounds!");
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);
    data = PMC_data(pmc);
    if (data[key] == PMCNULL)
        data[key] = pmc_new(interpreter, enum_class_Undef);
    return data[key];

}
#line 79 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 38 "src/pmc/resizablepmcarray.pmc"
{

    if (size < 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't resize!");

    if (!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedPMCArray_set_integer_native(interpreter, pmc, 8);
            PMC_int_val(pmc) = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedPMCArray_set_integer_native(interpreter, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i, cur, needed;
        i = cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            needed = size - cur;
            cur += needed + 4096;
            cur &= ~0xfff;
        }
        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof(PMC*));
        for (; i < cur; i++)
            ((PMC**)PMC_data(pmc))[i] = PMCNULL;
        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc) = size;
    }

}
#line 127 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* src)
#line 245 "src/pmc/resizablepmcarray.pmc"
{
    Parrot_FixedPMCArray_set_pmc_keyed(interpreter, pmc, key, src);

}
#line 137 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* src)
#line 227 "src/pmc/resizablepmcarray.pmc"
{
    PMC **data;

    /*
     * TODO in python mode, only .append is allowed
     */
    if (key < 0)
        key += PMC_int_val(pmc);
    if (key < 0)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizablePMCArray: index out of bounds!");
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);
    data = (PMC**)PMC_data(pmc);
    DOD_WRITE_BARRIER(interpreter, pmc, data[key], src);
    data[key] = src;

}
#line 161 "src/pmc/resizablepmcarray.c"


INTVAL
Parrot_ResizablePMCArray_pop_integer(Interp* interpreter, PMC* pmc)
#line 408 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    INTVAL value;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[--size];
    PMC_int_val(pmc)= size;

    value= VTABLE_get_integer(interpreter, data);
    return value;

}
#line 184 "src/pmc/resizablepmcarray.c"


FLOATVAL
Parrot_ResizablePMCArray_pop_float(Interp* interpreter, PMC* pmc)
#line 391 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    FLOATVAL value;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[--size];
    PMC_int_val(pmc)= size;

    value= VTABLE_get_number(interpreter, data);
    return value;

}
#line 207 "src/pmc/resizablepmcarray.c"


STRING*
Parrot_ResizablePMCArray_pop_string(Interp* interpreter, PMC* pmc)
#line 439 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    STRING* value;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[--size];
    PMC_int_val(pmc)= size;

    value= VTABLE_get_string(interpreter, data);
    return value;

}
#line 230 "src/pmc/resizablepmcarray.c"


PMC*
Parrot_ResizablePMCArray_pop_pmc(Interp* interpreter, PMC* pmc)
#line 425 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[--size];
    PMC_int_val(pmc)= size;
    return data;

}
#line 250 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 341 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* val;

    val= pmc_new(interpreter, enum_class_Integer);
    VTABLE_set_integer_native(interpreter, val, value);
    /* let set_pmc_keyed_int() worry about memory allocation */
     VTABLE_set_pmc_keyed_int(interpreter, pmc, size, val);

    return;

}
#line 268 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 329 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* val;

    val= pmc_new(interpreter, enum_class_Float);
    VTABLE_set_number_native(interpreter, val, value);
    /* let set_pmc_keyed_int() worry about memory allocation */
     VTABLE_set_pmc_keyed_int(interpreter, pmc, size, val);

    return;

}
#line 286 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_push_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 363 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* val;

    val= pmc_new(interpreter, enum_class_String);
    VTABLE_assign_string_native(interpreter, val, value);
    /* let set_pmc_keyed_int() worry about memory allocation */
     VTABLE_set_pmc_keyed_int(interpreter, pmc, size, val);

    return;

}
#line 304 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 353 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size = PMC_int_val(pmc);

    /* let set_integer_native() worry about memory allocation */
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    ((PMC**)PMC_data(pmc))[size] = value;

    return;

}
#line 320 "src/pmc/resizablepmcarray.c"


INTVAL
Parrot_ResizablePMCArray_shift_integer(Interp* interpreter, PMC* pmc)
#line 122 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    PMC** item;
    INTVAL value;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[0];
    value= VTABLE_get_integer(interpreter, data);
    PMC_int_val(pmc)= --size;

    item= (PMC**)PMC_data(pmc);
    mem_sys_memmove(item, item + 1, size * sizeof(PMC*));
    item[size]= PMCNULL;

    return value;

}
#line 348 "src/pmc/resizablepmcarray.c"


FLOATVAL
Parrot_ResizablePMCArray_shift_float(Interp* interpreter, PMC* pmc)
#line 100 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    PMC** item;
    FLOATVAL value;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[0];
    value= VTABLE_get_number(interpreter, data);
    PMC_int_val(pmc)= --size;

    item= (PMC**)PMC_data(pmc);
    mem_sys_memmove(item, item + 1, size * sizeof(PMC*));
    item[size]= PMCNULL;

    return value;

}
#line 376 "src/pmc/resizablepmcarray.c"


STRING*
Parrot_ResizablePMCArray_shift_string(Interp* interpreter, PMC* pmc)
#line 164 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    PMC** item;
    STRING* value;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[0];
    value= VTABLE_get_string(interpreter, data);
    PMC_int_val(pmc)= --size;

    item= (PMC**)PMC_data(pmc);
    mem_sys_memmove(item, item + 1, size * sizeof(PMC*));
    item[size]= PMCNULL;

    return value;

}
#line 404 "src/pmc/resizablepmcarray.c"


PMC*
Parrot_ResizablePMCArray_shift_pmc(Interp* interpreter, PMC* pmc)
#line 144 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* data;
    PMC** item;

    if (0 == size) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");
    }

    data= ((PMC**)PMC_data(pmc))[0];
    PMC_int_val(pmc)= --size;

    item= (PMC**)PMC_data(pmc);
    mem_sys_memmove(item, item + 1, size * sizeof(PMC*));
    item[size]= PMCNULL;

    return data;

}
#line 430 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_unshift_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 493 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* val;
    PMC** data;
    INTVAL i;

    val= pmc_new(interpreter, enum_class_Integer);
    VTABLE_set_integer_native(interpreter, val, value);

    /* let set_integer_native() worry about memory allocation */
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    /* make room */
    data= (PMC**)PMC_data(pmc);
    for (i= size; i; --i) {
        data[i]= data[i-1];
    }
    data[0]= val;
    return;

}
#line 456 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_unshift_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 473 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* val;
    PMC** data;
    INTVAL i;

    val= pmc_new(interpreter, enum_class_Float);
    VTABLE_set_number_native(interpreter, val, value);

    /* let set_integer_native() worry about memory allocation */
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    /* make room */
    data= (PMC**)PMC_data(pmc);
    for (i= size; i; --i) {
        data[i]= data[i-1];
    }
    data[0]= val;
    return;

}
#line 482 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_unshift_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 529 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC* val;
    PMC** data;
    INTVAL i;

    val= pmc_new(interpreter, enum_class_String);
    VTABLE_set_string_native(interpreter, val, value);

    /* let set_integer_native() worry about memory allocation */
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    /* make room */
    data= (PMC**)PMC_data(pmc);
    for (i= size; i; --i) {
        data[i]= data[i-1];
    }
    data[0]= val;
    return;

}
#line 508 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_unshift_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 513 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL size= PMC_int_val(pmc);
    PMC** data;
    INTVAL i;

    /* let set_integer_native() worry about memory allocation */
     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    /* make room */
    data= (PMC**)PMC_data(pmc);
    for (i= size; i; --i) {
        data[i]= data[i-1];
    }
    data[0]= value;
    return;

}
#line 530 "src/pmc/resizablepmcarray.c"


INTVAL
Parrot_ResizablePMCArray_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 576 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL j, n;

    if (value->vtable->base_type != enum_class_ResizablePMCArray)
        return 0;
    n =  VTABLE_elements(interpreter, pmc);
    if (VTABLE_elements(interpreter, value) != n)
        return 0;
    for (j = 0; j < n; ++j) {
        PMC *item1, *item2;
        item1 =  VTABLE_get_pmc_keyed_int(interpreter, pmc, j);
        item2 = VTABLE_get_pmc_keyed_int(interpreter, value, j);
        if (item1 == item2)
            continue;
        if (!mmd_dispatch_i_pp(interpreter, item1, item2, MMD_EQ))
            return 0;
    }
    return 1;

}
#line 556 "src/pmc/resizablepmcarray.c"


INTVAL
Parrot_ResizablePMCArray_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 283 "src/pmc/resizablepmcarray.pmc"
{
    INTVAL ix = key_integer(interpreter, key);
    return Parrot_ResizablePMCArray_exists_keyed_int(interpreter, pmc, ix);

}
#line 567 "src/pmc/resizablepmcarray.c"


INTVAL
Parrot_ResizablePMCArray_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 271 "src/pmc/resizablepmcarray.pmc"
{
    PMC **data;

    if (key < 0)
        key += PMC_int_val(pmc);
    if (key < 0 || key >= PMC_int_val(pmc))
        return 0;

    data = (PMC**)PMC_data(pmc);
    return !PMC_IS_NULL(data[key]);

}
#line 585 "src/pmc/resizablepmcarray.c"


INTVAL
Parrot_ResizablePMCArray_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 298 "src/pmc/resizablepmcarray.pmc"
{
    PMC* val;

    if (key < 0)
        key += PMC_int_val(pmc);
    if (key < 0 || key >= PMC_int_val(pmc))
        return 0;
    val =  VTABLE_get_pmc_keyed_int(interpreter, pmc, key);
    if(PMC_IS_NULL(val))
        return 0;

    return VTABLE_defined(interpreter, val);

}
#line 605 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 249 "src/pmc/resizablepmcarray.pmc"
{
    PMC **data;
    INTVAL idx = key_integer(interpreter, key);
    INTVAL i;
    INTVAL n = PMC_int_val(pmc);
    data = PMC_data(pmc);
    for (i = idx; i < n - 1; ++i)
        data[i] = data[i + 1];
    PMC_int_val(pmc)--;

}
#line 622 "src/pmc/resizablepmcarray.c"


void
Parrot_ResizablePMCArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ResizablePMCArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedPMCArray_morph,
        Parrot_default_mark,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_repr,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_ResizablePMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_FixedPMCArray_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedPMCArray_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_ResizablePMCArray_set_pmc_keyed,
        Parrot_ResizablePMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_pop_integer,
        Parrot_ResizablePMCArray_pop_float,
        Parrot_ResizablePMCArray_pop_string,
        Parrot_ResizablePMCArray_pop_pmc,
        Parrot_ResizablePMCArray_push_integer,
        Parrot_ResizablePMCArray_push_float,
        Parrot_ResizablePMCArray_push_string,
        Parrot_ResizablePMCArray_push_pmc,
        Parrot_ResizablePMCArray_shift_integer,
        Parrot_ResizablePMCArray_shift_float,
        Parrot_ResizablePMCArray_shift_string,
        Parrot_ResizablePMCArray_shift_pmc,
        Parrot_ResizablePMCArray_unshift_integer,
        Parrot_ResizablePMCArray_unshift_float,
        Parrot_ResizablePMCArray_unshift_string,
        Parrot_ResizablePMCArray_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizablePMCArray_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_FixedPMCArray_freeze,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_FixedPMCArray_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_ResizablePMCArray_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ResizablePMCArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizablePMCArray FixedPMCArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_ResizablePMCArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
