/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/resizablestringarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/resizablestringarray.pmc"
/*
Copyright: 2001-2005 The Perl Foundation.  All Rights Reserved.
$Id: resizablestringarray.pmc 12233 2006-04-14 16:17:53Z leo $

=head1 NAME

src/pmc/resizablestringarray.pmc - resizable array for strings only

=head1 DESCRIPTION

ResizableStringArray implements a resizeable array which stores Parrot
strings only. Any ints or floats assigned to elements of the array will
first be converted to String PMCs and then to native Parrot strings.
PMCs assigned to to elements of the array will be stringified by having
their C<get_string> method called.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 39 "src/pmc/resizablestringarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablestringarray.h"
#include "pmc_fixedstringarray.h"
#include "pmc_default.h"
#include "resizablestringarray.str"

PMC*
Parrot_ResizableStringArray_clone(Interp* interpreter, PMC* pmc)
#line 175 "src/pmc/resizablestringarray.pmc"
{
    PMC *copy = Parrot_FixedStringArray_clone(interpreter, pmc);
    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);
    return copy;

}
#line 58 "src/pmc/resizablestringarray.c"


STRING*
Parrot_ResizableStringArray_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 39 "src/pmc/resizablestringarray.pmc"
{
    STRING **data;
    if (key < 0)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizableStringArray: index out of bounds!");
    if(key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);

    data = (STRING**)PMC_data(pmc);
    return data[key];

}
#line 76 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 124 "src/pmc/resizablestringarray.pmc"
{
    if (size < 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableStringArray: Can't resize!");

    if(!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedStringArray_set_integer_native(interpreter, pmc, 8);
            PMC_int_val(pmc) = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedStringArray_set_integer_native(interpreter, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i, cur, needed;
        i = cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            needed = size - cur;
            cur += needed + 4096;
            cur &= ~0xfff;
        }
        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof(STRING*));
        for (; i < cur; i++)
            ((STRING**)PMC_data(pmc))[i] = NULL;
        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc) = size;
    }

}
#line 123 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 61 "src/pmc/resizablestringarray.pmc"
{
    STRING **data;
    if (key < 0)
        real_exception(interpreter, NULL, E_IndexError,
            "ResizableStringArray: index out of bounds!");
    if(key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interpreter, pmc, key+1);

    data = (STRING**)PMC_data(pmc);
    DOD_WRITE_BARRIER(interpreter, pmc, data[key], value);
    data[key] = value;

}
#line 142 "src/pmc/resizablestringarray.c"


STRING*
Parrot_ResizableStringArray_pop_string(Interp* interpreter, PMC* pmc)
#line 100 "src/pmc/resizablestringarray.pmc"
{
    INTVAL size;
    STRING* value;

    size = PMC_int_val(pmc);
    if (size == 0) {
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableStringArray: Can't pop from an empty array!");
    }
    value =  VTABLE_get_string_keyed_int(interpreter, pmc, size-1);
     VTABLE_set_integer_native(interpreter, pmc, size - 1);
    return value;

}
#line 162 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_push_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 85 "src/pmc/resizablestringarray.pmc"
{
    INTVAL nextix =  VTABLE_elements(interpreter, pmc);
     VTABLE_set_string_keyed_int(interpreter, pmc, nextix, value);

}
#line 173 "src/pmc/resizablestringarray.c"


STRING*
Parrot_ResizableStringArray_shift_string(Interp* interpreter, PMC* pmc)
#line 192 "src/pmc/resizablestringarray.pmc"
{
    INTVAL size;
    STRING* value;

    size = PMC_int_val(pmc);
    if (size == 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableStringArray: Can't shift from an empty array!");

    value =  VTABLE_get_string_keyed_int(interpreter, pmc, 0);
     VTABLE_delete_keyed_int(interpreter, pmc, 0);
    return value;

}
#line 193 "src/pmc/resizablestringarray.c"


PMC*
Parrot_ResizableStringArray_shift_pmc(Interp* interpreter, PMC* pmc)
#line 216 "src/pmc/resizablestringarray.pmc"
{
    INTVAL size;
    PMC *ret;
    STRING* value;

    size = PMC_int_val(pmc);
    if (size == 0)
        real_exception(interpreter, NULL, E_IndexError,
                "ResizableStringArray: Can't shift from an empty array!");

    value =  VTABLE_get_string_keyed_int(interpreter, pmc, 0);
    ret = pmc_new(interpreter, enum_class_String);
    VTABLE_set_string_native(interpreter, ret, value);
     VTABLE_delete_keyed_int(interpreter, pmc, 0);
    return ret;

}
#line 216 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_unshift_string(Interp* interpreter, PMC* pmc, STRING *value)
#line 244 "src/pmc/resizablestringarray.pmc"
{
    STRING **data; 
    INTVAL size, i;

    size = PMC_int_val(pmc);
    data = (STRING**)PMC_data(pmc);

     VTABLE_set_integer_native(interpreter, pmc, size + 1);
    data = PMC_data(pmc);
    for (i = size; i; --i)
        data[i] = data[i - 1];
     VTABLE_set_string_keyed_int(interpreter, pmc, 0, value);

}
#line 236 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 289 "src/pmc/resizablestringarray.pmc"
{
    STRING **data; 
    INTVAL size, idx, i;
    size = PMC_int_val(pmc);
    idx = key_integer(interpreter, key);

    data = PMC_data(pmc);
    for (i = idx; i < size - 1; ++i)
        data[i] = data[i + 1];
     VTABLE_set_integer_native(interpreter, pmc, size - 1);

}
#line 254 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_delete_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 268 "src/pmc/resizablestringarray.pmc"
{
    STRING **data; 
    INTVAL size, i;
    size = PMC_int_val(pmc);

    data = PMC_data(pmc);
    for (i = key; i < size - 1; ++i)
        data[i] = data[i + 1];
     VTABLE_set_integer_native(interpreter, pmc, size - 1);

}
#line 271 "src/pmc/resizablestringarray.c"


void
Parrot_ResizableStringArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ResizableStringArray,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_FixedStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_FixedStringArray_morph,
        Parrot_FixedStringArray_mark,
        Parrot_FixedStringArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_ResizableStringArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizableStringArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedStringArray_set_integer_keyed,
        Parrot_FixedStringArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedStringArray_set_number_keyed,
        Parrot_FixedStringArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_FixedStringArray_set_string_keyed,
        Parrot_ResizableStringArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_FixedStringArray_set_pmc_keyed,
        Parrot_FixedStringArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedStringArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_ResizableStringArray_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_ResizableStringArray_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_ResizableStringArray_shift_string,
        Parrot_ResizableStringArray_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_ResizableStringArray_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_delete_keyed,
        Parrot_ResizableStringArray_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_FixedStringArray_freeze,
        Parrot_FixedStringArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ResizableStringArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableStringArray FixedStringArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_ResizableStringArray_class_init */




/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
Added push_string                - Bernhard Schmalhofer 2004-10-17
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
