/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/retcontinuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/retcontinuation.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: retcontinuation.pmc 11709 2006-02-23 16:49:23Z leo $

=head1 NAME

src/pmc/retcontinuation.pmc - Return Continuation

=head1 DESCRIPTION

C<RetContinuation> extends C<Continuation>.

A return continuation is a one shot Continuation, it gets recycled
immediately after invocation.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"


#line 40 "src/pmc/retcontinuation.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_retcontinuation.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "retcontinuation.str"

void
Parrot_RetContinuation_init(Interp* interpreter, PMC* pmc)
#line 40 "src/pmc/retcontinuation.pmc"
{
    PMC_struct_val(pmc) = new_ret_continuation(interpreter);
    PMC_pmc_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 58 "src/pmc/retcontinuation.c"


void
Parrot_RetContinuation_destroy(Interp* interpreter, PMC* pmc)
#line 51 "src/pmc/retcontinuation.pmc"
{
    struct Parrot_cont * cc = PMC_cont(pmc);
    if (cc) {
        mem_sys_free(cc);
        PMC_struct_val(pmc) = NULL;
    }

}
#line 72 "src/pmc/retcontinuation.c"


PMC*
Parrot_RetContinuation_clone(Interp* interpreter, PMC* pmc)
#line 71 "src/pmc/retcontinuation.pmc"
{
    invalidate_retc_context(interpreter, pmc);
    return Parrot_Continuation_clone(interpreter, pmc);

}
#line 83 "src/pmc/retcontinuation.c"


void*
Parrot_RetContinuation_invoke(Interp* interpreter, PMC* pmc, void* next)
#line 86 "src/pmc/retcontinuation.pmc"
{
    Stack_Chunk_t *ctr_stack, *stack_now;
    struct Parrot_cont * cc = PMC_cont(pmc);
    parrot_context_t *caller_ctx;
    struct PackFile_ByteCode *seg;   /* bytecode segment */
    /*
    * unwind control stack
    */
    stack_now = CONTEXT(interpreter->ctx)->control_stack;
    caller_ctx = cc->to_ctx;
    ctr_stack = caller_ctx->control_stack;
    while (stack_now != ctr_stack) {
        if (!stack_now || !ctr_stack)
            internal_exception(1, "Control stack damaged");
        /*
         * this automagically runs all pushed action
         * handler during pop - see cleanup stuff
         * in stack_pop
         */
        (void)stack_pop(interpreter, &stack_now,
                        NULL, NO_STACK_ENTRY_TYPE);
    }

    /* debug print before context is switched */
    if (Interp_trace_TEST(interpreter, PARROT_TRACE_SUB_CALL_FLAG)) {
        Interp *tracer;

        PMC *to_sub = caller_ctx->current_sub;
        PMC *from_sub = cc->from_ctx->current_sub;

        tracer = interpreter->debugger ? 
            interpreter->debugger : interpreter;
        PIO_eprintf(tracer, "# Back in sub '%Ss' from '%Ss'\n",
                Parrot_full_sub_name(interpreter, to_sub),
                Parrot_full_sub_name(interpreter, from_sub));
    }
    CONTEXT(interpreter->ctx) = caller_ctx;
    interpreter->ctx.bp = caller_ctx->bp;
    interpreter->ctx.bp_ps = caller_ctx->bp_ps;
    next = cc->address;
    Parrot_free_context(interpreter, cc->from_ctx, 1);
    seg = cc->seg;
#ifdef NDEBUG
    /* the continuation is dead - delete and destroy it */
    mem_sys_free(cc);
    {
        struct Arenas *arena_base = interpreter->arena_base;
        struct Small_Object_Pool *pool, *ext_pool =
            arena_base->pmc_ext_pool;
        ext_pool->add_free_object(interpreter, ext_pool,
                pmc->pmc_ext);
        PObj_flags_SETTO((PObj *)pmc, PObj_on_free_list_FLAG);
        pool = arena_base->pmc_pool;
        pool->add_free_object(interpreter, pool, pmc);
        pool->num_free_objects ++;
    }
#else
    cc->from_ctx = NULL;
    /*
     * the to_ctx is marked in Continuation.mark
     * NULLify it or turn off the custom_mark bit
     */
    cc->to_ctx = NULL;
#endif
    interpreter->current_args = NULL;
    if (interpreter->code != seg) {
        Parrot_switch_to_cs(interpreter, seg, 1);
    }
    return next;

}
#line 160 "src/pmc/retcontinuation.c"


void
Parrot_RetContinuation_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_RetContinuation,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_RetContinuation_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Continuation_mark,
        Parrot_RetContinuation_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_RetContinuation_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Continuation_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Continuation_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_Continuation_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_Continuation_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Continuation_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Continuation_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_RetContinuation_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "RetContinuation");
        vt_clone->isa_str = CONST_STRING(interp, "RetContinuation Continuation");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_RetContinuation_class_init */


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
