/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/sarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/sarray.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: sarray.pmc 12508 2006-05-04 22:23:38Z bernhard $

=head1 NAME

src/pmc/sarray.pmc - Simple Array or Subroutine Parameter Array

=head1 DESCRIPTION

Simple Array or Subroutine Parameter Array PMC.
SArray data are kept in an malloced array of C<HashEntry>'s:

=over 4

=item 0 C<start_idx>

First index, for C<shift>.

=item 1 C<end_idx>

Last index, for C<push>.

=item 2...

Data.

=back

SArrays are fixed size, implying that the first operation on it must be
setting its size, and that only the most important vtable methods are
implemented.

Currently SArray's are used for:

=over 4

=item Global data per interpreter

=item For implementing lists, see F<src/list.c>. 

=item Base class of the Exception PMC, see F<src/exception.pmc>

=back

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static PARROT_INLINE INTVAL
ret_int(Interp* interpreter, HashEntry *e)>

Processes C<*e>, returning the appropriate integer, or raising an
exception if necessary.

=cut

*/

static PARROT_INLINE INTVAL
ret_int(Interp* interpreter, HashEntry *e)
{
    switch (e->type) {
    case enum_hash_int:
        return UVal_int(e->val);
    case enum_hash_pmc:
        return VTABLE_get_integer(interpreter, UVal_pmc(e->val));
    default:
        break;
    }
    real_exception(interpreter, NULL, E_IndexError,
            "SArray: Entry not an integer!");
    return 0;
}

/*

=item C<static PARROT_INLINE FLOATVAL
ret_num(Interp* interpreter, HashEntry *e)>

Processes C<*e>, returning the appropriate floating-point number, or
raising an exception if necessary.

=cut

*/

static PARROT_INLINE FLOATVAL
ret_num(Interp* interpreter, HashEntry *e)
{
    switch (e->type) {
        case enum_hash_num:
            return UVal_num(e->val);
        case enum_hash_pmc:
            return VTABLE_get_number(interpreter, UVal_pmc(e->val));
        default:
            break;
    }
    real_exception(interpreter, NULL, E_IndexError,
            "SArray: Entry not a number!");
    return 0;
}

/*

=item C<static PARROT_INLINE STRING *
ret_string(Interp* interpreter, HashEntry *e)>

Processes C<*e>, returning the appropriate Parrot string, or raising an
exception if necessary.

=cut

*/

static PARROT_INLINE STRING*
ret_string(Interp* interpreter, HashEntry *e)
{
    switch (e->type) {
        case enum_hash_string:
            return UVal_str(e->val);
        case enum_hash_pmc:
            return VTABLE_get_string(interpreter, UVal_pmc(e->val));
        default:
            break;
    }
    real_exception(interpreter, NULL, E_IndexError,
            "SArray: Entry not a string!");
    return 0;
}

/*

=item C<static PARROT_INLINE PMC *
ret_pmc(Interp* interpreter, HashEntry *e)>

Processes C<*e>, returning the appropriate PMC, or raising an exception
if necessary.

=cut

*/

static PARROT_INLINE PMC*
ret_pmc(Interp* interpreter, HashEntry *e)
{
    PMC *ret;
    switch (e->type) {
        case enum_hash_int:
            ret = pmc_new(interpreter, enum_class_Undef);
            VTABLE_set_integer_native(interpreter, ret, UVal_int(e->val));
            return ret;
        case enum_hash_num:
            ret = pmc_new(interpreter, enum_class_Undef);
            VTABLE_set_number_native(interpreter, ret, UVal_num(e->val));
            return ret;
        case enum_hash_string:
            ret = pmc_new(interpreter, enum_class_Undef);
            VTABLE_set_string_native(interpreter, ret, UVal_str(e->val));
            return ret;
        case enum_hash_pmc:
            return UVal_pmc(e->val);
        default:
            real_exception(interpreter, NULL, E_IndexError,
                    "SArray: Unknown entry!");
    }
    return NULL;
}

/*

=item C<static PARROT_INLINE HashEntry *
shift_entry(PMC *self)>

Removes and returns the first element from the array.

=cut

*/

static PARROT_INLINE HashEntry *
shift_entry(PMC *self)
{
    HashEntry *e = (HashEntry *) PMC_data(self);
    HashEntry *ret;
    INTVAL start_index = UVal_int(e[0].val);
    INTVAL end_index   = UVal_int(e[1].val);

    if (start_index >= end_index)
        internal_exception(OUT_OF_BOUNDS, "SArray index out of bounds!");

    ret = (HashEntry *) PMC_data(self) + (2 + start_index++);

    /* Update the starting index */
    UVal_int(e[0].val) = start_index;
    return ret;
}

/*

=item C<static PARROT_INLINE HashEntry *
get_entry(PMC *self, INTVAL key)>

Returns the element for index C<key>.

=cut

*/

static PARROT_INLINE HashEntry*
get_entry(PMC *self, INTVAL key)
{
    HashEntry *e = (HashEntry *) PMC_data(self);
    INTVAL start_index = UVal_int(e[0].val);
    INTVAL end_index   = UVal_int(e[1].val);

    if (key < 0) {
        key += end_index;
    }
    key += start_index;   /* lower bound if already shifted */
    if (key < start_index || key >= end_index)
        internal_exception(OUT_OF_BOUNDS, "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(self) + (2 + key);
    return e;
}

#line 247 "src/pmc/sarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_sarray.h"
#include "pmc_default.h"
#include "sarray.str"

void
Parrot_SArray_init(Interp* interpreter, PMC* pmc)
#line 253 "src/pmc/sarray.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = NULL;

}
#line 263 "src/pmc/sarray.c"


void
Parrot_SArray_morph(Interp* interpreter, PMC* pmc, INTVAL type)
#line 268 "src/pmc/sarray.pmc"
{
    Parrot_default_morph(interpreter, pmc, type);

}
#line 273 "src/pmc/sarray.c"


void
Parrot_SArray_mark(Interp* interpreter, PMC* pmc)
#line 282 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    int i, start, end;
    if (!PMC_data(pmc))
        return;
    e = (HashEntry *) PMC_data(pmc);
    start = UVal_int(e[0].val);
    end   = UVal_int(e[1].val);
    e = (HashEntry *) PMC_data(pmc) + (2 + start);
    for (i = start; i < end; i++, e++) {
        switch (e->type) {
            case enum_hash_string:
                if (UVal_str(e->val))
                pobject_lives(interpreter, (PObj *) UVal_str(e->val));
                break;
            case enum_hash_pmc:
                if (UVal_pmc(e->val))
                pobject_lives(interpreter, (PObj *) UVal_pmc(e->val));
                break;
            default:
                break;
        }
    }

}
#line 304 "src/pmc/sarray.c"


void
Parrot_SArray_destroy(Interp* interpreter, PMC* pmc)
#line 317 "src/pmc/sarray.pmc"
{
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;

}
#line 316 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_type_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 431 "src/pmc/sarray.pmc"
{
    HashEntry *e = get_entry(pmc, key);
    return e->type;

}
#line 327 "src/pmc/sarray.c"


PMC*
Parrot_SArray_clone(Interp* interpreter, PMC* pmc)
#line 333 "src/pmc/sarray.pmc"
{
    HashEntry *e, *d;
    int i, start, end;
    INTVAL size;
    PMC * dest = pmc_new(interpreter, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;
    size = PMC_int_val(pmc);
    PMC_int_val(dest) = size;
    PMC_data(dest) = mem_sys_allocate_zeroed((2 + size) *
        sizeof(HashEntry));
    e = (HashEntry *) PMC_data(pmc);
    d = (HashEntry *) PMC_data(dest);
    start = UVal_int(e[0].val);
    end   = UVal_int(e[1].val);
    UVal_int(d[0].val) = start;
    UVal_int(d[1].val) = end;
    e = (HashEntry *) PMC_data(pmc) + (2 + start);
    d = (HashEntry *) PMC_data(dest) + (2 + start);
    for (i = start; i < end; i++, e++, d++) {
        d->type = e->type;
        switch (e->type) {
            case enum_hash_int:
                UVal_int(d->val) = UVal_int(e->val);
                break;
            case enum_hash_num:
                UVal_num(d->val) = UVal_num(e->val);
                break;
            case enum_hash_string:
                UVal_str(d->val) = string_copy(interpreter, UVal_str(e->val));
                break;
            case enum_hash_pmc:
                UVal_pmc(d->val) = VTABLE_clone(interpreter, UVal_pmc(e->val));
                break;
            default:
                break;
        }
    }
    PObj_custom_mark_destroy_SETALL(dest);
    return dest;

}
#line 376 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_get_integer(Interp* interpreter, PMC* pmc)
#line 417 "src/pmc/sarray.pmc"
{
    return  VTABLE_elements(interpreter, pmc);

}
#line 386 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 461 "src/pmc/sarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interpreter, key);
    return Parrot_SArray_get_integer_keyed_int(interpreter, pmc, k);

}
#line 398 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 446 "src/pmc/sarray.pmc"
{
    HashEntry *e = get_entry(pmc, key);
    return ret_int(interpreter, e);

}
#line 409 "src/pmc/sarray.c"


FLOATVAL
Parrot_SArray_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 507 "src/pmc/sarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return Parrot_SArray_get_number_keyed_int(interpreter, pmc, k);

}
#line 420 "src/pmc/sarray.c"


FLOATVAL
Parrot_SArray_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 492 "src/pmc/sarray.pmc"
{
    HashEntry *e = get_entry(pmc, key);
    return ret_num(interpreter, e);

}
#line 431 "src/pmc/sarray.c"


STRING*
Parrot_SArray_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 553 "src/pmc/sarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return Parrot_SArray_get_string_keyed_int(interpreter, pmc, k);

}
#line 442 "src/pmc/sarray.c"


STRING*
Parrot_SArray_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 538 "src/pmc/sarray.pmc"
{
    HashEntry *e = get_entry(pmc, key);
    return ret_string(interpreter, e);

}
#line 453 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_get_bool(Interp* interpreter, PMC* pmc)
#line 386 "src/pmc/sarray.pmc"
{
    INTVAL size =  VTABLE_elements(interpreter, pmc);
    return (INTVAL)(size != 0);

}
#line 464 "src/pmc/sarray.c"


PMC*
Parrot_SArray_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 599 "src/pmc/sarray.pmc"
{
    INTVAL k = key_integer(interpreter, key);
    return Parrot_SArray_get_pmc_keyed_int(interpreter, pmc, k);

}
#line 475 "src/pmc/sarray.c"


PMC*
Parrot_SArray_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
#line 584 "src/pmc/sarray.pmc"
{
    HashEntry *e = get_entry(pmc, key);
    return ret_pmc(interpreter, e);

}
#line 486 "src/pmc/sarray.c"


void
Parrot_SArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL size)
#line 629 "src/pmc/sarray.pmc"
{
    if (PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray: Can't resize!");
    PMC_int_val(pmc) = size;
    /* Probably ought to actually copy this... */
    if (PMC_data(pmc)) {
      mem_sys_free(PMC_data(pmc));
    }
    PMC_data(pmc) = mem_sys_allocate_zeroed((2 + size) *
        sizeof(HashEntry));
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 506 "src/pmc/sarray.c"


void
Parrot_SArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
#line 653 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + (2 + key);
    e->type = enum_hash_int;
    UVal_int(e->val) = value;
    e = (HashEntry *) PMC_data(pmc) + 1;
    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;

}
#line 525 "src/pmc/sarray.c"


void
Parrot_SArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
#line 698 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + (2 + key);
    e->type = enum_hash_num;
    UVal_num(e->val) = value;
    e = (HashEntry *) PMC_data(pmc) + 1;
    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;

}
#line 544 "src/pmc/sarray.c"


void
Parrot_SArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
#line 742 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + (2 + key);
    e->type = enum_hash_string;
    UVal_str(e->val) = value;
    e = (HashEntry *) PMC_data(pmc) + 1;
    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;

}
#line 563 "src/pmc/sarray.c"


void
Parrot_SArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* src)
#line 787 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + (2 + key);
    e->type = enum_hash_pmc;
    DOD_WRITE_BARRIER(interpreter, pmc, UVal_pmc(e->val), src);
    UVal_pmc(e->val) = src;
    e = (HashEntry *) PMC_data(pmc) + 1;
    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;

}
#line 583 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_elements(Interp* interpreter, PMC* pmc)
#line 399 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    if (!PMC_data(pmc))
        return 0;
    e = (HashEntry *) PMC_data(pmc);
        return UVal_int(e[1].val) - UVal_int(e[0].val);

}
#line 597 "src/pmc/sarray.c"


void
Parrot_SArray_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
#line 676 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    INTVAL nextix;
    if (!PMC_data(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);
     VTABLE_set_integer_keyed_int(interpreter, pmc, nextix, value);

}
#line 614 "src/pmc/sarray.c"


void
Parrot_SArray_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 721 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    INTVAL nextix;
    if (!PMC_data(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);
     VTABLE_set_number_keyed_int(interpreter, pmc, nextix, value);

}
#line 631 "src/pmc/sarray.c"


void
Parrot_SArray_push_string(Interp* interpreter, PMC* pmc, STRING* value)
#line 766 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    INTVAL nextix;
    if (!PMC_data(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);
     VTABLE_set_string_keyed_int(interpreter, pmc, nextix, value);

}
#line 648 "src/pmc/sarray.c"


void
Parrot_SArray_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 811 "src/pmc/sarray.pmc"
{
    HashEntry *e;
    INTVAL nextix;
    if (!PMC_data(pmc))
        real_exception(interpreter, NULL, E_IndexError,
                "SArray index out of bounds!");
    e = (HashEntry *) PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);
     VTABLE_set_pmc_keyed_int(interpreter, pmc, nextix, value);

}
#line 665 "src/pmc/sarray.c"


INTVAL
Parrot_SArray_shift_integer(Interp* interpreter, PMC* pmc)
#line 477 "src/pmc/sarray.pmc"
{
    HashEntry *ret = shift_entry(pmc);
    return ret_int(interpreter, ret);

}
#line 676 "src/pmc/sarray.c"


FLOATVAL
Parrot_SArray_shift_float(Interp* interpreter, PMC* pmc)
#line 523 "src/pmc/sarray.pmc"
{
    HashEntry *ret = shift_entry(pmc);
    return ret_num(interpreter, ret);

}
#line 687 "src/pmc/sarray.c"


STRING*
Parrot_SArray_shift_string(Interp* interpreter, PMC* pmc)
#line 569 "src/pmc/sarray.pmc"
{
    HashEntry *ret = shift_entry(pmc);
    return ret_string(interpreter, ret);

}
#line 698 "src/pmc/sarray.c"


PMC*
Parrot_SArray_shift_pmc(Interp* interpreter, PMC* pmc)
#line 614 "src/pmc/sarray.pmc"
{
    HashEntry *ret = shift_entry(pmc);
    return ret_pmc(interpreter, ret);

}
#line 709 "src/pmc/sarray.c"


void
Parrot_SArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_SArray,	/* base_type */
        NULL,	/* whoami */
        VTABLE_HAS_CONST_TOO|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_SArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_SArray_morph,
        Parrot_SArray_mark,
        Parrot_SArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_SArray_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_SArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_SArray_get_integer,
        Parrot_SArray_get_integer_keyed,
        Parrot_SArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_SArray_get_number_keyed,
        Parrot_SArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_SArray_get_string_keyed,
        Parrot_SArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_SArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_SArray_get_pmc_keyed,
        Parrot_SArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_SArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_SArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_SArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_SArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_SArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_SArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_SArray_push_integer,
        Parrot_SArray_push_float,
        Parrot_SArray_push_string,
        Parrot_SArray_push_pmc,
        Parrot_SArray_shift_integer,
        Parrot_SArray_shift_float,
        Parrot_SArray_shift_string,
        Parrot_SArray_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "SArray");
        vt_clone->isa_str = CONST_STRING(interp, "SArray");
        vt_clone->does_str = CONST_STRING(interp, "array const");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_SArray_class_init */
void
Parrot_ConstSArray_morph(Interp* interpreter, PMC* pmc, INTVAL type)
 {
    if (1 || Parrot_is_const_pmc(interpreter, pmc))
	internal_exception(WRITE_TO_CONSTCLASS,
		"morph() in ConstSArray");
    else
        Parrot_SArray_morph(interpreter, pmc, type);
}

void
Parrot_ConstSArray_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"set_integer_native() in ConstSArray");
        
}

void
Parrot_ConstSArray_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"set_integer_keyed_int() in ConstSArray");
        
}

void
Parrot_ConstSArray_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"set_number_keyed_int() in ConstSArray");
        
}

void
Parrot_ConstSArray_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"set_string_keyed_int() in ConstSArray");
        
}

void
Parrot_ConstSArray_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"set_pmc_keyed_int() in ConstSArray");
        
}

void
Parrot_ConstSArray_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"push_integer() in ConstSArray");
        
}

void
Parrot_ConstSArray_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"push_float() in ConstSArray");
        
}

void
Parrot_ConstSArray_push_string(Interp* interpreter, PMC* pmc, STRING* value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"push_string() in ConstSArray");
        
}

void
Parrot_ConstSArray_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"push_pmc() in ConstSArray");
        
}

INTVAL
Parrot_ConstSArray_shift_integer(Interp* interpreter, PMC* pmc)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"shift_integer() in ConstSArray");
        return (INTVAL)0;
}

FLOATVAL
Parrot_ConstSArray_shift_float(Interp* interpreter, PMC* pmc)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"shift_float() in ConstSArray");
        return (FLOATVAL)0;
}

STRING*
Parrot_ConstSArray_shift_string(Interp* interpreter, PMC* pmc)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"shift_string() in ConstSArray");
        return (STRING*)0;
}

PMC*
Parrot_ConstSArray_shift_pmc(Interp* interpreter, PMC* pmc)
 {
	internal_exception(WRITE_TO_CONSTCLASS,
		"shift_pmc() in ConstSArray");
        return (PMC*)0;
}

void
Parrot_ConstSArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_ConstSArray,	/* base_type */
        NULL,	/* whoami */
        VTABLE_IS_CONST_FLAG|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_SArray_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_ConstSArray_morph,
        Parrot_SArray_mark,
        Parrot_SArray_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_SArray_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_SArray_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_SArray_get_integer,
        Parrot_SArray_get_integer_keyed,
        Parrot_SArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_SArray_get_number_keyed,
        Parrot_SArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_SArray_get_string_keyed,
        Parrot_SArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_SArray_get_bool,
        Parrot_default_get_pmc,
        Parrot_SArray_get_pmc_keyed,
        Parrot_SArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ConstSArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_ConstSArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_ConstSArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_ConstSArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_ConstSArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_SArray_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_ConstSArray_push_integer,
        Parrot_ConstSArray_push_float,
        Parrot_ConstSArray_push_string,
        Parrot_ConstSArray_push_pmc,
        Parrot_ConstSArray_shift_integer,
        Parrot_ConstSArray_shift_float,
        Parrot_ConstSArray_shift_string,
        Parrot_ConstSArray_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "ConstSArray");
        vt_clone->isa_str = CONST_STRING(interp, "ConstSArray SArray");
        vt_clone->does_str = CONST_STRING(interp, "array const");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_ConstSArray_class_init */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd03_calling_conventions.pod>.

=head1 HISTORY

Initial version 2003.07.04 by leo

2003.11.06 boemmels renamed HASH_ENTRY to HashEntry

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
