/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/sharedref.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/sharedref.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: sharedref.pmc 12544 2006-05-07 05:19:38Z petdance $

=head1 NAME

src/pmc/sharedref.pmc - Shared PMC Reference

=head1 DESCRIPTION

The vtable functions for the SharedRef base class.

This class wraps locking around PMC access.

All methods not present below get a default body autogenerated inside
C<Parrot::Pmc2c>.

Currently all access is locked. When we have a non-copying GC allocator
we can relax that a bit.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/*
 * TODO we should catch exceptions around these locks
 *      if the vtable meth throws the lock is never unlocked
 */
#define LOCK_PMC(interp, pmc) LOCK(PMC_sync(pmc)->pmc_lock);
#define UNLOCK_PMC(interp, pmc) UNLOCK(PMC_sync(pmc)->pmc_lock);

#line 50 "src/pmc/sharedref.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_sharedref.h"
#include "pmc_ref.h"
#include "pmc_default.h"
#include "sharedref.str"

void
Parrot_SharedRef_init(Interp* interpreter, PMC* pmc)
#line 41 "src/pmc/sharedref.pmc"
{
    Parrot_Ref_init(interpreter, pmc);

}
#line 66 "src/pmc/sharedref.c"


void
Parrot_SharedRef_init_pmc(Interp* interpreter, PMC* pmc, PMC* init)
#line 74 "src/pmc/sharedref.pmc"
{
    Parrot_Ref_init_pmc(interpreter, pmc, init);
    PObj_active_destroy_SET(pmc);

}
#line 77 "src/pmc/sharedref.c"


void
Parrot_SharedRef_init_pmc_props(Interp* interpreter, PMC* pmc, PMC* init, PMC* props)
#line 89 "src/pmc/sharedref.pmc"
{
    Parrot_Ref_init_pmc_props(interpreter, pmc, init, props);
    PObj_active_destroy_SET(pmc);

}
#line 88 "src/pmc/sharedref.c"


#line 89 "sharedref.c"

PMC*
Parrot_SharedRef_instantiate(Interp* interpreter, PMC* pmc, PMC* sig)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_instantiate(interpreter, PMC_pmc_val(pmc), sig);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 101 "sharedref.c"

PMC*
Parrot_SharedRef_new_from_string(Interp* interpreter, PMC* pmc, STRING* rep, INTVAL flags)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_new_from_string(interpreter, PMC_pmc_val(pmc), rep, flags);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 113 "sharedref.c"

void
Parrot_SharedRef_morph(Interp* interpreter, PMC* pmc, INTVAL type)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_morph(interpreter, PMC_pmc_val(pmc), type);
    UNLOCK_PMC(interpreter, pmc);
    
}

void
Parrot_SharedRef_mark(Interp* interpreter, PMC* pmc)
#line 117 "src/pmc/sharedref.pmc"
{
    Parrot_Ref_mark(interpreter, pmc);

}
#line 134 "src/pmc/sharedref.c"


void
Parrot_SharedRef_destroy(Interp* interpreter, PMC* pmc)
#line 157 "src/pmc/sharedref.pmc"
{
    PMC * const ref = PMC_pmc_val(pmc);
    if (PObj_active_destroy_TEST(ref))
        VTABLE_destroy(interpreter, ref);
    if (PMC_sync(pmc)->owner != interpreter)
        PANIC("SharedRef destroyed by wrong interpreter");
    MUTEX_DESTROY(PMC_sync(pmc)->pmc_lock);
    mem_sys_free(PMC_sync(pmc));

}
#line 150 "src/pmc/sharedref.c"


#line 151 "sharedref.c"

PMC*
Parrot_SharedRef_namespace(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_namespace(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 163 "sharedref.c"

PMC*
Parrot_SharedRef_getprop(Interp* interpreter, PMC* pmc, STRING* key)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_getprop(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 175 "sharedref.c"

void
Parrot_SharedRef_setprop(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_setprop(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 187 "sharedref.c"

void
Parrot_SharedRef_delprop(Interp* interpreter, PMC* pmc, STRING* key)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_delprop(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 199 "sharedref.c"

PMC*
Parrot_SharedRef_getprops(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_getprops(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 211 "sharedref.c"

INTVAL
Parrot_SharedRef_type(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_type(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 223 "sharedref.c"

INTVAL
Parrot_SharedRef_type_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_type_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 235 "sharedref.c"

INTVAL
Parrot_SharedRef_type_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_type_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 247 "sharedref.c"

INTVAL
Parrot_SharedRef_type_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_type_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 259 "sharedref.c"

UINTVAL
Parrot_SharedRef_subtype(Interp* interpreter, PMC* pmc, INTVAL type)
 {
    UINTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_subtype(interpreter, PMC_pmc_val(pmc), type);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 271 "sharedref.c"

STRING*
Parrot_SharedRef_name(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_name(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 283 "sharedref.c"

PMC*
Parrot_SharedRef_clone(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_clone(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 295 "sharedref.c"

PMC*
Parrot_SharedRef_find_method(Interp* interpreter, PMC* pmc, STRING* method_name)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_find_method(interpreter, PMC_pmc_val(pmc), method_name);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 307 "sharedref.c"

INTVAL
Parrot_SharedRef_hash(Interp* interpreter, PMC* pmc, size_t seed)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_hash(interpreter, PMC_pmc_val(pmc), seed);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 319 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_integer(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 331 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_integer_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 343 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_integer_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 355 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_integer_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 367 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number(Interp* interpreter, PMC* pmc)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_number(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 379 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_number_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 391 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_number_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 403 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_number_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 415 "sharedref.c"

PMC*
Parrot_SharedRef_get_bignum(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_bignum(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 427 "sharedref.c"

STRING*
Parrot_SharedRef_get_string(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_string(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 439 "sharedref.c"

STRING*
Parrot_SharedRef_get_repr(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_repr(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 451 "sharedref.c"

STRING*
Parrot_SharedRef_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_string_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 463 "sharedref.c"

STRING*
Parrot_SharedRef_get_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_string_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 475 "sharedref.c"

STRING*
Parrot_SharedRef_get_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_string_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 487 "sharedref.c"

INTVAL
Parrot_SharedRef_get_bool(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_bool(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

PMC*
Parrot_SharedRef_get_pmc(Interp* interpreter, PMC* pmc)
#line 140 "src/pmc/sharedref.pmc"
{
    real_exception(interpreter, NULL, E_ReferenceError,
            "deref not allowed");
    return NULL;

}
#line 510 "src/pmc/sharedref.c"


#line 511 "sharedref.c"

PMC*
Parrot_SharedRef_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pmc_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 523 "sharedref.c"

PMC*
Parrot_SharedRef_get_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pmc_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 535 "sharedref.c"

PMC*
Parrot_SharedRef_get_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pmc_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 547 "sharedref.c"

PMC*
Parrot_SharedRef_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL flag)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_slice(interpreter, PMC_pmc_val(pmc), key, flag);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 559 "sharedref.c"

void*
Parrot_SharedRef_get_pointer(Interp* interpreter, PMC* pmc)
 {
    void* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pointer(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 571 "sharedref.c"

void*
Parrot_SharedRef_get_pointer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    void* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pointer_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 583 "sharedref.c"

void*
Parrot_SharedRef_get_pointer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    void* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pointer_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 595 "sharedref.c"

void*
Parrot_SharedRef_get_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    void* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_pointer_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 607 "sharedref.c"

void
Parrot_SharedRef_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_integer_native(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 619 "sharedref.c"

void
Parrot_SharedRef_set_integer_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_integer_same(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 631 "sharedref.c"

void
Parrot_SharedRef_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_integer_keyed(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 643 "sharedref.c"

void
Parrot_SharedRef_set_integer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_integer_keyed_int(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 655 "sharedref.c"

void
Parrot_SharedRef_set_integer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_integer_keyed_str(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 667 "sharedref.c"

void
Parrot_SharedRef_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_number_native(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 679 "sharedref.c"

void
Parrot_SharedRef_set_number_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_number_same(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 691 "sharedref.c"

void
Parrot_SharedRef_set_number_keyed(Interp* interpreter, PMC* pmc, PMC* key, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_number_keyed(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 703 "sharedref.c"

void
Parrot_SharedRef_set_number_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_number_keyed_int(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 715 "sharedref.c"

void
Parrot_SharedRef_set_number_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_number_keyed_str(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 727 "sharedref.c"

void
Parrot_SharedRef_set_bignum_int(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_bignum_int(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 739 "sharedref.c"

void
Parrot_SharedRef_set_bignum_num(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_bignum_num(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 751 "sharedref.c"

void
Parrot_SharedRef_set_bignum_str(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_bignum_str(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 763 "sharedref.c"

void
Parrot_SharedRef_set_string_native(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_string_native(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 775 "sharedref.c"

void
Parrot_SharedRef_assign_string_native(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_assign_string_native(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 787 "sharedref.c"

void
Parrot_SharedRef_set_string_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_string_same(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 799 "sharedref.c"

void
Parrot_SharedRef_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_string_keyed(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 811 "sharedref.c"

void
Parrot_SharedRef_set_string_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_string_keyed_int(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 823 "sharedref.c"

void
Parrot_SharedRef_set_string_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_string_keyed_str(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 835 "sharedref.c"

void
Parrot_SharedRef_set_bool(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_bool(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

void
Parrot_SharedRef_set_pmc(Interp* interpreter, PMC* pmc, PMC* other)
#line 135 "src/pmc/sharedref.pmc"
{
    Parrot_Ref_set_pmc(interpreter, pmc, other);
    PObj_active_destroy_SET(pmc);

}
#line 857 "src/pmc/sharedref.c"


#line 858 "sharedref.c"

void
Parrot_SharedRef_assign_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_assign_pmc(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 870 "sharedref.c"

void
Parrot_SharedRef_set_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pmc_keyed(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 882 "sharedref.c"

void
Parrot_SharedRef_set_pmc_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pmc_keyed_int(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 894 "sharedref.c"

void
Parrot_SharedRef_set_pmc_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pmc_keyed_str(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 906 "sharedref.c"

void
Parrot_SharedRef_set_pointer(Interp* interpreter, PMC* pmc, void* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pointer(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 918 "sharedref.c"

void
Parrot_SharedRef_set_pointer_keyed(Interp* interpreter, PMC* pmc, PMC* key, void* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pointer_keyed(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 930 "sharedref.c"

void
Parrot_SharedRef_set_pointer_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, void* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pointer_keyed_int(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 942 "sharedref.c"

void
Parrot_SharedRef_set_pointer_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, void* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_pointer_keyed_str(interpreter, PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 954 "sharedref.c"

INTVAL
Parrot_SharedRef_elements(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_elements(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 966 "sharedref.c"

INTVAL
Parrot_SharedRef_pop_integer(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_pop_integer(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 978 "sharedref.c"

FLOATVAL
Parrot_SharedRef_pop_float(Interp* interpreter, PMC* pmc)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_pop_float(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 990 "sharedref.c"

STRING*
Parrot_SharedRef_pop_string(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_pop_string(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1002 "sharedref.c"

PMC*
Parrot_SharedRef_pop_pmc(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_pop_pmc(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1014 "sharedref.c"

void
Parrot_SharedRef_push_integer(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_push_integer(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1026 "sharedref.c"

void
Parrot_SharedRef_push_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_push_float(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1038 "sharedref.c"

void
Parrot_SharedRef_push_string(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_push_string(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1050 "sharedref.c"

void
Parrot_SharedRef_push_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_push_pmc(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1062 "sharedref.c"

INTVAL
Parrot_SharedRef_shift_integer(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_shift_integer(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1074 "sharedref.c"

FLOATVAL
Parrot_SharedRef_shift_float(Interp* interpreter, PMC* pmc)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_shift_float(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1086 "sharedref.c"

STRING*
Parrot_SharedRef_shift_string(Interp* interpreter, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_shift_string(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1098 "sharedref.c"

PMC*
Parrot_SharedRef_shift_pmc(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_shift_pmc(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1110 "sharedref.c"

void
Parrot_SharedRef_unshift_integer(Interp* interpreter, PMC* pmc, INTVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_unshift_integer(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1122 "sharedref.c"

void
Parrot_SharedRef_unshift_float(Interp* interpreter, PMC* pmc, FLOATVAL value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_unshift_float(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1134 "sharedref.c"

void
Parrot_SharedRef_unshift_string(Interp* interpreter, PMC* pmc, STRING* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_unshift_string(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1146 "sharedref.c"

void
Parrot_SharedRef_unshift_pmc(Interp* interpreter, PMC* pmc, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_unshift_pmc(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1158 "sharedref.c"

void
Parrot_SharedRef_splice(Interp* interpreter, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_splice(interpreter, PMC_pmc_val(pmc), value, offset, count);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1170 "sharedref.c"

void
Parrot_SharedRef_increment(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_increment(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1182 "sharedref.c"

void
Parrot_SharedRef_decrement(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_decrement(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1194 "sharedref.c"

PMC*
Parrot_SharedRef_absolute(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_absolute(interpreter, PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1206 "sharedref.c"

void
Parrot_SharedRef_i_absolute(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_i_absolute(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1218 "sharedref.c"

PMC*
Parrot_SharedRef_neg(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_neg(interpreter, PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1230 "sharedref.c"

void
Parrot_SharedRef_i_neg(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_i_neg(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1242 "sharedref.c"

PMC*
Parrot_SharedRef_bitwise_not(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_bitwise_not(interpreter, PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1254 "sharedref.c"

void
Parrot_SharedRef_i_bitwise_not(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_i_bitwise_not(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1266 "sharedref.c"

PMC*
Parrot_SharedRef_bitwise_nots(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_bitwise_nots(interpreter, PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1278 "sharedref.c"

void
Parrot_SharedRef_i_bitwise_nots(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_i_bitwise_nots(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1290 "sharedref.c"

INTVAL
Parrot_SharedRef_is_same(Interp* interpreter, PMC* pmc, PMC* value)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_is_same(interpreter, PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1302 "sharedref.c"

PMC*
Parrot_SharedRef_logical_not(Interp* interpreter, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_logical_not(interpreter, PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1314 "sharedref.c"

void
Parrot_SharedRef_i_logical_not(Interp* interpreter, PMC* pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_i_logical_not(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1326 "sharedref.c"

void
Parrot_SharedRef_substr(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_substr(interpreter, PMC_pmc_val(pmc), offset, length, dest);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1338 "sharedref.c"

STRING*
Parrot_SharedRef_substr_str(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length)
 {
    STRING* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_substr_str(interpreter, PMC_pmc_val(pmc), offset, length);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1350 "sharedref.c"

INTVAL
Parrot_SharedRef_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_exists_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1362 "sharedref.c"

INTVAL
Parrot_SharedRef_exists_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_exists_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1374 "sharedref.c"

INTVAL
Parrot_SharedRef_exists_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_exists_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1386 "sharedref.c"

INTVAL
Parrot_SharedRef_defined(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_defined(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1398 "sharedref.c"

INTVAL
Parrot_SharedRef_defined_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_defined_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1410 "sharedref.c"

INTVAL
Parrot_SharedRef_defined_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_defined_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1422 "sharedref.c"

INTVAL
Parrot_SharedRef_defined_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_defined_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1434 "sharedref.c"

void
Parrot_SharedRef_delete_keyed(Interp* interpreter, PMC* pmc, PMC* key)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_delete_keyed(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1446 "sharedref.c"

void
Parrot_SharedRef_delete_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_delete_keyed_int(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1458 "sharedref.c"

void
Parrot_SharedRef_delete_keyed_str(Interp* interpreter, PMC* pmc, STRING* key)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_delete_keyed_str(interpreter, PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1470 "sharedref.c"

PMC*
Parrot_SharedRef_nextkey_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL what)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_nextkey_keyed(interpreter, PMC_pmc_val(pmc), key, what);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1482 "sharedref.c"

PMC*
Parrot_SharedRef_nextkey_keyed_int(Interp* interpreter, PMC* pmc, INTVAL key, INTVAL what)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_nextkey_keyed_int(interpreter, PMC_pmc_val(pmc), key, what);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1494 "sharedref.c"

PMC*
Parrot_SharedRef_nextkey_keyed_str(Interp* interpreter, PMC* pmc, STRING* key, INTVAL what)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_nextkey_keyed_str(interpreter, PMC_pmc_val(pmc), key, what);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1506 "sharedref.c"

PMC*
Parrot_SharedRef_get_iter(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_iter(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1518 "sharedref.c"

void*
Parrot_SharedRef_invoke(Interp* interpreter, PMC* pmc, void* next)
 {
    void* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_invoke(interpreter, PMC_pmc_val(pmc), next);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1530 "sharedref.c"

INTVAL
Parrot_SharedRef_can(Interp* interpreter, PMC* pmc, STRING* method)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_can(interpreter, PMC_pmc_val(pmc), method);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1542 "sharedref.c"

INTVAL
Parrot_SharedRef_does(Interp* interpreter, PMC* pmc, STRING* method)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_does(interpreter, PMC_pmc_val(pmc), method);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1554 "sharedref.c"

INTVAL
Parrot_SharedRef_isa(Interp* interpreter, PMC* pmc, STRING* _class)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_isa(interpreter, PMC_pmc_val(pmc), _class);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1566 "sharedref.c"

PMC*
Parrot_SharedRef_subclass(Interp* interpreter, PMC* pmc, PMC* name)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_subclass(interpreter, PMC_pmc_val(pmc), name);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1578 "sharedref.c"

PMC*
Parrot_SharedRef_get_attr(Interp* interpreter, PMC* pmc, INTVAL idx)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_attr(interpreter, PMC_pmc_val(pmc), idx);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1590 "sharedref.c"

PMC*
Parrot_SharedRef_get_attr_str(Interp* interpreter, PMC* pmc, STRING* idx)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_attr_str(interpreter, PMC_pmc_val(pmc), idx);
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1602 "sharedref.c"

void
Parrot_SharedRef_set_attr(Interp* interpreter, PMC* pmc, INTVAL idx, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_attr(interpreter, PMC_pmc_val(pmc), idx, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1614 "sharedref.c"

void
Parrot_SharedRef_set_attr_str(Interp* interpreter, PMC* pmc, STRING* idx, PMC* value)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_set_attr_str(interpreter, PMC_pmc_val(pmc), idx, value);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1626 "sharedref.c"

PMC*
Parrot_SharedRef_get_class(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_class(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1638 "sharedref.c"

void
Parrot_SharedRef_add_parent(Interp* interpreter, PMC* pmc, PMC* parent)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_add_parent(interpreter, PMC_pmc_val(pmc), parent);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1650 "sharedref.c"

void
Parrot_SharedRef_become_parent(Interp* interpreter, PMC* pmc, PMC* class)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_become_parent(interpreter, PMC_pmc_val(pmc), class);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1662 "sharedref.c"

INTVAL
Parrot_SharedRef_class_type(Interp* interpreter, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_class_type(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1674 "sharedref.c"

void
Parrot_SharedRef_add_method(Interp* interpreter, PMC* pmc, STRING* method, PMC* sub_pmc)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_add_method(interpreter, PMC_pmc_val(pmc), method, sub_pmc);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1686 "sharedref.c"

void
Parrot_SharedRef_remove_method(Interp* interpreter, PMC* pmc, STRING* method)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_remove_method(interpreter, PMC_pmc_val(pmc), method);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1698 "sharedref.c"

PMC*
Parrot_SharedRef_new_singleton(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_new_singleton(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1710 "sharedref.c"

PMC*
Parrot_SharedRef_get_anonymous_subclass(Interp* interpreter, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interpreter, pmc);
    ret_val = VTABLE_get_anonymous_subclass(interpreter, PMC_pmc_val(pmc));
    UNLOCK_PMC(interpreter, pmc);
    return ret_val;
}

#line 1722 "sharedref.c"

void
Parrot_SharedRef_freeze(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_freeze(interpreter, PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1734 "sharedref.c"

void
Parrot_SharedRef_thaw(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_thaw(interpreter, PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1746 "sharedref.c"

void
Parrot_SharedRef_thawfinish(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_thawfinish(interpreter, PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interpreter, pmc);
    
}

#line 1758 "sharedref.c"

void
Parrot_SharedRef_visit(Interp* interpreter, PMC* pmc, visit_info* info)
 {
    
    LOCK_PMC(interpreter, pmc);
    (void) VTABLE_visit(interpreter, PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interpreter, pmc);
    
}

void
Parrot_SharedRef_share(Interp* interpreter, PMC* pmc)
#line 104 "src/pmc/sharedref.pmc"
{

}
#line 1778 "src/pmc/sharedref.c"


void
Parrot_SharedRef_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_SharedRef,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_SharedRef_init,
        Parrot_SharedRef_init_pmc,
        Parrot_SharedRef_init_pmc_props,
        Parrot_SharedRef_instantiate,
        Parrot_SharedRef_new_from_string,
        Parrot_SharedRef_morph,
        Parrot_SharedRef_mark,
        Parrot_SharedRef_destroy,
        Parrot_SharedRef_namespace,
        Parrot_SharedRef_getprop,
        Parrot_SharedRef_setprop,
        Parrot_SharedRef_delprop,
        Parrot_SharedRef_getprops,
        Parrot_SharedRef_type,
        Parrot_SharedRef_type_keyed,
        Parrot_SharedRef_type_keyed_int,
        Parrot_SharedRef_type_keyed_str,
        Parrot_SharedRef_subtype,
        Parrot_SharedRef_name,
        Parrot_SharedRef_clone,
        Parrot_SharedRef_find_method,
        Parrot_SharedRef_hash,
        Parrot_SharedRef_get_integer,
        Parrot_SharedRef_get_integer_keyed,
        Parrot_SharedRef_get_integer_keyed_int,
        Parrot_SharedRef_get_integer_keyed_str,
        Parrot_SharedRef_get_number,
        Parrot_SharedRef_get_number_keyed,
        Parrot_SharedRef_get_number_keyed_int,
        Parrot_SharedRef_get_number_keyed_str,
        Parrot_SharedRef_get_bignum,
        Parrot_SharedRef_get_string,
        Parrot_SharedRef_get_repr,
        Parrot_SharedRef_get_string_keyed,
        Parrot_SharedRef_get_string_keyed_int,
        Parrot_SharedRef_get_string_keyed_str,
        Parrot_SharedRef_get_bool,
        Parrot_SharedRef_get_pmc,
        Parrot_SharedRef_get_pmc_keyed,
        Parrot_SharedRef_get_pmc_keyed_int,
        Parrot_SharedRef_get_pmc_keyed_str,
        Parrot_SharedRef_slice,
        Parrot_SharedRef_get_pointer,
        Parrot_SharedRef_get_pointer_keyed,
        Parrot_SharedRef_get_pointer_keyed_int,
        Parrot_SharedRef_get_pointer_keyed_str,
        Parrot_SharedRef_set_integer_native,
        Parrot_SharedRef_set_integer_same,
        Parrot_SharedRef_set_integer_keyed,
        Parrot_SharedRef_set_integer_keyed_int,
        Parrot_SharedRef_set_integer_keyed_str,
        Parrot_SharedRef_set_number_native,
        Parrot_SharedRef_set_number_same,
        Parrot_SharedRef_set_number_keyed,
        Parrot_SharedRef_set_number_keyed_int,
        Parrot_SharedRef_set_number_keyed_str,
        Parrot_SharedRef_set_bignum_int,
        Parrot_SharedRef_set_bignum_num,
        Parrot_SharedRef_set_bignum_str,
        Parrot_SharedRef_set_string_native,
        Parrot_SharedRef_assign_string_native,
        Parrot_SharedRef_set_string_same,
        Parrot_SharedRef_set_string_keyed,
        Parrot_SharedRef_set_string_keyed_int,
        Parrot_SharedRef_set_string_keyed_str,
        Parrot_SharedRef_set_bool,
        Parrot_SharedRef_set_pmc,
        Parrot_SharedRef_assign_pmc,
        Parrot_SharedRef_set_pmc_keyed,
        Parrot_SharedRef_set_pmc_keyed_int,
        Parrot_SharedRef_set_pmc_keyed_str,
        Parrot_SharedRef_set_pointer,
        Parrot_SharedRef_set_pointer_keyed,
        Parrot_SharedRef_set_pointer_keyed_int,
        Parrot_SharedRef_set_pointer_keyed_str,
        Parrot_SharedRef_elements,
        Parrot_SharedRef_pop_integer,
        Parrot_SharedRef_pop_float,
        Parrot_SharedRef_pop_string,
        Parrot_SharedRef_pop_pmc,
        Parrot_SharedRef_push_integer,
        Parrot_SharedRef_push_float,
        Parrot_SharedRef_push_string,
        Parrot_SharedRef_push_pmc,
        Parrot_SharedRef_shift_integer,
        Parrot_SharedRef_shift_float,
        Parrot_SharedRef_shift_string,
        Parrot_SharedRef_shift_pmc,
        Parrot_SharedRef_unshift_integer,
        Parrot_SharedRef_unshift_float,
        Parrot_SharedRef_unshift_string,
        Parrot_SharedRef_unshift_pmc,
        Parrot_SharedRef_splice,
        Parrot_SharedRef_increment,
        Parrot_SharedRef_decrement,
        Parrot_SharedRef_absolute,
        Parrot_SharedRef_i_absolute,
        Parrot_SharedRef_neg,
        Parrot_SharedRef_i_neg,
        Parrot_SharedRef_bitwise_not,
        Parrot_SharedRef_i_bitwise_not,
        Parrot_SharedRef_bitwise_nots,
        Parrot_SharedRef_i_bitwise_nots,
        Parrot_SharedRef_is_same,
        Parrot_SharedRef_logical_not,
        Parrot_SharedRef_i_logical_not,
        Parrot_SharedRef_substr,
        Parrot_SharedRef_substr_str,
        Parrot_SharedRef_exists_keyed,
        Parrot_SharedRef_exists_keyed_int,
        Parrot_SharedRef_exists_keyed_str,
        Parrot_SharedRef_defined,
        Parrot_SharedRef_defined_keyed,
        Parrot_SharedRef_defined_keyed_int,
        Parrot_SharedRef_defined_keyed_str,
        Parrot_SharedRef_delete_keyed,
        Parrot_SharedRef_delete_keyed_int,
        Parrot_SharedRef_delete_keyed_str,
        Parrot_SharedRef_nextkey_keyed,
        Parrot_SharedRef_nextkey_keyed_int,
        Parrot_SharedRef_nextkey_keyed_str,
        Parrot_SharedRef_get_iter,
        Parrot_SharedRef_invoke,
        Parrot_SharedRef_can,
        Parrot_SharedRef_does,
        Parrot_SharedRef_isa,
        Parrot_SharedRef_subclass,
        Parrot_SharedRef_get_attr,
        Parrot_SharedRef_get_attr_str,
        Parrot_SharedRef_set_attr,
        Parrot_SharedRef_set_attr_str,
        Parrot_SharedRef_get_class,
        Parrot_SharedRef_add_parent,
        Parrot_SharedRef_become_parent,
        Parrot_SharedRef_class_type,
        Parrot_SharedRef_add_method,
        Parrot_SharedRef_remove_method,
        Parrot_SharedRef_new_singleton,
        Parrot_SharedRef_get_anonymous_subclass,
        Parrot_SharedRef_freeze,
        Parrot_SharedRef_thaw,
        Parrot_SharedRef_thawfinish,
        Parrot_SharedRef_visit,
        Parrot_SharedRef_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "SharedRef");
        vt_clone->isa_str = CONST_STRING(interp, "SharedRef Ref");
        vt_clone->does_str = CONST_STRING(interp, "ref");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_SharedRef_class_init */


/*

=back

=head1 HISTORY

Initial revision by leo 2004.01.14.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
