/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/slice.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/slice.pmc"
/*
Copyright: 2004-2006 The Perl Foundation.  All Rights Reserved.
$Id: slice.pmc 12114 2006-04-04 22:50:48Z bernhard $

=head1 NAME

src/pmc/slice.pmc - Slice PMC

=head1 DESCRIPTION

These are the vtable functions for the slice PMC class.

A Slice PMC isa Key PMC, holding a chain of start and/or end values
for slice ranges. Private flags define the meaning of the values:

  [ s .. e ]    s .. KEY_start_slice_FLAG; e .. KEY_end_slice_FLAG
  [ x,     ]    KEY_start_slice_FLAG | KEY_end_slice_FLAG
  [  .. e  ]    KEY_inf_slice_FLAG   | KEY_end_slice_FLAG
  [ s ..   ]    KEY_start_slice_FLAG | KEY_inf_slice_FLAG

Infinite ranges are currently implemented for Array and PerlString only.

Run

  $ parrot -d2000 slice.pasm

to see slice constant flags.

During initialization above key chain gets converted to parrot_range_t structures.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/*
 * create range_t structure
 *
 * set the Slice iter state to initial, first position
 * no backwards iterations for now
 *
 * XXX self is a key chain (PMC constant), which shouldn't be modified
 *     finally this stuff should be call from packfiles thaw
 *
 */
static void
set_slice_start(Interp *interpreter, PMC *self, PMC *key, PMC *agg)
{
    parrot_range_t *range = mem_sys_allocate(sizeof *range);

    PMC_struct_val(self) = range;
next_range:
    range->next = NULL;
    RVal_int(range->step) = 1;

    if (key_type(interpreter, key) & KEY_integer_FLAG) {
        range->type = enum_type_INTVAL;
        /* integer key */
        if ((PObj_get_FLAGS(key) &
                    (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) ==
                (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) {
            /* start == end */
            RVal_int(range->start) =
                RVal_int(range->end) = key_integer(interpreter, key);
        }
        else if ((PObj_get_FLAGS(key) &
                    (KEY_inf_slice_FLAG|KEY_end_slice_FLAG)) ==
                (KEY_inf_slice_FLAG|KEY_end_slice_FLAG)) {
            /*
             * first range is ".. end"
             * start at index 0
             * */
            RVal_int(range->start) = 0;
            RVal_int(range->end) = key_integer(interpreter, key);
        }
        else {
            /*
             * else start at range value
             */
            RVal_int(range->start) = key_integer(interpreter, key);
            if ((PObj_get_FLAGS(key) &
                    (KEY_inf_slice_FLAG|KEY_start_slice_FLAG)) ==
                (KEY_inf_slice_FLAG|KEY_start_slice_FLAG)) {
                /* last range "start .." */
                RVal_int(range->end) = VTABLE_elements(interpreter, agg) - 1;
                if (PMC_data(key))
                    internal_exception(1, "Illegal range after start..");
            }
            else {
                /* must have end in next key */
                key = PMC_data(key);
                if (!key)
                    internal_exception(1, "no end range specified");
                RVal_int(range->end) = key_integer(interpreter, key);
            }
        }
        if (agg->vtable->base_type == enum_class_Slice)
            --RVal_int(range->end);
        RVal_int(range->cur) = RVal_int(range->start);
range_end:
        key = PMC_data(key);
        if (key) {
            parrot_range_t *n = mem_sys_allocate(sizeof *range);
            range->next = n;
            range = n;
            goto next_range;
        }
        return;
    }
    else {
        if (PObj_get_FLAGS(key) & KEY_inf_slice_FLAG) {
            internal_exception(1, "unlimited slice range for hash not implemented");
        }
        range->type = enum_type_STRING;
        /*
         * string assumed
         * start at value
         */
        RVal_str(range->start) =
            RVal_str(range->cur) =
            key_string(interpreter, key);
        if ((PObj_get_FLAGS(key) &
                    (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) ==
                (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) {
            /* start == end */
            RVal_str(range->end) = RVal_str(range->start);
        }
        else {
            /* must have end in next key */
            key = PMC_data(key);
            if (!key)
                internal_exception(1, "no end range specified");
            RVal_str(range->end) = key_string(interpreter, key);
        }
        goto range_end;
    }
}

/*
 * increment Slice value according to range and/or advance to
 * next range PMC in Key chain
 */
static void
set_slice_next(Interp *interpreter, PMC *self, PMC *agg)
{
    parrot_range_t *r = PMC_struct_val(self);
    if (!r || (INTVAL) r == -1)
        real_exception(interpreter, NULL, E_StopIteration, "StopIteration");
    if (r->type == enum_type_INTVAL) {
        RVal_int(r->cur) += RVal_int(r->step);
        if (RVal_int(r->step) > 0) {
            if (RVal_int(r->cur) > RVal_int(r->end)) {
                parrot_range_t *n;
next_range:
                n = r->next;
                mem_sys_free(r);
                PMC_struct_val(self) = n;
                if (!n)
                    PMC_int_val(self) = -1;
            }
        }
        else {
            if (RVal_int(r->cur) < RVal_int(r->end)) {
                goto next_range;
            }
        }
    }
    else {
        STRING *cur = RVal_str(r->cur);
        STRING *end = RVal_str(r->end);
        if (string_compare(interpreter, cur, end) < 0)
            RVal_str(r->cur) = string_increment(interpreter, cur);
        else
            goto next_range;
    }
}

#line 195 "src/pmc/slice.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_slice.h"
#include "pmc_key.h"
#include "pmc_default.h"
#include "slice.str"

void
Parrot_Slice_init(Interp* interpreter, PMC* pmc)
#line 185 "src/pmc/slice.pmc"
{
    PMC_struct_val(pmc) = NULL;
    PMC_pmc_val(pmc) = NULL;

}
#line 212 "src/pmc/slice.c"


void
Parrot_Slice_init_pmc(Interp* interpreter, PMC* pmc, PMC* key)
#line 195 "src/pmc/slice.pmc"
{
    Parrot_Slice_init(interpreter, pmc);
    /* that's actually the KEY_number_FLAG - but I can't hardly
     * imagine that we get keyed by FLOATVAL slices on
     * arrays
     */
    PObj_get_FLAGS(pmc) |= PObj_private1_FLAG;
    PObj_custom_mark_destroy_SETALL(pmc);
    set_slice_start(interpreter, pmc, key, pmc);

}
#line 229 "src/pmc/slice.c"


void
Parrot_Slice_mark(Interp* interpreter, PMC* pmc)
#line 190 "src/pmc/slice.pmc"
{
    if (PMC_pmc_val(pmc))
        pobject_lives(interpreter, (PObj*) PMC_pmc_val(pmc));

}
#line 240 "src/pmc/slice.c"


void
Parrot_Slice_destroy(Interp* interpreter, PMC* pmc)
#line 206 "src/pmc/slice.pmc"
{
    parrot_range_t *r = PMC_struct_val(pmc), *n;
    /* iteration ended - all is freed */
    if ((INTVAL) r == -1)
        return;
    while (r) {
        n = r->next;
        mem_sys_free(r);
        r = n;
    }

}
#line 258 "src/pmc/slice.c"


PMC*
Parrot_Slice_clone(Interp* interpreter, PMC* pmc)
#line 218 "src/pmc/slice.pmc"
{
    real_exception(interpreter, NULL, E_NotImplementedError, "Unimplemented");
    return NULL;

}
#line 269 "src/pmc/slice.c"


INTVAL
Parrot_Slice_get_integer(Interp* interpreter, PMC* pmc)
#line 237 "src/pmc/slice.pmc"
{
    parrot_range_t *r = PMC_struct_val(pmc);
    if (!r || (INTVAL) r == -1)
        real_exception(interpreter, NULL, E_StopIteration, "StopIteration");
    return RVal_int(r->cur);

}
#line 282 "src/pmc/slice.c"


INTVAL
Parrot_Slice_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 290 "src/pmc/slice.pmc"
{
    parrot_range_t *r = PMC_struct_val(key);
    return RVal_int(r->cur);

}
#line 293 "src/pmc/slice.c"


STRING*
Parrot_Slice_get_string(Interp* interpreter, PMC* pmc)
#line 244 "src/pmc/slice.pmc"
{
    parrot_range_t *r = PMC_struct_val(pmc);
    return RVal_str(r->cur);

}
#line 304 "src/pmc/slice.c"


STRING*
Parrot_Slice_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 295 "src/pmc/slice.pmc"
{
    INTVAL v = VTABLE_get_integer(interpreter, key);
    return string_from_int(interpreter, v);

}
#line 315 "src/pmc/slice.c"


PMC*
Parrot_Slice_get_pmc_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 300 "src/pmc/slice.pmc"
{
    parrot_range_t *r = PMC_struct_val(key);
    PMC *res = PMC_pmc_val(pmc);
    PMC_int_val(res) = RVal_int(r->cur);
    return res;

}
#line 328 "src/pmc/slice.c"


PMC*
Parrot_Slice_slice(Interp* interpreter, PMC* pmc, PMC *key, INTVAL f)
#line 262 "src/pmc/slice.pmc"
{
    if (f) {
        real_exception(interpreter, NULL, E_ValueError,
                "Slice: Unknown slice type");
        return NULL;
    }
    else {
        PMC *iter = pmc_new_init(interpreter, enum_class_Iterator, pmc);
        PMC_struct_val(iter) = key;
        return iter;
    }

}
#line 347 "src/pmc/slice.c"


INTVAL
Parrot_Slice_elements(Interp* interpreter, PMC* pmc)
#line 281 "src/pmc/slice.pmc"
{
    parrot_range_t *r = PMC_struct_val(pmc);
    /* only start .. end supported so:
     * TODO check flags somewhere
     * */
    INTVAL n = RVal_int(r->start) - RVal_int(r->end);
    return n;

}
#line 362 "src/pmc/slice.c"


PMC*
Parrot_Slice_nextkey_keyed(Interp* interpreter, PMC* pmc, PMC* agg, INTVAL what)
#line 316 "src/pmc/slice.pmc"
{
    PMC *ret = pmc;

    switch (what) {
        case ITERATE_FROM_START:
        case ITERATE_FROM_START_KEYS:    /* reset key */
            if (!agg) {
                /* xrange implementation - the slice PMC
                 * itself serves as the aggregate. It's already
                 * initialized
                 */
                return pmc;
            }

            /*
             * need a new Slice PMC that hold's the state
             * especially PMC_data() must be zero
             *
             * aggregate call get_integer/get_string on this
             * PMC, because it's marked being a Key PMC
             */
            ret = pmc_new(interpreter, enum_class_Slice);
            PObj_get_FLAGS(ret) |= KEY_pmc_FLAG;
            /*
             * set start value
             */
            set_slice_start(interpreter, ret, pmc, agg);
            break;
            /*
             * we are passed now the new PMC, we had created above
             */
        case ITERATE_GET_NEXT:
            set_slice_next(interpreter, pmc, agg);
            break;
        default:
            real_exception(interpreter, NULL, E_NotImplementedError,
                    "No backward iteration on slices yet");
            break;
    }
    return ret;

}
#line 410 "src/pmc/slice.c"


PMC*
Parrot_Slice_get_iter(Interp* interpreter, PMC* pmc)
#line 275 "src/pmc/slice.pmc"
{
    PMC *iter = pmc_new_init(interpreter, enum_class_Iterator, pmc);
    PMC_struct_val(iter) = pmc;
    return iter;

}
#line 422 "src/pmc/slice.c"


void
Parrot_Slice_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Slice,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Slice_init,
        Parrot_Slice_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Slice_mark,
        Parrot_Slice_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Slice_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_Slice_get_integer,
        Parrot_Slice_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Slice_get_string,
        Parrot_default_get_repr,
        Parrot_Slice_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_get_bool,
        Parrot_Key_get_pmc,
        Parrot_Slice_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Slice_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Key_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Key_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Key_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_Key_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Slice_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_Key_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_Key_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_Slice_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Slice_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Key_freeze,
        Parrot_Key_thaw,
        Parrot_Key_thawfinish,
        Parrot_Key_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Slice");
        vt_clone->isa_str = CONST_STRING(interp, "Slice Key");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_Slice_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
