/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/string.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/string.pmc"
/*
Copyright: 2003 The Perl Foundation.  All Rights Reserved.
$Id: string.pmc 11892 2006-03-13 20:25:10Z leo $

=head1 NAME

src/pmc/string.pmc - String PMC Class

=head1 DESCRIPTION

C<String> extends C<scalar> to provide a string for languages
that want a C<string> type without going to an S register. Acts as a
wrapper for the functions in /src/string.c

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 37 "src/pmc/string.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_string.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "string.str"

void
Parrot_String_init(Interp* interpreter, PMC* pmc)
#line 37 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) =
        string_make_empty(interpreter, enum_stringrep_one, 0);
    PObj_custom_mark_SET(pmc);

}
#line 55 "src/pmc/string.c"


PMC*
Parrot_String_new_from_string(Interp* interpreter, PMC* pmc, STRING *rep, INTVAL flags)
#line 52 "src/pmc/string.pmc"
{
    INTVAL type;
    PMC *res;

    type = pmc->vtable->base_type;
    if (flags & PObj_constant_FLAG)
        res = constant_pmc_new(interpreter, type);
    else
        res = pmc_new(interpreter, type);
    PMC_str_val(res) = rep;
    return res;

}
#line 74 "src/pmc/string.c"


void
Parrot_String_mark(Interp* interpreter, PMC* pmc)
#line 75 "src/pmc/string.pmc"
{
    if(PMC_str_val(pmc))
        pobject_lives(interpreter, (PObj *)PMC_str_val(pmc));

}
#line 85 "src/pmc/string.c"


PMC*
Parrot_String_clone(Interp* interpreter, PMC* pmc)
#line 90 "src/pmc/string.pmc"
{
    PMC* dest = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    PObj_custom_mark_SET(dest);
    PMC_str_val(dest) = string_copy(interpreter,PMC_str_val(pmc));
    return dest;

}
#line 98 "src/pmc/string.c"


INTVAL
Parrot_String_get_integer(Interp* interpreter, PMC* pmc)
#line 107 "src/pmc/string.pmc"
{
    STRING *s = (STRING*) PMC_str_val(pmc);
    return string_to_int(interpreter, s);

}
#line 109 "src/pmc/string.c"


INTVAL
Parrot_String_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 615 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    return string_ord(interpreter, s, key_integer(interpreter, key));

}
#line 120 "src/pmc/string.c"


FLOATVAL
Parrot_String_get_number(Interp* interpreter, PMC* pmc)
#line 122 "src/pmc/string.pmc"
{
    STRING *s = (STRING*) PMC_str_val(pmc);
    return string_to_num(interpreter, s);

}
#line 131 "src/pmc/string.c"


PMC*
Parrot_String_get_bignum(Interp* interpreter, PMC* pmc)
#line 137 "src/pmc/string.pmc"
{
    STRING *s =  VTABLE_get_string(interpreter, pmc);
    PMC *ret = pmc_new(interpreter, enum_class_BigInt);
    VTABLE_set_string_native(interpreter, ret, s);
    return ret;

}
#line 144 "src/pmc/string.c"


STRING*
Parrot_String_get_string(Interp* interpreter, PMC* pmc)
#line 154 "src/pmc/string.pmc"
{
    return (STRING*) PMC_str_val(pmc);

}
#line 154 "src/pmc/string.c"


STRING*
Parrot_String_get_string_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 609 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    INTVAL k = key_integer(interpreter, key);
    return string_substr(interpreter, s, k, 1, NULL, 0);

}
#line 166 "src/pmc/string.c"


INTVAL
Parrot_String_get_bool(Interp* interpreter, PMC* pmc)
#line 168 "src/pmc/string.pmc"
{
    STRING *s = (STRING*) PMC_str_val(pmc);
    return string_bool(interpreter, s);

}
#line 177 "src/pmc/string.c"


PMC*
Parrot_String_slice(Interp* interpreter, PMC* pmc, PMC* key, INTVAL f)
#line 684 "src/pmc/string.pmc"
{
    switch (f) {
        case 0:
            {
                PMC *iter = pmc_new_init(interpreter,
                        enum_class_Iterator, pmc);
                PMC_struct_val(iter) = key;
                return iter;
            }
    }
    real_exception(interpreter, NULL, E_ValueError,
            "String: Unknown slice type");
    return NULL;

}
#line 198 "src/pmc/string.c"


void
Parrot_String_set_integer_native(Interp* interpreter, PMC* pmc, INTVAL value)
#line 185 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) = string_from_int(interpreter, value);

}
#line 208 "src/pmc/string.c"


void
Parrot_String_set_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key, INTVAL value)
#line 626 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *c = string_chr(interpreter, (UINTVAL) value);
    string_replace(interpreter, s, key_integer(interpreter, key), 1, c, NULL);

}
#line 220 "src/pmc/string.c"


void
Parrot_String_set_number_native(Interp* interpreter, PMC* pmc, FLOATVAL value)
#line 203 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) = string_from_num(interpreter, value);

}
#line 230 "src/pmc/string.c"


void
Parrot_String_set_string_native(Interp* interpreter, PMC* pmc, STRING* value)
#line 218 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) = value;

}
#line 240 "src/pmc/string.c"


void
Parrot_String_assign_string_native(Interp* interpreter, PMC* pmc, STRING* value)
#line 232 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) =
        string_set(interpreter, PMC_str_val(pmc), value);

}
#line 251 "src/pmc/string.c"


void
Parrot_String_set_string_same(Interp* interpreter, PMC* pmc, PMC* value)
#line 248 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) =
        string_set(interpreter, PMC_str_val(pmc), PMC_str_val(value));

}
#line 262 "src/pmc/string.c"


void
Parrot_String_set_string_keyed(Interp* interpreter, PMC* pmc, PMC* key, STRING *value)
#line 620 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    INTVAL len = string_length(interpreter, value);
    string_replace(interpreter, s, key_integer(interpreter, key), len, value, NULL);

}
#line 274 "src/pmc/string.c"


void
Parrot_String_set_bool(Interp* interpreter, PMC* pmc, INTVAL value)
#line 189 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) = string_from_int(interpreter, value);

}
#line 284 "src/pmc/string.c"


void
Parrot_String_set_pmc(Interp* interpreter, PMC* pmc, PMC* value)
#line 263 "src/pmc/string.pmc"
{
    PMC_str_val(pmc) = VTABLE_get_string(interpreter, value);

}
#line 294 "src/pmc/string.c"


INTVAL
Parrot_String_elements(Interp* interpreter, PMC* pmc)
#line 680 "src/pmc/string.pmc"
{
    return string_length(interpreter, PMC_str_val(pmc));

}
#line 304 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_ors(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 306 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_or(interpreter, s, v, NULL));
    return dest;

}
#line 320 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_ors_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
#line 316 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_or(interpreter, s, value, NULL));
    return dest;

}
#line 335 "src/pmc/string.c"


void
Parrot_String_i_bitwise_ors(Interp* interpreter, PMC* pmc, PMC* value)
#line 325 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
     VTABLE_set_string_native(interpreter, pmc, string_bitwise_or(interpreter, s, v, &s));

}
#line 347 "src/pmc/string.c"


void
Parrot_String_i_bitwise_ors_str(Interp* interpreter, PMC* pmc, STRING* value)
#line 331 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
     VTABLE_set_string_native(interpreter, pmc, string_bitwise_or(interpreter, s, value, &s));

}
#line 358 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_ands(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 336 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_and(interpreter, s, v, NULL));
    return dest;

}
#line 374 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_ands_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
#line 346 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_and(interpreter, s, value, NULL));
    return dest;

}
#line 389 "src/pmc/string.c"


void
Parrot_String_i_bitwise_ands(Interp* interpreter, PMC* pmc, PMC* value)
#line 356 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
     VTABLE_set_string_native(interpreter, pmc, string_bitwise_and(interpreter, s, v, &s));

}
#line 401 "src/pmc/string.c"


void
Parrot_String_i_bitwise_ands_str(Interp* interpreter, PMC* pmc, STRING* value)
#line 362 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
     VTABLE_set_string_native(interpreter, pmc, string_bitwise_and(interpreter, s, value, &s));

}
#line 412 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_xors(Interp* interpreter, PMC* pmc, PMC* value, PMC* dest)
#line 367 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_xor(interpreter, s, v, NULL));
    return dest;

}
#line 428 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_xors_str(Interp* interpreter, PMC* pmc, STRING* value, PMC* dest)
#line 377 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_xor(interpreter, s, value, NULL));
    return dest;

}
#line 443 "src/pmc/string.c"


void
Parrot_String_i_bitwise_xors(Interp* interpreter, PMC* pmc, PMC* value)
#line 386 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
     VTABLE_set_string_native(interpreter, pmc, string_bitwise_xor(interpreter, s, v, &s));

}
#line 455 "src/pmc/string.c"


void
Parrot_String_i_bitwise_xors_str(Interp* interpreter, PMC* pmc, STRING* value)
#line 392 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
     VTABLE_set_string_native(interpreter, pmc, string_bitwise_xor(interpreter, s, value, &s));

}
#line 466 "src/pmc/string.c"


PMC*
Parrot_String_bitwise_nots(Interp* interpreter, PMC* pmc, PMC* dest)
#line 397 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    if (!dest)
        dest = pmc_new(interpreter, pmc->vtable->base_type);
    VTABLE_set_string_native(
        interpreter, dest, string_bitwise_not(interpreter, s, NULL));
    return dest;

}
#line 481 "src/pmc/string.c"


void
Parrot_String_i_bitwise_nots(Interp* interpreter, PMC* pmc)
#line 406 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    VTABLE_set_string_native(
        interpreter, pmc, string_bitwise_not(interpreter, s, &s));

}
#line 493 "src/pmc/string.c"


INTVAL
Parrot_String_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 422 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    return (INTVAL)(0 == string_equal(interpreter, s, v));

}
#line 505 "src/pmc/string.c"


INTVAL
Parrot_String_is_equal_num(Interp* interpreter, PMC* pmc, PMC* value)
#line 439 "src/pmc/string.pmc"
{
    FLOATVAL sf = string_to_num(interpreter, PMC_str_val(pmc));
    FLOATVAL vf = VTABLE_get_number(interpreter, value);
    return (INTVAL)(sf == vf);

}
#line 517 "src/pmc/string.c"


INTVAL
Parrot_String_is_equal_string(Interp* interpreter, PMC* pmc, PMC* value)
#line 455 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    return string_equal(interpreter, s, v) == 0;

}
#line 529 "src/pmc/string.c"


INTVAL
Parrot_String_is_same(Interp* interpreter, PMC* pmc, PMC* value)
#line 474 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = PMC_str_val(value);
    return (INTVAL)(
            value->vtable == pmc->vtable &&
            s == v
        );

}
#line 544 "src/pmc/string.c"


INTVAL
Parrot_String_cmp(Interp* interpreter, PMC* pmc, PMC* value)
#line 494 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    return string_compare(interpreter, s, v);

}
#line 556 "src/pmc/string.c"


INTVAL
Parrot_String_cmp_num(Interp* interpreter, PMC* pmc, PMC* value)
#line 511 "src/pmc/string.pmc"
{
    FLOATVAL sf = string_to_num(interpreter, PMC_str_val(pmc));
    FLOATVAL vf = VTABLE_get_number(interpreter, value);
    if(sf < vf)
        return (INTVAL)(-1);
    if(sf > vf)
        return (INTVAL)(1);
    return (INTVAL)(0);

}
#line 572 "src/pmc/string.c"


INTVAL
Parrot_String_cmp_string(Interp* interpreter, PMC* pmc, PMC* value)
#line 532 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *v = VTABLE_get_string(interpreter, value);
    return string_compare(interpreter, s, v);

}
#line 584 "src/pmc/string.c"


void
Parrot_String_substr(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
#line 548 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    STRING *s2 = string_substr(interpreter, s, offset, length, NULL, 0);
    VTABLE_set_string_native(interpreter, dest, s2);

}
#line 596 "src/pmc/string.c"


STRING*
Parrot_String_substr_str(Interp* interpreter, PMC* pmc, INTVAL offset, INTVAL length)
#line 564 "src/pmc/string.pmc"
{
    STRING *s = PMC_str_val(pmc);
    return string_substr(interpreter, s, offset, length, NULL, 0);

}
#line 607 "src/pmc/string.c"


INTVAL
Parrot_String_exists_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 580 "src/pmc/string.pmc"
{
    INTVAL n = string_length(interpreter, PMC_str_val(pmc));
    INTVAL k = VTABLE_get_integer(interpreter, key);
    return (INTVAL)( (k>=0 && k<=n) || (k<0 && -k<=n) );

}
#line 619 "src/pmc/string.c"


PMC*
Parrot_String_get_iter(Interp* interpreter, PMC* pmc)
#line 699 "src/pmc/string.pmc"
{
    PMC *iter = pmc_new_init(interpreter, enum_class_Iterator, pmc);
    PMC *key =  pmc_new(interpreter, enum_class_Key);
    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;
    PMC_int_val(key) = 0;
    if (!string_length(interpreter, PMC_str_val(pmc)))
        PMC_int_val(key) = -1;
    return iter;

}
#line 636 "src/pmc/string.c"


void
Parrot_String_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 725 "src/pmc/string.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_freeze(interpreter, pmc, info);
     VTABLE_push_string(interpreter, io, PMC_str_val(pmc));

}
#line 648 "src/pmc/string.c"


void
Parrot_String_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 740 "src/pmc/string.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        PMC_str_val(pmc) =  VTABLE_shift_string(interpreter, io);

}
#line 661 "src/pmc/string.c"


void
Parrot_String_replace(Interp* interpreter, PMC* pmc, STRING* orig, STRING* new)
#line 641 "src/pmc/string.pmc"
{
    INTVAL i  = 0;
    STRING *s = PMC_str_val(pmc);
    INTVAL old_len = string_length(interpreter, orig);
    INTVAL new_len = string_length(interpreter, new);
    
    while (-1 != (i = string_str_index(interpreter, s, orig, i))) {
        (void)string_replace(interpreter, s, i, old_len, new, NULL);
        i += new_len;
    }

}
#line 679 "src/pmc/string.c"


PMC*
Parrot_String_lower(Interp* interpreter, PMC* pmc)
#line 762 "src/pmc/string.pmc"
{
    STRING *s = string_downcase(interpreter, PMC_str_val(pmc));
    PMC *ret = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    PMC_str_val(ret) = s;
    PObj_custom_mark_SET(ret);
    return ret;

}
#line 693 "src/pmc/string.c"


void
Parrot_String_trans(Interp* interpreter, PMC* pmc, STRING* src, PMC* table)
#line 780 "src/pmc/string.pmc"
{
    INTVAL i, len;
    unsigned char *p, ch;
    INTVAL *tr_data;

    len = string_length(interpreter, src);
    if (!len)
        return;
    if (src->charset != Parrot_ascii_charset_ptr)
        real_exception(interpreter, NULL, INVALID_ENCODING,
            "Can't translate non-ascii"); 
    p = src->strstart;
    /* TODO verify trans table */
    tr_data = PMC_data(table);    /* XXX */
    for (i = 0; i < len; ++i, ++p) {
        ch = *p;
        ch = (unsigned char)tr_data[ch];
        if (ch)
            *p = ch;
    }

}
#line 721 "src/pmc/string.c"


void
Parrot_String_reverse(Interp* interpreter, PMC* pmc, STRING* src)
#line 812 "src/pmc/string.pmc"
{
    INTVAL i, len;
    unsigned char *p, ch;

    len = string_length(interpreter, src);
    if (!len)
        return;
    if (src->charset != Parrot_ascii_charset_ptr)
        real_exception(interpreter, NULL, INVALID_ENCODING,
            "Can't reverse non-ascii"); 
    p = src->strstart;
    for (i = 0, --len; i < len; ++i, --len) {
        ch = p[len];
        p[len] = p[i];
        p[i] = ch;
    }

}
#line 745 "src/pmc/string.c"


INTVAL
Parrot_String_is_integer(Interp* interpreter, PMC* pmc, STRING* src)
#line 842 "src/pmc/string.pmc"
{
    INTVAL i, len;
    unsigned char *p;

    len = string_length(interpreter, src);
    if (!len)
        return (INTVAL)(0);
    if (src->charset != Parrot_ascii_charset_ptr)
        real_exception(interpreter, NULL, INVALID_ENCODING,
            "Can't is_integer non-ascii"); 

    i = 0;
    p = src->strstart;

    if (p[i] == '-' || p[i] == '+' ||
        (p[i] >= '0' && p[i] <= '9')) {
        for (i = 1; i < len; ++i)
            if (p[i] < '0' || p[i] > '9')
                return (INTVAL)(0);
        return (INTVAL)(1);
    }
    else
        return (INTVAL)(0);

}
#line 776 "src/pmc/string.c"


void
Parrot_String_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_String,	/* base_type */
        NULL,	/* whoami */
        0, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_String_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_String_new_from_string,
        Parrot_scalar_morph,
        Parrot_String_mark,
        Parrot_default_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_String_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_String_get_integer,
        Parrot_String_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_String_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_String_get_bignum,
        Parrot_String_get_string,
        Parrot_default_get_repr,
        Parrot_String_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_String_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_String_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_String_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_String_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_String_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_String_set_string_native,
        Parrot_String_assign_string_native,
        Parrot_String_set_string_same,
        Parrot_String_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_String_set_bool,
        Parrot_String_set_pmc,
        Parrot_scalar_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_String_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_scalar_neg,
        Parrot_scalar_i_neg,
        Parrot_scalar_bitwise_not,
        Parrot_scalar_i_bitwise_not,
        Parrot_String_bitwise_nots,
        Parrot_String_i_bitwise_nots,
        Parrot_String_is_same,
        Parrot_scalar_logical_not,
        Parrot_scalar_i_logical_not,
        Parrot_String_substr,
        Parrot_String_substr_str,
        Parrot_String_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_String_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_String_freeze,
        Parrot_String_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_add_Complex },
        { MMD_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_add },
        { MMD_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_add_int },
        { MMD_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_add_float },
        { MMD_I_ADD, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_add },
        { MMD_I_ADD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_add_float },
        { MMD_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_subtract },
        { MMD_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_subtract_int },
        { MMD_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_subtract_float },
        { MMD_I_SUBTRACT, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_multiply },
        { MMD_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_multiply_int },
        { MMD_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_multiply_float },
        { MMD_I_MULTIPLY, 0, enum_class_Complex,
                    (funcptr_t) Parrot_scalar_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_divide },
        { MMD_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_divide_int },
        { MMD_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_divide_float },
        { MMD_I_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_divide },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_divide_float },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_floor_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_floor_divide_float },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_floor_divide_float },
        { MMD_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_modulus },
        { MMD_MOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_modulus_int },
        { MMD_MOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_modulus_float },
        { MMD_I_MOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_modulus },
        { MMD_I_MOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_modulus_int },
        { MMD_I_MOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_modulus_float },
        { MMD_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_cmodulus },
        { MMD_CMOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_cmodulus_float },
        { MMD_I_CMOD, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_cmodulus },
        { MMD_I_CMOD, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_cmodulus_int },
        { MMD_I_CMOD, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_cmodulus_float },
        { MMD_POW, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_pow },
        { MMD_POW, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_pow_int },
        { MMD_POW, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_pow_float },
        { MMD_I_POW, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_pow },
        { MMD_I_POW, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_pow_int },
        { MMD_I_POW, 0, enum_type_FLOATVAL,
                    (funcptr_t) Parrot_scalar_i_pow_float },
        { MMD_BOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_or },
        { MMD_BOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_or_int },
        { MMD_I_BOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_or },
        { MMD_I_BOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_or_int },
        { MMD_BAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_and },
        { MMD_BAND, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_and_int },
        { MMD_I_BAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_and },
        { MMD_I_BAND, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_and_int },
        { MMD_BXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_xor },
        { MMD_BXOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_xor_int },
        { MMD_I_BXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_xor },
        { MMD_I_BXOR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_xor_int },
        { MMD_SOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_bitwise_ors },
        { MMD_SOR, 0, enum_type_STRING,
                    (funcptr_t) Parrot_String_bitwise_ors_str },
        { MMD_I_SOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_i_bitwise_ors },
        { MMD_I_SOR, 0, enum_type_STRING,
                    (funcptr_t) Parrot_String_i_bitwise_ors_str },
        { MMD_SAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_bitwise_ands },
        { MMD_SAND, 0, enum_type_STRING,
                    (funcptr_t) Parrot_String_bitwise_ands_str },
        { MMD_I_SAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_i_bitwise_ands },
        { MMD_I_SAND, 0, enum_type_STRING,
                    (funcptr_t) Parrot_String_i_bitwise_ands_str },
        { MMD_SXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_bitwise_xors },
        { MMD_SXOR, 0, enum_type_STRING,
                    (funcptr_t) Parrot_String_bitwise_xors_str },
        { MMD_I_SXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_i_bitwise_xors },
        { MMD_I_SXOR, 0, enum_type_STRING,
                    (funcptr_t) Parrot_String_i_bitwise_xors_str },
        { MMD_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_shl },
        { MMD_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_shr },
        { MMD_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_shr_int },
        { MMD_LSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_bitwise_lsr },
        { MMD_LSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_bitwise_lsr_int },
        { MMD_I_LSR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_bitwise_lsr },
        { MMD_I_LSR, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_bitwise_lsr_int },
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_is_equal },
        { MMD_NUMEQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_is_equal_num },
        { MMD_STREQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_is_equal_string },
        { MMD_CMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_cmp },
        { MMD_NUMCMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_cmp_num },
        { MMD_STRCMP, 0, enum_type_PMC,
                    (funcptr_t) Parrot_String_cmp_string },
        { MMD_LOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_or },
        { MMD_LAND, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_and },
        { MMD_LXOR, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_logical_xor },
        { MMD_CONCAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_concatenate },
        { MMD_CONCAT, 0, enum_type_STRING,
                    (funcptr_t) Parrot_scalar_concatenate_str },
        { MMD_I_CONCAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_concatenate },
        { MMD_I_CONCAT, 0, enum_type_STRING,
                    (funcptr_t) Parrot_scalar_i_concatenate_str },
        { MMD_REPEAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_repeat },
        { MMD_REPEAT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_repeat_int },
        { MMD_I_REPEAT, 0, enum_type_PMC,
                    (funcptr_t) Parrot_scalar_i_repeat },
        { MMD_I_REPEAT, 0, enum_type_INTVAL,
                    (funcptr_t) Parrot_scalar_i_repeat_int }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "String");
        vt_clone->isa_str = CONST_STRING(interp, "String scalar");
        vt_clone->does_str = CONST_STRING(interp, "scalar string");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_String_replace),
                "replace", "vJOSS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_String_lower),
                "lower", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_String_trans),
                "trans", "vJOSP");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_String_reverse),
                "reverse", "vJOS");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_String_is_integer),
                "is_integer", "IJOS");
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_String_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/

