/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/sub.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/sub.pmc"
/*
Copyright: 2001-2006 The Perl Foundation.  All Rights Reserved.
$Id: sub.pmc 12596 2006-05-10 11:46:33Z leo $

=head1 NAME

src/pmc/sub.pmc - Subroutine

=head1 DESCRIPTION

These are the vtable functions for the Sub (subroutine) base class

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"
#include "sub.str"
#include <assert.h>

static void
print_sub_name(Interp* interpreter, PMC* sub)
{
    Interp * const tracer =
        interpreter->debugger ? interpreter->debugger : interpreter;

        /* sub was located via globals */
    PIO_eprintf(tracer, "# Calling sub '%Ss'\n# ",
        Parrot_full_sub_name(interpreter, sub));
    print_pbc_location(interpreter);
}

/*
 * A sub now contains more data like namespace, which makes it
 * effectively a container. Therefore need_ext has to be set
 */
#line 54 "src/pmc/sub.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "sub.str"

void
Parrot_Sub_init(Interp* interpreter, PMC* pmc)
#line 72 "src/pmc/sub.pmc"
{
    PMC_struct_val(pmc) = new_sub(interpreter);
    PMC_pmc_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
#if 0
    if (Interp_flags_TEST(interpreter, PARROT_DEBUG_FLAG))
        printf("Address of base segment is %p\n",
            ((struct Parrot_sub *)PMC_sub(pmc))->seg->base.pf->base.data);
#endif

}
#line 76 "src/pmc/sub.c"


void
Parrot_Sub_mark(Interp* interpreter, PMC* pmc)
#line 362 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    if (!sub)
        return;
    if (sub->name)
        pobject_lives(interpreter, (PObj *) sub->name);
    if (!PMC_IS_NULL(sub->namespace))
        pobject_lives(interpreter, (PObj *) sub->namespace);
    if (!PMC_IS_NULL(sub->multi_signature))
        pobject_lives(interpreter, (PObj *) sub->multi_signature);
    if (!PMC_IS_NULL(sub->eval_pmc))
        pobject_lives(interpreter, (PObj *) sub->eval_pmc);

}
#line 96 "src/pmc/sub.c"


void
Parrot_Sub_destroy(Interp* interpreter, PMC* pmc)
#line 93 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    if (!sub)
        return;
#if 0
    {
        STRING *n = Parrot_full_sub_name(interpreter, pmc);
        fprintf(stderr, "DESTROY sub %p %s\n", pmc,
                n && n->strstart ? (char*)n->strstart : "???");
    }
#endif
    mem_sys_free(sub);
    PMC_struct_val(pmc) = NULL;

}
#line 117 "src/pmc/sub.c"


PMC*
Parrot_Sub_clone(Interp* interpreter, PMC* pmc)
#line 336 "src/pmc/sub.pmc"
{
    struct Parrot_sub * sub;
    PMC* const ret = pmc_new_noinit(interpreter, pmc->vtable->base_type);
    /*
     * we have to mark it ourselves
     */
    PObj_custom_mark_destroy_SETALL(ret);
    sub = mem_sys_allocate(sizeof(struct Parrot_sub));
    /* first set the sub struct, string_copy may cause GC */
    PMC_struct_val(ret) = sub;
    PMC_pmc_val(ret) = NULL;
    memcpy(sub, PMC_sub(pmc), sizeof(struct Parrot_sub));
    sub->name = string_copy(interpreter, sub->name);
    return ret;

}
#line 139 "src/pmc/sub.c"


INTVAL
Parrot_Sub_get_integer_keyed(Interp* interpreter, PMC* pmc, PMC* key)
#line 176 "src/pmc/sub.pmc"
{
    return (INTVAL) ((PMC_sub(pmc))->seg->base.data);

}
#line 149 "src/pmc/sub.c"


STRING*
Parrot_Sub_get_string(Interp* interpreter, PMC* pmc)
#line 122 "src/pmc/sub.pmc"
{
    return Parrot_full_sub_name(interpreter, pmc);

}
#line 159 "src/pmc/sub.c"


INTVAL
Parrot_Sub_get_bool(Interp* interpreter, PMC* pmc)
#line 197 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    return 1;

}
#line 170 "src/pmc/sub.c"


void*
Parrot_Sub_get_pointer(Interp* interpreter, PMC* pmc)
#line 159 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->seg->base.data + sub->start_offs;

}
#line 181 "src/pmc/sub.c"


void
Parrot_Sub_set_string_native(Interp* interpreter, PMC* pmc, STRING *subname)
#line 126 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    sub->name = string_copy(interpreter, subname);

}
#line 192 "src/pmc/sub.c"


void
Parrot_Sub_set_pointer(Interp* interpreter, PMC* pmc, void* value)
#line 143 "src/pmc/sub.pmc"
{
    real_exception(interpreter, NULL, E_NotImplementedError,
            "Don't set the address of a sub\n"
            "use .Sub constants instead");

}
#line 204 "src/pmc/sub.c"


INTVAL
Parrot_Sub_is_equal(Interp* interpreter, PMC* pmc, PMC* value)
#line 399 "src/pmc/sub.pmc"
{
    return pmc->vtable == value->vtable &&
        (PMC_sub(pmc))->start_offs == (PMC_sub(value))->start_offs &&
        (PMC_sub(pmc))->seg == (PMC_sub(value))->seg;

}
#line 216 "src/pmc/sub.c"


INTVAL
Parrot_Sub_defined(Interp* interpreter, PMC* pmc)
#line 192 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    return 1;

}
#line 227 "src/pmc/sub.c"


void*
Parrot_Sub_invoke(Interp* interpreter, PMC* pmc, void* next)
#line 212 "src/pmc/sub.pmc"
{
    struct Parrot_sub * sub = PMC_sub(pmc);
    parrot_context_t *caller_ctx;
    struct Parrot_Context *context;
    PMC *ccont;
    opcode_t *pc;

    if (Interp_trace_TEST(interpreter, PARROT_TRACE_SUB_CALL_FLAG)) {
        print_sub_name(interpreter, pmc);
    }
    /*
     * A remark WRT tail calls
     *
     * we have:
     * sub A:
     *    ...
     *    B()
     *    ...
     * sub B:
     *    ...
     *    .return C(...)
     *
     * that is the sub B() returns whatever C() returns.
     *
     * We are just calling the sub C().
     * If the private2 flag is set, this code is called by a
     * tailcall opcode.
     *
     * We allocate a new register frame and recycle it
     * immediately after argument passing.
     *
     */
    pc = sub->seg->base.data + sub->start_offs;
    caller_ctx = CONTEXT(interpreter->ctx);
    ccont = interpreter->current_cont;
    interpreter->current_cont = NULL;
    if (ccont == NEED_CONTINUATION) {
        ccont = new_ret_continuation_pmc(interpreter, next);
    }

    assert (!PMC_IS_NULL(ccont));
    /*
     * plain subroutine call
     * create new context, place it in interpreter
     */
#define PREMATURE_OPT 
#ifdef PREMATURE_OPT 
    if (caller_ctx->current_sub == pmc)
        context = Parrot_dup_context(interpreter, caller_ctx);
    else 
#endif
        context = Parrot_alloc_context(interpreter, sub->n_regs_used);
    context->current_sub = pmc;
    context->caller_ctx = caller_ctx;
    context->current_pc = pc;
    context->current_cont = ccont;
    /* check recursion/call depth */
    if (++context->recursion_depth >
            interpreter->recursion_limit) {
        real_exception(interpreter, next, E_RuntimeError,
                "maximum recursion depth exceeded");
    }
    /*
     * and copy set context variables
     */
    PMC_cont(ccont)->from_ctx = context;
    /*
     * set context of the sub
     */
    sub->ctx = context;
    if (PObj_get_FLAGS(pmc) & SUB_FLAG_IS_OUTER) {
        /* don't destroy context */
        ccont->vtable = interpreter->vtables[enum_class_Continuation];
        context->ref_count++;
    }

    if (!PMC_IS_NULL(interpreter->current_object)) {
        context->current_object = interpreter->current_object;
        interpreter->current_object = NULL;
        context->current_method = interpreter->current_method;
        interpreter->current_method = NULL;
    }
    context->current_HLL = sub->HLL_id;
    context->current_namespace = sub->namespace_stash;

    /* create pad if needed
     * TODO move this up in front of argument passing
     *      and factor out common code with coroutine pmc
     */
    if (!PMC_IS_NULL(sub->lex_info)) {
        context->lex_pad = pmc_new_init(interpreter,
                Parrot_get_ctx_HLL_type(interpreter,
                    enum_class_LexPad),
                sub->lex_info);
        VTABLE_set_pointer(interpreter, context->lex_pad, context);
    }
    /* switch code segment if needed */
    if (interpreter->code != sub->seg) {
        Parrot_switch_to_cs(interpreter, sub->seg, 1);
    }
    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        if (!(*pc == PARROT_OP_get_params_pc ||
                    (*pc == PARROT_OP_push_eh_ic &&
                     pc[2] == PARROT_OP_get_params_pc))) {
            /* TODO keep it or resize it */
            --context->recursion_depth;
            PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
            context->caller_ctx = caller_ctx->caller_ctx;
            Parrot_free_context(interpreter, caller_ctx, 1);
        }
    }
    return pc;

}
#line 347 "src/pmc/sub.c"


void
Parrot_Sub_freeze(Interp* interpreter, PMC* pmc, visit_info *info)
#line 441 "src/pmc/sub.pmc"
{
    IMAGE_IO * const io = info->image_io;
    struct Parrot_sub * const sub = PMC_sub(pmc);
    int i;

    Parrot_default_freeze(interpreter, pmc, info);
    /*
     * we currently need to write these items:
     * - start offset in byte-code segment
     * - end   offset in byte-code segment
     * - segment TODO ???
     * - flags  (i.e. :load pragma and such)
     * - name of the sub's label
     * - namespace
     * - HLL_id
     * - multi_signature
     * - n_regs_used[i]
     * - lex_info
     */

     VTABLE_push_integer(interpreter, io, (INTVAL) sub->start_offs);
     VTABLE_push_integer(interpreter, io, (INTVAL) sub->end_offs);
     VTABLE_push_integer(interpreter, io,
            PObj_get_FLAGS(pmc) & SUB_FLAG_PF_MASK);
     VTABLE_push_string(interpreter, io, sub->name);
     VTABLE_push_integer(interpreter, io, sub->HLL_id);
    for (i = 0; i < 4; ++i)
         VTABLE_push_integer(interpreter, io, sub->n_regs_used[i]);

}
#line 383 "src/pmc/sub.c"


void
Parrot_Sub_thaw(Interp* interpreter, PMC* pmc, visit_info *info)
#line 481 "src/pmc/sub.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interpreter, pmc, info);

    if (info->extra_flags == EXTRA_IS_NULL) {
        struct Parrot_sub * const sub = PMC_sub(pmc);
        INTVAL flags;
        int i;
        /*
         * we get relative offsets
         */
        sub->start_offs = (size_t)  VTABLE_shift_integer(interpreter, io);
        sub->end_offs   = (size_t)  VTABLE_shift_integer(interpreter, io);
        flags =  VTABLE_shift_integer(interpreter, io);
        PObj_get_FLAGS(pmc) |= flags & SUB_FLAG_PF_MASK;
        sub->name =  VTABLE_shift_string(interpreter, io);
        sub->HLL_id  =  VTABLE_shift_integer(interpreter, io);
        for (i = 0; i < 4; ++i)
            sub->n_regs_used[i] =  VTABLE_shift_integer(interpreter, io);
    }

}
#line 411 "src/pmc/sub.c"


void
Parrot_Sub_visit(Interp* interpreter, PMC* pmc, visit_info *info)
#line 419 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);

    info->thaw_ptr = &sub->namespace;
    (info->visit_pmc_now)(interpreter, sub->namespace, info);
    info->thaw_ptr = &sub->multi_signature;
    (info->visit_pmc_now)(interpreter, sub->multi_signature, info);
    info->thaw_ptr = &sub->outer_sub;
    (info->visit_pmc_now)(interpreter, sub->outer_sub, info);
    /*
     * XXX visit_pmc_now is wrong, because it breaks
     *     depth-first visit inside the todo list
     * TODO change all user visit functions to use
     *    visit_pmc (the todo renamed visit_pm_later)
     *
     * Therefore the hash must be last during visit for now.   
     */    
    info->thaw_ptr = &sub->lex_info;
    (info->visit_pmc_now)(interpreter, sub->lex_info, info);
    Parrot_default_visit(interpreter, pmc, info);

}
#line 439 "src/pmc/sub.c"


PMC*
Parrot_Sub_get_namespace(Interp* interpreter, PMC* pmc)
#line 534 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);

    return sub->namespace_stash;

}
#line 451 "src/pmc/sub.c"


INTVAL
Parrot_Sub___get_regs_used(Interp* interpreter, PMC* pmc, char *kind)
#line 540 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    /* TODO switch to canonical NiSP order
     * see also imcc/reg_alloc.c
     */
    static const char types[] = "INSP";
    char *p;

    assert(sub->n_regs_used);
    if (!*kind || kind[1])
        real_exception(interpreter, NULL, E_ValueError,
            "illegal register kind '%s'", kind);
    p = strchr(types, *kind);
    if (!p)
        real_exception(interpreter, NULL, E_ValueError,
            "illegal register kind '%s'", kind);
    return sub->n_regs_used[p - types];

}
#line 476 "src/pmc/sub.c"


PMC*
Parrot_Sub_get_lexinfo(Interp* interpreter, PMC* pmc)
#line 559 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->lex_info ? sub->lex_info : PMCNULL;

}
#line 487 "src/pmc/sub.c"


PMC*
Parrot_Sub_get_outer(Interp* interpreter, PMC* pmc)
#line 564 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->outer_sub ? sub->outer_sub : PMCNULL;

}
#line 498 "src/pmc/sub.c"


PMC*
Parrot_Sub_get_multisig(Interp* interpreter, PMC* pmc)
#line 569 "src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->multi_signature ? sub->multi_signature : PMCNULL;

}
#line 509 "src/pmc/sub.c"


void
Parrot_Sub_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_Sub,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_Sub_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_Sub_mark,
        Parrot_Sub_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_Sub_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_Sub_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Sub_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_default_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_default_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_Sub_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_Sub_freeze,
        Parrot_Sub_thaw,
        Parrot_default_thawfinish,
        Parrot_Sub_visit,
        Parrot_default_share
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC,
                    (funcptr_t) Parrot_Sub_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
	which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "Sub");
        vt_clone->isa_str = CONST_STRING(interp, "Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_get_namespace),
                "get_namespace", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Sub___get_regs_used),
                "__get_regs_used", "IJOt");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_get_lexinfo),
                "get_lexinfo", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_get_outer),
                "get_outer", "PJO");
        enter_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_get_multisig),
                "get_multisig", "PJO");
        /* class_init */
    
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
        Parrot_mmd_register_table(interp, entry,
            _temp_mmd_init, N_MMD_INIT);
    } /* pass */
} /* Parrot_Sub_class_init */


/*

=back

=head1 HISTORY

Initial version by Melvin on 2002/06/06.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
