/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'src/pmc/tqueue.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "src/pmc/tqueue.pmc"
/*
Copyright: 2001-2003 The Perl Foundation.  All Rights Reserved.
$Id: tqueue.pmc 11248 2006-01-18 20:02:15Z bernhard $

=head1 NAME

src/pmc/tqueue.pmc - Threadsafe Queue

=head1 DESCRIPTION

Threadsafe queue class for inter thread communication. If you have an
unthreaded program then please use a PerlArray.

     new P0, .TQueue
     push P0, some
     new P2, .ParrotThread
     ...

and in other thread (at least, when shared PMCs work :)

     shift P1, P0

Note: The TQueue must always be emptied before program exit.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

#line 48 "src/pmc/tqueue.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_tqueue.h"
#include "pmc_default.h"
#include "tqueue.str"

void
Parrot_TQueue_init(Interp* interpreter, PMC* pmc)
#line 48 "src/pmc/tqueue.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = queue_init(0);
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 65 "src/pmc/tqueue.c"


void
Parrot_TQueue_mark(Interp* interpreter, PMC* pmc)
#line 79 "src/pmc/tqueue.pmc"
{
    QUEUE *queue = PMC_data(pmc);
    QUEUE_ENTRY *entry;

    queue_lock(queue);
    entry = queue->head;
    while (entry) {
        pobject_lives(interpreter, (PObj*) entry->data);
        if (entry == queue->tail)
            break;
        entry = entry->next;
    }
    queue_unlock(queue);

}
#line 86 "src/pmc/tqueue.c"


void
Parrot_TQueue_destroy(Interp* interpreter, PMC* pmc)
#line 104 "src/pmc/tqueue.pmc"
{
    if (PMC_data(pmc)) {
        QUEUE *queue = PMC_data(pmc);
#if 0
        /*
         * wait til queue is empty
         * XXX implement a time wait and PANIC if queue
         * isn't empty after some TIMEOUT
         */
        while (Parrot_TQueue_elements(interpreter, pmc)) {
            queue_lock(queue);
            queue_wait(queue);
            queue_unlock(queue);
        }
#endif
        mem_sys_free(queue);
        PMC_data(pmc) = NULL;
    }

}
#line 112 "src/pmc/tqueue.c"


PMC*
Parrot_TQueue_clone(Interp* interpreter, PMC* pmc)
#line 64 "src/pmc/tqueue.pmc"
{
    /* XXX fake a shared PMC */
    return pmc;

}
#line 123 "src/pmc/tqueue.c"


INTVAL
Parrot_TQueue_get_integer(Interp* interpreter, PMC* pmc)
#line 146 "src/pmc/tqueue.pmc"
{
    INTVAL items;
    QUEUE *queue = PMC_data(pmc);

    items = PMC_int_val(pmc);
    return items;

}
#line 137 "src/pmc/tqueue.c"


INTVAL
Parrot_TQueue_elements(Interp* interpreter, PMC* pmc)
#line 164 "src/pmc/tqueue.pmc"
{
    return Parrot_TQueue_get_integer(interpreter, pmc);

}
#line 147 "src/pmc/tqueue.c"


void
Parrot_TQueue_push_pmc(Interp* interpreter, PMC* pmc, PMC *item)
#line 178 "src/pmc/tqueue.pmc"
{
    QUEUE_ENTRY* entry = mem_sys_allocate(sizeof(QUEUE_ENTRY));
    QUEUE *queue = PMC_data(pmc);

    /*
     * if item isn't shared nor const, then make
     *       a shared item
     */
    if (!(item->vtable->flags &
                (VTABLE_IS_CONST_FLAG | VTABLE_IS_SHARED_FLAG)))
        VTABLE_share(interpreter, item);

    DOD_WRITE_BARRIER(interpreter, pmc, NULL, item);
    entry->data = item;
    entry->type = QUEUE_ENTRY_TYPE_NONE;
    /* s. tsq.c:queue_push */
    queue_lock(queue);
    ++PMC_int_val(pmc);
    /* Is there something in the queue? */
    if (queue->tail) {
        queue->tail->next = entry;
        queue->tail = entry;
    } else {
        queue->head = entry;
        queue->tail = entry;
    }
    queue_broadcast(queue);        /* signal all waiters */
    queue_unlock(queue);

}
#line 183 "src/pmc/tqueue.c"


PMC*
Parrot_TQueue_shift_pmc(Interp* interpreter, PMC* pmc)
#line 218 "src/pmc/tqueue.pmc"
{
    QUEUE_ENTRY *entry;
    QUEUE *queue = PMC_data(pmc);
    PMC *ret;

    queue_lock(queue);
    while (queue->head == NULL) {
        queue_wait(queue);
    }
    entry = nosync_pop_entry(queue);
    --PMC_int_val(pmc);
    queue_unlock(queue);
    ret = entry->data;
    mem_sys_free(entry);
    return ret;

}
#line 206 "src/pmc/tqueue.c"


INTVAL
Parrot_TQueue_defined(Interp* interpreter, PMC* pmc)
#line 134 "src/pmc/tqueue.pmc"
{
    return Parrot_TQueue_get_integer(interpreter, pmc) != 0;

}
#line 216 "src/pmc/tqueue.c"


void
Parrot_TQueue_class_init(Parrot_Interp interp, int entry, int pass)
{
    const struct _vtable temp_base_vtable = {
        NULL,	/* namespace */
        enum_class_TQueue,	/* base_type */
        NULL,	/* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        Parrot_TQueue_init,
        Parrot_default_init_pmc,
        Parrot_default_init_pmc_props,
        Parrot_default_instantiate,
        Parrot_default_new_from_string,
        Parrot_default_morph,
        Parrot_TQueue_mark,
        Parrot_TQueue_destroy,
        Parrot_default_namespace,
        Parrot_default_getprop,
        Parrot_default_setprop,
        Parrot_default_delprop,
        Parrot_default_getprops,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_subtype,
        Parrot_default_name,
        Parrot_TQueue_clone,
        Parrot_default_find_method,
        Parrot_default_hash,
        Parrot_TQueue_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_bignum,
        Parrot_default_get_string,
        Parrot_default_get_repr,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_get_bool,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_slice,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_string_native,
        Parrot_default_assign_string_native,
        Parrot_default_set_string_same,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_bool,
        Parrot_default_set_pmc,
        Parrot_default_assign_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_TQueue_elements,
        Parrot_default_pop_integer,
        Parrot_default_pop_float,
        Parrot_default_pop_string,
        Parrot_default_pop_pmc,
        Parrot_default_push_integer,
        Parrot_default_push_float,
        Parrot_default_push_string,
        Parrot_TQueue_push_pmc,
        Parrot_default_shift_integer,
        Parrot_default_shift_float,
        Parrot_default_shift_string,
        Parrot_TQueue_shift_pmc,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_float,
        Parrot_default_unshift_string,
        Parrot_default_unshift_pmc,
        Parrot_default_splice,
        Parrot_default_increment,
        Parrot_default_decrement,
        Parrot_default_absolute,
        Parrot_default_i_absolute,
        Parrot_default_neg,
        Parrot_default_i_neg,
        Parrot_default_bitwise_not,
        Parrot_default_i_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_i_bitwise_nots,
        Parrot_default_is_same,
        Parrot_default_logical_not,
        Parrot_default_i_logical_not,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_TQueue_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_invoke,
        Parrot_default_can,
        Parrot_default_does,
        Parrot_default_isa,
        Parrot_default_subclass,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_get_class,
        Parrot_default_add_parent,
        Parrot_default_become_parent,
        Parrot_default_class_type,
        Parrot_default_add_method,
        Parrot_default_remove_method,
        Parrot_default_new_singleton,
        Parrot_default_get_anonymous_subclass,
        Parrot_default_freeze,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_visit,
        Parrot_default_share
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        struct _vtable *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);

        vt_clone->whoami = CONST_STRING(interp, "TQueue");
        vt_clone->isa_str = CONST_STRING(interp, "TQueue");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    } 
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
    
    } /* pass */
} /* Parrot_TQueue_class_init */


/*

=back

=head1 HISTORY

2003.12.19 leo initial rev.

=cut

*/

/*
 * Local variables:
 * c-indentation-style: bsd
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 *
 * vim: expandtab shiftwidth=4:
*/
