/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically by tools/build/nativecall.pl
 * from definitions in src/call_list.txt
 *
 * Any changes made here will be lost!
 *
 */

/* nci.c
 *  Copyright: 2001-2005 The Perl Foundation.  All Rights Reserved.
 *  SVN Info
 *     $Id$
 *  Overview:
 *     Native Call Interface routines. The code needed to build a
 *     parrot to C call frame is in here
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *  References:
 */
#include "parrot/parrot.h"
#include "parrot/hash.h"
#include "parrot/oplib/ops.h"

/*
 * if the architecture can build some or all of these signatures
 * enable the define below
 * - the JITed function will be called first
 * - if it returns NULL, the hardcoded version will do the job
 */

#if defined(HAS_JIT) && defined(I386)
#  include "parrot/exec.h"
#  include "parrot/jit.h"
/*#  define CAN_BUILD_CALL_FRAMES*/
#endif

/*
 * helper funcs - get argument n
 */
static INTVAL
get_nci_I(Interp *interpreter, struct call_state *st, int n)
{
    assert(n < st->src.n);
    Parrot_fetch_arg_nci(interpreter, st);

    return UVal_int(st->val);
}

static FLOATVAL
get_nci_N(Interp *interpreter, struct call_state *st, int n)
{
    assert(n < st->src.n);
    Parrot_fetch_arg_nci(interpreter, st);

    return UVal_num(st->val);
}

static STRING*
get_nci_S(Interp *interpreter, struct call_state *st, int n)
{
    assert(n < st->src.n);
    Parrot_fetch_arg_nci(interpreter, st);

    return UVal_str(st->val);
}

static PMC*
get_nci_P(Interp *interpreter, struct call_state *st, int n)
{
    /*
     * exessive args are passed as NULL
     * used by e.g. MMD infix like __add
     */
    if (n < st->src.n)
        Parrot_fetch_arg_nci(interpreter, st);
    else
        UVal_pmc(st->val) = NULL;

    return UVal_pmc(st->val);
}

#define GET_NCI_I(n) get_nci_I(interpreter, &st, n)
#define GET_NCI_S(n) get_nci_S(interpreter, &st, n)
#define GET_NCI_N(n) get_nci_N(interpreter, &st, n)
#define GET_NCI_P(n) get_nci_P(interpreter, &st, n)

/*
 * set return value
 */
static void
set_nci_I(Interp *interpreter, struct call_state *st, INTVAL val)
{
    Parrot_init_ret_nci(interpreter, st, "I");
    UVal_int(st->val) = val;
    Parrot_convert_arg(interpreter, st);
    Parrot_store_arg(interpreter, st);
}

static void
set_nci_N(Interp *interpreter, struct call_state *st, FLOATVAL val)
{
    Parrot_init_ret_nci(interpreter, st, "N");
    UVal_num(st->val) = val;
    Parrot_convert_arg(interpreter, st);
    Parrot_store_arg(interpreter, st);
}

static void
set_nci_S(Interp *interpreter, struct call_state *st, STRING *val)
{
    Parrot_init_ret_nci(interpreter, st, "S");
    UVal_str(st->val) = val;
    Parrot_convert_arg(interpreter, st);
    Parrot_store_arg(interpreter, st);
}

static void
set_nci_P(Interp *interpreter, struct call_state *st, PMC* val)
{
    Parrot_init_ret_nci(interpreter, st, "P");
    UVal_pmc(st->val) = val;
    Parrot_convert_arg(interpreter, st);
    Parrot_store_arg(interpreter, st);
}

/* All our static functions that call in various ways. Yes, terribly
   hackish, but that is just fine */

static void
pcf_c_(Interp *interpreter, PMC *self)
{
    char (*pointer)(void);
    char return_data;
    
    struct call_state st;
    

    pointer =  (char (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (char)(*pointer)();
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_c_p(Interp *interpreter, PMC *self)
{
    typedef char (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    char return_data;
    
    PMC *t_0;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_0 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_0));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_c_pi(Interp *interpreter, PMC *self)
{
    typedef char (*func_t)(void *, int);
    func_t pointer;
    struct call_state st;
    char return_data;
    
    PMC *t_1;
    int t_2;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_1 = GET_NCI_P(0);
    t_2 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_1),t_2);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_d_(Interp *interpreter, PMC *self)
{
    double (*pointer)(void);
    double return_data;
    
    struct call_state st;
    

    pointer =  (double (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (double)(*pointer)();
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_d_d(Interp *interpreter, PMC *self)
{
    typedef double (*func_t)(double);
    func_t pointer;
    struct call_state st;
    double return_data;
    
    double t_3;
    Parrot_init_arg_nci(interpreter, &st, "N");
    t_3 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (double)(*pointer)(t_3);
    
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_d_JOd(Interp *interpreter, PMC *self)
{
    typedef double (*func_t)(Interp *, PMC *, double);
    func_t pointer;
    struct call_state st;
    double return_data;
    
    PMC *t_5;
    double t_6;
    Parrot_init_arg_nci(interpreter, &st, "PN");
    t_5 = GET_NCI_P(0);
    t_6 = (double)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (double)(*pointer)(interpreter,t_5 == PMCNULL ? NULL : t_5,t_6);
    
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_I_JOS(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, PMC *, STRING *);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    PMC *t_8;
    STRING *t_9;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_8 = GET_NCI_P(0);
    t_9 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_8 == PMCNULL ? NULL : t_8,t_9);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_S_JOS(Interp *interpreter, PMC *self)
{
    typedef STRING * (*func_t)(Interp *, PMC *, STRING *);
    func_t pointer;
    struct call_state st;
    STRING * return_data;
    
    PMC *t_11;
    STRING *t_12;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_11 = GET_NCI_P(0);
    t_12 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interpreter,t_11 == PMCNULL ? NULL : t_11,t_12);
    
    set_nci_S(interpreter, &st, return_data);
    
}
static void
pcf_I_JI(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, INTVAL);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    INTVAL t_14;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_14 = GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_14);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_v_JOSP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, STRING *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_16;
    STRING *t_17;
    PMC *t_18;
    Parrot_init_arg_nci(interpreter, &st, "PSP");
    t_16 = GET_NCI_P(0);
    t_17 = GET_NCI_S(1);
    t_18 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_16 == PMCNULL ? NULL : t_16,t_17,t_18 == PMCNULL ? NULL : t_18);
    
    
    
}
static void
pcf_v_JOS(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, STRING *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_20;
    STRING *t_21;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_20 = GET_NCI_P(0);
    t_21 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_20 == PMCNULL ? NULL : t_20,t_21);
    
    
    
}
static void
pcf_P_JOS(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, STRING *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_23;
    STRING *t_24;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_23 = GET_NCI_P(0);
    t_24 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_23 == PMCNULL ? NULL : t_23,t_24);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_I_JOI(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, PMC *, INTVAL);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    PMC *t_26;
    INTVAL t_27;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_26 = GET_NCI_P(0);
    t_27 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_26 == PMCNULL ? NULL : t_26,t_27);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_v_JPPP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_29;
    PMC *t_30;
    PMC *t_31;
    Parrot_init_arg_nci(interpreter, &st, "PPP");
    t_29 = GET_NCI_P(0);
    t_30 = GET_NCI_P(1);
    t_31 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_29 == PMCNULL ? NULL : t_29,t_30 == PMCNULL ? NULL : t_30,t_31 == PMCNULL ? NULL : t_31);
    
    
    
}
static void
pcf_v_JPIP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, INTVAL, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_33;
    INTVAL t_34;
    PMC *t_35;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_33 = GET_NCI_P(0);
    t_34 = GET_NCI_I(1);
    t_35 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_33 == PMCNULL ? NULL : t_33,t_34,t_35 == PMCNULL ? NULL : t_35);
    
    
    
}
static void
pcf_v_JPSP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, STRING *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_37;
    STRING *t_38;
    PMC *t_39;
    Parrot_init_arg_nci(interpreter, &st, "PSP");
    t_37 = GET_NCI_P(0);
    t_38 = GET_NCI_S(1);
    t_39 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_37 == PMCNULL ? NULL : t_37,t_38,t_39 == PMCNULL ? NULL : t_39);
    
    
    
}
static void
pcf_v_JPNP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_41;
    FLOATVAL t_42;
    PMC *t_43;
    Parrot_init_arg_nci(interpreter, &st, "PNP");
    t_41 = GET_NCI_P(0);
    t_42 = GET_NCI_N(1);
    t_43 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_41 == PMCNULL ? NULL : t_41,t_42,t_43 == PMCNULL ? NULL : t_43);
    
    
    
}
static void
pcf_v_JPP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_45;
    PMC *t_46;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_45 = GET_NCI_P(0);
    t_46 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_45 == PMCNULL ? NULL : t_45,t_46 == PMCNULL ? NULL : t_46);
    
    
    
}
static void
pcf_v_JPI(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, INTVAL);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_48;
    INTVAL t_49;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_48 = GET_NCI_P(0);
    t_49 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_48 == PMCNULL ? NULL : t_48,t_49);
    
    
    
}
static void
pcf_v_JPS(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, STRING *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_51;
    STRING *t_52;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_51 = GET_NCI_P(0);
    t_52 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_51 == PMCNULL ? NULL : t_51,t_52);
    
    
    
}
static void
pcf_v_JPN(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, FLOATVAL);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_54;
    FLOATVAL t_55;
    Parrot_init_arg_nci(interpreter, &st, "PN");
    t_54 = GET_NCI_P(0);
    t_55 = GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_54 == PMCNULL ? NULL : t_54,t_55);
    
    
    
}
static void
pcf_P_JPPP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_57;
    PMC *t_58;
    PMC *t_59;
    Parrot_init_arg_nci(interpreter, &st, "PPP");
    t_57 = GET_NCI_P(0);
    t_58 = GET_NCI_P(1);
    t_59 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_57 == PMCNULL ? NULL : t_57,t_58 == PMCNULL ? NULL : t_58,t_59 == PMCNULL ? NULL : t_59);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JPIP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, INTVAL, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_61;
    INTVAL t_62;
    PMC *t_63;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_61 = GET_NCI_P(0);
    t_62 = GET_NCI_I(1);
    t_63 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_61 == PMCNULL ? NULL : t_61,t_62,t_63 == PMCNULL ? NULL : t_63);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JPSP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, STRING *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_65;
    STRING *t_66;
    PMC *t_67;
    Parrot_init_arg_nci(interpreter, &st, "PSP");
    t_65 = GET_NCI_P(0);
    t_66 = GET_NCI_S(1);
    t_67 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_65 == PMCNULL ? NULL : t_65,t_66,t_67 == PMCNULL ? NULL : t_67);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JPNP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_69;
    FLOATVAL t_70;
    PMC *t_71;
    Parrot_init_arg_nci(interpreter, &st, "PNP");
    t_69 = GET_NCI_P(0);
    t_70 = GET_NCI_N(1);
    t_71 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_69 == PMCNULL ? NULL : t_69,t_70,t_71 == PMCNULL ? NULL : t_71);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_I_JPP(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    PMC *t_73;
    PMC *t_74;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_73 = GET_NCI_P(0);
    t_74 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_73 == PMCNULL ? NULL : t_73,t_74 == PMCNULL ? NULL : t_74);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_f_(Interp *interpreter, PMC *self)
{
    float (*pointer)(void);
    float return_data;
    
    struct call_state st;
    

    pointer =  (float (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (float)(*pointer)();
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_f_ff(Interp *interpreter, PMC *self)
{
    typedef float (*func_t)(float, float);
    func_t pointer;
    struct call_state st;
    float return_data;
    
    float t_75;
    float t_76;
    Parrot_init_arg_nci(interpreter, &st, "NN");
    t_75 = (float)GET_NCI_N(0);
    t_76 = (float)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_75,t_76);
    
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_f_is(Interp *interpreter, PMC *self)
{
    typedef float (*func_t)(int, short);
    func_t pointer;
    struct call_state st;
    float return_data;
    
    int t_77;
    short t_78;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_77 = (int)GET_NCI_I(0);
    t_78 = (short)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_77,t_78);
    
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_i_(Interp *interpreter, PMC *self)
{
    int (*pointer)(void);
    int return_data;
    
    struct call_state st;
    

    pointer =  (int (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (int)(*pointer)();
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_b(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    STRING *t_79;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_79 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PObj_bufstart(t_79));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_d(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(double);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    double t_80;
    Parrot_init_arg_nci(interpreter, &st, "N");
    t_80 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_80);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_81;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_81 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_81);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_82;
    int t_83;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_82 = (int)GET_NCI_I(0);
    t_83 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_82,t_83);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ii4(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, long *);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg2;
    int t_84;
    int t_85;
    PMC *t_86;
    Parrot_init_arg_nci(interpreter, &st, "IIP");
    t_84 = (int)GET_NCI_I(0);
    t_85 = (int)GET_NCI_I(1);
    t_86 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_86);
    return_data =  (int)(*pointer)(t_84,t_85,&arg2);
    PMC_int_val(t_86) = arg2;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ii4i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, long *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg2;
    int t_87;
    int t_88;
    PMC *t_89;
    int t_90;
    Parrot_init_arg_nci(interpreter, &st, "IIPI");
    t_87 = (int)GET_NCI_I(0);
    t_88 = (int)GET_NCI_I(1);
    t_89 = GET_NCI_P(2);
    t_90 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_89);
    return_data =  (int)(*pointer)(t_87,t_88,&arg2,t_90);
    PMC_int_val(t_89) = arg2;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iiii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_91;
    int t_92;
    int t_93;
    int t_94;
    Parrot_init_arg_nci(interpreter, &st, "IIII");
    t_91 = (int)GET_NCI_I(0);
    t_92 = (int)GET_NCI_I(1);
    t_93 = (int)GET_NCI_I(2);
    t_94 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_91,t_92,t_93,t_94);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iiilsp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, int, long, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_95;
    int t_96;
    int t_97;
    long t_98;
    short t_99;
    PMC *t_100;
    Parrot_init_arg_nci(interpreter, &st, "IIIIIP");
    t_95 = (int)GET_NCI_I(0);
    t_96 = (int)GET_NCI_I(1);
    t_97 = (int)GET_NCI_I(2);
    t_98 = (long)GET_NCI_I(3);
    t_99 = (short)GET_NCI_I(4);
    t_100 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_95,t_96,t_97,t_98,t_99,PMC_data(t_100));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iil(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_101;
    int t_102;
    long t_103;
    Parrot_init_arg_nci(interpreter, &st, "III");
    t_101 = (int)GET_NCI_I(0);
    t_102 = (int)GET_NCI_I(1);
    t_103 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_101,t_102,t_103);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iili(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, long, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_104;
    int t_105;
    long t_106;
    int t_107;
    Parrot_init_arg_nci(interpreter, &st, "IIII");
    t_104 = (int)GET_NCI_I(0);
    t_105 = (int)GET_NCI_I(1);
    t_106 = (long)GET_NCI_I(2);
    t_107 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_104,t_105,t_106,t_107);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iip(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_108;
    int t_109;
    PMC *t_110;
    Parrot_init_arg_nci(interpreter, &st, "IIP");
    t_108 = (int)GET_NCI_I(0);
    t_109 = (int)GET_NCI_I(1);
    t_110 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_108,t_109,PMC_data(t_110));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iit(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_111;
    int t_112;
    char *t_113;
    Parrot_init_arg_nci(interpreter, &st, "IIS");
    t_111 = (int)GET_NCI_I(0);
    t_112 = (int)GET_NCI_I(1);
    t_113 = string_to_cstring(interpreter, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_111,t_112,t_113);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_113);
}
static void
pcf_i_iiti(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, char *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_114;
    int t_115;
    char *t_116;
    int t_117;
    Parrot_init_arg_nci(interpreter, &st, "IISI");
    t_114 = (int)GET_NCI_I(0);
    t_115 = (int)GET_NCI_I(1);
    t_116 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_117 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_114,t_115,t_116,t_117);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_116);
}
static void
pcf_i_ilsp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, long, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_118;
    long t_119;
    short t_120;
    PMC *t_121;
    Parrot_init_arg_nci(interpreter, &st, "IIIP");
    t_118 = (int)GET_NCI_I(0);
    t_119 = (long)GET_NCI_I(1);
    t_120 = (short)GET_NCI_I(2);
    t_121 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_118,t_119,t_120,PMC_data(t_121));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iti(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, char *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_122;
    char *t_123;
    int t_124;
    Parrot_init_arg_nci(interpreter, &st, "ISI");
    t_122 = (int)GET_NCI_I(0);
    t_123 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_124 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_122,t_123,t_124);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_123);
}
static void
pcf_i_l(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    long t_125;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_125 = (long)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_125);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_li(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    long t_126;
    int t_127;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_126 = (long)GET_NCI_I(0);
    t_127 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_126,t_127);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_lp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    long t_128;
    PMC *t_129;
    Parrot_init_arg_nci(interpreter, &st, "IP");
    t_128 = (long)GET_NCI_I(0);
    t_129 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_128,PMC_data(t_129));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_lsp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    long t_130;
    short t_131;
    PMC *t_132;
    Parrot_init_arg_nci(interpreter, &st, "IIP");
    t_130 = (long)GET_NCI_I(0);
    t_131 = (short)GET_NCI_I(1);
    t_132 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_130,t_131,PMC_data(t_132));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_133;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_133 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_133));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p33(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg1;
    int arg2;
    PMC *t_134;
    PMC *t_135;
    PMC *t_136;
    Parrot_init_arg_nci(interpreter, &st, "PPP");
    t_134 = GET_NCI_P(0);
    t_135 = GET_NCI_P(1);
    t_136 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_135);
    arg2 = PMC_int_val(t_136);
    return_data =  (int)(*pointer)(PMC_data(t_134),&arg1,&arg2);
    PMC_int_val(t_135) = arg1;
    PMC_int_val(t_136) = arg2;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p333(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg1;
    int arg2;
    int arg3;
    PMC *t_137;
    PMC *t_138;
    PMC *t_139;
    PMC *t_140;
    Parrot_init_arg_nci(interpreter, &st, "PPPP");
    t_137 = GET_NCI_P(0);
    t_138 = GET_NCI_P(1);
    t_139 = GET_NCI_P(2);
    t_140 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_138);
    arg2 = PMC_int_val(t_139);
    arg3 = PMC_int_val(t_140);
    return_data =  (int)(*pointer)(PMC_data(t_137),&arg1,&arg2,&arg3);
    PMC_int_val(t_138) = arg1;
    PMC_int_val(t_139) = arg2;
    PMC_int_val(t_140) = arg3;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p333333(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *, int *, int *, int *);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg1;
    int arg2;
    int arg3;
    int arg4;
    int arg5;
    int arg6;
    PMC *t_141;
    PMC *t_142;
    PMC *t_143;
    PMC *t_144;
    PMC *t_145;
    PMC *t_146;
    PMC *t_147;
    Parrot_init_arg_nci(interpreter, &st, "PPPPPPP");
    t_141 = GET_NCI_P(0);
    t_142 = GET_NCI_P(1);
    t_143 = GET_NCI_P(2);
    t_144 = GET_NCI_P(3);
    t_145 = GET_NCI_P(4);
    t_146 = GET_NCI_P(5);
    t_147 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_142);
    arg2 = PMC_int_val(t_143);
    arg3 = PMC_int_val(t_144);
    arg4 = PMC_int_val(t_145);
    arg5 = PMC_int_val(t_146);
    arg6 = PMC_int_val(t_147);
    return_data =  (int)(*pointer)(PMC_data(t_141),&arg1,&arg2,&arg3,&arg4,&arg5,&arg6);
    PMC_int_val(t_142) = arg1;
    PMC_int_val(t_143) = arg2;
    PMC_int_val(t_144) = arg3;
    PMC_int_val(t_145) = arg4;
    PMC_int_val(t_146) = arg5;
    PMC_int_val(t_147) = arg6;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p4(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long *);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg1;
    PMC *t_148;
    PMC *t_149;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_148 = GET_NCI_P(0);
    t_149 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_149);
    return_data =  (int)(*pointer)(PMC_data(t_148),&arg1);
    PMC_int_val(t_149) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p42p(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long *, short *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg1;
    short arg2;
    PMC *t_150;
    PMC *t_151;
    PMC* t_152;
    PMC *t_153;
    Parrot_init_arg_nci(interpreter, &st, "PPPP");
    t_150 = GET_NCI_P(0);
    t_151 = GET_NCI_P(1);
    t_152 = GET_NCI_P(2);
    t_153 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_151);
    arg2 = (short)PMC_int_val(t_152);
    return_data =  (int)(*pointer)(PMC_data(t_150),&arg1,&arg2,PMC_data(t_153));
    PMC_int_val(t_151) = arg1;
    PMC_int_val(t_152) = arg2;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_p4i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg1;
    PMC *t_154;
    PMC *t_155;
    int t_156;
    Parrot_init_arg_nci(interpreter, &st, "PPI");
    t_154 = GET_NCI_P(0);
    t_155 = GET_NCI_P(1);
    t_156 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_155);
    return_data =  (int)(*pointer)(PMC_data(t_154),&arg1,t_156);
    PMC_int_val(t_155) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pb(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_157;
    STRING *t_158;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_157 = GET_NCI_P(0);
    t_158 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_157),PObj_bufstart(t_158));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_159;
    int t_160;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_159 = GET_NCI_P(0);
    t_160 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_159),t_160);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_161;
    int t_162;
    int t_163;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_161 = GET_NCI_P(0);
    t_162 = (int)GET_NCI_I(1);
    t_163 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_161),t_162,t_163);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pii4(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg3;
    PMC *t_164;
    int t_165;
    int t_166;
    PMC *t_167;
    Parrot_init_arg_nci(interpreter, &st, "PIIP");
    t_164 = GET_NCI_P(0);
    t_165 = (int)GET_NCI_I(1);
    t_166 = (int)GET_NCI_I(2);
    t_167 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_167);
    return_data =  (int)(*pointer)(PMC_data(t_164),t_165,t_166,&arg3);
    PMC_int_val(t_167) = arg3;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pii4i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg3;
    PMC *t_168;
    int t_169;
    int t_170;
    PMC *t_171;
    int t_172;
    Parrot_init_arg_nci(interpreter, &st, "PIIPI");
    t_168 = GET_NCI_P(0);
    t_169 = (int)GET_NCI_I(1);
    t_170 = (int)GET_NCI_I(2);
    t_171 = GET_NCI_P(3);
    t_172 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_171);
    return_data =  (int)(*pointer)(PMC_data(t_168),t_169,t_170,&arg3,t_172);
    PMC_int_val(t_171) = arg3;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_piii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_173;
    int t_174;
    int t_175;
    int t_176;
    Parrot_init_arg_nci(interpreter, &st, "PIII");
    t_173 = GET_NCI_P(0);
    t_174 = (int)GET_NCI_I(1);
    t_175 = (int)GET_NCI_I(2);
    t_176 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_173),t_174,t_175,t_176);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_piiiiii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, int, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_177;
    int t_178;
    int t_179;
    int t_180;
    int t_181;
    int t_182;
    int t_183;
    Parrot_init_arg_nci(interpreter, &st, "PIIIIII");
    t_177 = GET_NCI_P(0);
    t_178 = (int)GET_NCI_I(1);
    t_179 = (int)GET_NCI_I(2);
    t_180 = (int)GET_NCI_I(3);
    t_181 = (int)GET_NCI_I(4);
    t_182 = (int)GET_NCI_I(5);
    t_183 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_177),t_178,t_179,t_180,t_181,t_182,t_183);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_piiilsp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, long, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_184;
    int t_185;
    int t_186;
    int t_187;
    long t_188;
    short t_189;
    PMC *t_190;
    Parrot_init_arg_nci(interpreter, &st, "PIIIIIP");
    t_184 = GET_NCI_P(0);
    t_185 = (int)GET_NCI_I(1);
    t_186 = (int)GET_NCI_I(2);
    t_187 = (int)GET_NCI_I(3);
    t_188 = (long)GET_NCI_I(4);
    t_189 = (short)GET_NCI_I(5);
    t_190 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_184),t_185,t_186,t_187,t_188,t_189,PMC_data(t_190));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_piil(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_191;
    int t_192;
    int t_193;
    long t_194;
    Parrot_init_arg_nci(interpreter, &st, "PIII");
    t_191 = GET_NCI_P(0);
    t_192 = (int)GET_NCI_I(1);
    t_193 = (int)GET_NCI_I(2);
    t_194 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_191),t_192,t_193,t_194);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_piili(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_195;
    int t_196;
    int t_197;
    long t_198;
    int t_199;
    Parrot_init_arg_nci(interpreter, &st, "PIIII");
    t_195 = GET_NCI_P(0);
    t_196 = (int)GET_NCI_I(1);
    t_197 = (int)GET_NCI_I(2);
    t_198 = (long)GET_NCI_I(3);
    t_199 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_195),t_196,t_197,t_198,t_199);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_piit(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_200;
    int t_201;
    int t_202;
    char *t_203;
    Parrot_init_arg_nci(interpreter, &st, "PIIS");
    t_200 = GET_NCI_P(0);
    t_201 = (int)GET_NCI_I(1);
    t_202 = (int)GET_NCI_I(2);
    t_203 = string_to_cstring(interpreter, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_200),t_201,t_202,t_203);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_203);
}
static void
pcf_i_piiti(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_204;
    int t_205;
    int t_206;
    char *t_207;
    int t_208;
    Parrot_init_arg_nci(interpreter, &st, "PIISI");
    t_204 = GET_NCI_P(0);
    t_205 = (int)GET_NCI_I(1);
    t_206 = (int)GET_NCI_I(2);
    t_207 = string_to_cstring(interpreter, GET_NCI_S(3));
    t_208 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_204),t_205,t_206,t_207,t_208);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_207);
}
static void
pcf_i_pilsp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, long, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_209;
    int t_210;
    long t_211;
    short t_212;
    PMC *t_213;
    Parrot_init_arg_nci(interpreter, &st, "PIIIP");
    t_209 = GET_NCI_P(0);
    t_210 = (int)GET_NCI_I(1);
    t_211 = (long)GET_NCI_I(2);
    t_212 = (short)GET_NCI_I(3);
    t_213 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_209),t_210,t_211,t_212,PMC_data(t_213));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pit(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_214;
    int t_215;
    char *t_216;
    Parrot_init_arg_nci(interpreter, &st, "PIS");
    t_214 = GET_NCI_P(0);
    t_215 = (int)GET_NCI_I(1);
    t_216 = string_to_cstring(interpreter, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_214),t_215,t_216);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_216);
}
static void
pcf_i_pl(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_217;
    long t_218;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_217 = GET_NCI_P(0);
    t_218 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_217),t_218);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pli(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_219;
    long t_220;
    int t_221;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_219 = GET_NCI_P(0);
    t_220 = (long)GET_NCI_I(1);
    t_221 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_219),t_220,t_221);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pll(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_222;
    long t_223;
    long t_224;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_222 = GET_NCI_P(0);
    t_223 = (long)GET_NCI_I(1);
    t_224 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_222),t_223,t_224);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pllllllll(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long, long, long, long, long, long, long, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_225;
    long t_226;
    long t_227;
    long t_228;
    long t_229;
    long t_230;
    long t_231;
    long t_232;
    long t_233;
    Parrot_init_arg_nci(interpreter, &st, "PIIIIIIII");
    t_225 = GET_NCI_P(0);
    t_226 = (long)GET_NCI_I(1);
    t_227 = (long)GET_NCI_I(2);
    t_228 = (long)GET_NCI_I(3);
    t_229 = (long)GET_NCI_I(4);
    t_230 = (long)GET_NCI_I(5);
    t_231 = (long)GET_NCI_I(6);
    t_232 = (long)GET_NCI_I(7);
    t_233 = (long)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_225),t_226,t_227,t_228,t_229,t_230,t_231,t_232,t_233);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_plp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_234;
    long t_235;
    PMC *t_236;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_234 = GET_NCI_P(0);
    t_235 = (long)GET_NCI_I(1);
    t_236 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_234),t_235,PMC_data(t_236));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_plsp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, long, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_237;
    long t_238;
    short t_239;
    PMC *t_240;
    Parrot_init_arg_nci(interpreter, &st, "PIIP");
    t_237 = GET_NCI_P(0);
    t_238 = (long)GET_NCI_I(1);
    t_239 = (short)GET_NCI_I(2);
    t_240 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_237),t_238,t_239,PMC_data(t_240));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_241;
    PMC *t_242;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_241 = GET_NCI_P(0);
    t_242 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_241),PMC_data(t_242));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ppi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, void *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_243;
    PMC *t_244;
    int t_245;
    Parrot_init_arg_nci(interpreter, &st, "PPI");
    t_243 = GET_NCI_P(0);
    t_244 = GET_NCI_P(1);
    t_245 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_243),PMC_data(t_244),t_245);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ppiiiiiiii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, void *, int, int, int, int, int, int, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_246;
    PMC *t_247;
    int t_248;
    int t_249;
    int t_250;
    int t_251;
    int t_252;
    int t_253;
    int t_254;
    int t_255;
    Parrot_init_arg_nci(interpreter, &st, "PPIIIIIIII");
    t_246 = GET_NCI_P(0);
    t_247 = GET_NCI_P(1);
    t_248 = (int)GET_NCI_I(2);
    t_249 = (int)GET_NCI_I(3);
    t_250 = (int)GET_NCI_I(4);
    t_251 = (int)GET_NCI_I(5);
    t_252 = (int)GET_NCI_I(6);
    t_253 = (int)GET_NCI_I(7);
    t_254 = (int)GET_NCI_I(8);
    t_255 = (int)GET_NCI_I(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_246),PMC_data(t_247),t_248,t_249,t_250,t_251,t_252,t_253,t_254,t_255);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pppp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_256;
    PMC *t_257;
    PMC *t_258;
    PMC *t_259;
    Parrot_init_arg_nci(interpreter, &st, "PPPP");
    t_256 = GET_NCI_P(0);
    t_257 = GET_NCI_P(1);
    t_258 = GET_NCI_P(2);
    t_259 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_256),PMC_data(t_257),PMC_data(t_258),PMC_data(t_259));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_psp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_260;
    short t_261;
    PMC *t_262;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_260 = GET_NCI_P(0);
    t_261 = (short)GET_NCI_I(1);
    t_262 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_260),t_261,PMC_data(t_262));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_pt(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_263;
    char *t_264;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_263 = GET_NCI_P(0);
    t_264 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_263),t_264);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_264);
}
static void
pcf_i_pti(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_265;
    char *t_266;
    int t_267;
    Parrot_init_arg_nci(interpreter, &st, "PSI");
    t_265 = GET_NCI_P(0);
    t_266 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_267 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_265),t_266,t_267);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_266);
}
static void
pcf_i_pitl(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_268;
    int t_269;
    char *t_270;
    long t_271;
    Parrot_init_arg_nci(interpreter, &st, "PISI");
    t_268 = GET_NCI_P(0);
    t_269 = (int)GET_NCI_I(1);
    t_270 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_271 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_268),t_269,t_270,t_271);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_270);
}
static void
pcf_i_s(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    short t_272;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_272 = (short)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_272);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_s22(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short, short *, short *);
    func_t pointer;
    struct call_state st;
    int return_data;
    short arg1;
    short arg2;
    short t_273;
    PMC* t_274;
    PMC* t_275;
    Parrot_init_arg_nci(interpreter, &st, "IPP");
    t_273 = (short)GET_NCI_I(0);
    t_274 = GET_NCI_P(1);
    t_275 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = (short)PMC_int_val(t_274);
    arg2 = (short)PMC_int_val(t_275);
    return_data =  (int)(*pointer)(t_273,&arg1,&arg2);
    PMC_int_val(t_274) = arg1;
    PMC_int_val(t_275) = arg2;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_s222(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short, short *, short *, short *);
    func_t pointer;
    struct call_state st;
    int return_data;
    short arg1;
    short arg2;
    short arg3;
    short t_276;
    PMC* t_277;
    PMC* t_278;
    PMC* t_279;
    Parrot_init_arg_nci(interpreter, &st, "IPPP");
    t_276 = (short)GET_NCI_I(0);
    t_277 = GET_NCI_P(1);
    t_278 = GET_NCI_P(2);
    t_279 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = (short)PMC_int_val(t_277);
    arg2 = (short)PMC_int_val(t_278);
    arg3 = (short)PMC_int_val(t_279);
    return_data =  (int)(*pointer)(t_276,&arg1,&arg2,&arg3);
    PMC_int_val(t_277) = arg1;
    PMC_int_val(t_278) = arg2;
    PMC_int_val(t_279) = arg3;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_sp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    short t_280;
    PMC *t_281;
    Parrot_init_arg_nci(interpreter, &st, "IP");
    t_280 = (short)GET_NCI_I(0);
    t_281 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_280,PMC_data(t_281));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_sss(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short, short, short);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    short t_282;
    short t_283;
    short t_284;
    Parrot_init_arg_nci(interpreter, &st, "III");
    t_282 = (short)GET_NCI_I(0);
    t_283 = (short)GET_NCI_I(1);
    t_284 = (short)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_282,t_283,t_284);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ssss(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short, short, short, short);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    short t_285;
    short t_286;
    short t_287;
    short t_288;
    Parrot_init_arg_nci(interpreter, &st, "IIII");
    t_285 = (short)GET_NCI_I(0);
    t_286 = (short)GET_NCI_I(1);
    t_287 = (short)GET_NCI_I(2);
    t_288 = (short)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_285,t_286,t_287,t_288);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_t(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    char *t_289;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_289 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_289);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_289);
}
static void
pcf_i_ti(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(char *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    char *t_290;
    int t_291;
    Parrot_init_arg_nci(interpreter, &st, "SI");
    t_290 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_291 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_290,t_291);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_290);
}
static void
pcf_i_4(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long *);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg0;
    PMC *t_292;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_292 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_292);
    return_data =  (int)(*pointer)(&arg0);
    PMC_int_val(t_292) = arg0;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_4i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg0;
    PMC *t_293;
    int t_294;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_293 = GET_NCI_P(0);
    t_294 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_293);
    return_data =  (int)(*pointer)(&arg0,t_294);
    PMC_int_val(t_293) = arg0;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_42p(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(long *, short *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    long arg0;
    short arg1;
    PMC *t_295;
    PMC* t_296;
    PMC *t_297;
    Parrot_init_arg_nci(interpreter, &st, "PPP");
    t_295 = GET_NCI_P(0);
    t_296 = GET_NCI_P(1);
    t_297 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_295);
    arg1 = (short)PMC_int_val(t_296);
    return_data =  (int)(*pointer)(&arg0,&arg1,PMC_data(t_297));
    PMC_int_val(t_295) = arg0;
    PMC_int_val(t_296) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_(Interp *interpreter, PMC *self)
{
    long (*pointer)(void);
    long return_data;
    
    struct call_state st;
    

    pointer =  (long (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (long)(*pointer)();
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_ii(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(int, int);
    func_t pointer;
    struct call_state st;
    long return_data;
    
    int t_298;
    int t_299;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_298 = (int)GET_NCI_I(0);
    t_299 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_298,t_299);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_l4(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(long, long *);
    func_t pointer;
    struct call_state st;
    long return_data;
    long arg1;
    long t_300;
    PMC *t_301;
    Parrot_init_arg_nci(interpreter, &st, "IP");
    t_300 = (long)GET_NCI_I(0);
    t_301 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_301);
    return_data =  (long)(*pointer)(t_300,&arg1);
    PMC_int_val(t_301) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_p(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    long return_data;
    
    PMC *t_302;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_302 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_302));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_pi(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(void *, int);
    func_t pointer;
    struct call_state st;
    long return_data;
    
    PMC *t_303;
    int t_304;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_303 = GET_NCI_P(0);
    t_304 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_303),t_304);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_pii(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(void *, int, int);
    func_t pointer;
    struct call_state st;
    long return_data;
    
    PMC *t_305;
    int t_306;
    int t_307;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_305 = GET_NCI_P(0);
    t_306 = (int)GET_NCI_I(1);
    t_307 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_305),t_306,t_307);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_p33l(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(void *, int *, int *, long);
    func_t pointer;
    struct call_state st;
    long return_data;
    int arg1;
    int arg2;
    PMC *t_308;
    PMC *t_309;
    PMC *t_310;
    long t_311;
    Parrot_init_arg_nci(interpreter, &st, "PPPI");
    t_308 = GET_NCI_P(0);
    t_309 = GET_NCI_P(1);
    t_310 = GET_NCI_P(2);
    t_311 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_309);
    arg2 = PMC_int_val(t_310);
    return_data =  (long)(*pointer)(PMC_data(t_308),&arg1,&arg2,t_311);
    PMC_int_val(t_309) = arg1;
    PMC_int_val(t_310) = arg2;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_l_33l(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(int *, int *, long);
    func_t pointer;
    struct call_state st;
    long return_data;
    int arg0;
    int arg1;
    PMC *t_312;
    PMC *t_313;
    long t_314;
    Parrot_init_arg_nci(interpreter, &st, "PPI");
    t_312 = GET_NCI_P(0);
    t_313 = GET_NCI_P(1);
    t_314 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_312);
    arg1 = PMC_int_val(t_313);
    return_data =  (long)(*pointer)(&arg0,&arg1,t_314);
    PMC_int_val(t_312) = arg0;
    PMC_int_val(t_313) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_P_Ji(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, int);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    int t_316;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_316 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_316);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JOl(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, long);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_318;
    long t_319;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_318 = GET_NCI_P(0);
    t_319 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_318 == PMCNULL ? NULL : t_318,t_319);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JOP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_321;
    PMC *t_322;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_321 = GET_NCI_P(0);
    t_322 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_321 == PMCNULL ? NULL : t_321,t_322 == PMCNULL ? NULL : t_322);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_Jt(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, char *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    char *t_324;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_324 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_324);
    
    set_nci_P(interpreter, &st, return_data);
    string_cstring_free(t_324);
}
static void
pcf_p_(Interp *interpreter, PMC *self)
{
    void * (*pointer)(void);
    void * return_data;
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);
    struct call_state st;
    

    pointer =  (void * (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (void *)(*pointer)();
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_B(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void **);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);STRING *t_325;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_325 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(&PObj_bufstart(t_325));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_b(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);STRING *t_326;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_326 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PObj_bufstart(t_326));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_Jt(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(Interp *, char *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_328;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_328 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interpreter,t_328);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_328);
}
static void
pcf_p_i(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_329;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_329 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_329);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_ii(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_330;
    int t_331;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_330 = (int)GET_NCI_I(0);
    t_331 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_330,t_331);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_iiii(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_332;
    int t_333;
    int t_334;
    int t_335;
    Parrot_init_arg_nci(interpreter, &st, "IIII");
    t_332 = (int)GET_NCI_I(0);
    t_333 = (int)GET_NCI_I(1);
    t_334 = (int)GET_NCI_I(2);
    t_335 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_332,t_333,t_334,t_335);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_iiiiii(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_336;
    int t_337;
    int t_338;
    int t_339;
    int t_340;
    int t_341;
    Parrot_init_arg_nci(interpreter, &st, "IIIIII");
    t_336 = (int)GET_NCI_I(0);
    t_337 = (int)GET_NCI_I(1);
    t_338 = (int)GET_NCI_I(2);
    t_339 = (int)GET_NCI_I(3);
    t_340 = (int)GET_NCI_I(4);
    t_341 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_336,t_337,t_338,t_339,t_340,t_341);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_iiiiiiii(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int, int, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_342;
    int t_343;
    int t_344;
    int t_345;
    int t_346;
    int t_347;
    int t_348;
    int t_349;
    Parrot_init_arg_nci(interpreter, &st, "IIIIIIII");
    t_342 = (int)GET_NCI_I(0);
    t_343 = (int)GET_NCI_I(1);
    t_344 = (int)GET_NCI_I(2);
    t_345 = (int)GET_NCI_I(3);
    t_346 = (int)GET_NCI_I(4);
    t_347 = (int)GET_NCI_I(5);
    t_348 = (int)GET_NCI_I(6);
    t_349 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_342,t_343,t_344,t_345,t_346,t_347,t_348,t_349);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_p(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_350;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_350 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_350));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_pt(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, char *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_351;
    char *t_352;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_351 = GET_NCI_P(0);
    t_352 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_351),t_352);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_352);
}
static void
pcf_p_pi(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_353;
    int t_354;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_353 = GET_NCI_P(0);
    t_354 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_353),t_354);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_pii(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, int, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_355;
    int t_356;
    int t_357;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_355 = GET_NCI_P(0);
    t_356 = (int)GET_NCI_I(1);
    t_357 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_355),t_356,t_357);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_piiii(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, int, int, int, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_358;
    int t_359;
    int t_360;
    int t_361;
    int t_362;
    Parrot_init_arg_nci(interpreter, &st, "PIIII");
    t_358 = GET_NCI_P(0);
    t_359 = (int)GET_NCI_I(1);
    t_360 = (int)GET_NCI_I(2);
    t_361 = (int)GET_NCI_I(3);
    t_362 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_358),t_359,t_360,t_361,t_362);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_t(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(char *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_363;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_363 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_363);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_363);
}
static void
pcf_p_tpp(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(char *, void *, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_364;
    PMC *t_365;
    PMC *t_366;
    Parrot_init_arg_nci(interpreter, &st, "SPP");
    t_364 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_365 = GET_NCI_P(1);
    t_366 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_364,PMC_data(t_365),PMC_data(t_366));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_364);
}
static void
pcf_p_ttttttt(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(char *, char *, char *, char *, char *, char *, char *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_367;
    char *t_368;
    char *t_369;
    char *t_370;
    char *t_371;
    char *t_372;
    char *t_373;
    Parrot_init_arg_nci(interpreter, &st, "SSSSSSS");
    t_367 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_368 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_369 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_370 = string_to_cstring(interpreter, GET_NCI_S(3));
    t_371 = string_to_cstring(interpreter, GET_NCI_S(4));
    t_372 = string_to_cstring(interpreter, GET_NCI_S(5));
    t_373 = string_to_cstring(interpreter, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_367,t_368,t_369,t_370,t_371,t_372,t_373);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_367);
    string_cstring_free(t_368);
    string_cstring_free(t_369);
    string_cstring_free(t_370);
    string_cstring_free(t_371);
    string_cstring_free(t_372);
    string_cstring_free(t_373);
}
static void
pcf_s_(Interp *interpreter, PMC *self)
{
    short (*pointer)(void);
    short return_data;
    
    struct call_state st;
    

    pointer =  (short (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (short)(*pointer)();
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_t_(Interp *interpreter, PMC *self)
{
    char * (*pointer)(void);
    char * return_data;
    STRING *final_destination;
    struct call_state st;
    

    pointer =  (char * (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (char *)(*pointer)();
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_i(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(int);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;int t_374;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_374 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_374);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_ii(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(int, int);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;int t_375;
    int t_376;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_375 = (int)GET_NCI_I(0);
    t_376 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_375,t_376);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_p(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_377;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_377 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_377));
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_pi(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(void *, int);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_378;
    int t_379;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_378 = GET_NCI_P(0);
    t_379 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_378),t_379);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_pii(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(void *, int, int);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_380;
    int t_381;
    int t_382;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_380 = GET_NCI_P(0);
    t_381 = (int)GET_NCI_I(1);
    t_382 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_380),t_381,t_382);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_pt(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(void *, char *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_383;
    char *t_384;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_383 = GET_NCI_P(0);
    t_384 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_383),t_384);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    string_cstring_free(t_384);
}
static void
pcf_t_t(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(char *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;char *t_385;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_385 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_385);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    string_cstring_free(t_385);
}
static void
pcf_t_tl4(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(char *, long, long *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    long arg2;
    STRING *final_destination;char *t_386;
    long t_387;
    PMC *t_388;
    Parrot_init_arg_nci(interpreter, &st, "SIP");
    t_386 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_387 = (long)GET_NCI_I(1);
    t_388 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_388);
    return_data =  (char *)(*pointer)(t_386,t_387,&arg2);
    PMC_int_val(t_388) = arg2;
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    string_cstring_free(t_386);
}
static void
pcf_t_t4(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(char *, long *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    long arg1;
    STRING *final_destination;char *t_389;
    PMC *t_390;
    Parrot_init_arg_nci(interpreter, &st, "SP");
    t_389 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_390 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_390);
    return_data =  (char *)(*pointer)(t_389,&arg1);
    PMC_int_val(t_390) = arg1;
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    string_cstring_free(t_389);
}
static void
pcf_v_(Interp *interpreter, PMC *self)
{
    void (*pointer)(void);
    
    
    
    

    pointer =  (void (*)(void))D2FPTR(PMC_struct_val(self));
     (void)(*pointer)();
    
    
}
static void
pcf_v_Jiiip(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, int, int, int, void *);
    func_t pointer;
    struct call_state st;
    
    
    int t_392;
    int t_393;
    int t_394;
    PMC *t_395;
    Parrot_init_arg_nci(interpreter, &st, "IIIP");
    t_392 = (int)GET_NCI_I(0);
    t_393 = (int)GET_NCI_I(1);
    t_394 = (int)GET_NCI_I(2);
    t_395 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_392,t_393,t_394,PMC_data(t_395));
    
    
    
}
static void
pcf_v_JOP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_397;
    PMC *t_398;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_397 = GET_NCI_P(0);
    t_398 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_397 == PMCNULL ? NULL : t_397,t_398 == PMCNULL ? NULL : t_398);
    
    
    
}
static void
pcf_v_i(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(int);
    func_t pointer;
    struct call_state st;
    
    
    int t_399;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_399 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_399);
    
    
    
}
static void
pcf_v_ii(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(int, int);
    func_t pointer;
    struct call_state st;
    
    
    int t_400;
    int t_401;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_400 = (int)GET_NCI_I(0);
    t_401 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_400,t_401);
    
    
    
}
static void
pcf_v_illllllll(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(int, long, long, long, long, long, long, long, long);
    func_t pointer;
    struct call_state st;
    
    
    int t_402;
    long t_403;
    long t_404;
    long t_405;
    long t_406;
    long t_407;
    long t_408;
    long t_409;
    long t_410;
    Parrot_init_arg_nci(interpreter, &st, "IIIIIIIII");
    t_402 = (int)GET_NCI_I(0);
    t_403 = (long)GET_NCI_I(1);
    t_404 = (long)GET_NCI_I(2);
    t_405 = (long)GET_NCI_I(3);
    t_406 = (long)GET_NCI_I(4);
    t_407 = (long)GET_NCI_I(5);
    t_408 = (long)GET_NCI_I(6);
    t_409 = (long)GET_NCI_I(7);
    t_410 = (long)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_402,t_403,t_404,t_405,t_406,t_407,t_408,t_409,t_410);
    
    
    
}
static void
pcf_v_l(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(long);
    func_t pointer;
    struct call_state st;
    
    
    long t_411;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_411 = (long)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_411);
    
    
    
}
static void
pcf_v_p(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_412;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_412 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_412));
    
    
    
}
static void
pcf_v_pbip(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, void *, int, void *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_413;
    STRING *t_414;
    int t_415;
    PMC *t_416;
    Parrot_init_arg_nci(interpreter, &st, "PSIP");
    t_413 = GET_NCI_P(0);
    t_414 = GET_NCI_S(1);
    t_415 = (int)GET_NCI_I(2);
    t_416 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_413),PObj_bufstart(t_414),t_415,PMC_data(t_416));
    
    
    
}
static void
pcf_v_pi(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, int);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_417;
    int t_418;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_417 = GET_NCI_P(0);
    t_418 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_417),t_418);
    
    
    
}
static void
pcf_v_piiii(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, int, int, int, int);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_419;
    int t_420;
    int t_421;
    int t_422;
    int t_423;
    Parrot_init_arg_nci(interpreter, &st, "PIIII");
    t_419 = GET_NCI_P(0);
    t_420 = (int)GET_NCI_I(1);
    t_421 = (int)GET_NCI_I(2);
    t_422 = (int)GET_NCI_I(3);
    t_423 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_419),t_420,t_421,t_422,t_423);
    
    
    
}
static void
pcf_v_pl(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, long);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_424;
    long t_425;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_424 = GET_NCI_P(0);
    t_425 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_424),t_425);
    
    
    
}
static void
pcf_v_pp(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, void *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_426;
    PMC *t_427;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_426 = GET_NCI_P(0);
    t_427 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_426),PMC_data(t_427));
    
    
    
}
static void
pcf_i_JP(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_429;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_429 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_429 == PMCNULL ? NULL : t_429);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_v_JP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_431;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_431 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_431 == PMCNULL ? NULL : t_431);
    
    
    
}
static void
pcf_i_JPi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_433;
    int t_434;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_433 = GET_NCI_P(0);
    t_434 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_433 == PMCNULL ? NULL : t_433,t_434);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_JPii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_436;
    int t_437;
    int t_438;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_436 = GET_NCI_P(0);
    t_437 = (int)GET_NCI_I(1);
    t_438 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_436 == PMCNULL ? NULL : t_436,t_437,t_438);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_JPiii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, int, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_440;
    int t_441;
    int t_442;
    int t_443;
    Parrot_init_arg_nci(interpreter, &st, "PIII");
    t_440 = GET_NCI_P(0);
    t_441 = (int)GET_NCI_I(1);
    t_442 = (int)GET_NCI_I(2);
    t_443 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_440 == PMCNULL ? NULL : t_440,t_441,t_442,t_443);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_JPt(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_445;
    char *t_446;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_445 = GET_NCI_P(0);
    t_446 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_445 == PMCNULL ? NULL : t_445,t_446);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_446);
}
static void
pcf_P_JOSSS(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, STRING *, STRING *, STRING *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_448;
    STRING *t_449;
    STRING *t_450;
    STRING *t_451;
    Parrot_init_arg_nci(interpreter, &st, "PSSS");
    t_448 = GET_NCI_P(0);
    t_449 = GET_NCI_S(1);
    t_450 = GET_NCI_S(2);
    t_451 = GET_NCI_S(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_448 == PMCNULL ? NULL : t_448,t_449,t_450,t_451);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_v_JOSS(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, STRING *, STRING *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_453;
    STRING *t_454;
    STRING *t_455;
    Parrot_init_arg_nci(interpreter, &st, "PSS");
    t_453 = GET_NCI_P(0);
    t_454 = GET_NCI_S(1);
    t_455 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_453 == PMCNULL ? NULL : t_453,t_454,t_455);
    
    
    
}
static void
pcf_P_JP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_457;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_457 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_457 == PMCNULL ? NULL : t_457);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JPP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_459;
    PMC *t_460;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_459 = GET_NCI_P(0);
    t_460 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_459 == PMCNULL ? NULL : t_459,t_460 == PMCNULL ? NULL : t_460);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JO(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_462;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_462 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_462 == PMCNULL ? NULL : t_462);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_S_JO(Interp *interpreter, PMC *self)
{
    typedef STRING * (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    STRING * return_data;
    
    PMC *t_464;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_464 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interpreter,t_464 == PMCNULL ? NULL : t_464);
    
    set_nci_S(interpreter, &st, return_data);
    
}
static void
pcf_i_P(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(PMC *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_465;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_465 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_465 == PMCNULL ? NULL : t_465);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_S_JOI(Interp *interpreter, PMC *self)
{
    typedef STRING * (*func_t)(Interp *, PMC *, INTVAL);
    func_t pointer;
    struct call_state st;
    STRING * return_data;
    
    PMC *t_467;
    INTVAL t_468;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_467 = GET_NCI_P(0);
    t_468 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interpreter,t_467 == PMCNULL ? NULL : t_467,t_468);
    
    set_nci_S(interpreter, &st, return_data);
    
}
static void
pcf_i_sc(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(short, char);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    short t_469;
    char t_470;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_469 = (short)GET_NCI_I(0);
    t_470 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_469,t_470);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_s_sc(Interp *interpreter, PMC *self)
{
    typedef short (*func_t)(short, char);
    func_t pointer;
    struct call_state st;
    short return_data;
    
    short t_471;
    char t_472;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_471 = (short)GET_NCI_I(0);
    t_472 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (short)(*pointer)(t_471,t_472);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_c_sc(Interp *interpreter, PMC *self)
{
    typedef char (*func_t)(short, char);
    func_t pointer;
    struct call_state st;
    char return_data;
    
    short t_473;
    char t_474;
    Parrot_init_arg_nci(interpreter, &st, "II");
    t_473 = (short)GET_NCI_I(0);
    t_474 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_473,t_474);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_iii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_475;
    int t_476;
    int t_477;
    Parrot_init_arg_nci(interpreter, &st, "III");
    t_475 = (int)GET_NCI_I(0);
    t_476 = (int)GET_NCI_I(1);
    t_477 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_475,t_476,t_477);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_i3(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, int *);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg1;
    int t_478;
    PMC *t_479;
    Parrot_init_arg_nci(interpreter, &st, "IP");
    t_478 = (int)GET_NCI_I(0);
    t_479 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_479);
    return_data =  (int)(*pointer)(t_478,&arg1);
    PMC_int_val(t_479) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_t_b(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;STRING *t_480;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_480 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PObj_bufstart(t_480));
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_B(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(void **);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;STRING *t_481;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_481 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(&PObj_bufstart(t_481));
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_v_P(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_482;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_482 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_482 == PMCNULL ? NULL : t_482);
    
    
    
}
static void
pcf_v_pP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_483;
    PMC *t_484;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_483 = GET_NCI_P(0);
    t_484 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_483),t_484 == PMCNULL ? NULL : t_484);
    
    
    
}
static void
pcf_p_ip(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_485;
    PMC *t_486;
    Parrot_init_arg_nci(interpreter, &st, "IP");
    t_485 = (int)GET_NCI_I(0);
    t_486 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_485,PMC_data(t_486));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_i_33(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int *, int *);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg0;
    int arg1;
    PMC *t_487;
    PMC *t_488;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_487 = GET_NCI_P(0);
    t_488 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_487);
    arg1 = PMC_int_val(t_488);
    return_data =  (int)(*pointer)(&arg0,&arg1);
    PMC_int_val(t_487) = arg0;
    PMC_int_val(t_488) = arg1;
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_v_pii(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, int, int);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_489;
    int t_490;
    int t_491;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_489 = GET_NCI_P(0);
    t_490 = (int)GET_NCI_I(1);
    t_491 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_489),t_490,t_491);
    
    
    
}
static void
pcf_v_JO(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_493;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_493 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_493 == PMCNULL ? NULL : t_493);
    
    
    
}
static void
pcf_i_JO(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_495;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_495 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_495 == PMCNULL ? NULL : t_495);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_JOi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_497;
    int t_498;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_497 = GET_NCI_P(0);
    t_498 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_497 == PMCNULL ? NULL : t_497,t_498);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_JOt(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_500;
    char *t_501;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_500 = GET_NCI_P(0);
    t_501 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_500 == PMCNULL ? NULL : t_500,t_501);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_501);
}
static void
pcf_i_Jt(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    char *t_503;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_503 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_503);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_503);
}
static void
pcf_i_Ji(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_505;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_505 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_505);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_p_pi33ipi(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, int, int *, int *, int, void *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    int arg2;
    int arg3;
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_506;
    int t_507;
    PMC *t_508;
    PMC *t_509;
    int t_510;
    PMC *t_511;
    int t_512;
    Parrot_init_arg_nci(interpreter, &st, "PIPPIPI");
    t_506 = GET_NCI_P(0);
    t_507 = (int)GET_NCI_I(1);
    t_508 = GET_NCI_P(2);
    t_509 = GET_NCI_P(3);
    t_510 = (int)GET_NCI_I(4);
    t_511 = GET_NCI_P(5);
    t_512 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_508);
    arg3 = PMC_int_val(t_509);
    return_data =  (void *)(*pointer)(PMC_data(t_506),t_507,&arg2,&arg3,t_510,PMC_data(t_511),t_512);
    PMC_int_val(t_508) = arg2;
    PMC_int_val(t_509) = arg3;
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_ptii33i(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, int, int *, int *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    int arg4;
    int arg5;
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_513;
    char *t_514;
    int t_515;
    int t_516;
    PMC *t_517;
    PMC *t_518;
    int t_519;
    Parrot_init_arg_nci(interpreter, &st, "PSIIPPI");
    t_513 = GET_NCI_P(0);
    t_514 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_515 = (int)GET_NCI_I(2);
    t_516 = (int)GET_NCI_I(3);
    t_517 = GET_NCI_P(4);
    t_518 = GET_NCI_P(5);
    t_519 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg4 = PMC_int_val(t_517);
    arg5 = PMC_int_val(t_518);
    return_data =  (void *)(*pointer)(PMC_data(t_513),t_514,t_515,t_516,&arg4,&arg5,t_519);
    PMC_int_val(t_517) = arg4;
    PMC_int_val(t_518) = arg5;
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_514);
}
static void
pcf_p_ptit33i(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, char *, int *, int *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    int arg4;
    int arg5;
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_520;
    char *t_521;
    int t_522;
    char *t_523;
    PMC *t_524;
    PMC *t_525;
    int t_526;
    Parrot_init_arg_nci(interpreter, &st, "PSISPPI");
    t_520 = GET_NCI_P(0);
    t_521 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_522 = (int)GET_NCI_I(2);
    t_523 = string_to_cstring(interpreter, GET_NCI_S(3));
    t_524 = GET_NCI_P(4);
    t_525 = GET_NCI_P(5);
    t_526 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg4 = PMC_int_val(t_524);
    arg5 = PMC_int_val(t_525);
    return_data =  (void *)(*pointer)(PMC_data(t_520),t_521,t_522,t_523,&arg4,&arg5,t_526);
    PMC_int_val(t_524) = arg4;
    PMC_int_val(t_525) = arg5;
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_521);
    string_cstring_free(t_523);
}
static void
pcf_i_ptit33i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *, int, char *, int *, int *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg4;
    int arg5;
    PMC *t_527;
    char *t_528;
    int t_529;
    char *t_530;
    PMC *t_531;
    PMC *t_532;
    int t_533;
    Parrot_init_arg_nci(interpreter, &st, "PSISPPI");
    t_527 = GET_NCI_P(0);
    t_528 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_529 = (int)GET_NCI_I(2);
    t_530 = string_to_cstring(interpreter, GET_NCI_S(3));
    t_531 = GET_NCI_P(4);
    t_532 = GET_NCI_P(5);
    t_533 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg4 = PMC_int_val(t_531);
    arg5 = PMC_int_val(t_532);
    return_data =  (int)(*pointer)(PMC_data(t_527),t_528,t_529,t_530,&arg4,&arg5,t_533);
    PMC_int_val(t_531) = arg4;
    PMC_int_val(t_532) = arg5;
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_528);
    string_cstring_free(t_530);
}
static void
pcf_i_ptiit33i(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *, int, int, char *, int *, int *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg5;
    int arg6;
    PMC *t_534;
    char *t_535;
    int t_536;
    int t_537;
    char *t_538;
    PMC *t_539;
    PMC *t_540;
    int t_541;
    Parrot_init_arg_nci(interpreter, &st, "PSIISPPI");
    t_534 = GET_NCI_P(0);
    t_535 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_536 = (int)GET_NCI_I(2);
    t_537 = (int)GET_NCI_I(3);
    t_538 = string_to_cstring(interpreter, GET_NCI_S(4));
    t_539 = GET_NCI_P(5);
    t_540 = GET_NCI_P(6);
    t_541 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg5 = PMC_int_val(t_539);
    arg6 = PMC_int_val(t_540);
    return_data =  (int)(*pointer)(PMC_data(t_534),t_535,t_536,t_537,t_538,&arg5,&arg6,t_541);
    PMC_int_val(t_539) = arg5;
    PMC_int_val(t_540) = arg6;
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_535);
    string_cstring_free(t_538);
}
static void
pcf_p_tiB3P(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(char *, int, void **, int *, PMC *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    int arg3;
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_542;
    int t_543;
    STRING *t_544;
    PMC *t_545;
    PMC *t_546;
    Parrot_init_arg_nci(interpreter, &st, "SISPP");
    t_542 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_543 = (int)GET_NCI_I(1);
    t_544 = GET_NCI_S(2);
    t_545 = GET_NCI_P(3);
    t_546 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_545);
    return_data =  (void *)(*pointer)(t_542,t_543,&PObj_bufstart(t_544),&arg3,t_546 == PMCNULL ? NULL : t_546);
    PMC_int_val(t_545) = arg3;
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_542);
}
static void
pcf_p_tip3P(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(char *, int, void *, int *, PMC *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    int arg3;
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_547;
    int t_548;
    PMC *t_549;
    PMC *t_550;
    PMC *t_551;
    Parrot_init_arg_nci(interpreter, &st, "SIPPP");
    t_547 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_548 = (int)GET_NCI_I(1);
    t_549 = GET_NCI_P(2);
    t_550 = GET_NCI_P(3);
    t_551 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_550);
    return_data =  (void *)(*pointer)(t_547,t_548,PMC_data(t_549),&arg3,t_551 == PMCNULL ? NULL : t_551);
    PMC_int_val(t_550) = arg3;
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_547);
}
static void
pcf_i_pPtiiipi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, PMC *, char *, int, int, int, void *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_552;
    PMC *t_553;
    char *t_554;
    int t_555;
    int t_556;
    int t_557;
    PMC *t_558;
    int t_559;
    Parrot_init_arg_nci(interpreter, &st, "PPSIIIPI");
    t_552 = GET_NCI_P(0);
    t_553 = GET_NCI_P(1);
    t_554 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_555 = (int)GET_NCI_I(3);
    t_556 = (int)GET_NCI_I(4);
    t_557 = (int)GET_NCI_I(5);
    t_558 = GET_NCI_P(6);
    t_559 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_552),t_553 == PMCNULL ? NULL : t_553,t_554,t_555,t_556,t_557,PMC_data(t_558),t_559);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_554);
}
static void
pcf_i_tpiibi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(char *, void *, int, int, void *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    char *t_560;
    PMC *t_561;
    int t_562;
    int t_563;
    STRING *t_564;
    int t_565;
    Parrot_init_arg_nci(interpreter, &st, "SPIISI");
    t_560 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_561 = GET_NCI_P(1);
    t_562 = (int)GET_NCI_I(2);
    t_563 = (int)GET_NCI_I(3);
    t_564 = GET_NCI_S(4);
    t_565 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_560,PMC_data(t_561),t_562,t_563,PObj_bufstart(t_564),t_565);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_560);
}
static void
pcf_p_iiil(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(int, int, int, long);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_566;
    int t_567;
    int t_568;
    long t_569;
    Parrot_init_arg_nci(interpreter, &st, "IIII");
    t_566 = (int)GET_NCI_I(0);
    t_567 = (int)GET_NCI_I(1);
    t_568 = (int)GET_NCI_I(2);
    t_569 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_566,t_567,t_568,t_569);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_i_ppl(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, void *, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_570;
    PMC *t_571;
    long t_572;
    Parrot_init_arg_nci(interpreter, &st, "PPI");
    t_570 = GET_NCI_P(0);
    t_571 = GET_NCI_P(1);
    t_572 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_570),PMC_data(t_571),t_572);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_v_pip(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, int, void *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_573;
    int t_574;
    PMC *t_575;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_573 = GET_NCI_P(0);
    t_574 = (int)GET_NCI_I(1);
    t_575 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_573),t_574,PMC_data(t_575));
    
    
    
}
static void
pcf_p_ti(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(char *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);char *t_576;
    int t_577;
    Parrot_init_arg_nci(interpreter, &st, "SI");
    t_576 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_577 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_576,t_577);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_576);
}
static void
pcf_p_ptp(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, char *, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_578;
    char *t_579;
    PMC *t_580;
    Parrot_init_arg_nci(interpreter, &st, "PSP");
    t_578 = GET_NCI_P(0);
    t_579 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_580 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_578),t_579,PMC_data(t_580));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_579);
}
static void
pcf_i_pt33(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *, int *, int *);
    func_t pointer;
    struct call_state st;
    int return_data;
    int arg2;
    int arg3;
    PMC *t_581;
    char *t_582;
    PMC *t_583;
    PMC *t_584;
    Parrot_init_arg_nci(interpreter, &st, "PSPP");
    t_581 = GET_NCI_P(0);
    t_582 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_583 = GET_NCI_P(2);
    t_584 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_583);
    arg3 = PMC_int_val(t_584);
    return_data =  (int)(*pointer)(PMC_data(t_581),t_582,&arg2,&arg3);
    PMC_int_val(t_583) = arg2;
    PMC_int_val(t_584) = arg3;
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_582);
}
static void
pcf_i_JPP(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_586;
    PMC *t_587;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_586 = GET_NCI_P(0);
    t_587 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_586 == PMCNULL ? NULL : t_586,t_587 == PMCNULL ? NULL : t_587);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_tp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(char *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    char *t_588;
    PMC *t_589;
    Parrot_init_arg_nci(interpreter, &st, "SP");
    t_588 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_589 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_588,PMC_data(t_589));
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_588);
}
static void
pcf_v_tiiiptt(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(char *, int, int, int, void *, char *, char *);
    func_t pointer;
    struct call_state st;
    
    
    char *t_590;
    int t_591;
    int t_592;
    int t_593;
    PMC *t_594;
    char *t_595;
    char *t_596;
    Parrot_init_arg_nci(interpreter, &st, "SIIIPSS");
    t_590 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_591 = (int)GET_NCI_I(1);
    t_592 = (int)GET_NCI_I(2);
    t_593 = (int)GET_NCI_I(3);
    t_594 = GET_NCI_P(4);
    t_595 = string_to_cstring(interpreter, GET_NCI_S(5));
    t_596 = string_to_cstring(interpreter, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_590,t_591,t_592,t_593,PMC_data(t_594),t_595,t_596);
    
    
    string_cstring_free(t_590);
    string_cstring_free(t_595);
    string_cstring_free(t_596);
}
static void
pcf_i_Pip(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(PMC *, int, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_597;
    int t_598;
    PMC *t_599;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_597 = GET_NCI_P(0);
    t_598 = (int)GET_NCI_I(1);
    t_599 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_597 == PMCNULL ? NULL : t_597,t_598,PMC_data(t_599));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_p_J(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(Interp *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);
    Parrot_init_arg_nci(interpreter, &st, "");
    

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interpreter);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_t_J(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(Interp *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;
    Parrot_init_arg_nci(interpreter, &st, "");
    

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interpreter);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_t_Jp(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(Interp *, void *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_603;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_603 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interpreter,PMC_data(t_603));
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    
}
static void
pcf_p_Jp(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(Interp *, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_605;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_605 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interpreter,PMC_data(t_605));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_t_Jpt(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(Interp *, void *, char *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_607;
    char *t_608;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_607 = GET_NCI_P(0);
    t_608 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interpreter,PMC_data(t_607),t_608);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    string_cstring_free(t_608);
}
static void
pcf_i_Jp(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_610;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_610 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,PMC_data(t_610));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_Jpi(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, void *, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_612;
    int t_613;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_612 = GET_NCI_P(0);
    t_613 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,PMC_data(t_612),t_613);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_JPip(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, PMC *, int, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_615;
    int t_616;
    PMC *t_617;
    Parrot_init_arg_nci(interpreter, &st, "PIP");
    t_615 = GET_NCI_P(0);
    t_616 = (int)GET_NCI_I(1);
    t_617 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,t_615 == PMCNULL ? NULL : t_615,t_616,PMC_data(t_617));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_v_ptt(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, char *, char *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_618;
    char *t_619;
    char *t_620;
    Parrot_init_arg_nci(interpreter, &st, "PSS");
    t_618 = GET_NCI_P(0);
    t_619 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_620 = string_to_cstring(interpreter, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_618),t_619,t_620);
    
    
    string_cstring_free(t_619);
    string_cstring_free(t_620);
}
static void
pcf_v_pit(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(void *, int, char *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_621;
    int t_622;
    char *t_623;
    Parrot_init_arg_nci(interpreter, &st, "PIS");
    t_621 = GET_NCI_P(0);
    t_622 = (int)GET_NCI_I(1);
    t_623 = string_to_cstring(interpreter, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_621),t_622,t_623);
    
    
    string_cstring_free(t_623);
}
static void
pcf_i_Jpii(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(Interp *, void *, int, int);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_625;
    int t_626;
    int t_627;
    Parrot_init_arg_nci(interpreter, &st, "PII");
    t_625 = GET_NCI_P(0);
    t_626 = (int)GET_NCI_I(1);
    t_627 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interpreter,PMC_data(t_625),t_626,t_627);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_i_ip(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(int, void *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    int t_628;
    PMC *t_629;
    Parrot_init_arg_nci(interpreter, &st, "IP");
    t_628 = (int)GET_NCI_I(0);
    t_629 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_628,PMC_data(t_629));
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_P_JOPP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_631;
    PMC *t_632;
    PMC *t_633;
    Parrot_init_arg_nci(interpreter, &st, "PPP");
    t_631 = GET_NCI_P(0);
    t_632 = GET_NCI_P(1);
    t_633 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_631 == PMCNULL ? NULL : t_631,t_632 == PMCNULL ? NULL : t_632,t_633 == PMCNULL ? NULL : t_633);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JOPPP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_635;
    PMC *t_636;
    PMC *t_637;
    PMC *t_638;
    Parrot_init_arg_nci(interpreter, &st, "PPPP");
    t_635 = GET_NCI_P(0);
    t_636 = GET_NCI_P(1);
    t_637 = GET_NCI_P(2);
    t_638 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_635 == PMCNULL ? NULL : t_635,t_636 == PMCNULL ? NULL : t_636,t_637 == PMCNULL ? NULL : t_637,t_638 == PMCNULL ? NULL : t_638);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_v_JOPP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_640;
    PMC *t_641;
    PMC *t_642;
    Parrot_init_arg_nci(interpreter, &st, "PPP");
    t_640 = GET_NCI_P(0);
    t_641 = GET_NCI_P(1);
    t_642 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_640 == PMCNULL ? NULL : t_640,t_641 == PMCNULL ? NULL : t_641,t_642 == PMCNULL ? NULL : t_642);
    
    
    
}
static void
pcf_v_JOPPP(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_644;
    PMC *t_645;
    PMC *t_646;
    PMC *t_647;
    Parrot_init_arg_nci(interpreter, &st, "PPPP");
    t_644 = GET_NCI_P(0);
    t_645 = GET_NCI_P(1);
    t_646 = GET_NCI_P(2);
    t_647 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_644 == PMCNULL ? NULL : t_644,t_645 == PMCNULL ? NULL : t_645,t_646 == PMCNULL ? NULL : t_646,t_647 == PMCNULL ? NULL : t_647);
    
    
    
}
static void
pcf_P_JOPPPP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_649;
    PMC *t_650;
    PMC *t_651;
    PMC *t_652;
    PMC *t_653;
    Parrot_init_arg_nci(interpreter, &st, "PPPPP");
    t_649 = GET_NCI_P(0);
    t_650 = GET_NCI_P(1);
    t_651 = GET_NCI_P(2);
    t_652 = GET_NCI_P(3);
    t_653 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_649 == PMCNULL ? NULL : t_649,t_650 == PMCNULL ? NULL : t_650,t_651 == PMCNULL ? NULL : t_651,t_652 == PMCNULL ? NULL : t_652,t_653 == PMCNULL ? NULL : t_653);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_P_JOPPPPP(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_655;
    PMC *t_656;
    PMC *t_657;
    PMC *t_658;
    PMC *t_659;
    PMC *t_660;
    Parrot_init_arg_nci(interpreter, &st, "PPPPPP");
    t_655 = GET_NCI_P(0);
    t_656 = GET_NCI_P(1);
    t_657 = GET_NCI_P(2);
    t_658 = GET_NCI_P(3);
    t_659 = GET_NCI_P(4);
    t_660 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_655 == PMCNULL ? NULL : t_655,t_656 == PMCNULL ? NULL : t_656,t_657 == PMCNULL ? NULL : t_657,t_658 == PMCNULL ? NULL : t_658,t_659 == PMCNULL ? NULL : t_659,t_660 == PMCNULL ? NULL : t_660);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_I_JOSI(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, PMC *, STRING *, INTVAL);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    PMC *t_662;
    STRING *t_663;
    INTVAL t_664;
    Parrot_init_arg_nci(interpreter, &st, "PSI");
    t_662 = GET_NCI_P(0);
    t_663 = GET_NCI_S(1);
    t_664 = GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_662 == PMCNULL ? NULL : t_662,t_663,t_664);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_P_JOSII(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, STRING *, INTVAL, INTVAL);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_666;
    STRING *t_667;
    INTVAL t_668;
    INTVAL t_669;
    Parrot_init_arg_nci(interpreter, &st, "PSII");
    t_666 = GET_NCI_P(0);
    t_667 = GET_NCI_S(1);
    t_668 = GET_NCI_I(2);
    t_669 = GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_666 == PMCNULL ? NULL : t_666,t_667,t_668,t_669);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_p_Ji(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(Interp *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_671;
    Parrot_init_arg_nci(interpreter, &st, "I");
    t_671 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interpreter,t_671);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_Jipp(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(Interp *, int, void *, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);int t_673;
    PMC *t_674;
    PMC *t_675;
    Parrot_init_arg_nci(interpreter, &st, "IPP");
    t_673 = (int)GET_NCI_I(0);
    t_674 = GET_NCI_P(1);
    t_675 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interpreter,t_673,PMC_data(t_674),PMC_data(t_675));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_p_Jbip(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(Interp *, void *, int, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);STRING *t_677;
    int t_678;
    PMC *t_679;
    Parrot_init_arg_nci(interpreter, &st, "SIP");
    t_677 = GET_NCI_S(0);
    t_678 = (int)GET_NCI_I(1);
    t_679 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interpreter,PObj_bufstart(t_677),t_678,PMC_data(t_679));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_v_Jp(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, void *);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_681;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_681 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,PMC_data(t_681));
    
    
    
}
static void
pcf_v_JS(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, STRING *);
    func_t pointer;
    struct call_state st;
    
    
    STRING *t_683;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_683 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_683);
    
    
    
}
static void
pcf_t_tt(Interp *interpreter, PMC *self)
{
    typedef char * (*func_t)(char *, char *);
    func_t pointer;
    struct call_state st;
    char * return_data;
    
    STRING *final_destination;char *t_684;
    char *t_685;
    Parrot_init_arg_nci(interpreter, &st, "SS");
    t_684 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_685 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_684,t_685);
    
    final_destination = string_from_cstring(interpreter, return_data, 0);
    set_nci_S(interpreter, &st, final_destination);
    string_cstring_free(t_684);
    string_cstring_free(t_685);
}
static void
pcf_I_JOt(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, PMC *, char *);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    PMC *t_687;
    char *t_688;
    Parrot_init_arg_nci(interpreter, &st, "PS");
    t_687 = GET_NCI_P(0);
    t_688 = string_to_cstring(interpreter, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_687 == PMCNULL ? NULL : t_687,t_688);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_688);
}
static void
pcf_v_JOSI(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, STRING *, INTVAL);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_690;
    STRING *t_691;
    INTVAL t_692;
    Parrot_init_arg_nci(interpreter, &st, "PSI");
    t_690 = GET_NCI_P(0);
    t_691 = GET_NCI_S(1);
    t_692 = GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_690 == PMCNULL ? NULL : t_690,t_691,t_692);
    
    
    
}
static void
pcf_S_JOi(Interp *interpreter, PMC *self)
{
    typedef STRING * (*func_t)(Interp *, PMC *, int);
    func_t pointer;
    struct call_state st;
    STRING * return_data;
    
    PMC *t_694;
    int t_695;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_694 = GET_NCI_P(0);
    t_695 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interpreter,t_694 == PMCNULL ? NULL : t_694,t_695);
    
    set_nci_S(interpreter, &st, return_data);
    
}
static void
pcf_v_JOi(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, int);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_697;
    int t_698;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_697 = GET_NCI_P(0);
    t_698 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_697 == PMCNULL ? NULL : t_697,t_698);
    
    
    
}
static void
pcf_I_JO(Interp *interpreter, PMC *self)
{
    typedef INTVAL (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    INTVAL return_data;
    
    PMC *t_700;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_700 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interpreter,t_700 == PMCNULL ? NULL : t_700);
    
    set_nci_I(interpreter, &st, return_data);
    
}
static void
pcf_N_JO(Interp *interpreter, PMC *self)
{
    typedef FLOATVAL (*func_t)(Interp *, PMC *);
    func_t pointer;
    struct call_state st;
    FLOATVAL return_data;
    
    PMC *t_702;
    Parrot_init_arg_nci(interpreter, &st, "P");
    t_702 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (FLOATVAL)(*pointer)(interpreter,t_702 == PMCNULL ? NULL : t_702);
    
    set_nci_N(interpreter, &st, return_data);
    
}
static void
pcf_v_JON(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, FLOATVAL);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_704;
    FLOATVAL t_705;
    Parrot_init_arg_nci(interpreter, &st, "PN");
    t_704 = GET_NCI_P(0);
    t_705 = GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_704 == PMCNULL ? NULL : t_704,t_705);
    
    
    
}
static void
pcf_P_JOi(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, int);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_707;
    int t_708;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_707 = GET_NCI_P(0);
    t_708 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_707 == PMCNULL ? NULL : t_707,t_708);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_v_JOI(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(Interp *, PMC *, INTVAL);
    func_t pointer;
    struct call_state st;
    
    
    PMC *t_710;
    INTVAL t_711;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_710 = GET_NCI_P(0);
    t_711 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interpreter,t_710 == PMCNULL ? NULL : t_710,t_711);
    
    
    
}
static void
pcf_P_JOI(Interp *interpreter, PMC *self)
{
    typedef PMC * (*func_t)(Interp *, PMC *, INTVAL);
    func_t pointer;
    struct call_state st;
    PMC * return_data;
    
    PMC *t_713;
    INTVAL t_714;
    Parrot_init_arg_nci(interpreter, &st, "PI");
    t_713 = GET_NCI_P(0);
    t_714 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interpreter,t_713 == PMCNULL ? NULL : t_713,t_714);
    
    set_nci_P(interpreter, &st, return_data);
    
}
static void
pcf_i_pttttt(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *, char *, char *, char *, char *);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_715;
    char *t_716;
    char *t_717;
    char *t_718;
    char *t_719;
    char *t_720;
    Parrot_init_arg_nci(interpreter, &st, "PSSSSS");
    t_715 = GET_NCI_P(0);
    t_716 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_717 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_718 = string_to_cstring(interpreter, GET_NCI_S(3));
    t_719 = string_to_cstring(interpreter, GET_NCI_S(4));
    t_720 = string_to_cstring(interpreter, GET_NCI_S(5));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_715),t_716,t_717,t_718,t_719,t_720);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_716);
    string_cstring_free(t_717);
    string_cstring_free(t_718);
    string_cstring_free(t_719);
    string_cstring_free(t_720);
}
static void
pcf_c_pttt(Interp *interpreter, PMC *self)
{
    typedef char (*func_t)(void *, char *, char *, char *);
    func_t pointer;
    struct call_state st;
    char return_data;
    
    PMC *t_721;
    char *t_722;
    char *t_723;
    char *t_724;
    Parrot_init_arg_nci(interpreter, &st, "PSSS");
    t_721 = GET_NCI_P(0);
    t_722 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_723 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_724 = string_to_cstring(interpreter, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_721),t_722,t_723,t_724);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_722);
    string_cstring_free(t_723);
    string_cstring_free(t_724);
}
static void
pcf_p_pttttiti(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, int);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_725;
    char *t_726;
    char *t_727;
    char *t_728;
    char *t_729;
    int t_730;
    char *t_731;
    int t_732;
    Parrot_init_arg_nci(interpreter, &st, "PSSSSISI");
    t_725 = GET_NCI_P(0);
    t_726 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_727 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_728 = string_to_cstring(interpreter, GET_NCI_S(3));
    t_729 = string_to_cstring(interpreter, GET_NCI_S(4));
    t_730 = (int)GET_NCI_I(5);
    t_731 = string_to_cstring(interpreter, GET_NCI_S(6));
    t_732 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_725),t_726,t_727,t_728,t_729,t_730,t_731,t_732);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_726);
    string_cstring_free(t_727);
    string_cstring_free(t_728);
    string_cstring_free(t_729);
    string_cstring_free(t_731);
}
static void
pcf_i_ptl(Interp *interpreter, PMC *self)
{
    typedef int (*func_t)(void *, char *, long);
    func_t pointer;
    struct call_state st;
    int return_data;
    
    PMC *t_733;
    char *t_734;
    long t_735;
    Parrot_init_arg_nci(interpreter, &st, "PSI");
    t_733 = GET_NCI_P(0);
    t_734 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_735 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_733),t_734,t_735);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_734);
}
static void
pcf_p_ptt(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_736;
    char *t_737;
    char *t_738;
    Parrot_init_arg_nci(interpreter, &st, "PSS");
    t_736 = GET_NCI_P(0);
    t_737 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_738 = string_to_cstring(interpreter, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_736),t_737,t_738);
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    string_cstring_free(t_737);
    string_cstring_free(t_738);
}
static void
pcf_p_pp(Interp *interpreter, PMC *self)
{
    typedef void * (*func_t)(void *, void *);
    func_t pointer;
    struct call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interpreter, enum_class_UnManagedStruct);PMC *t_739;
    PMC *t_740;
    Parrot_init_arg_nci(interpreter, &st, "PP");
    t_739 = GET_NCI_P(0);
    t_740 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_739),PMC_data(t_740));
    
    PMC_data(final_destination) = return_data;
    set_nci_P(interpreter, &st, final_destination);
    
}
static void
pcf_l_ttl(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(char *, char *, long);
    func_t pointer;
    struct call_state st;
    long return_data;
    
    char *t_741;
    char *t_742;
    long t_743;
    Parrot_init_arg_nci(interpreter, &st, "SSI");
    t_741 = string_to_cstring(interpreter, GET_NCI_S(0));
    t_742 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_743 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_741,t_742,t_743);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_741);
    string_cstring_free(t_742);
}
static void
pcf_l_pttl(Interp *interpreter, PMC *self)
{
    typedef long (*func_t)(void *, char *, char *, long);
    func_t pointer;
    struct call_state st;
    long return_data;
    
    PMC *t_744;
    char *t_745;
    char *t_746;
    long t_747;
    Parrot_init_arg_nci(interpreter, &st, "PSSI");
    t_744 = GET_NCI_P(0);
    t_745 = string_to_cstring(interpreter, GET_NCI_S(1));
    t_746 = string_to_cstring(interpreter, GET_NCI_S(2));
    t_747 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_744),t_745,t_746,t_747);
    
    set_nci_I(interpreter, &st, return_data);
    string_cstring_free(t_745);
    string_cstring_free(t_746);
}
static void
pcf_v_t(Interp *interpreter, PMC *self)
{
    typedef void (*func_t)(char *);
    func_t pointer;
    struct call_state st;
    
    
    char *t_748;
    Parrot_init_arg_nci(interpreter, &st, "S");
    t_748 = string_to_cstring(interpreter, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_748);
    
    
    string_cstring_free(t_748);
}


/* This function serves a single purpose. It takes the function
   signature for a C function we want to call and returns a pointer
   to a function that can call it. */
void *
build_call_func(Interp *interpreter, PMC *pmc_nci,
                STRING *signature)
{
    char       *c;
    STRING     *ns, *message;
    PMC        *b;
    PMC        *iglobals;
    PMC        *temp_pmc;
    UINTVAL    signature_len;

    void       *result        = NULL;
    Hash       *known_frames  = NULL;
    PMC        *HashPointer   = NULL;

#if defined(CAN_BUILD_CALL_FRAMES)

    /* Try if JIT code can build that signature,
     * if yes, we are done
     */

     result = Parrot_jit_build_call_func(interpreter, pmc_nci, signature);

#endif
    if (result)
        return result;

    /* And in here is the platform-independent way. Which is to say
       "here there be hacks" */
    UNUSED(pmc_nci);
    signature_len = string_length(interpreter, signature);
    if (0 == signature_len) return F2DPTR(pcf_v_);
    /* remove deprecated void argument 'v' character */
    if (2 == signature_len && 'v' == string_index(interpreter, signature, 1)) {
       Parrot_warn(interpreter, PARROT_WARNINGS_ALL_FLAG, "function signature argument character 'v' ignored");
       signature = string_chopn(interpreter, signature, 1, 1);
       signature_len = string_length(interpreter, signature);
    }

    iglobals = interpreter->iglobals;

    if (PMC_IS_NULL(iglobals))
        PANIC("iglobals isnt created yet");
    HashPointer = VTABLE_get_pmc_keyed_int(interpreter, iglobals,
            IGLOBALS_NCI_FUNCS);

    if (!HashPointer) {
        HashPointer = pmc_new(interpreter, enum_class_Hash);
        VTABLE_set_pmc_keyed_int(interpreter, iglobals, IGLOBALS_NCI_FUNCS,
                HashPointer);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "c", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "cp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_pi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "cpi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "d", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_d;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "dd", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_JOd;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "dJOd", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJOS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "SJOS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOSP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJOI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPIP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPIP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPSP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPSP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPNP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPNP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPN;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJPN", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJPPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPIP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJPIP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPSP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJPSP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPNP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJPNP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "f", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_ff;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "fff", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_is;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "fis", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_b;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ib", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_d;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "id", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iii4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii4i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iii4i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiilsp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiiilsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iil;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiil", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iili;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiili", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iit;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiit", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiiti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ilsp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iilsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_l;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "il", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_li;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ili", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_lp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ilp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_lsp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ilsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p33;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip33", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p333;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip333", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p333333;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip333333", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p42p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip42p", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p4i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ip4i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pb;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipb", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipii4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii4i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipii4i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiiiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiiiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiilsp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiiilsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piil;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiil", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piili;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiili", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piit;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiit", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipiiti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pilsp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipilsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pit;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipit", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pli;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipli", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pll;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipll", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pllllllll;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipllllllll", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iplp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plsp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iplsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ippi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppiiiiiiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ippiiiiiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pppp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipppp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_psp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipsp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pitl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipitl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "is", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s22;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "is22", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s222;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "is222", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "isp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sss;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "isss", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ssss;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "issss", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_t;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "it", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "i4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_4i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "i4i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_42p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "i42p", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "l", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_l4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ll4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lpi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lpii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_p33l;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lp33l", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_33l;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "l33l", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_Ji;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_Jt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "p", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_B;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pB", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_b;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pb", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pJt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "piiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiiiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "piiiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiiiiiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "piiiiiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_piiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_t;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tpp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ptpp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ttttttt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pttttttt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_s_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "s", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "t", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_ii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tpi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tpii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tpt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_t;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_tl4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ttl4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_t4;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tt4", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "v", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jiiip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJiiip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_illllllll;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "villllllll", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_l;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_p;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pbip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpbip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_piiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpiiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJPi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJPii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPiii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJPiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJPt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOSSS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOSSS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOSS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JO;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJO", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JO;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "SJO", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_P;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "SJOI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sc;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "isc", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_s_sc;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ssc", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_sc;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "csc", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iiii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i3;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ii3", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_b;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tb", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_B;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tB", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_P;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_33;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "i33", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JO;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJO", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JO;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJO", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJOi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJOt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Ji;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pi33ipi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppi33ipi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptii33i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pptii33i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptit33i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pptit33i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ptit33i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iptit33i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ptiit33i;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iptiit33i", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tiB3P;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ptiB3P", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tip3P;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ptip3P", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pPtiiipi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipPtiiipi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_tpiibi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "itpiibi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiil;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "piiil", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ippl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pptp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pt33;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipt33", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_tp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "itp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_tiiiptt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vtiiiptt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Pip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iPip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_J;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pJ", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_J;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tJ", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_Jp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tJp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pJp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_Jpt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "tJpt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jpi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJpi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJPip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ptt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vptt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pit;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vpit", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jpii;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iJpii", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOPPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOPPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOPPPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPPPP;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOPPPPP", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOSI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJOSI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOSII;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOSII", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Ji;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pJi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jipp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pJipp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jbip;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pJbip", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JS;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJS", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_tt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ttt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJOt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOSI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "SJOi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JO;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "IJO", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_N_JO;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "NJO", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JON;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJON", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOi;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOi", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vJOI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOI;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "PJOI", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pttttt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ipttttt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_pttt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "cpttt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pttttiti;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppttttiti", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ptl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "iptl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptt;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "pptt", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pp;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "ppp", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ttl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lttl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pttl;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "lpttl", 0), temp_pmc);

        temp_pmc = pmc_new(interpreter, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_t;
        VTABLE_set_pmc_keyed_str(interpreter, HashPointer, string_from_cstring(interpreter, "vt", 0), temp_pmc);


    }

    b = VTABLE_get_pmc_keyed_str(interpreter, HashPointer, signature);

    if (b && b->vtable->base_type == enum_class_UnManagedStruct)
        return F2DPTR(PMC_data(b));

    /*
      These three lines have been added to aid debugging. I want to be able to
      see which signature has an unknown type. I am sure someone can come up
      with a neater way to do this.
     */
    ns = string_make(interpreter, " is an unknown signature type", 29, "ascii", 0);
    message = string_concat(interpreter, signature, ns, 0);

#if defined(CAN_BUILD_CALL_FRAMES)
    ns = string_make(interpreter, ".\nCAN_BUILD_CALL_FRAMES is enabled, this should not happen", 58, "ascii", 0);
#else
    ns = string_make(interpreter, ".\nCAN_BUILD_CALL_FRAMES is disabled, add the signature to src/call_list.txt", 75, "ascii", 0);
#endif
    message = string_concat(interpreter, message, ns, 0);

    /*
     * I think there may be memory issues with this but if we get to here we are
     * aborting.
     */
    c = string_to_cstring(interpreter, message);
    PANIC(c);
    return NULL;
}

